VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmLoadIntoDb 
   Caption         =   "Load Database"
   ClientHeight    =   8415.001
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9720.001
   OleObjectBlob   =   "frmLoadIntoDb.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmLoadIntoDb"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False




'Expert Designer Data Loader
'
'
' ==================================================================================================
' Revision History
' --------------------------------------------------------------------------------------------------
' Date      By  Modification
' --------  --- ------------------------------------------------------------------------------------
' 03/16/06  RBL LoadVegSpecies()
'               LoadVegClassification()
'               LoadVegBenchmark()
'               LoadActionDetail()
'               LoadCrew()
'                   - commented line ID = NextPK() - these tables do not have an ID field
'
' 06/11/08  DRH Added Incremental Load Functionality
'
'
' ==================================================================================================

'----------------------------------------------------------------------
'
'     $Source: /geoelec-root/Utility_Applications/ExpertDesigner/Tools/DataLoaderVBACode/frmLoadIntoDb.frm $
'
'  $Copyright: (c) 2013 Bentley Systems, Incorporated. All rights reserved. $
'
'----------------------------------------------------------------------
Option Explicit
Dim CurrentUserID&
Public Conn As ADODB.connection
Public dbtype$
Dim LoadUnitsOnly%
Dim IgnoreUnits%
Dim IncrementalLoad%
Dim ValidateUtility%
Dim AtrLglVlUpdate As String
Dim logfile$
Dim logdir$
Dim logUpdatesToFile As Boolean
Dim LastFtrTypeID&
Dim FtrAttributes As Collection
Dim LaborTypes As Collection
Dim WorkTypes As Collection
Dim CUs As Collection
Dim ClassCodes As Collection
Dim FtrTypes As Collection
Public FailedSheets$

'DAVID Custem
Dim IsSqlServerS2T As Boolean

Const StandardDomains$ = "IntegerVal;StringVal;DateVal;FloatVal;"
Private Function ContextID&(ContextName$)
    Dim temp$
    ContextID = 1
    temp = Trim$(LCase(ContextName))
    If InStr(1, temp, "request", vbTextCompare) Then
        ContextID = 1
    ElseIf InStr(1, temp, "design", vbTextCompare) Then
        ContextID = 2
    ElseIf InStr(1, temp, "unit", vbTextCompare) Then
        ContextID = 3
    ElseIf InStr(1, temp, "material", vbTextCompare) Then
        ContextID = 4
    ElseIf InStr(1, temp, "custom", vbTextCompare) Then
        ContextID = 5
    ElseIf InStr(1, temp, "default", vbTextCompare) Then
        ContextID = 6
    End If
        
End Function

Private Sub CreateFilterConstraint(FCTID&, Name$, value$, Operator$, valueType$)
    Dim rs As New ADODB.Recordset
    Dim ID&, OpCode&, ADOValType&
    
    rs.Open FILTERCONTRAINT_TBLNAME, Conn, adOpenDynamic, _
                                                adLockPessimistic, adCmdTable
    ID = NextPK(FILTERCONTRAINT_TBLNAME, FILTERCONTRAINT_ID)
    
    ADOValType = ADOValueType(valueType)
    OpCode = OperatorCode(Operator)
    
    rs.AddNew
    rs(FILTERCONTRAINT_ID) = ID
    rs(FILTERCONTRAINT_FLTRCNSTTYPEID) = FCTID
    rs(FILTERCONTRAINT_NAME) = Name
    rs(FILTERCONTRAINT_VALUE) = value
    rs(FILTERCONTRAINT_OPERATOR) = OpCode
    rs(FILTERCONTRAINT_VALUETYPE) = ADOValType

    rs.Update
    
End Sub

Function DirectoryExists%(path$)
    On Error GoTo Fail
    If Dir(path, vbDirectory) <> "" Then
        DirectoryExists = True
    Else
Fail:
        DirectoryExists = False
    End If
End Function

Function JobStatusID&(Name$)
    Dim temp$
    temp = LCase(Trim(Name))
    
    If temp = "running" Then
        JobStatusID = 0
    ElseIf temp = "queued" Then
        JobStatusID = 1
    ElseIf temp = "failed" Then
        JobStatusID = 2
    ElseIf temp = "cancelled" Then
        JobStatusID = 3
    ElseIf temp = "scheduled" Then
        JobStatusID = 4
    ElseIf temp = "suspended" Then
        JobStatusID = 5
    ElseIf temp = "hung" Then
        JobStatusID = 6
    Else
        JobStatusID = 1
    End If
    
End Function

Function WeekDay&(Name$)
    Dim temp$
    temp = LCase(Trim(Name))
    
    If temp = "sunday" Then
        WeekDay = 0
    ElseIf temp = "monday" Then
        WeekDay = 1
    ElseIf temp = "tuesday" Then
        WeekDay = 2
    ElseIf temp = "wednesday" Then
        WeekDay = 3
    ElseIf temp = "thursday" Then
        WeekDay = 4
    ElseIf temp = "friday" Then
        WeekDay = 5
    ElseIf temp = "saturday" Then
        WeekDay = 6
    Else
        WeekDay = -1    'any day
    End If
    
End Function
Sub Set_logupdates(value As Boolean)
    logUpdatesToFile = value
End Sub
Sub Set_logdir(value As String)
    If DirectoryExists(value) Then
        logdir = value
    Else
        MsgBox "Invalid log directory: " & value
        logfile = ""
        logdir = ""
        Exit Sub
    End If
End Sub

Sub Set_logfile(value As String)
    logfile = value
End Sub

Sub clearLog()
    Dim FileName$
    If logdir = "" Or logfile = "" Then
        Exit Sub
    End If
    
    Dim fs As FileSystemObject
    Dim ts As TextStream
    Set fs = New FileSystemObject
    FileName = WithTrailingBackslash(logdir) & logfile
    Set ts = fs.OpenTextFile(FileName, ForWriting, True)
    ts.Close
    Set ts = Nothing
End Sub

Sub LogMsg(msg$)
    If logdir = "" Or logfile = "" Then
        Exit Sub
    End If
    
    Dim FileName$
    Dim theFile%

    On Error GoTo LM_Error
    FileName = WithTrailingBackslash(logdir) & logfile
    theFile = FreeFile
    Open FileName For Append As theFile
    Write #theFile, msg
    Close theFile
    Exit Sub

LM_Error:
    'Just exit quietly.
    Exit Sub
End Sub

Function ValidateRuleValue%(FtrTypeID&, AttrID&, attrValue$, valueType&)
    
    Dim DomainID&
    Dim sql$, domainName$
    Dim rs As ADODB.Recordset
    Dim retVal%
    retVal = True
       
    If AttrID = 0 Then
        retVal = False
        GoTo VRV_Exit
    End If
    
    '===================================================
    ' 050206 RBL - handle cases where AttrValue contains
    ' an apostrophe
    Dim tempAttrValue$
    tempAttrValue = attrValue
    DealWithApostrophes tempAttrValue
    '===================================================
    
    sql = "select " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_NAME & _
            ", " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_ID & _
            ", " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_VALUETYPE & _
            " from " & ATTRDOMAIN_TBLNAME & ", " & FEATUREATTR_TBLNAME & _
            " where " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_ID & " = " & _
            FEATUREATTR_TBLNAME & "." & FEATUREATTR_ATTRDOMAINID & _
            " and " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_ID & " = " & CStr(AttrID)
    
    Set rs = Conn.Execute(sql, , adCmdText)
    
    If rs.BOF And rs.EOF Then
        valueType = NULL_LONG
        retVal = False
        GoTo VRV_Exit
    End If
    DomainID = rs(ATTRDOMAIN_ID)
    domainName = rs(ATTRDOMAIN_NAME)
    valueType = rs(ATTRDOMAIN_VALUETYPE)
    
    rs.Close
    
    If (InStr(1, StandardDomains, domainName, 1) = 0) Then
    
        sql = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " from " & _
                ATTRLEGALVALUE_TBLNAME & ", " & _
                ATTRLEGALVALUEASSIGN_TBLNAME & " where " & _
                ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_DOMAINID & _
                " = " & CStr(DomainID) & _
                " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_LEGALVALUEID & _
                " = " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " and (" & _
                ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_VALUE & " = '" & tempAttrValue & "')"
                'or " & _
                'ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ALTERNATEVALUE & " = '" & AttrValue & "')"
    
        Set rs = Conn.Execute(sql, , adCmdText)
        
        If rs.BOF And rs.EOF Then
'            MsgBox "'" & AttrValue & "' is not a legal value " & vbCrLf & _
'                        "for attribute '" & AttrName & "'", vbOKOnly, "Invalid Value"
            retVal = False
        End If
        
    End If
    
VRV_Exit:
    ValidateRuleValue = retVal

End Function

Function AttributeValueType&(FtrTypeID&, AttrID&)
    
    Dim DomainID&
    Dim sql$, domainName$
    Dim rs As ADODB.Recordset
    Dim retVal%
    
    retVal = True
    
    sql = "select " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_VALUETYPE & _
            " from " & ATTRDOMAIN_TBLNAME & ", " & FEATUREATTR_TBLNAME & _
            " where " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_ID & " = " & _
            FEATUREATTR_TBLNAME & "." & FEATUREATTR_ATTRDOMAINID & _
            " and " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_ID & " = " & CStr(AttrID)
    
    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        AttributeValueType = NULL_LONG
        'Err.Raise vbObjectError + 27, , "No Attribute Domain Found"
    Else
        AttributeValueType = rs(ATTRDOMAIN_VALUETYPE)
    End If
    rs.Close


End Function
Function WithTrailingBackslash$(ByVal aString)

    If Right$(aString, 1) <> "\" Then
        WithTrailingBackslash = aString & "\"
    Else
        WithTrailingBackslash = aString
    End If
End Function
Function ConductorCharacteristicID&(LineType&, PhaseCondMaterial$, PhaseCondSize$, _
                                                        NeutCondMaterial$, NeutCondSize$, NumPhases&)

    Dim PhaseCondMatID&, PhaseCondSizeID&, NeutCondMatID&, NeutCondSizeID&
    Dim sql$
    Dim rs As ADODB.Recordset

    PhaseCondMatID = EARatingID(PhaseCondMaterial, EARating_PhaseConductorMaterial)
    PhaseCondSizeID = EARatingID(PhaseCondSize, EARating_PhaseConductorSize)
    NeutCondMatID = EARatingID(NeutCondMaterial, EARating_NeutralConductorMaterial)
    NeutCondSizeID = EARatingID(NeutCondSize, EARating_NeutralConductorSize)
    
    sql = "select " & CONDCHAR_ID & " from " & CONDCHAR_TABLENAME & " where " & _
                CONDCHAR_LINETYPE & " = " & LineType & " and " & _
                CONDCHAR_NOOFPHASES & " = " & NumPhases & " and " & _
                CONDCHAR_PHASECONDUCTORMATERIALEARID & " = " & PhaseCondMatID & " and " & _
                CONDCHAR_PHASECONDUCTORSIZEEARID & " = " & PhaseCondSizeID & " and "
                'Check if CONDCHAR_NEUTRALCONDUCTORMATERIALEARID is null, and formulate the sql accordingly
                If (NeutCondMatID = NULL_LONG) Then
                    sql = sql & CONDCHAR_NEUTRALCONDUCTORMATERIALEARID & " is null and "
                Else
                    sql = sql & CONDCHAR_NEUTRALCONDUCTORMATERIALEARID & " = " & NeutCondMatID & " and "
                End If
                'Check if CONDCHAR_PHASECONDUCTORSIZEEARID is null, and formulate the sql accordingly
                If (NeutCondSizeID = NULL_LONG) Then
                 sql = sql & CONDCHAR_NEUTRALCONDUCTORSIZEEARID & " is null "
                Else
                    sql = sql & CONDCHAR_NEUTRALCONDUCTORSIZEEARID & " = " & NeutCondSizeID
                End If
        

    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        Err.Raise vbObjectError + 27, , "No Conductor Characteristic Found"
    Else
       ConductorCharacteristicID = rs(CONDCHAR_ID)
    End If

End Function

Function DistTransCharacteristicID&(TransformerType&, UnitKVASize$, _
                                        SecondaryVoltage$, NumUnits&, BankKVASize$)

    Dim UnitKvaSizeID&, SecondaryVoltageID&, BankKvaSizeID&
    Dim sql$
    Dim rs As ADODB.Recordset

    UnitKvaSizeID = EARatingID(UnitKVASize, EARating_DistTransformerKVA)
    SecondaryVoltageID = EARatingID(SecondaryVoltage, EARating_SecondaryVoltage)
    BankKvaSizeID = EARatingID(BankKVASize, EARating_DistTransformerKVA)
    
    sql = "select " & DISTTRANCHAR_ID & " from " & DISTTRANCHAR_TABLENAME & " where " & _
                DISTTRANCHAR_TRANSFORMERTYPE & " = " & TransformerType & " and " & _
                DISTTRANCHAR_NUMBEROFUNITS & " = " & NumUnits & " and " & _
                DISTTRANCHAR_UNITKVASIZEEARID & " = " & UnitKvaSizeID & " and " & _
                DISTTRANCHAR_SECONDARYVOLTAGEEARID & " = " & SecondaryVoltageID & " and " & _
                DISTTRANCHAR_BANKKVASIZEEARID & " = " & BankKvaSizeID

    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        Err.Raise vbObjectError + 27, , "No Distribution Transformer Characteristic Found"
    Else
       DistTransCharacteristicID = rs(DISTTRANCHAR_ID)
    End If

End Function

Function VoltageRegCharacteristicID&(LoadCurrent&, RegulationRange&, RatedKVASize$, _
                                                            RatedVoltage$, NumPhases&)

    Dim RatedKVASizeID&, RatedVoltageID&
    Dim sql$
    Dim rs As ADODB.Recordset

    'Don't know how the EARating types match up, but this is what I was told...
    RatedKVASizeID = EARatingID(RatedKVASize, EARating_PowerTransformerKVA)
    RatedVoltageID = EARatingID(RatedVoltage, EARating_PrimaryVoltage)
    
    sql = "select " & VOLTREGCHAR_ID & " from " & VOLTREGCHAR_TABLENAME & " where " & _
                VOLTREGCHAR_REGULATIONRANGE & " = " & RegulationRange & " and " & _
                VOLTREGCHAR_LOADCURRENT & " = " & LoadCurrent & " and " & _
                VOLTREGCHAR_NOOFPHASES & " = " & NumPhases & " and " & _
                VOLTREGCHAR_RATEKVASIZEEARID & " = " & RatedKVASizeID & " and " & _
                VOLTREGCHAR_RATEDVOLTAGEEARID & " = " & RatedVoltageID

    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        Err.Raise vbObjectError + 27, , "No Voltage Regulator Characteristic Found"
    Else
       VoltageRegCharacteristicID = rs(VOLTREGCHAR_ID)
    End If

End Function

Function PowerTransCharacteristicID&(MinTapSetting#, MaxTapSetting#, RatedKVASize$, _
                                                            PrimaryVoltage$, SecondaryVoltage$, NumPhases&)

    Dim RatedKVASizeID&, PrimaryVoltageID&, SecondaryVoltageID&
    Dim sql$
    Dim rs As ADODB.Recordset

    'Don't know how the EARating types match up, but this is what I was told...
    RatedKVASizeID = EARatingID(RatedKVASize, EARating_PowerTransformerKVA)
    PrimaryVoltageID = EARatingID(PrimaryVoltage, EARating_PrimaryVoltage)
    SecondaryVoltageID = EARatingID(SecondaryVoltage, EARating_PrimaryVoltage)
    
    sql = "select " & POWERTRANCHAR_ID & " from " & POWERTRANCHAR_TABLENAME & " where " & _
                POWERTRANCHAR_MINTAPSETTING & " = " & MinTapSetting & " and " & _
                POWERTRANCHAR_MAXTAPSETTING & " = " & MaxTapSetting & " and " & _
                POWERTRANCHAR_NOOFPHASES & " = " & NumPhases & " and " & _
                POWERTRANCHAR_RATEDKVASIZEEARID & " = " & RatedKVASizeID & " and " & _
                POWERTRANCHAR_NOMINALSECONDARYVOLTAGEEARID & " = " & SecondaryVoltageID & " and " & _
                POWERTRANCHAR_NOMINALPRIMARYVOLTAGEEARID & " = " & PrimaryVoltageID

    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        Err.Raise vbObjectError + 27, , "No Power Transformer Characteristic Found"
    Else
       PowerTransCharacteristicID = rs(POWERTRANCHAR_ID)
    End If

End Function
Sub DealWithApostrophes(str$)
    Dim pos%, newpos%
    Dim apostrophe$
    apostrophe = "'"
    pos = 0
    pos = InStr(str, apostrophe)
    Do While pos > 0
        str = Left(str, pos - 1) & "''" & Mid(str, pos + 1)
        newpos = InStr(pos + 2, str, apostrophe)
        pos = newpos
    Loop
End Sub

Private Sub DeleteCuUnitRules()
    Dim MySql As String
    Dim rs As Recordset
    
    MySql = "select * from " & ATTRRULE_TBLNAME & _
            " where " & ATTRRULE_CATEGORY & " = " & ATTRRULE_UNIT
            
    Set rs = Conn.Execute(MySql)
    Do While rs.EOF <> True
        Dim AttrRuleId As Long
        
        AttrRuleId = rs.Fields.Item(ATTRRULE_ID).value
        
        MySql = "Delete from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_ATTRRULEID & " = " & AttrRuleId
        
        Conn.Execute (MySql)
        
        MySql = "Delete from " & ATTRRULE_TBLNAME & _
                " where " & ATTRRULE_ID & " = " & AttrRuleId
        
        Conn.Execute (MySql)
        
        rs.MoveNext
        
    Loop
        
    rs.Close
    
End Sub

Private Sub DeleteCustomWREvents()
    Dim MySql$
    Dim MaxCoreID&
    MaxCoreID = 99
    
    MySql = "delete from " & WREVENT_TBLNAME & _
            " where " & WREVENT_ID & " > " & CStr(MaxCoreID)
            
    Conn.Execute (MySql)
    
End Sub
Private Sub DeleteEARules()
    Dim MySql$
    Dim rs As Recordset
    Dim AttrRuleId&
    
    MySql = "select * from " & ATTRRULE_TBLNAME & _
            " where " & ATTRRULE_CATEGORY & " = " & ATTRRULE_ANALYSIS
            
    Set rs = Conn.Execute(MySql)
    Do While rs.EOF <> True
        
        
        AttrRuleId = rs.Fields.Item(ATTRRULE_ID).value
        
        MySql = "Delete from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_ATTRRULEID & " = " & AttrRuleId
        
        Conn.Execute (MySql)
        
        MySql = "Delete from " & ATTRRULE_TBLNAME & _
                " where " & ATTRRULE_ID & " = " & AttrRuleId
        
        Conn.Execute (MySql)
        
        rs.MoveNext
        
    Loop
        
    rs.Close
    
End Sub
Function AllowedAccessValue&(str$)
    Dim val&
    Dim temp$
    temp = Trim(UCase(str))
    val = 2
    If temp = "NONE" Then
       val = 0
    ElseIf temp = "READ ONLY" Then
        val = 1
    ElseIf temp = "READ WRITE" Then
        val = 2
    ElseIf temp = "MANDATORY" Then
        val = 3
    End If
    
    AllowedAccessValue = val
        
End Function

Function GetPAAssignmentType&(str$)
    Dim val&
    Dim temp$
    temp = Trim(UCase(str))
    val = 2
    If temp = "INSTALL" Then
       val = 0
    ElseIf temp = "TRANSFER" Then
        val = 1
    ElseIf temp = "REMOVE" Then
        val = 2
    End If
    GetPAAssignmentType = val
        
End Function

Function CreateRuleset&(ComponentTypeId&, Violation$, Enabled%, RuleType%)
    
    Dim rs As New ADODB.Recordset
    Dim sql$, temp$
    Dim ID&, VIOLATIONID&
    
    temp = Violation
    DealWithApostrophes temp
    sql = "select * from " & VIOLATION_TBLNAME & " where " & VIOLATION_MESSAGE & _
            " = '" & temp & "'"
    rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
    If (rs.BOF And rs.EOF) Then
        VIOLATIONID = NextPK(VIOLATION_TBLNAME, VIOLATION_ID)
        If VIOLATIONID < 10 Then VIOLATIONID = 10
        rs.AddNew
        rs(VIOLATION_ID) = VIOLATIONID
        rs(VIOLATION_MESSAGE) = Violation
        rs.Update
    Else
        VIOLATIONID = rs(VIOLATION_ID)
    End If
    rs.Close
    
    ID = NextPK(RULESET_TBLNAME, RULESET_ID)
    sql = "select * from " & RULESET_TBLNAME & " where " & RULESET_ID & " = -1"
    rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
    rs.AddNew
    rs(RULESET_ID) = ID
    rs(RULESET_VIOLATIONID) = VIOLATIONID
    rs(RULESET_COMPTYPEID) = ComponentTypeId
    rs(RULESET_ISENABLED) = Enabled
    rs(RULESET_RULETYPE) = RuleType
    rs.Update
    rs.Close
    CreateRuleset = ID
    
End Function

Function GeomCategoryValue&(str$)
    Dim val&
    Dim temp$
    temp = Trim(UCase(str))
    val = 0
    If temp = "NORMAL" Then
       val = 0
    ElseIf temp = "NETWORK" Then
        val = 1
    ElseIf temp = "ANNOTATION" Then
        val = 2
    End If
    
    GeomCategoryValue = val
End Function


Function GetCurrentUser$()
    Dim rs As ADODB.Recordset
    Dim USERNAME$, sql$
    USERNAME = Environ("UserName")
    sql = "select * from UserLogin where UserLogin.UserName = '" & USERNAME & "'"
    
    Set rs = Conn.Execute(sql)
    If (Not (rs.BOF And rs.EOF)) Then
        CurrentUserID = rs!ID
    Else
        CurrentUserID = 0   'Default to something - 0 is EnterpriseUser
    End If
    rs.Close
    GetCurrentUser = USERNAME
End Function
Function CreateRule&(RuleSetID&, RuleType&, Name$, Enabled%, IsPropagate%)
    Dim rs As New Recordset
    Dim ID&
    Dim sql$
    
    ID = NextPK(RULE_TBLNAME, RULE_ID)

    If IsSQLSERVER Then
        sql = "select * from [" & RULE_TBLNAME & "] where " & RULE_ID & " = -1"
    Else
        sql = "select * from " & RULE_TBLNAME & " where " & RULE_ID & " = -1"
    End If
    
    rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText

    rs.AddNew
    rs(RULE_ID) = ID
    rs(RULE_ISENABLED) = Enabled
    rs(RULE_RULESETID) = RuleSetID
    rs(RULE_NAME) = Name
    rs(RULE_CATEGORY) = 0
    rs(RULE_TYPE) = RuleType
    rs(RULE_ISPROPAGATION) = IsPropagate
    rs.Update
    rs.Close

    CreateRule = ID

End Function

Function AttributeRuleIdFromFtrTblAndCuId&(FtrTblName$, CompUnit$, CCName$, AddNew%, Optional ds As String)
    Dim rs As ADODB.Recordset
    Dim qrystr$
    Dim CompUnitID&, FtrTypeID&, CCID&, ID&
    Dim CreateNew%
    
    CompUnitID = CUID(Trim(CompUnit))
    If ds <> "" Then
        FtrTypeID = FeatureTypeID(FtrTblName, ds)
    Else
        FtrTypeID = FeatureTypeID(FtrTblName)
    End If
    CCID = ClassCodeId(CCName)
    
    If CompUnitID = 0 Or FtrTypeID = 0 Then GoTo ARID_Error
    
    If Not AddNew Then
        qrystr = "select Max(" & ATTRRULE_ID & ") as " & ATTRRULE_ID & " from " & ATTRRULE_TBLNAME & _
                    " where " & ATTRRULE_VALUE & " = " & CompUnitID & " And " & _
                    ATTRRULE_FTRTYPEID & " = " & FtrTypeID
        Set rs = Conn.Execute(qrystr)
        If rs.EOF And rs.BOF Then
            CreateNew = True
        Else
            AttributeRuleIdFromFtrTblAndCuId = rs.Fields.Item(ATTRRULE_ID).value
            CreateNew = False
        End If
        rs.Close
    Else
        CreateNew = True
    End If

   
    If CreateNew Then
        Dim rs1 As New ADODB.Recordset
        qrystr = "select * from " & ATTRRULE_TBLNAME & " where " & ATTRRULE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(ATTRRULE_TBLNAME, ATTRRULE_ID)
        rs1.Fields.Item(ATTRRULE_ID).value = ID
        rs1.Fields.Item(ATTRRULE_VALUE).value = CompUnitID
        rs1.Fields.Item(ATTRRULE_FTRTYPEID).value = FtrTypeID
        rs1.Fields.Item(ATTRRULE_VALUETYPE).value = 203
        rs1.Fields.Item(ATTRRULE_CATEGORY).value = ATTRRULE_UNIT
        rs1.Fields.Item(ATTRRULE_PRIORITY).value = 1
        If CCID <> 0 Then rs1.Fields.Item(ATTRRULE_CLASSCODEID).value = CCID
        
        rs1.Update
        rs1.Close
        AttributeRuleIdFromFtrTblAndCuId = ID
    End If
    Exit Function
ARID_Error:
    AttributeRuleIdFromFtrTblAndCuId = 0
End Function

Function AttributeRuleIdFromFtrTypeAndCuId&(FtrTypeID&, CompUnitID&, CCID&, AddNew%, Quantity&)
    Dim rs As ADODB.Recordset
    Dim qrystr$
    Dim ID&
    Dim CreateNew%
     
    If CompUnitID = 0 Or FtrTypeID = 0 Then GoTo ARID_Error
    
    If Not AddNew Then
        qrystr = "select Max(" & ATTRRULE_ID & ") as " & ATTRRULE_ID & " from " & ATTRRULE_TBLNAME & _
                    " where " & ATTRRULE_VALUE & " = " & CompUnitID & " And " & _
                    ATTRRULE_FTRTYPEID & " = " & FtrTypeID
        Set rs = Conn.Execute(qrystr)
        If rs.EOF And rs.BOF Then
            CreateNew = True
        Else
            AttributeRuleIdFromFtrTypeAndCuId = rs.Fields.Item(ATTRRULE_ID).value
            CreateNew = False
        End If
        rs.Close
    Else
        CreateNew = True
    End If

   
    If CreateNew Then
        Dim rs1 As New ADODB.Recordset
        qrystr = "select * from " & ATTRRULE_TBLNAME & " where " & ATTRRULE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(ATTRRULE_TBLNAME, ATTRRULE_ID)
        rs1.Fields.Item(ATTRRULE_ID).value = ID
        rs1.Fields.Item(ATTRRULE_VALUE).value = CompUnitID
        rs1.Fields.Item(ATTRRULE_FTRTYPEID).value = FtrTypeID
        rs1.Fields.Item(ATTRRULE_VALUETYPE).value = 203
        rs1.Fields.Item(ATTRRULE_CATEGORY).value = ATTRRULE_UNIT
        rs1.Fields.Item(ATTRRULE_PRIORITY).value = 1
        If CCID <> 0 Then rs1.Fields.Item(ATTRRULE_CLASSCODEID).value = CCID
        If Quantity <> 0 Then rs1.Fields.Item(ATTRRULE_QUANTITY).value = Quantity
        
        rs1.Update
        rs1.Close
        AttributeRuleIdFromFtrTypeAndCuId = ID
    End If
    Exit Function
ARID_Error:
    AttributeRuleIdFromFtrTypeAndCuId = NULL_LONG
End Function

Function EAAttributeRuleID&(ftrName$, CharacteristicID&, AddNew%, Optional ds As String)
    Dim rs As ADODB.Recordset
    Dim sql$
    Dim FtrTypeID&, ID&
    Dim CreateNew%
    
    If ds <> "" Then
        FtrTypeID = FeatureTypeID(ftrName, ds)
    Else
        FtrTypeID = FeatureTypeID(ftrName)
    End If
    
    If Not AddNew Then
        sql = "select Max(" & ATTRRULE_ID & ") as " & ATTRRULE_ID & " from " & ATTRRULE_TBLNAME & " where " & _
                        ATTRRULE_VALUE & " = " & CharacteristicID & " And " & ATTRRULE_FTRTYPEID & " = " & FtrTypeID
        Set rs = Conn.Execute(sql)
        If rs.EOF And rs.BOF Then
           CreateNew = True
        Else
            EAAttributeRuleID = rs(ATTRRULE_ID)
            CreateNew = False
        End If
        rs.Close
    Else
        CreateNew = True
    End If
    
    If CreateNew Then
         Dim rs1 As New ADODB.Recordset
         sql = "select * from " & ATTRRULE_TBLNAME & " where " & ATTRRULE_ID & " = -1"
         rs1.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
         rs1.AddNew
         ID = NextPK(ATTRRULE_TBLNAME, ATTRRULE_ID)
         rs1.Fields.Item(ATTRRULE_ID).value = ID
         rs1.Fields.Item(ATTRRULE_VALUE).value = CharacteristicID
         rs1.Fields.Item(ATTRRULE_FTRTYPEID).value = FtrTypeID
         rs1.Fields.Item(ATTRRULE_VALUETYPE).value = 3
         rs1.Fields.Item(ATTRRULE_CATEGORY).value = ATTRRULE_ANALYSIS
         rs1.Fields.Item(ATTRRULE_PRIORITY).value = 1
         rs1.Update
         rs1.Close
         EAAttributeRuleID = ID
    End If
    
End Function
Function FeatureStateId(FtrState As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim ID&
    
    qrystr = "select " & FTRSTATE_ID & " from " & FTRSTATE_TBLNAME & " where " & _
                    FTRSTATE_NAME & " = '" & FtrState & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New Recordset
        rs1.Open FTRSTATE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
        rs1.AddNew
        ID = NextPK(FTRSTATE_TBLNAME, FTRSTATE_ID)
        rs1.Fields.Item(FTRSTATE_ID).value = ID
        rs1.Fields.Item(FTRSTATE_NAME).value = FtrState
        rs1.Fields.Item(FTRSTATE_EXTNAME).value = FtrState
        rs1.Fields.Item(FTRSTATE_ATTRLGLVLU).value = LegalValueId(FtrState, False)
        rs1.Update
        rs1.Close

        FeatureStateId = ID
    Else
        FeatureStateId = rs.Fields.Item(FTRSTATE_ID).value
    End If

    rs.Close
    
End Function

Function FeatureStateIdFromExternalName&(ExternalName$)
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & FTRSTATE_ID & " from " & FTRSTATE_TBLNAME & " where " & _
                    FTRSTATE_EXTNAME & " = '" & ExternalName & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        FeatureStateIdFromExternalName = NULL_LONG
    Else
        FeatureStateIdFromExternalName = rs.Fields.Item(FTRSTATE_ID).value
    End If

    rs.Close
    
End Function
'Returns the ID of the fixed feature states, based upon their internal name.
'Returns NULL_LONG if this is not a fixed state.
Function FixedFeatureStateID(FtrState$) As Long

    Dim temp$
    temp = Trim(UCase(FtrState))
    If temp = "PROPOSED INSTALL" Then
        FixedFeatureStateID = 1
    ElseIf temp = "IN-SERVICE" Then
        FixedFeatureStateID = 2
    ElseIf temp = "PROPOSED REMOVE" Then
        FixedFeatureStateID = 3
    ElseIf temp = "PROPOSED TRANSFER" Then
        FixedFeatureStateID = 4
    ElseIf temp = "ABANDONED" Then
        FixedFeatureStateID = 5
    Else
        FixedFeatureStateID = NULL_LONG
    End If
    
End Function
Function CUID(CUCuId As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    Dim ID&
    
    If CUs Is Nothing Then
        Set CUs = New Collection
        GoTo not_in_CU_collection
    End If
    
    On Error GoTo not_in_CU_collection
    ID = CUs.Item(CUCuId)
    On Error GoTo 0
    
    CUID = ID
    Exit Function
    
not_in_CU_collection:

    temp = CUCuId
    DealWithApostrophes temp
    
    qrystr = "select " & CU_ID & " from " & CU_TBLNAME & " where " & CU_CUID & _
            " = '" & temp & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ID = 0
    Else
        ID = rs.Fields.Item(CU_ID).value
    End If

    rs.Close
    
    CUs.Add ID, CUCuId
    CUID = ID
    
End Function
Function CustomCostTypeID&(TypeName$)
    Dim rs As ADODB.Recordset
    Dim qrystr As String
    
    qrystr = "select " & CUSTOMCOSTTYPE_ID & " from " & CUSTOMCOSTTYPE_TBLNAME & _
                    " where " & CUSTOMCOSTTYPE_NAME & " = '" & TypeName & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        CustomCostTypeID = 0
    Else
        CustomCostTypeID = rs.Fields.Item(CUSTOMCOSTTYPE_ID).value
    End If

    rs.Close
    
End Function
Function GetPlantAccountID&(PAName$)
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & PLANTACCOUNT_ID & " from " & PLANTACCOUNT_TBLNAME & _
                    " where " & PLANTACCOUNT_NAME & " = '" & PAName & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        GetPlantAccountID = 0
    Else
        GetPlantAccountID = rs.Fields.Item(PLANTACCOUNT_ID).value
    End If

    rs.Close
    
End Function
Function MIID(MIMiId As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & MI_ID & " from " & MI_TBLNAME & " where " & MI_MIID & " = '" & MIMiId & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        MIID = 0
    Else
        MIID = rs.Fields.Item(MI_ID).value
    End If

    rs.Close
    
End Function
Function OperatorValue$(Operator$, LimitValues%)
    Dim val$
    Dim OperatorSymbol$
    Dim symbolStr As String
    
    symbolStr = "= <> ++ != < <= > >= ( > (= )="
    val = ""
    OperatorSymbol = Trim(LCase(Operator))
    
    If InStr(symbolStr, OperatorSymbol) > 0 Then
        'If operator passed in is already a symbol,
        'then return it
        OperatorValue = OperatorSymbol
    Else
        'Operator passed in is in string format
        'compare and return the corresponding symbol
        If OperatorSymbol = "equal to" Then
            val = "="
        ElseIf OperatorSymbol = "not equal to" Then
            val = "<>"
        ElseIf OperatorSymbol = "c equal to" Then
            val = "=="
        ElseIf OperatorSymbol = "c not equal to" Then
            val = "!="
        ElseIf OperatorSymbol = "less than" Then
            val = "<"
        ElseIf OperatorSymbol = "less than or equal to" Then
            val = "<="
        ElseIf OperatorSymbol = "greater than" Then
            val = ">"
        ElseIf OperatorSymbol = "greater than or equal to" Then
            val = ">="
        ElseIf Not LimitValues Then
            If OperatorSymbol = "contains" Then
                val = "("
            ElseIf OperatorSymbol = "contained in" Then
                val = ")"
            ElseIf OperatorSymbol = "strictly contains" Then
                val = "(="
            ElseIf OperatorSymbol = "strictly contained in" Then
                val = ")="
            End If
        End If
        
        OperatorValue = val
    End If
    
End Function

Function OperatorCode&(OperatorName$)
    Dim val&
    Dim OperatorSymbol$
    val = 0
    OperatorSymbol = Trim(LCase(OperatorName))
    
    If (OperatorSymbol = "equal to") Or (OperatorSymbol = "=") _
        Or (OperatorSymbol = "==") Or (OperatorSymbol = "equals") Then
            val = 0
    ElseIf (OperatorSymbol = "not equal to") Or (OperatorSymbol = "<>") _
        Or (OperatorSymbol = "!=") Or (OperatorSymbol = "not equal") Then
            val = 1
    ElseIf (OperatorSymbol = "less than") Or (OperatorSymbol = "<") Then
        val = 2
    ElseIf (OperatorSymbol = "less than or equal to") Or (OperatorSymbol = "<=") Then
        val = 3
    ElseIf (OperatorSymbol = "greater than") Or (OperatorSymbol = ">") Then
        val = 4
    ElseIf (OperatorSymbol = "greater than or equal to") Or (OperatorSymbol = ">=") Then
        val = 5
    ElseIf (OperatorSymbol = "contains") Or (OperatorSymbol = "(") Then
        val = 6
    ElseIf (OperatorSymbol = "contained in") Or (OperatorSymbol = ")") Then
        val = 7
    ElseIf (OperatorSymbol = "strictly contains") Or (OperatorSymbol = "(=") Then
        val = 8
    ElseIf (OperatorSymbol = "strictly contained in") Or (OperatorSymbol = ")=") Then
        val = 9
    End If
  
    OperatorCode = val
    
End Function
Function UserIDForName&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$
    
    sql = "select " & USER_ID & " from " & USER_TBLNAME & " where " & USER_USERNAME & " = '" & LCase(Name) & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        UserIDForName = rs(USER_ID)
    End If
    
End Function

Function WRState&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$
    
    sql = "select " & WRSTATE_ID & " from " & WRSTATE_TBLNAME & " where " & _
            WRSTATE_NAME & " = '" & Name & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        WRState = rs(WRSTATE_ID)
    Else
        WRState = 0
    End If
    
End Function
Function WorkFlowID&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$
    
    sql = "select " & WORKFLOW_ID & " from " & WORKFLOW_TBLNAME & " where " & _
            WORKFLOW_NAME & " = '" & Name & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        WorkFlowID = rs(WORKFLOW_ID)
    Else
        WorkFlowID = 0
    End If
    
End Function
Function WREvent&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$
    
    sql = "select " & WREVENT_ID & " from " & WREVENT_TBLNAME & " where " & _
            WREVENT_NAME & " = '" & Name & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        WREvent = rs(WREVENT_ID)
    Else
        WREvent = 0
    End If
    
End Function

Function WRAction&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$
    
    sql = "select " & WRACTION_ID & " from " & WRACTION_TBLNAME & " where " & _
                    WRACTION_NAME & " = '" & Name & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        WRAction = rs(WRACTION_ID)
    Else
        WRAction = 0
    End If
    
End Function

Function ReportContext&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$, temp$
    temp = Trim(UCase(Name))
  
    If temp = "WORK REQUEST" Then
        ReportContext = 2
    ElseIf temp = "WORKREQUEST" Then
        ReportContext = 2
    ElseIf temp = "DESIGN" Then
        ReportContext = 3
    ElseIf temp = "COMPATIBLE UNIT" Then
        ReportContext = 4
    ElseIf temp = "CU" Then
        ReportContext = 4
    ElseIf temp = "UNIT" Then
        ReportContext = 4
    ElseIf temp = "USER" Then
        ReportContext = 5
    ElseIf temp = "MASTER PLAN" Then
        ReportContext = 6
    ElseIf temp = "PLAN" Then
        ReportContext = 7
    Else
        ReportContext = 1
    End If
    
End Function
Function GroupIDForName&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$, temp$
    temp = Name
    DealWithApostrophes temp
    sql = "select " & GROUP_ID & " from " & GROUP_TBLNAME & " where " & GROUP_NAME & " = '" & temp & "'"
    
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        GroupIDForName = rs(GROUP_ID)
    End If
    
End Function
Function CapabilityIDForName&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$, temp$
    
    sql = "select " & CAPABILITY_ID & " from " & CAPABILITY_TBLNAME & " where " & _
                            CAPABILITY_NAME & " = '" & Name & "'"
                            
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        CapabilityIDForName = rs(CAPABILITY_ID)
    End If
    
End Function

Function EAElementTypeID&(ClassID&)
    Dim rs As Recordset
    Dim sql As String
    
    sql = "select " & EAELEMTYPE_ID & " from " & EAELEMTYPE_TABLENAME & _
            " where " & EAELEMTYPE_CLASSIFICATIONTYPEID & " = " & CStr(ClassID)
    Set rs = Conn.Execute(sql)
    
    If rs.EOF And rs.BOF Then
        EAElementTypeID = 0
    Else
        EAElementTypeID = rs.Fields.Item(EAELEMTYPE_ID).value
    End If

    rs.Close
    
End Function

Function EAAttrDomainID&(AttrDomainName$)
    Dim rs As Recordset
    Dim sql$
    Dim AttrDomID&
    
    AttrDomID = AttributeDomainId(AttrDomainName)
    
    sql = "select " & EAELEMATTRDOMAIN_ID & " from " & EAELEMATTRDOMAIN_TABLENAME & _
            " where " & EAELEMATTRDOMAIN_ATTRIBUTEDOMAINID & " = " & CStr(AttrDomID)
            
    Set rs = Conn.Execute(sql)
    
    If rs.EOF And rs.BOF Then
        Err.Raise vbObjectError + 27, , "No EAAttribute Domain found"
    Else
        EAAttrDomainID = rs.Fields.Item(EAELEMATTRDOMAIN_ID).value
    End If

    rs.Close
    
End Function
Function ClassificationID(ClassificationName As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    temp = ClassificationName
    DealWithApostrophes temp
    qrystr = "select " & CLASSTYPE_ID & " from " & CLASSTYPE_TBLNAME & " where " & CLASSTYPE_NAME & _
                    " = '" & temp & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ClassificationID = 0
    Else
        ClassificationID = rs.Fields.Item(CLASSTYPE_ID).value
    End If

    rs.Close
    
End Function
Function ConfigSettingID&(ConfigName$)
    Dim rs As Recordset
    Dim qrystr$, temp$
    temp = ConfigName
    DealWithApostrophes temp
    qrystr = "select " & CONFIGSETTING_ID & " from " & CONFIGSETTING_TBLNAME & " where " & _
                    CONFIGSETTING_NAME & " = '" & temp & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ConfigSettingID = NULL_LONG
    Else
        ConfigSettingID = rs.Fields.Item(CONFIGSETTING_ID).value
    End If

    rs.Close
    
End Function
Function RuleTypeId(RuleType As String) As Long
    Dim RuleTypeName$
    RuleTypeName = Trim(LCase(RuleType))
    If RuleTypeName = "allowed connection" Then
        RuleTypeId = 0
    ElseIf RuleTypeName = "allowed relation" Then
        RuleTypeId = 1
    Else
        RuleTypeId = 2
    End If
End Function
Function ServiceClassification&(ClassName$)
    Dim Name$
    Name = UCase(ClassName)
    If Name = "RESIDENTIAL CLASS 1" Or Name = "RESIDENTIAL - CLASS 1" Then
        ServiceClassification = 1
    ElseIf Name = "RESIDENTIAL CLASS 2" Or Name = "RESIDENTIAL - CLASS 2" Then
        ServiceClassification = 2
    ElseIf Name = "RESIDENTIAL CLASS 3" Or Name = "RESIDENTIAL - CLASS 3" Then
        ServiceClassification = 3
    ElseIf Name = "COMMERCIAL CLASS 1" Or Name = "COMMERCIAL - CLASS 1" Then
        ServiceClassification = 4
    ElseIf Name = "COMMERCIAL CLASS 2" Or Name = "COMMERCIAL - CLASS 2" Then
        ServiceClassification = 5
    ElseIf Name = "COMMERCIAL CLASS 3" Or Name = "COMMERCIAL - CLASS 3" Then
        ServiceClassification = 6
    ElseIf Name = "INDUSTRIAL CLASS 1" Or Name = "INDUSTRIAL - CLASS 1" Then
        ServiceClassification = 7
    ElseIf Name = "INDUSTRIAL CLASS 2" Or Name = "INDUSTRIAL - CLASS 2" Then
        ServiceClassification = 8
    Else
        ServiceClassification = 9
    End If
End Function
Function RuleViolationId(ViolationString As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim ID&
    Dim temp$
    temp = ViolationString
    DealWithApostrophes temp
    qrystr = "select " & VIOLATION_ID & " from " & VIOLATION_TBLNAME & " where " & _
                    VIOLATION_MESSAGE & " = '" & temp & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New Recordset
        qrystr = "select * from " & VIOLATION_TBLNAME & " where " & VIOLATION_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(VIOLATION_TBLNAME, VIOLATION_ID)
        rs1.Fields.Item(VIOLATION_ID).value = ID
        rs1.Fields.Item(VIOLATION_MESSAGE).value = ViolationString
        
        rs1.Update

        RuleViolationId = ID
    Else
        RuleViolationId = rs.Fields.Item(VIOLATION_ID).value
    End If
    
    rs.Close
    
End Function
Function ComponentTypeIdForAllowedConn(FtrTypeID As Long, ComponentType As Long) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim ID&
            
    qrystr = "select " & COMPTYPE_ID & " from " & COMPTYPE_TBLNAME & " where " & _
                    COMPTYPE_FTRTYPEID & " = '" & FtrTypeID & "' and " & COMPTYPE_COMPTYPE & " = " & ComponentType
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New Recordset
        qrystr = "select * from " & COMPTYPE_TBLNAME & " where " & COMPTYPE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(COMPTYPE_TBLNAME, COMPTYPE_ID)
        rs1.Fields.Item(COMPTYPE_ID).value = ID
        rs1.Fields.Item(COMPTYPE_NAME).value = FeatureTypeName(FtrTypeID)
        rs1.Fields.Item(COMPTYPE_ISDEVICE).value = -1
        rs1.Fields.Item(COMPTYPE_PORTCOUNT).value = 2
        rs1.Fields.Item(COMPTYPE_RQDCONNS).value = 2
        rs1.Fields.Item(COMPTYPE_COMPTYPE).value = ComponentType
        rs1.Fields.Item(COMPTYPE_FTRTYPEID).value = FtrTypeID
        
        rs1.Update
        
        ComponentTypeIdForAllowedConn = ID
    Else
        ComponentTypeIdForAllowedConn = rs.Fields.Item(COMPTYPE_ID).value
    End If
    
    rs.Close
    
End Function
Function RulesetIdForAllowedConn(FtrTypeID As Long, ComponentType As Long, ViolationString As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim CompTypeID&, RuleVioId&, ID&
    
    CompTypeID = ComponentTypeIdForAllowedConn(FtrTypeID, ComponentType)
    RuleVioId = RuleViolationId(ViolationString)
    
    qrystr = "select " & RULESET_ID & " from " & RULESET_TBLNAME & " where " & _
                    RULESET_COMPTYPEID & " = " & CompTypeID & " and " & RULESET_VIOLATIONID & " = " & RuleVioId
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New Recordset
        qrystr = "select * from " & RULESET_TBLNAME & " where " & RULESET_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(RULESET_TBLNAME, RULESET_ID)
        rs1.Fields.Item(RULESET_ID).value = ID
        rs1.Fields.Item(RULESET_COMPTYPEID).value = CompTypeID
        rs1.Fields.Item(RULESET_ISENABLED).value = -1
        rs1.Fields.Item(RULESET_VIOLATIONID).value = RuleVioId
        rs1.Fields.Item(RULESET_RULETYPE).value = 0
        
        rs1.Update
        rs1.Close
        
        RulesetIdForAllowedConn = ID
    Else
        RulesetIdForAllowedConn = rs.Fields.Item(RULESET_ID).value
    End If

    rs.Close
    
End Function
Function RuleIdForAllowedConn(RuleName As String, FtrTypeID As Long, ComponentType As Long, ViolationString As String) As Long
    Dim rs As Recordset
    Dim qrystr$, temp$
    Dim RuleSetID&, ID&

    temp = RuleName
    
    RuleSetID = RulesetIdForAllowedConn(FtrTypeID, ComponentType, ViolationString)
    DealWithApostrophes temp
    qrystr = "select " & RULE_ID & " from " & RULE_TBLNAME & " where " & RULE_NAME & _
                    " = '" & temp & "' and " & RULE_RULESETID & " = " & RuleSetID
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New Recordset
        qrystr = "select * from " & RULE_TBLNAME & " where " & RULE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        rs1.AddNew
        ID = NextPK(RULE_TBLNAME, RULE_ID)
        rs1.Fields.Item(RULE_ID).value = ID
        rs1.Fields.Item(RULE_RULESETID).value = RuleSetID
        rs1.Fields.Item(RULE_ISENABLED).value = -1
        rs1.Fields.Item(RULE_NAME).value = RuleName
        rs1.Fields.Item(RULE_CATEGORY).value = 0
        rs1.Fields.Item(RULE_TYPE).value = 0
        rs1.Fields.Item(RULE_ISPROPAGATION) = 0
        
        rs1.Update
        rs1.Close
    
        RuleIdForAllowedConn = ID
    Else
        RuleIdForAllowedConn = rs.Fields.Item(RULE_ID).value
    End If
    
    rs.Close
    
End Function


Function ComponentTypeId(FtrTypeID&, ComponentType&) As Long
    Dim rs As Recordset
    Dim qrystr As String
            
    qrystr = "select id from chdata.componenttype where componenttype  = '" & ComponentType & _
                    "' and FeatureTypeID = " & FtrTypeID
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ComponentTypeId = 0
    Else
        ComponentTypeId = rs.Fields.Item("ID").value
    End If
    
    rs.Close
    
End Function

Function ComponentTypeTypeId(ComponentTypeTypeName As String) As Long
    If Trim(UCase(ComponentTypeTypeName)) = "STRUCTURAL" Then
        ComponentTypeTypeId = 0
    Else
        ComponentTypeTypeId = 1
    End If
End Function
Function PlacementTypeId(PlacementType As String) As Long
    Dim PlacementTypeName$
    PlacementTypeName = Trim(LCase(PlacementType))
    If PlacementTypeName = "at work location" Then
        PlacementTypeId = PlacementType_AtWL
    ElseIf PlacementTypeName = "at attachment point" Then
        PlacementTypeId = PlacementType_AtWLOffset
    ElseIf PlacementTypeName = "at work location offset" Then
        PlacementTypeId = PlacementType_AtWLOffset
    ElseIf PlacementTypeName = "in line" Then
        PlacementTypeId = PlacementType_InLine
    ElseIf PlacementTypeName = "in-line" Then
        PlacementTypeId = PlacementType_InLine
    ElseIf PlacementTypeName = "off line" Then
        PlacementTypeId = PlacementType_OffLine
    ElseIf PlacementTypeName = "off-line" Then
        PlacementTypeId = PlacementType_OffLine
    Else
        PlacementTypeId = PlacementType_AtWLOffset
    End If
End Function


Function ValidatePlacementType&(geomType&, PlacementType&)
    ValidatePlacementType = PlacementType
    If geomType <> GeomType_Point Then
        If PlacementType = PlacementType_OffLine Or PlacementType = PlacementType_InLine Then
            ValidatePlacementType = PlacementType_AtWLOffset
        End If
    End If

End Function
Function GeomTypeId(geomType As String) As Long
    Dim GeomTypeName$
    GeomTypeName = Trim(UCase(geomType))
    If GeomTypeName = "POINT" Then
        GeomTypeId = GeomType_Point
    ElseIf GeomTypeName = "LINE" Then
        GeomTypeId = GeomType_Line
    ElseIf GeomTypeName = "TEXT" Then
        GeomTypeId = GeomType_Text
    ElseIf GeomTypeName = "ANNOTATION" Then
        GeomTypeId = GeomType_Annotation
    ElseIf GeomTypeName = "SPANATPOINT" Then
        GeomTypeId = GeomType_SpanAtPoint
    ElseIf InStr(1, GeomTypeName, "TRUNCATE", vbTextCompare) Then
        GeomTypeId = GeomType_TruncateExisting
    Else
        GeomTypeId = GeomType_Point
    End If
    
End Function
Function LineTypeVal&(LineTypeName$)
    Dim Name$
    Name = UCase(LineTypeName)
    If Name = "OH PRIMARY" Then
        LineTypeVal = 1
    ElseIf Name = "UG PRIMARY" Then
        LineTypeVal = 2
    ElseIf Name = "OH SECONDARY TPX" Then
        LineTypeVal = 3
    ElseIf Name = "OH SECONDARY QPX" Then
        LineTypeVal = 4
    ElseIf Name = "UG SECONDARY TPX" Then
        LineTypeVal = 5
    ElseIf Name = "UG SECONDARY QPX" Then
        LineTypeVal = 6
    Else
        LineTypeVal = 7
    End If
End Function
Function AttributeSetId(SetName As String) As Long
    Dim rs As Recordset
    Dim qrystr$, temp$
    
    temp = SetName
    DealWithApostrophes temp
    qrystr = "select " & ATTRSET_ID & " from " & ATTRSET_TBLNAME & " where " & _
                    ATTRSET_NAME & " = '" & temp & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        AttributeSetId = 0
    Else
        AttributeSetId = rs.Fields.Item(ATTRSET_ID).value
    End If

    rs.Close
    
End Function

Function AttrIdFromNameAndFtrTbl(AttributeName As String, FtrTblName As String, Optional ds As String) As Long
    Dim rs As Recordset
    Dim qrystr$, temp$
    Dim FtrId&

    temp = AttributeName
    DealWithApostrophes temp
    
    If FtrTblName <> "" Then
        If ds <> "" Then
            FtrId = FeatureTypeID(FtrTblName, ds)
        Else
            FtrId = FeatureTypeID(FtrTblName)
        End If
        
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_NAME & " = '" & temp & "' and " & _
                    FEATUREATTR_FTRTYPEID & " = " & FtrId
    Else
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_NAME & " = '" & temp & "' and " & _
                    FEATUREATTR_FTRTYPEID & " IS NULL"
    End If
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Err.Raise vbObjectError + 27, , "No FeatureAttribute found"
    Else
        AttrIdFromNameAndFtrTbl = rs.Fields.Item(FEATUREATTR_ID).value
    End If
    
    rs.Close

    
End Function

Function AttrIdFromNameAndFtrTypeID&(AttributeName$, FtrTypeID&)
    Dim rs As Recordset
    Dim qrystr$, temp$

    temp = AttributeName
    DealWithApostrophes temp
    
    If FtrTypeID <> NULL_LONG Then
  
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_NAME & " = '" & temp & "' and " & _
                    FEATUREATTR_FTRTYPEID & " = " & FtrTypeID
    Else
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_NAME & " = '" & temp & "' and (" & _
                    FEATUREATTR_FTRTYPEID & " IS NULL or " & FEATUREATTR_FTRTYPEID & " = -2147483648)"
                    ' FEATUREATTR_FTRTYPEID & " IS NULL"
    End If
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Err.Raise vbObjectError + 27, , "No FeatureAttribute found"
    Else
        AttrIdFromNameAndFtrTypeID = rs.Fields.Item(FEATUREATTR_ID).value
    End If
    
    rs.Close

    
End Function
Function EARatingID&(Name$, ratingType&)
    Dim rs As Recordset
    Dim sql$, temp$

    'RAS 01/10/2013 - To workaround the Oracle Connection error - "end of file communication"
    If Name = "" Then
        temp = " "
    Else
        temp = Name
    End If
    
    DealWithApostrophes temp
    sql = "select " & EARATING_ID & " from " & EARATING_TABLENAME & _
                    " where " & EARATING_NAME & " = '" & temp & "' and " & _
                    EARATING_TYPE & " = " & CStr(ratingType)
    
    Set rs = Conn.Execute(sql)
    
    If rs.EOF And rs.BOF Then
        'EARatingID = 0
        EARatingID = NULL_LONG
    Else
        EARatingID = rs.Fields.Item(EARATING_ID).value
    End If
    
    rs.Close
    
End Function
Function AttrIdFromExternalNameAndFtrTbl(AttributeName As String, FtrTblName As String, Optional ds As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim FtrId As Long
    Dim temp$
    temp = AttributeName
    
    If ds <> "" Then
        FtrId = FeatureTypeID(FtrTblName, ds)
    Else
        FtrId = FeatureTypeID(FtrTblName)
    End If
    
    If FtrId <> 0 Then
        DealWithApostrophes temp
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & " where " & FEATUREATTR_EXTERNALNAME & " = '" & temp & "' and " & FEATUREATTR_FTRTYPEID & " = " & FtrId
        
        Set rs = Conn.Execute(qrystr)
        
        If rs.EOF And rs.BOF Then
            AttrIdFromExternalNameAndFtrTbl = 0
        Else
            AttrIdFromExternalNameAndFtrTbl = rs.Fields.Item(FEATUREATTR_ID).value
        End If
        rs.Close
    Else
        AttrIdFromExternalNameAndFtrTbl = 0
    End If
    
End Function

Function AttrIdFromInternalNameAndFtrTbl(AttributeName As String, FtrTblName As String, Optional ds As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim FtrId As Long
    Dim temp$
    temp = AttributeName
            
    If ds <> "" Then
        FtrId = FeatureTypeID(FtrTblName, ds)
    Else
        FtrId = FeatureTypeID(FtrTblName)
    End If
    
    If FtrId <> 0 Then
        DealWithApostrophes temp
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & " where " & FEATUREATTR_INTERNALNAME & " = '" & temp & "' and " & FEATUREATTR_FTRTYPEID & " = " & FtrId
        
        Set rs = Conn.Execute(qrystr)
        
        If rs.EOF And rs.BOF Then
            AttrIdFromInternalNameAndFtrTbl = NULL_LONG
        Else
            AttrIdFromInternalNameAndFtrTbl = rs.Fields.Item(FEATUREATTR_ID).value
        End If
        rs.Close
    Else
        AttrIdFromInternalNameAndFtrTbl = NULL_LONG
    End If
    
End Function


Function AttrIdFromInternalNameAndFtrTypeID&(AttributeName$, FtrTypeID&)
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    Dim AttrID&
    
            
    If LastFtrTypeID <> FtrTypeID Then
        If Not FtrAttributes Is Nothing Then Set FtrAttributes = Nothing
        Set FtrAttributes = New Collection
        LastFtrTypeID = FtrTypeID
        GoTo not_in_collection
    Else
        On Error GoTo not_in_collection
        AttrID = FtrAttributes.Item(AttributeName)
        On Error GoTo 0
    End If
    
    AttrIdFromInternalNameAndFtrTypeID = AttrID
    Exit Function
    
not_in_collection:
    temp = AttributeName
    DealWithApostrophes temp
    qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                " where " & FEATUREATTR_INTERNALNAME & " = '" & temp & _
                "' and " & FEATUREATTR_FTRTYPEID & " = " & FtrTypeID
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        AttrID = 0
    Else
        AttrID = rs.Fields.Item(FEATUREATTR_ID).value
    End If
    rs.Close
    
    FtrAttributes.Add AttrID, AttributeName
    AttrIdFromInternalNameAndFtrTypeID = AttrID
    
End Function

Function AttrIdFromExternalNameAndFtrTypeID&(AttributeName$, FtrTypeID&)
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    temp = AttributeName
            

    If FtrTypeID <> 0 Then
        DealWithApostrophes temp
        qrystr = "select " & FEATUREATTR_ID & " from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_EXTERNALNAME$ & " = '" & temp & _
                    "' and " & FEATUREATTR_FTRTYPEID & " = " & FtrTypeID
        
        Set rs = Conn.Execute(qrystr)
        
        If rs.EOF And rs.BOF Then
            AttrIdFromExternalNameAndFtrTypeID = 0
        Else
            AttrIdFromExternalNameAndFtrTypeID = rs.Fields.Item(FEATUREATTR_ID).value
        End If
        rs.Close
    Else
        AttrIdFromExternalNameAndFtrTypeID = 0
    End If
    
    
    
End Function
Function LegalValueId&(LegalValue$, CreateNew%, Optional AlternateVal$ = "")
    Dim rs As Recordset
    Dim qrystr$
    Dim ID&
    Dim temp$, AltTemp$
    Dim msg$
    
    temp = LegalValue
    DealWithApostrophes temp
    If AlternateVal = "" Then
        qrystr = "select " & ATTRLEGALVALUE_ID & _
                       "," & ATTRLEGALVALUE_VALUE & _
                       "," & ATTRLEGALVALUE_ALTERNATEVALUE & _
                 " from " & ATTRLEGALVALUE_TBLNAME & _
                 " where " & ATTRLEGALVALUE_VALUE & " = '" & temp & "' and " & _
                 ATTRLEGALVALUE_ALTERNATEVALUE & " is NULL"
    Else
        AltTemp = AlternateVal
        DealWithApostrophes AltTemp
        qrystr = "select " & ATTRLEGALVALUE_ID & _
                       "," & ATTRLEGALVALUE_VALUE & _
                       "," & ATTRLEGALVALUE_ALTERNATEVALUE & _
                " from " & ATTRLEGALVALUE_TBLNAME & _
                " where " & ATTRLEGALVALUE_VALUE & " = '" & temp & "' and " & _
                ATTRLEGALVALUE_ALTERNATEVALUE & " = '" & AltTemp & "'"
    End If
    
    Set rs = Conn.Execute(qrystr)

    If rs.EOF And rs.BOF Then
        If CreateNew = True Then
            Dim rs1 As New Recordset
            
            rs.Close
            qrystr = "select * from " & ATTRLEGALVALUE_TBLNAME & _
                        " where " & ATTRLEGALVALUE_ID & " = -1"
            rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
            
            rs1.AddNew
            ID = NextPK(ATTRLEGALVALUE_TBLNAME, ATTRLEGALVALUE_ID)
            rs1.Fields.Item(ATTRLEGALVALUE_ID).value = ID
            rs1.Fields.Item(ATTRLEGALVALUE_VALUE).value = LegalValue
            If AlternateVal <> "" Then
                rs1.Fields.Item(ATTRLEGALVALUE_ALTERNATEVALUE).value = AlternateVal
            End If
            rs1.Update
            rs1.Close
            
            LegalValueId = ID

        Else
            LegalValueId = 0
            msg = "Error: No legal value found for: " & LegalValue
            If logdir <> "" And logfile <> "" Then
                LogMsg msg
            Else
                MsgBox qrystr
                Err.Raise vbObjectError + 27, , msg
            End If
        End If
        
    Else
        If AlternateVal = "" Then
            If rs.Fields.Item(ATTRLEGALVALUE_VALUE).value <> LegalValue Then
                AtrLglVlUpdate = "Value"
            End If
        Else
            If rs.Fields.Item(ATTRLEGALVALUE_ALTERNATEVALUE).value <> AlternateVal Then
                AtrLglVlUpdate = "Display Value"
            End If
        End If
        
        LegalValueId = rs.Fields.Item(ATTRLEGALVALUE_ID).value
        rs.Close
    End If

End Function

Function AttrLegalValueID&(LegalValue$, DomainID&)
    Dim rs As Recordset
    Dim qrystr$
    Dim temp$

    temp = LegalValue
    DealWithApostrophes temp
    qrystr = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & _
                " from " & ATTRLEGALVALUE_TBLNAME & ", " & ATTRLEGALVALUEASSIGN_TBLNAME & _
                " where " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_VALUE & _
                " = '" & temp & "' and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & _
                ATTRLEGALVALUEASSIGN_DOMAINID & " = " & DomainID
    
    Set rs = Conn.Execute(qrystr)

    If rs.EOF And rs.BOF Then
        AttrLegalValueID = NULL_LONG
    Else
        AttrLegalValueID = rs.Fields.Item(ATTRLEGALVALUE_ID).value
        rs.Close
    End If

End Function
Function ControlTypeId(controlType As String) As Long
    Dim ControlTypeName$
    ControlTypeName = Trim(UCase(controlType))
    If ControlTypeName = "DROP DOWN" Then
        ControlTypeId = 1
    ElseIf ControlTypeName = "CHECK" Then
        ControlTypeId = 2
    ElseIf ControlTypeName = "SPIN" Then
        ControlTypeId = 3
    ElseIf ControlTypeName = "DATE" Then
        ControlTypeId = 4
    ElseIf ControlTypeName = "CURRENCY" Then
        ControlTypeId = 5
    ElseIf ControlTypeName = "DOUBLE" Then
        ControlTypeId = 6
    Else
        ControlTypeId = 0
    End If
End Function

Function CUAssignState%(StateName$)
    Dim temp$
    temp = Trim(UCase(StateName))
    If temp = "PROPOSED INSTALL" Then
        CUAssignState = 1
    ElseIf temp = "INSTALL" Then
        CUAssignState = 1
    ElseIf temp = "IN-SERVICE" Then
        CUAssignState = 2
    ElseIf temp = "INSERVICE" Then
        CUAssignState = 2
    ElseIf temp = "IN SERVICE" Then
        CUAssignState = 2
    ElseIf temp = "EXISTING" Then
        CUAssignState = 2
    ElseIf temp = "PROPOSED REMOVE" Then
        CUAssignState = 3
    ElseIf temp = "REMOVE" Then
        CUAssignState = 3
    ElseIf temp = "PROPOSED TRANSFER" Then
        CUAssignState = 4
    ElseIf temp = "TRANSFER" Then
        CUAssignState = 4
    ElseIf temp = "PROPOSED ABANDON" Then
        CUAssignState = 5
    ElseIf temp = "ABANDON" Then
        CUAssignState = 5
    ElseIf temp = "ABANDONED" Then
        CUAssignState = 5
    Else
        CUAssignState = 1
    End If
End Function
Function ValueTypeID(ValueTypeName As String) As Long
    Dim temp$
    temp = LCase(ValueTypeName)
    If temp = "dateval" Then
        ValueTypeID = 7 'adDate
    ElseIf temp = "integerval" Then
        ValueTypeID = 3 'adInteger
    ElseIf temp = "floatval" Then
        ValueTypeID = 5 'adDouble
    ElseIf temp = "shortval" Then
        ValueTypeID = 3 'adInteger
    ElseIf temp = "boolval" Then
        ValueTypeID = 11 'adBoolean
    Else
        ValueTypeID = 8 'adBSTR
    End If
End Function

Function TableTypeID&(TableTypeName As String)
    Dim temp$
    temp = Trim(LCase(TableTypeName))
    
    'work request
    If temp = "work request" Then
        TableTypeID = 0
    'design
    ElseIf temp = "design" Then
        TableTypeID = 1
    'compatible unit
    ElseIf temp = "compatible unit" Then
        TableTypeID = 2
    ElseIf temp = "cu" Then
        TableTypeID = 2
    'compatible unit assign
    ElseIf temp = "compatible unit assign" Then
        TableTypeID = 3
    ElseIf temp = "cu assign" Then
        TableTypeID = 3
    ElseIf temp = "compatible unit assignment" Then
        TableTypeID = 3
    ElseIf temp = "cu assignment" Then
        TableTypeID = 3
    'material item
    ElseIf temp = "material item" Then
        TableTypeID = 4
    ElseIf temp = "material" Then
        TableTypeID = 4
    ElseIf temp = "mi" Then
        TableTypeID = 4
    'material item assign
    ElseIf temp = "material item assign" Then
        TableTypeID = 5
    ElseIf temp = "material assign" Then
        TableTypeID = 5
    ElseIf temp = "material item assignment" Then
        TableTypeID = 5
    ElseIf temp = "material assignment" Then
        TableTypeID = 5
    ElseIf temp = "mi assignment" Then
        TableTypeID = 5
    ElseIf temp = "mi assignment" Then
        TableTypeID = 5
    'custom cost
    ElseIf temp = "custom cost" Then
        TableTypeID = 6
    ElseIf temp = "cc" Then
        TableTypeID = 6
    'custom cost assign
    ElseIf temp = "custom cost assign" Then
        TableTypeID = 7
    ElseIf temp = "cc assign" Then
        TableTypeID = 7
    ElseIf temp = "custom cost assignment" Then
        TableTypeID = 7
    ElseIf temp = "cc assignment" Then
        TableTypeID = 7
    Else
        TableTypeID = NULL_LONG
    End If
    
End Function
Function FilterTypeID&(FilterTypeName$)
    Dim temp$
    temp = Trim(LCase(FilterTypeName))

    If temp = "path by trace" Then
        FilterTypeID = 0
    ElseIf temp = "pathbytrace" Then
        FilterTypeID = 0
    Else
        FilterTypeID = NULL_LONG
    End If
    
End Function
Function NetworkTypeID&(NetworkTypeName$)
    Dim temp$
    temp = Trim(LCase(NetworkTypeName))
           
    If temp = "ea primary" Then
        NetworkTypeID = 1
    ElseIf temp = "ea secondary" Then
        NetworkTypeID = 2
    ElseIf temp = "structural" Then
        NetworkTypeID = 3
    ElseIf temp = "gas analysis ip" Then
        NetworkTypeID = 4
    ElseIf temp = "gas analysis lp" Then
        NetworkTypeID = 5
    ElseIf temp = "gas analysis hp" Then
        NetworkTypeID = 6
    ElseIf temp = "path by trace" Then
        NetworkTypeID = 7
    ElseIf temp = "pathbytrace" Then
        NetworkTypeID = 7
    Else
        NetworkTypeID = NULL_LONG
    End If
    
End Function
Function ADOValueType(ValueTypeName As String) As Long
    
    Dim temp$
    temp = Trim(LCase(ValueTypeName))
    If temp = "date" Then
        ADOValueType = 7
    ElseIf temp = "integer" Then
        ADOValueType = 3
    ElseIf temp = "number" Then
        ADOValueType = 3
    ElseIf temp = "numeric" Then
        ADOValueType = 3
    ElseIf temp = "float" Then
        ADOValueType = 5
    ElseIf temp = "decimal" Then
        ADOValueType = 5
    ElseIf temp = "double" Then
        ADOValueType = 5
    ElseIf temp = "short" Then
        ADOValueType = 3
    ElseIf temp = "long" Then
        ADOValueType = 3
    ElseIf temp = "string" Then
        ADOValueType = 8
    ElseIf temp = "text" Then
        ADOValueType = 8
    Else
        ADOValueType = 8
    End If
End Function
Function FacilityCode&(ComponentName$)
    
    Dim temp$
    temp = Trim(LCase(ComponentName))
    If temp = "vgis" Then
        FacilityCode = 4096   '&H1000
    ElseIf temp = "vwms" Then
        FacilityCode = 8192   '&H2000
    ElseIf temp = "work management" Then
        FacilityCode = 12288   '&H3000
    ElseIf temp = "design editor" Then
        FacilityCode = 16384   '&H4000
    ElseIf temp = "archive" Then
        FacilityCode = 20480   '&H5000
    ElseIf temp = "tree trimming" Then
        FacilityCode = 24576   '&H6000
    ElseIf temp = "spatial wizard" Then
        FacilityCode = 28672   '&H7000
    ElseIf temp = "electric optimization" Then
        FacilityCode = 36864   '&H9000
    ElseIf temp = "custom" Then
        FacilityCode = 40960   '&HA000
    ElseIf temp = "geometry" Then
        FacilityCode = 45056   '&HB000
    ElseIf temp = "feature" Then
        FacilityCode = 49152   '&HC000
    ElseIf temp = "security manager" Then
        FacilityCode = 53248   '&HD000
    ElseIf temp = "cu manager" Then
        FacilityCode = 57344   '&HE000
    ElseIf temp = "trace manager" Then
        FacilityCode = 61440   '&HF000
    Else
        FacilityCode = 16384   'default to DE
    End If

End Function
Function AttributeDomainId(AttrDomainName As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & ATTRDOMAIN_ID & " from " & ATTRDOMAIN_TBLNAME & " where LOWER(" & _
                    ATTRDOMAIN_NAME & ") = '" & LCase(AttrDomainName) & "'"
                    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        AttributeDomainId = 0
    Else
        AttributeDomainId = rs.Fields.Item(ATTRDOMAIN_ID).value
    End If

    rs.Close
    
End Function

Function AttrDomainIDForFtrAttr&(FtrAttrID&)
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & FEATUREATTR_ATTRDOMAINID & " from " & FEATUREATTR_TBLNAME & " where " & _
                    FEATUREATTR_ID & " = " & FtrAttrID
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        AttrDomainIDForFtrAttr = NULL_LONG
    Else
        AttrDomainIDForFtrAttr = rs.Fields.Item(FEATUREATTR_ATTRDOMAINID).value
    End If

    rs.Close
    
End Function
Function AttributeSetTypeId(TypeName As String)
    Dim temp$
    temp = Trim(UCase(TypeName))
    If temp = "GLOBAL" Then
        AttributeSetTypeId = 5
    ElseIf temp = "JOB TYPE" Then
        AttributeSetTypeId = 3
    ElseIf temp = "SYSTEM" Then
        AttributeSetTypeId = 5
    Else
        AttributeSetTypeId = 6
    End If
End Function
Function FeatureTypeID(FtrTable As String, Optional ds As String) As Long
    Dim rs As Recordset
    Dim qrystr As String
    Dim TblName$
    Dim ID&
    
    If FtrTypes Is Nothing Then Set FtrTypes = New Collection
    
    On Error GoTo not_in_FT_collection
    'RAS - 08/13/2012
    'Use dataset in the featuretype collection
    Dim SearchStr As String
    If ds <> "" Then
        SearchStr = ds & "." & FtrTable
    Else
        SearchStr = FtrTable
    End If
        
    ID = FtrTypes.Item(SearchStr)
    On Error GoTo 0
    FeatureTypeID = ID
    Exit Function
    
not_in_FT_collection:
    TblName = Trim$(FtrTable)
    DealWithApostrophes TblName
    qrystr = "select " & FEATURETYPE_ID & " from " & FEATURETYPE_TBLNAME & _
                    " where " & FEATURETYPE_NAME & " = '" & TblName & "'"
                    
    If ds <> "" Then
        qrystr = qrystr + " and " & FEATURETYPE_DATASET & " = '" & ds & "'"
    End If
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ID = 0
    Else
        ID = rs.Fields.Item(FEATURETYPE_ID).value
    End If
  
    rs.Close
    FtrTypes.Add ID, SearchStr
    FeatureTypeID = ID
    
End Function
Function ClassCodeId&(Name)
    Dim rs As Recordset
    Dim qrystr As String
    Dim CCName$
    Dim ID&
    
    If Name = "" Then GoTo problem
    CCName = Trim$(Name)
    
    If ClassCodes Is Nothing Then Set ClassCodes = New Collection
    
    On Error GoTo not_in_CC_collection
    ID = ClassCodes.Item(CCName)
    On Error GoTo 0
    
    ClassCodeId = ID
    Exit Function
    
not_in_CC_collection:
    
    DealWithApostrophes CCName
    qrystr = "select " & CLASSCODE_ID & " from " & CLASSCODE_TBLNAME & _
                    " where " & CLASSCODE_NAME & " = '" & CCName & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New ADODB.Recordset
        qrystr = "select * from " & CLASSCODE_TBLNAME & " where " & CLASSCODE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        ID = NextPK(CLASSCODE_TBLNAME, CLASSCODE_ID)
        rs1.AddNew
        rs1(CLASSCODE_NAME) = Trim$(Name)
        rs1(CLASSCODE_ID) = ID
        rs1.Update
        rs1.Close
    Else
        ID = rs.Fields.Item(CLASSCODE_ID).value
    End If
  
    rs.Close
    ClassCodes.Add ID, CCName
    ClassCodeId = ID
    Exit Function
problem:
    ClassCodeId = 0
End Function


Function UnitOfMeasureID&(Name)
    Dim rs As Recordset
    Dim qrystr As String
    Dim UomName$
    Dim ID&
    
    If Name = "" Then GoTo uom_problem
    
    UomName = Trim$(Name)
    DealWithApostrophes UomName
    qrystr = "select " & UNITOFMEASURE_ID & " from " & UNITOFMEASURE_TBLNAME & _
                    " where " & UNITOFMEASURE_NAME & " = '" & UomName & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        Dim rs1 As New ADODB.Recordset
        qrystr = "select * from " & UNITOFMEASURE_TBLNAME & " where " & UNITOFMEASURE_ID & " = -1"
        rs1.Open qrystr, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        ID = NextPK(UNITOFMEASURE_TBLNAME, UNITOFMEASURE_ID)
        rs1.AddNew
        rs1(UNITOFMEASURE_NAME) = Trim$(Name)
        rs1(UNITOFMEASURE_ID) = ID
        rs1.Update
        rs1.Close
        UnitOfMeasureID = ID
    Else
        UnitOfMeasureID = rs.Fields.Item(UNITOFMEASURE_ID).value
    End If
  
    rs.Close
   Exit Function
uom_problem:
    UnitOfMeasureID = 0
End Function
Function FeatureTypeName(FtrTypeID As Long) As String
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    
    qrystr = "select " & FEATURETYPE_NAME & " from " & FEATURETYPE_TBLNAME & _
                    " where " & FEATURETYPE_ID & " = " & FtrTypeID

    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        FeatureTypeName = ""
    Else
        FeatureTypeName = rs.Fields.Item(FEATURETYPE_NAME).value
    End If
  
    rs.Close
    
End Function

Function FeatureTypeGISTableName$(FtrTypeID&)
    Dim rs As Recordset
    Dim qrystr As String
    Dim temp$
    
    qrystr = "select " & FEATURETYPE_GISTABLE & " from " & FEATURETYPE_TBLNAME & _
                    " where " & FEATURETYPE_ID & " = " & FtrTypeID

    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        FeatureTypeGISTableName = ""
    Else
        FeatureTypeGISTableName = rs.Fields.Item(FEATURETYPE_GISTABLE).value
    End If
  
    rs.Close
    
End Function
Function BoolStringToInt(Optional BoolString As String) As Long
    If BoolString <> "" Then
        If InStr(UCase(BoolString), "N") <> 0 Then
            BoolStringToInt = 0
        Else
            BoolStringToInt = -1
        End If
    Else
        BoolStringToInt = 0
    End If
End Function



Private Sub btnLoadCA_Click()
    Dim OldCursor&
    
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CUSTOMATTR_TBLNAME
    End If
    
    LoadCustomAttributes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CheckIncrementalLoad_Click()
    IncrementalLoad = CheckIncrementalLoad.value
End Sub

Private Sub CheckIsSqlServerS2T_Click()
    IsSqlServerS2T = CheckIsSqlServerS2T.value
End Sub

Private Sub ChkNoUnits_Click()
    IgnoreUnits = ChkNoUnits.value
End Sub

Private Sub ChkUnitsOnly_Click()
    LoadUnitsOnly = ChkUnitsOnly.value
End Sub

Private Sub chkValidateUtility_Click()
    ValidateUtility = chkValidateUtility.value
End Sub

'Sub Set_IgnoreUnits(value As Boolean)
'    IgnoreUnits = value
'    ChkNoUnits.value = IgnoreUnits
'End Sub
'
'Sub Set_IncrementalLoad(value As Boolean)
'    IncrementalLoad = value
'    CheckIncrementalLoad.value = IncrementalLoad
'End Sub
'
'Sub Set_LoadUnitsOnly(value As Boolean)
'    LoadUnitsOnly = value
'    ChkNoUnits.value = LoadUnitsOnly
'End Sub
'
'Sub Set_ValidateUtility(value As Boolean)
'    ValidateUtility = value
'    chkValidateUtility.value = ValidateUtility
'End Sub

Private Sub CmdACLoadChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ACUNITLOADCHAR_TABLENAME
    End If
    
    LoadACLoadChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdADRule_Click()
   Dim OldCursor&
   
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    
    If Not IncrementalLoad Then
        Label2.Caption = "Status: Deleting Existing Application Dependency Rules"
        DeleteAppDependRules (0)
    End If
    
    Label2.Caption = "Status: Ready"
    
    LoadAppDependRules
    LoadADFeatureTypeRules
    LoadFeatureInstRules
    LoadFeatureAttrConstraintRules
    
    Label2.Caption = "Status: Ready"

    
    Application.Cursor = OldCursor
End Sub

Public Sub DeleteAppDependRules(ADRuleType&)
    Dim MySql As String
    Dim rsADRule As Recordset
    Dim rsADFtrType As Recordset
    Dim rsADFtrInst As Recordset
    
    MySql = "select " & ADRULE_ID & " from " & ADRULE_TABLENAME & _
            " where " & ADRULE_TYPE & " = " & ADRuleType
            
    Set rsADRule = Conn.Execute(MySql)
    DeleteTable ADCUCODERULE_TABLENAME
    DeleteTable ADFEATUREATTRCONSTRNT_TABLENAME
    
    'Loop through all ADRule records and delete related child records ADFeatureType,
    'ADFeatureInst and ADFeatureConstrnt then delete self ADRule
    Do While rsADRule.EOF <> True
        Dim ADRuleId As Long
        
        ADRuleId = rsADRule.Fields.Item(ADRULE_ID).value
        
        MySql = "select " & ADFEATURETYPE_ID & " from " & ADFEATURETYPE_TABLENAME & _
                " where " & ADFEATURETYPE_ADRULEID & " = " & ADRuleId
        
        Set rsADFtrType = Conn.Execute(MySql)
        
        'Loop through all related ADFeatureType records and delete related child records
        'ADFeatureInst and ADFeatureConstrnt then delete self ADFeatureType
        Do While rsADFtrType.EOF <> True
            Dim ADFtrTypeId As Long
        
            ADFtrTypeId = rsADFtrType.Fields.Item(ADFEATURETYPE_ID).value
            
            MySql = "Select * from " & ADFEATUREINST_TABLENAME & _
                    " where " & ADFEATUREINST_ADFEATURETYPEID & " = " & ADFtrTypeId
            
            Set rsADFtrInst = Conn.Execute(MySql)
            
            'Delete all Related ADFeatureAttrConstrnt records
            'Do While rsADFtrInst.EOF <> True
            '    Dim ADFtrInstId As Long
            '
            '    MySql = "Delete from " & ADFEATUREATTRCONSTRNT_TABLENAME & _
            '            " where " & ADFEATUREATTRCONSTRNT_ADFTRINSTID & " = " & ADFtrTypeId
            '
            '    Conn.Execute (MySql)
            '    rsADFtrInst.MoveNext
            'Loop
            
            'Delete all Related child ADFeatureInst records where .ParentId in not Null
            MySql = "Delete from " & ADFEATUREINST_TABLENAME & _
                    " where " & ADFEATUREINST_ADFEATURETYPEID & " = " & ADFtrTypeId & " and " & _
                    ADFEATUREINST_PARENTID & " <> " & "NULL"
                    
            
                    
                    
            Conn.Execute (MySql)
            
            'Delete Related parent ADFeatureInst records
            MySql = "Delete from " & ADFEATUREINST_TABLENAME & _
                    " where " & ADFEATUREINST_PARENTID & " = " & ADFtrTypeId
                    
            Conn.Execute (MySql)

            
            'Delete all remaining Related parent ADFeatureInst records
            MySql = "Delete from " & ADFEATUREINST_TABLENAME & _
                    " where " & ADFEATUREINST_ADFEATURETYPEID & " = " & ADFtrTypeId
                    
            Conn.Execute (MySql)
            
            'Deleting the ADFeatureType record
            MySql = "Delete from " & ADFEATURETYPE_TABLENAME & _
                    " where " & ADFEATURETYPE_ID & " = " & ADFtrTypeId
                    
            Conn.Execute (MySql)
            
            rsADFtrType.MoveNext
            rsADFtrInst.Close
        Loop
                        
        MySql = "Delete from " & ADRULE_TABLENAME & _
                " where " & ADRULE_ID & " = " & ADRuleId
                        
        Conn.Execute (MySql)
        rsADRule.MoveNext
        rsADFtrType.Close
    Loop
    
        
    rsADRule.Close

    
End Sub

Public Sub LoadAppDependRules()
    Dim rs As New Recordset
    Dim rs2 As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim ftrName$, ID$
    Dim ADRuleType$, ADRulePriority&
    Dim ADRuleId&, CUADTypeIdNum&
    Dim CUADTypeCodeIdNum&, CUIdNum&
    Dim CUADType$, CUADTypeCode$
    Dim Operator$
    Dim MyNum&
    Dim ctr%
    Dim LastCUID$
    Dim MissingData As Boolean
    Dim InvalidData As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Application Dependencies Rules"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("ADRule")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ADRule")
    logUpdates = GetLogUpdates("ADRule")
   
    ctr = 2
    
    Set cell = ws.Range("A3")
    ID = Trim(cell.value)
    
    LastCUID = ""
        
    rs.Open ADRULE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ADRuleId = NextPK(ADRULE_TABLENAME, ADRULE_ID)
    
    rs2.Open ADCUCODERULE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While ID <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        CUADType = Trim(cell.value)
        'CUADTypeIdNum = CUADTypeId(Trim(CUADType))
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        CUADTypeCode = Trim(cell.value)
        'CUADTypeCodeIdNum = CUADTypeCodeId(Trim(CUADTypeCode))
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        
        If MyStr <> LastCUID Or LastCUID = "" Then
            CUIdNum = CUID(Trim(MyStr))
        End If
        
        LastCUID = MyStr
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        ADRulePriority = Trim(cell.value)
    

        
        If ID = "" Or CUADType = "" Or CUADTypeCode = "" Then
            MissingData = True
        Else
            MissingData = False
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        
        If CUIdNum = 0 Then
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
        Else
            'cellstr = "D" & ctr
            'Set cell = ws.Range(cellstr)
            'cell.Font.ColorIndex = 0
            'cell.Font.Color = RGB(0, 0, 0)
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        
        If CUIdNum = 0 Or ID = "" _
        Or ADRuleId = 0 Or CUADType = "" Or CUADTypeCode = "" Then
            'Mark the failure in the spreadsheet
            cell.value = "Failed - Invalid or Missing Data"
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            
            If MissingData = True And InvalidData = True Then
                cell.value = "Failed - Missing and Invalid Data"
            ElseIf MissingData = True Then
                cell.value = "Failed - Missing Data"
            ElseIf InvalidData = True Then
                cell.value = "Failed - Invalid Data"
            End If
        
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ADRULE_TABLENAME & _
                    " where " & ADRULE_TABLENAME & "." & ADRULE_ID & " = " & ADRuleId & _
                    " and " & ADRULE_TABLENAME & "." & ADRULE_TYPE & " = " & "0" & _
                    " and " & ADRULE_TABLENAME & "." & ADRULE_PRIORITY & " = " & ADRulePriority
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(ADRULE_ID).value = ADRuleId
                rs.Fields.Item(ADRULE_TYPE).value = 0
                rs.Fields.Item(ADRULE_PRIORITY).value = ADRulePriority
            Else
                'rsTmp.Fields.Item(ADRULE_ID).Value = ADRuleId
                'rsTmp.Fields.Item(ADRULE_TYPE).Value = 0
                'rsTmp.Fields.Item(ADRULE_PRIORITY).Value = ADRulePriority
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row (ADRULE)"
                    Failure = True
                End If
            End If
            rsTmp.Close

            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ADCUCODERULE_TABLENAME & _
                    " where " & ADCUCODERULE_TABLENAME & "." & ADCUCODERULE_ID & " = " & MyNum & _
                    " and " & ADCUCODERULE_TABLENAME & "." & ADCUCODERULE_ADRULEID & " = " & ADRuleId & _
                    " and " & ADCUCODERULE_TABLENAME & "." & ADCUCODERULE_CUID & " = " & CUIdNum & _
                    " and " & ADCUCODERULE_TABLENAME & "." & ADCUCODERULE_ADTYPE & " = '" & CUADType & "'" & _
                    " and " & ADCUCODERULE_TABLENAME & "." & ADCUCODERULE_ADCODE & " = '" & CUADTypeCode & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs2.AddNew
                MyNum = ID
                rs2.Fields.Item(ADCUCODERULE_ID).value = MyNum
                rs2.Fields.Item(ADCUCODERULE_ADRULEID).value = ADRuleId
                rs2.Fields.Item(ADCUCODERULE_CUID).value = CUIdNum
                rs2.Fields.Item(ADCUCODERULE_ADTYPE).value = CUADType
                rs2.Fields.Item(ADCUCODERULE_ADCODE).value = CUADTypeCode
            Else
                'rsTmp.Fields.Item(ADCUCODERULE_ID).Value = MyNum
                'rsTmp.Fields.Item(ADCUCODERULE_ADRULEID).Value = ADRuleId
                'rsTmp.Fields.Item(ADCUCODERULE_CUID).Value = CUIdNum
                'rsTmp.Fields.Item(ADCUCODERULE_ADTYPE).Value = CUADType
                'rsTmp.Fields.Item(ADCUCODERULE_ADCODE).Value = CUADTypeCode
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            
            cell.Font.ColorIndex = 0
            cell.value = ""
        End If
        
        ctr = ctr + 1
        ADRuleId = ADRuleId + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Not (rs2.BOF And rs2.EOF) Then rs2.Update
    rs2.Close
    
    If Failure Then
        LogSheetFailure "ADRule"
    End If
    
End Sub

Public Sub LoadADFeatureTypeRules()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim ftrName$, ID$
    Dim ADRuleIdNum&, FeatureTypeIdNum&
    Dim MinInstReq&, MaxInstAllowed&
    Dim MyNum&, ADFeatureTypeId&
    Dim ctr%, LastADRuleIdNum
    Dim InvalidData As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Set ws = Worksheets("ADFeatureType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ADFeatureType")
    logUpdates = GetLogUpdates("ADFeatureType")
   
    ctr = 2
    
    Set cell = ws.Range("A3")
    ID = Trim(cell.value)
        
    rs.Open ADFEATURETYPE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    LastADRuleIdNum = -1
    
    Do While ID <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
                                
        MyNum = ID
        If LastADRuleIdNum <> MyNum And LastADRuleIdNum <> 0 Then
            ADRuleIdNum = ADRuleId(MyNum)
        End If
        
        LastADRuleIdNum = MyNum
                
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ADFeatureTypeId = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If ds <> "" Then
            FeatureTypeIdNum = FeatureTypeID(Trim(MyStr), ds)
        Else
            FeatureTypeIdNum = FeatureTypeID(Trim(MyStr))
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MinInstReq = Trim(cell.value)

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MaxInstAllowed = Trim(cell.value)
        
        If ADRuleIdNum = 0 Then
            cellstr = "A" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            InvalidData = True
        Else
            cellstr = "A" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.ColorIndex = 0
            InvalidData = False
        End If

        If FeatureTypeIdNum = 0 Then
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            InvalidData = True
        Else
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.ColorIndex = 0
            InvalidData = False
        End If

        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        
        If ADRuleIdNum = 0 Or FeatureTypeIdNum = 0 Or MinInstReq = 0 Or _
        MaxInstAllowed = 0 Or MinInstReq = 0 Then
            'Mark the failure in the spreadsheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - Invalid or Missing Data"
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ADFEATURETYPE_TABLENAME & _
                    " where " & ADFEATURETYPE_TABLENAME & "." & ADFEATURETYPE_ID & " = " & ADFeatureTypeId & _
                    " and " & ADFEATURETYPE_TABLENAME & "." & ADFEATURETYPE_ADRULEID & " = " & ADRuleIdNum & _
                    " and " & ADFEATURETYPE_TABLENAME & "." & ADFEATURETYPE_FEATURETYPEID & " = " & FeatureTypeIdNum
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(ADFEATURETYPE_ID).value = ADFeatureTypeId
                rs.Fields.Item(ADFEATURETYPE_ADRULEID).value = ADRuleIdNum
                rs.Fields.Item(ADFEATURETYPE_FEATURETYPEID).value = FeatureTypeIdNum
                rs.Fields.Item(ADFEATURETYPE_MININSTREQ).value = MinInstReq
                rs.Fields.Item(ADFEATURETYPE_MAXINSTALLOWED).value = MaxInstAllowed
            Else
                'rsTmp.Fields.Item(ADFEATURETYPE_ID).Value = ADFeatureTypeId
                'rsTmp.Fields.Item(ADFEATURETYPE_ADRULEID).Value = ADRuleIdNum
                'rsTmp.Fields.Item(ADFEATURETYPE_FEATURETYPEID).Value = FeatureTypeIdNum
                rsTmp.Fields.Item(ADFEATURETYPE_MININSTREQ).value = MinInstReq
                rsTmp.Fields.Item(ADFEATURETYPE_MAXINSTALLOWED).value = MaxInstAllowed
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ADFeatureType"
    End If

End Sub

Public Function ADRuleId(ADCUCodeId As Long) As Long
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & ADCUCODERULE_ADRULEID & " from " & ADCUCODERULE_TABLENAME & " where " & ADCUCODERULE_ID & " = '" & ADCUCodeId & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ADRuleId = 0
    Else
        ADRuleId = rs.Fields.Item(ADCUCODERULE_ADRULEID).value
    End If

    rs.Close
    
End Function
Public Sub LoadFeatureInstRules()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim ftrName$, ID$
    Dim ParentID$, ADFeatureTypeId&, ADParentExists&
    Dim MyNum&, ADFeatureInstId&
    Dim ADRuleIdNum&, ADFeatureTypeIdValidNum&
    Dim ctr%, ParentIdNum&, LastADFeatureInstId&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
       
    Set ws = Worksheets("ADFeatureInst")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ADFeatureInst")
    logUpdates = GetLogUpdates("ADFeatureInst")
   
    ctr = 3
    
    Set cell = ws.Range("A3")
    ID = Trim(cell.value)
        
    rs.Open ADFEATUREINST_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    LastADFeatureInstId = -1
    
    Do While ID <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
                
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ADFeatureInstId = Trim(cell.value)
                
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ParentID = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        ADFeatureTypeId = Trim(cell.value)
        
        If LastADFeatureInstId <> ADFeatureInstId And LastADFeatureInstId <> 0 Then
            ADFeatureTypeIdValidNum = ADFeatureTypeIdValid(ADFeatureTypeId)
        End If
                
        LastADFeatureInstId = ADFeatureInstId
        
        ADParentExists = ADParentInstExists(ParentID)
          
        If ADFeatureTypeIdValidNum = 0 Then
            'Mark the failure in the spreadsheet
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = "Failed - Invalid Data"
        ElseIf ADParentExists = 0 Then
            'Mark the failure in the spreadsheet
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = "Failed - Invalid Data"
        Else
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ADFEATUREINST_TABLENAME & _
                    " where " & ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_ID & " = " & ADFeatureInstId & _
                    " and " & ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_ADFEATURETYPEID & " = " & ADFeatureTypeId
            If ParentID <> "NULL" Then
                sqlTmp = sqlTmp & _
                " and " & ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_PARENTID & " = " & ParentIdNum
            Else
                sqlTmp = sqlTmp & _
                " and " & ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_PARENTID & " is null"
            End If
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(ADFEATUREINST_ID).value = ADFeatureInstId
                rs.Fields.Item(ADFEATUREINST_ADFEATURETYPEID).value = ADFeatureTypeId
                If ParentID <> "NULL" Then
                    ParentIdNum = ParentID
                    rs.Fields.Item(ADFEATUREINST_PARENTID).value = ParentIdNum
                End If
            Else
                'rsTmp.Fields.Item(ADFEATUREINST_ID).Value = ADFeatureInstId
                'rsTmp.Fields.Item(ADFEATUREINST_ADFEATURETYPEID).Value = ADFeatureTypeId
                'If ParentID <> "NULL" Then
                '    ParentIdNum = ParentID
                '    rsTmp.Fields.Item(ADFEATUREINST_PARENTID).Value = ParentIdNum
                'End If
                'rsTmp.Update
                
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.ColorIndex = 0
            
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.ColorIndex = 0
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.ColorIndex = 0
            cell.value = ""
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
        
        If Not (rs.BOF And rs.EOF) Then rs.Update
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ADFeatureInst"
    End If

End Sub

Public Function ADParentInstExists(ParentID$) As Long
    Dim MySql As String
    Dim rs As Recordset
    
    ADParentInstExists = 0
    
    If ParentID = "NULL" Then
        ADParentInstExists = 1
    Else
        MySql = "select * from " & ADFEATUREINST_TABLENAME & _
            " where " & ADFEATUREINST_ID & " = " & ParentID
            
        Set rs = Conn.Execute(MySql)
    
        Do While rs.EOF <> True
            ADParentInstExists = 1
            rs.MoveNext
        Loop

    End If


End Function
Public Function ADFeatureTypeIdValid(ADFeatureTypeId)
    Dim rs As Recordset
    Dim qrystr As String
    
    qrystr = "select " & ADFEATURETYPE_ID & " from " & ADFEATURETYPE_TABLENAME & _
                " where " & ADFEATURETYPE_ID & " = '" & ADFeatureTypeId & "'"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ADFeatureTypeIdValid = 0
    Else
        ADFeatureTypeIdValid = rs.Fields.Item(ADFEATURETYPE_ID).value
    End If

    rs.Close

End Function

Public Sub LoadFeatureAttrConstraintRules()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, NewMyStr$, MyStrRef$
    Dim ftrName$, ID$
    Dim ADFeatureAttrConstrntId&, FtrTypeAttrIdNum&
    Dim ConstraintValues$
    Dim Operator&
    Dim MyNum&, ADFtrInstId&
    Dim ctr%
    Dim cellstr$, ValStr$
    Dim FtrAttrValueNum$, OperatorValid$
    Dim StrCnt&, intLoop&, colCnt&, cnt&
    Dim FtrAttrValuesValid As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
       
    Set ws = Worksheets("ADFeatureAttrConstrnt")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ADFeatureAttrConstrnt")
    logUpdates = GetLogUpdates("ADFeatureAttrConstrnt")
   
    ctr = 3
    
    Set cell = ws.Range("A3")
    ID = Trim(cell.value)
        
    rs.Open ADFEATUREATTRCONSTRNT_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    StrCnt = 0
    
    Do While ID <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        StrCnt = StrCnt + 1
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ADFeatureAttrConstrntId = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ADFtrInstId = Trim(cell.value)
        
        ADFtrInstId = ValidInstId(Trim(cell.value))
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        FtrTypeAttrIdNum = ADFtrTypeAttrId(Trim(MyStr), ADFtrInstId)

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        ConstraintValues = MyStr
        
        ValStr = Token2(MyStr, ",")
        Do While ValStr <> ""
            FtrAttrValueNum = VerifyFtrAttrValue(ValStr, FtrTypeAttrIdNum)
            ' Toggle FtrAttrValuesValid variable if any bad values found
            If FtrAttrValueNum = 0 Then
                FtrAttrValuesValid = False
            End If
            ValStr = Token2(MyStr, ",")
        Loop
        
        'Force as true need to look into VerifyFtrAttrValue
        FtrAttrValuesValid = True
        
        OperatorValid = 0
        
        If Operator = 0 Or Operator = 1 Or Operator = 1 Then
            OperatorValid = 1
        End If
        
        If FtrTypeAttrIdNum = 0 Or ADFeatureAttrConstrntId = 0 Or ADFtrInstId = 0 Or _
        ConstraintValues = "" Or OperatorValid = 0 Or FtrAttrValuesValid = False Then
            'Mark the failure in the spreadsheet
            cellstr = "G" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed"
        Else
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ADFEATUREATTRCONSTRNT_TABLENAME & _
                    " where " & ADFEATUREATTRCONSTRNT_TABLENAME & "." & ADFEATUREATTRCONSTRNT_ID & " = " & ADFeatureAttrConstrntId & _
                    " and " & ADFEATUREATTRCONSTRNT_TABLENAME & "." & ADFEATUREATTRCONSTRNT_ADFTRINSTID & " = " & ADFtrInstId & _
                    " and " & ADFEATUREATTRCONSTRNT_TABLENAME & "." & ADFEATUREATTRCONSTRNT_FTRATTRID & " = " & FtrTypeAttrIdNum & _
                    " and " & ADFEATUREATTRCONSTRNT_TABLENAME & "." & ADFEATUREATTRCONSTRNT_ATTRVALUES & " = '" & ConstraintValues & "'" & _
                    " and " & ADFEATUREATTRCONSTRNT_TABLENAME & "." & ADFEATUREATTRCONSTRNT_OPERATOR & " = " & Operator
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(ADFEATUREATTRCONSTRNT_ID).value = ADFeatureAttrConstrntId
                rs.Fields.Item(ADFEATUREATTRCONSTRNT_ADFTRINSTID).value = ADFtrInstId
                rs.Fields.Item(ADFEATUREATTRCONSTRNT_FTRATTRID).value = FtrTypeAttrIdNum
                rs.Fields.Item(ADFEATUREATTRCONSTRNT_ATTRVALUES).value = ConstraintValues
                rs.Fields.Item(ADFEATUREATTRCONSTRNT_OPERATOR).value = Operator
            Else
                'rsTmp.Fields.Item(ADFEATUREATTRCONSTRNT_ID).Value = ADFeatureAttrConstrntId
                'rsTmp.Fields.Item(ADFEATUREATTRCONSTRNT_ADFTRINSTID).Value = ADFtrInstId
                'rsTmp.Fields.Item(ADFEATUREATTRCONSTRNT_FTRATTRID).Value = FtrTypeAttrIdNum
                'rsTmp.Fields.Item(ADFEATUREATTRCONSTRNT_ATTRVALUES).Value = ConstraintValues
                'rsTmp.Fields.Item(ADFEATUREATTRCONSTRNT_OPERATOR).Value = Operator
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        If ADFtrInstId = 0 Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        If FtrTypeAttrIdNum = 0 Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If FtrAttrValuesValid = False Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close

    ImgADRule.Visible = True
    
    If Failure Then
        LogSheetFailure "ADFeatureAttrConstrnt"
    End If

End Sub

Public Function VerifyFtrAttrValue(attrValue$, AttrID&) As Long
    
    Dim DomainID&
    Dim sql$, domainName$
    Dim rs As ADODB.Recordset
    Dim retVal%

    
    sql = "select " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_NAME & _
            ", " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_ID & _
            " from " & ATTRDOMAIN_TBLNAME & ", " & FEATUREATTR_TBLNAME & _
            " where " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_ID & " = " & _
            FEATUREATTR_TBLNAME & "." & FEATUREATTR_ATTRDOMAINID & _
            " and " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_ID & " = " & CStr(AttrID)
    
    Set rs = Conn.Execute(sql, , adCmdText)
        
    If Not rs.BOF And Not rs.EOF Then
        DomainID = rs(ATTRDOMAIN_ID)
        domainName = rs(ATTRDOMAIN_NAME)
        rs.Close
    Else
        VerifyFtrAttrValue = 0
        Exit Function
    End If
    
    If (InStr(1, StandardDomains, domainName, 1) = 0) Then
    
        sql = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " from " & _
                ATTRLEGALVALUE_TBLNAME & ", " & _
                ATTRLEGALVALUEASSIGN_TBLNAME & " where " & _
                ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_DOMAINID & _
                " = " & CStr(DomainID) & _
                " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_LEGALVALUEID & _
                " = " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " and " & _
                ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_VALUE & " = '" & attrValue & "'"
    
        Set rs = Conn.Execute(sql, , adCmdText)
        
        If rs.EOF And rs.BOF Then
            VerifyFtrAttrValue = 0
        Else
            VerifyFtrAttrValue = rs.Fields.Item(FEATUREATTR_ID).value
        End If
        
    End If
    

    rs.Close

End Function
Public Function ADFtrTypeAttrId(Name As String, ADFeatureInstId As Long) As Long
    Dim rs As Recordset
    Dim qrystr As String
    
    'TO DO
    qrystr = "SELECT Name, FEATUREATTRIBUTE.id, FEATUREATTRIBUTE.FEATURETYPEID FROM ADFEATUREINST, ADFEATURETYPE, FEATUREATTRIBUTE " & _
    "WHERE ( (ADFEATURETYPE.ID = ADFEATUREINST.ADFEATURETYPEID And ADFEATUREINST.ID = " & ADFeatureInstId & _
    ") AND (FEATUREATTRIBUTE.FEATURETYPEID = ADFEATURETYPE.FEATURETYPEID) And (FEATUREATTRIBUTE.NAME = '" & Name & "' ) )"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        ADFtrTypeAttrId = 0
    Else
        ADFtrTypeAttrId = rs.Fields.Item(FEATUREATTR_ID).value
    End If

    rs.Close

End Function
Public Function ValidInstId(FeatureInstID$) As Long
    Dim MySql As String
    Dim rs As Recordset
    
    ValidInstId = 0
            
    MySql = "select * from " & ADFEATUREINST_TABLENAME & ", " & _
    ADFEATURETYPE_TABLENAME & " where ((" & ADFEATURETYPE_TABLENAME & "." & ADFEATURETYPE_ID & _
    " = " & ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_ADFEATURETYPEID & ") And (" & _
    ADFEATUREINST_TABLENAME & "." & ADFEATUREINST_ID & " = " & FeatureInstID & "))"
              
    Set rs = Conn.Execute(MySql)
    
    Do While rs.EOF <> True
        ValidInstId = FeatureInstID
        rs.MoveNext
    Loop

End Function
Private Sub CmdAttrConstraint_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait

    If Not IncrementalLoad Then
        DeleteTable ATTRCONSTRAINT_TBLNAME
    End If
    
    LoadAttributeConstraints
    LoadCustomRuleViolation
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdAttrStopCond_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRSTOPCOND_TBLNAME
    End If
    
    LoadAttrStopCondition
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdCondChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CONDCHAR_TABLENAME
    End If
    
    LoadCondChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdCondCharRules_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
      
    If Not IncrementalLoad Then
        DeleteEARules
    End If
    
    LoadCondCharRuleAttributes
    LoadDistTranCharRuleAttributes
    LoadFuseCharRuleAttributes
    LoadVoltageRegCharRuleAttributes
    LoadPowerTransCharRuleAttributes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdCondPref_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CONDPREFRANK_TABLENAME
    End If
    
    LoadCondPrefRanking
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdConfig_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CONFIGURATION_TBLNAME
        DeleteConfigurationSettings
    End If

    LoadConfiguration
    LoadConfigurationSettings

    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub cmdConnect_Click()
    
    ' Set our log file and directory
    If logdir = "" And logfile = "" Then
        Set_logfile "Dataloader.log"
        Set_logdir Environ$("USERPROFILE")
    End If
    clearLog
    
    frmDBConnect.Show
    If ConnectStr = "" Then Exit Sub
    
    Connect ConnectStr
End Sub

'Check if the current connection has a DBA or CHEDADMIN role.
'If it doesn't then we won't be able to truncate tables or add records
'to the configuration tables
Public Function IsSQLSERVER%()
    
    Dim retVal%
    If dbtype = "" Then
        Const sqlDriver$ = "sqlncli"
        Dim odbcDrv
        retVal = False
        odbcDrv = ""
        odbcDrv = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\" _
                        & TextBox1.Text, "Driver")
        dbtype = "ORACLE"
        If odbcDrv <> "" Then
            If InStr(1, LCase(odbcDrv), sqlDriver) > 0 Then
                dbtype = "SQLSERVER"
                retVal = True
            End If
        End If
    Else
        If dbtype = "SQLSERVER" Then
            retVal = True
        Else
            retVal = False
        End If
    End If
    
    IsSQLSERVER = retVal
End Function

Sub Connect(ConnectStr As String)

    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait

    On Error GoTo DB_Connect_Failed
    If Not Conn Is Nothing Then
        If Conn.State = adStateOpen Then Conn.Close
        Set Conn = Nothing
    End If
    Set Conn = New ADODB.connection
    
    SaveSetting "DBLoader", "General", "DSN", TextBox1.Text

    Dim connstr$, USERNAME$, sql$, msg$
    Dim Instance

    If IsSQLSERVER Then
        Dim ServerData As String
        Dim DatabaseData As String
        ServerData = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\CHDATA", "Server")
        DatabaseData = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\CHDATA", "Database")
        'Get the Provider from driver
        Const sqlDriver$ = "sqlncli"
        Dim odbcDrv, nDriverPos
        Dim Provider As String
        odbcDrv = ""
        odbcDrv = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\CHDATA", "Driver")
        nDriverPos = InStr(1, LCase(odbcDrv), sqlDriver)
        Provider = Replace(odbcDrv, ".dll", "", nDriverPos)
        connstr = ";Provider=" & Provider & ";Server=" & ServerData & ";Database=" & DatabaseData & ";Trusted_Connection=yes;MultipleActiveResultSets=true"
    Else
        connstr = ";DSN=" & TextBox1.Text & ConnectStr
    End If
    
    Conn.ConnectionString = connstr
    Conn.Open "", "", ""
     
    On Error GoTo Current_User_Failed
    USERNAME = GetCurrentUser
   
    Application.Cursor = OldCursor
   
    If HasDBARights Then
        
        If logdir <> "" And logfile <> "" Then
        
            Instance = ""
            If IsSQLSERVER Then
                Instance = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\" _
                                & TextBox1.Text, "Database")
            Else
                Instance = ReadRegistryKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Wow6432Node\ODBC\ODBC.INI\" _
                                & TextBox1.Text, "ServerName")
            End If
    
            If Instance <> "" Then
                frmLoadIntoDb.Caption = Left$(frmLoadIntoDb.Caption, 13) & " - " & Instance
                msg = USERNAME & " " & Now & " " & Instance
            Else
                msg = USERNAME & " " & Now & " " & TextBox1.Text
            End If
            LogMsg msg
        End If
        
        'Enable all of the controls
        Dim ctrl As Control
        For Each ctrl In Me.Controls
            If ctrl.Name <> "cmdConnect" And ctrl.Name <> "CmdTreeTrim" Then
                ctrl.Enabled = True
            Else
                If ctrl.Name = "CmdTreeTrim" Then
                    If Not IsSQLSERVER Then
                        ctrl.Enabled = True
                    End If
                End If
            End If
        Next ctrl
        
        For Each ctrl In Frame1.Controls
            ctrl.Enabled = False
        Next ctrl
        CmdLoadAll.SetFocus
    End If
    Exit Sub
DB_Connect_Failed:
    Debug.Print Err.Description
    Application.Cursor = OldCursor
    
    msg = "Error: Could not connect to Database" & vbCrLf & Err.Description
    If logdir <> "" And logfile <> "" Then
        LogMsg msg
    Else
        MsgBox msg, vbOKOnly & vbCritical, "ED Data Loader"
    End If
    
    Exit Sub
    'Unload Me
Current_User_Failed:
    Debug.Print Err.Description
    Application.Cursor = OldCursor
    
    msg = "Error: User Not Found"
    If logdir <> "" And logfile <> "" Then
        LogMsg msg
    Else
        MsgBox msg, vbOKOnly & vbCritical, "ED Data Loader"
    End If
End Sub

Private Sub CmdCustomQuery_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FOLDERCUSTOMQUERY_TBLNAME
    End If
    
    LoadFolderCustomQuery
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub LoadFolderCustomQuery()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim Folder$, Group$, Query$, ContextName$
    Dim groupid&, context&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False

    Label2.Caption = "Loading Folder Custom Query"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("FolderCustomQuery")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FolderCustomQuery")
    logUpdates = GetLogUpdates("FolderCustomQuery")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    Folder = Trim(cell.value)
        
    rs.Open FOLDERCUSTOMQUERY_TBLNAME, Conn, adOpenDynamic, _
                                            adLockPessimistic, adCmdTable
    
    Do While Folder <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
                 
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        groupid = GroupIDForName(Group)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ContextName = Trim(cell.value)
        context = ContextID(ContextName)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Query = Trim(cell.value)
    
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & FOLDERCUSTOMQUERY_TBLNAME & _
                " where " & FOLDERCUSTOMQUERY_TBLNAME & "." & FOLDERCUSTOMQUERY_FOLDERNAME & " = '" & Folder & "'" & _
                " and " & FOLDERCUSTOMQUERY_TBLNAME & "." & FOLDERCUSTOMQUERY_GROUPID & " = " & groupid & _
                " and " & FOLDERCUSTOMQUERY_TBLNAME & "." & FOLDERCUSTOMQUERY_QUERY & " = " & Query
                
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(FOLDERCUSTOMQUERY_FOLDERNAME) = Folder
            rs(FOLDERCUSTOMQUERY_GROUPID) = groupid
            rs(FOLDERCUSTOMQUERY_CONTEXTID) = context
            rs(FOLDERCUSTOMQUERY_QUERY) = Query
        Else
            'rsTmp(FOLDERCUSTOMQUERY_FOLDERNAME) = Folder
            'rsTmp(FOLDERCUSTOMQUERY_GROUPID) = GroupID
            'rsTmp(FOLDERCUSTOMQUERY_CONTEXTID) = context
            rsTmp(FOLDERCUSTOMQUERY_QUERY) = Query
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Folder = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FolderCustomQuery"
    End If
    ImgQueries.Visible = True
End Sub
Private Sub CmdDifficultyFactor_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable DIFFICULTYFACTOR_TBLNAME
    End If
    
    LoadDifficultyFactor
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdDistTranChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable DISTTRANCHAR_TABLENAME
    End If
    
    LoadDistTranChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub CmdDistTranFlicker_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable DISTTRANFLICKER_TABLENAME
    End If
    
    LoadDistTranFlickerBasedSize
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdDistTranPref_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable DISTTRANPREF_TABLENAME
    End If
    
    LoadDistTranPreference
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdElementAttrs_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EAELEMATTR_TABLENAME
    End If
    
    LoadEAElementAttr
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdElementDomain_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EAELEMATTRDOMAIN_TABLENAME
    End If
    
    LoadEAAttrDomain
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdElementType_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EAELEMTYPE_TABLENAME
    End If
    
    LoadEAElementType
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub CmdErrorMessage_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ERRORMESSAGE_TABLENAME
    End If
    
    LoadErrorMessage
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdExportFtrDetail_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EXPORTFTRDETAILS_TBLNAME
    End If
    
    LoadExportFtrDetails
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdFilter_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FILTERCONTRAINTTYPE_TBLNAME
        DeleteTable FILTER_TBLNAME
    End If
    
    LoadFilter
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub LoadFilter()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "Loading filters"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("filter")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("filter")
    logUpdates = GetLogUpdates("filter")

    Dim FilterType&, ctr&
    Dim Name$, FilterTypeName$
    Dim ID&, ParentID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
           
    ctr = 2
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)
    
    rs.Open FILTER_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FILTER_TBLNAME, NETWORKASSIGN_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        FilterTypeName = Trim(cell.value)
        If IsNumeric(FilterTypeName) Then
            FilterType = CLng(FilterTypeName)
            If FilterType <> 0 Then
                FilterType = NULL_LONG
            End If
        Else
            FilterType = FilterTypeID(FilterTypeName)
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        If FilterType <> NULL_LONG Then
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FILTER_TBLNAME & _
                    " where " & FILTER_TBLNAME & "." & FILTER_NAME & " = '" & Name & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FILTER_ID).value = ID
                rs.Fields.Item(FILTER_NAME).value = Name
                rs.Fields.Item(FILTER_TYPE).value = FilterType
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FILTER_ID).Value = ID
                rsTmp.Fields.Item(FILTER_NAME).value = Name
                'rsTmp.Fields.Item(FILTER_TYPE).Value = FilterType
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - not a valid filter type"
        End If
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "filter"
    End If
    ImgFilter.Visible = True
End Sub

Private Sub LoadFilterConstraintType()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "loading filterconstrainttype"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("filterconstrainttype")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("filterconstrainttype")
    logUpdates = GetLogUpdates("filterconstrainttype")

    Dim ntype&, ctr&
    Dim FilterName$, FeatureName$, LastFilterName$, LastFeatureName$
    Dim ConstraintName$, ConstraintValue$, Operator$, valueType$
    Dim ID&, FeatureID&, FilterID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ctr = 2
    LastFilterName = "": LastFeatureName = ""
    
    Set cell = ws.Range("A2")
    FilterName = Trim(cell.value)
    
    rs.Open FILTERCONTRAINTTYPE_TBLNAME, Conn, adOpenDynamic, _
                                                adLockPessimistic, adCmdTable
    ID = NextPK(FILTERCONTRAINTTYPE_TBLNAME, FILTERCONTRAINTTYPE_ID)
    Do While FilterName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
 
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        FeatureName = Trim(cell.value)
        
        If (LastFeatureName <> FeatureName) Or (LastFilterName <> FilterName) Then
            FilterID = FilterIDFromName(FilterName)
            If ds <> "" Then
                FeatureID = FeatureTypeID(FeatureName, ds)
            Else
                FeatureID = FeatureTypeID(FeatureName)
            End If
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FILTERCONTRAINTTYPE_TBLNAME & _
                    " where " & FILTERCONTRAINTTYPE_TBLNAME & "." & FILTERCONTRAINTTYPE_FILTERID & " = " & FilterID & _
                    " and " & FILTERCONTRAINTTYPE_TBLNAME & "." & FILTERCONTRAINTTYPE_OBJECTTYPEID & " = " & FeatureID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FILTERCONTRAINTTYPE_ID).value = ID
                rs.Fields.Item(FILTERCONTRAINTTYPE_FILTERID).value = FilterID
                rs.Fields.Item(FILTERCONTRAINTTYPE_OBJECTTYPEID).value = FeatureID
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FILTERCONTRAINTTYPE_ID).Value = ID
                'rsTmp.Fields.Item(FILTERCONTRAINTTYPE_FILTERID).Value = FilterID
                'rsTmp.Fields.Item(FILTERCONTRAINTTYPE_OBJECTTYPEID).Value = FeatureID
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
            LastFilterName = FilterName
            LastFeatureName = FeatureName
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ConstraintName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        ConstraintValue = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        Operator = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        valueType = Trim(cell.value)
        
        If (ConstraintName <> "") And (ConstraintValue <> "") And (Operator <> "") Then
            CreateFilterConstraint ID, ConstraintName, ConstraintValue, Operator, valueType
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        FilterName = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "filterconstrainttype"
    End If
    ImgFiltConstType.Visible = True
End Sub
Function FilterIDFromName&(Name$)
    Dim rs As Recordset
    Dim qrystr As String
       
    qrystr = "select " & FILTER_ID & " from " & FILTER_TBLNAME & _
                " where " & FILTER_NAME & " = '" & Name & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        FilterIDFromName = 0
    Else
        FilterIDFromName = rs.Fields.Item(FILTER_ID).value
    End If

    rs.Close
    
End Function



Private Sub CmdFilterConstType_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FILTERCONTRAINT_TBLNAME
        DeleteTable FILTERCONTRAINTTYPE_TBLNAME
    End If
    
    LoadFilterConstraintType
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdFtrCatalog_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteFtrCatalogConfigurationSettings
    End If
    
    LoadFtrCatalog
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdFuseChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FUSECHAR_TABLENAME
    End If
    
    LoadFuseChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLFParam_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EAOPTLFPARAM_TABLENAME
    End If
    
    LoadEAOptLFParamSetting
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub CmdLinkedAttrs_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRIBUTELINK_TBLNAME
    End If
    
    LoadLinkedAttributes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAttrRel_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait

    If Not IncrementalLoad Then
        DeleteTable ATTRREL_TBLNAME
    End If
    
    LoadAttributeRelations
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub LoadFeatureAttrMapping()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim FtrTypeID&, ID&, FtrAttrID&
    Dim ftrName$, attrName$, LastFtrName$, LastAttrName$
    Dim Operator$, attrValue$
    Dim ctr%, FtrChanged%, AttrChanged%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Label2.Caption = "Loading Feature Attribute Mapping"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("FeatureAttributeMapping")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureAttributeMapping")
    logUpdates = GetLogUpdates("FeatureAttributeMapping")

    ctr = 2
    
    LastFtrName = ""
    LastAttrName = ""
    
    Set cell = ws.Range("A2")
    ftrName = Trim(cell.value)
        
    rs.Open FTRATTRMAP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FTRATTRMAP_TBLNAME, FTRATTRMAP_ID)
    
    Do While ftrName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
         
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
         
        If ftrName <> LastFtrName Then
            If ds <> "" Then
                FtrTypeID = FeatureTypeID(ftrName, ds)
            Else
                FtrTypeID = FeatureTypeID(ftrName)
            End If
            LastFtrName = ftrName
            FtrChanged = True
        Else
            FtrChanged = False
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        attrName = Trim(cell.value)
        If attrName <> LastAttrName Then
            LastAttrName = attrName
            AttrChanged = True
        Else
            AttrChanged = False
        End If
        If FtrChanged Or AttrChanged Then
            FtrAttrID = AttrIdFromExternalNameAndFtrTypeID(attrName, FtrTypeID)
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        attrValue = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        Operator = OperatorValue(MyStr, True)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        
        If FtrAttrID = 0 Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "There is no attribute with this external name"
        ElseIf Operator = "" Then
            'Mark the failure in the spreadsheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Not a valid operator"
        Else
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FTRATTRMAP_TBLNAME & _
                    " where " & FTRATTRMAP_TBLNAME & "." & FTRATTRMAP_ATTRNAME & " = '" & attrName & "'" & _
                    " and " & FTRATTRMAP_TBLNAME & "." & FTRATTRMAP_VALUE & " = '" & attrValue & "'" & _
                    " and " & FTRATTRMAP_TBLNAME & "." & FTRATTRMAP_OPERATOR & " = '" & Operator & "'" & _
                    " and " & FTRATTRMAP_TBLNAME & "." & FTRATTRMAP_FTRTYPEID & " = " & FtrTypeID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FTRATTRMAP_ID).value = ID
                rs.Fields.Item(FTRATTRMAP_FTRTYPEID).value = FtrTypeID
                rs.Fields.Item(FTRATTRMAP_ATTRNAME) = attrName
                rs.Fields.Item(FTRATTRMAP_VALUE) = attrValue
                rs.Fields.Item(FTRATTRMAP_OPERATOR) = Operator
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FTRATTRMAP_ID).Value = ID
                'rsTmp.Fields.Item(FTRATTRMAP_FTRTYPEID).Value = FtrTypeID
                'rsTmp.Fields.Item(FTRATTRMAP_ATTRNAME) = attrName
                'rsTmp.Fields.Item(FTRATTRMAP_VALUE) = attrValue
                'rsTmp.Fields.Item(FTRATTRMAP_OPERATOR) = Operator
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureAttributeMapping"
    End If
    ImgFtrTypeAttrMap.Visible = True
End Sub

Private Sub LoadLinkedAttributes()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim FtrTypeID&, FtrAttrID&, LinkedFtrAttrID&
    Dim ftrName$, attrName$, LinkedFtrAttrName$
    Dim Operator$, LinkedFtrName$, LastFtrName$, LastAttrName$, LastLinkFtr$, LastLinkAttr$
    Dim ctr%, FtrChanged%, AttrChanged%, LinkFtrChanged%, LinkAttrChanged%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Label2.Caption = "Loading Linked Attributes"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("LinkedAttributes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("LinkedAttributes")
    logUpdates = GetLogUpdates("LinkedAttributes")

    ctr = 2
    LastFtrName = ""
    LastAttrName = ""
    LastLinkFtr = ""
    LastLinkAttr = ""
    
    Set cell = ws.Range("A2")
    attrName = Trim(cell.value)
        
    rs.Open ATTRIBUTELINK_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While attrName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        If attrName <> LastAttrName Then
            LastAttrName = attrName
            AttrChanged = True
        Else
            AttrChanged = False
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        If ftrName <> LastFtrName Then
            LastFtrName = ftrName
            FtrChanged = True
        Else
            FtrChanged = False
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        LinkedFtrAttrName = Trim(cell.value)
        If LinkedFtrAttrName <> LastLinkAttr Then
            LastLinkAttr = LinkedFtrAttrName
            LinkAttrChanged = True
        Else
            LinkAttrChanged = False
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        LinkedFtrName = Trim(cell.value)
        If LinkedFtrName <> LastLinkFtr Then
            LastLinkFtr = LinkedFtrName
            LinkFtrChanged = True
        Else
            LinkFtrChanged = False
        End If
        If FtrChanged Or AttrChanged Then
            If ds <> "" Then
                FtrAttrID = AttrIdFromInternalNameAndFtrTbl(attrName, ftrName, ds)
            Else
                FtrAttrID = AttrIdFromInternalNameAndFtrTbl(attrName, ftrName)
            End If
        End If
        If LinkFtrChanged Or LinkAttrChanged Then
            If ds <> "" Then
                LinkedFtrAttrID = AttrIdFromInternalNameAndFtrTbl(LinkedFtrAttrName, LinkedFtrName, ds)
            Else
                LinkedFtrAttrID = AttrIdFromInternalNameAndFtrTbl(LinkedFtrAttrName, LinkedFtrName)
            End If
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        
        If FtrAttrID = NULL_LONG Then
            'Mark the failure in the spreadsheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = ftrName & " does not have an attribute with internal name " & attrName
        ElseIf LinkedFtrAttrID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = LinkedFtrName & " does not have an attribute with internal name " & LinkedFtrAttrName
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & ATTRIBUTELINK_TBLNAME & _
                    " where " & ATTRIBUTELINK_TBLNAME & "." & ATTRIBUTELINK_FTRATTRID & " = " & FtrAttrID & _
                    " and " & ATTRIBUTELINK_TBLNAME & "." & ATTRIBUTELINK_LINKEDFTRATTRID & " = " & LinkedFtrAttrID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(ATTRIBUTELINK_FTRATTRID).value = FtrAttrID
                rs.Fields.Item(ATTRIBUTELINK_LINKEDFTRATTRID).value = LinkedFtrAttrID
            Else
                'rsTmp.Fields.Item(ATTRIBUTELINK_FTRATTRID).Value = FtrAttrID
                'rsTmp.Fields.Item(ATTRIBUTELINK_LINKEDFTRATTRID).Value = LinkedFtrAttrID
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close

        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        attrName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close

    If Failure Then
        LogSheetFailure "LinkedAttributes"
    End If
    ImgLinkedAttrs.Visible = True
End Sub
Private Sub LoadFtrAttrSplitMapping()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim FtrTypeID&, ID&, FtrAttrID&, DomainID&, LegalValID&
    Dim ftrName$, attrName$
    Dim Operator$, attrValue$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Label2.Caption = "Loading Feature Attribute Split Mapping"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("FeatureAttributeSplitMapping")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureAttributeSplitMapping")
    logUpdates = GetLogUpdates("FeatureAttributeSplitMapping")

    ctr = 2
    
    Set cell = ws.Range("A2")
    ftrName = Trim(cell.value)
        
    rs.Open FTRATTRSPLITMAP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FTRATTRSPLITMAP_TBLNAME, FTRATTRSPLITMAP_ID)
    
    Do While ftrName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)

        If ds <> "" Then
            FtrTypeID = FeatureTypeID(ftrName, ds)
        Else
            FtrTypeID = FeatureTypeID(ftrName)
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        attrName = Trim(cell.value)
        FtrAttrID = AttrIdFromNameAndFtrTypeID(attrName, FtrTypeID)
        DomainID = AttrDomainIDForFtrAttr(FtrAttrID)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        attrValue = Trim(cell.value)
        LegalValID = NULL_LONG
        If DomainID <> NULL_LONG Then
            LegalValID = AttrLegalValueID(attrValue, DomainID)
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)

        MyStr = Trim(cell.value)
        Operator = OperatorValue(MyStr, False)

        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        
        If Operator = "" Then
            'Mark the failure in the spreadsheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Not a valid operator"
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FTRATTRSPLITMAP_TBLNAME & _
                    " where " & FTRATTRSPLITMAP_TBLNAME & "." & FTRATTRSPLITMAP_FTRTYPEID & " = " & FtrTypeID & _
                    " and " & FTRATTRSPLITMAP_TBLNAME & "." & FTRATTRSPLITMAP_FTRATTRID & " = " & FtrAttrID & _
                    " and " & FTRATTRSPLITMAP_TBLNAME & "." & FTRATTRSPLITMAP_OPERATOR & " = '" & Operator & "'" & _
                    " and (" & FTRATTRSPLITMAP_TBLNAME & "." & FTRATTRSPLITMAP_LEGALVALUEID & " = " & LegalValID & _
                    " or " & FTRATTRSPLITMAP_TBLNAME & "." & FTRATTRSPLITMAP_VALUE & " = '" & attrValue & "')"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FTRATTRSPLITMAP_ID).value = ID
                rs.Fields.Item(FTRATTRSPLITMAP_FTRTYPEID).value = FtrTypeID
                rs.Fields.Item(FTRATTRSPLITMAP_FTRATTRID) = FtrAttrID
                If LegalValID <> NULL_LONG Then
                    rs.Fields.Item(FTRATTRSPLITMAP_LEGALVALUEID) = LegalValID
                Else
                    rs.Fields.Item(FTRATTRSPLITMAP_VALUE) = attrValue
                End If
                rs.Fields.Item(FTRATTRSPLITMAP_OPERATOR) = Operator
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FTRATTRSPLITMAP_ID).Value = ID
                'rsTmp.Fields.Item(FTRATTRSPLITMAP_FTRTYPEID).Value = FtrTypeID
                'rsTmp.Fields.Item(FTRATTRSPLITMAP_FTRATTRID) = FtrAttrID
                'If LegalValID <> NULL_LONG Then
                '    rsTmp.Fields.Item(FTRATTRSPLITMAP_LEGALVALUEID) = LegalValID
                'Else
                '    rsTmp.Fields.Item(FTRATTRSPLITMAP_VALUE) = attrValue
                'End If
                'rsTmp.Fields.Item(FTRATTRSPLITMAP_OPERATOR) = Operator
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureAttributeSplitMapping"
    End If
    ImgFtrSplitMap.Visible = True
End Sub

Private Sub CmdLoadCommodityType_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CMDTGROUPASSIGNMENT_TBLNAME
        DeleteTable CMDTGROUP_TBLNAME
        DeleteTable CMDTTYPE_TBLNAME
    End If
    
    LoadCommodityType
    LoadCommodityGroup
    LoadCommodityGroupAssignment
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor

End Sub

Private Sub CmdLoadEDServer_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable RUNCONCURRENCYCNSTRNT_TBLNAME
        DeleteTable RUNTIMECNSTRNT_TBLNAME
        DeleteTable SERVERCONFIGURATION_TBLNAME
        DeleteTable SERVERLOGITEM_TBLNAME
        DeleteTable JOB_TBLNAME, "CHSERVER"
        DeleteTable JOBTYPE_TBLNAME
    End If
    
    LoadEDServer
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadFtrAttrMap_Click()
    Dim OldCursor&
    
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FTRATTRMAP_TBLNAME
    End If
    
    LoadFeatureAttrMapping
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdLoadFtrSplitMapping_Click()
    Dim OldCursor&
    
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FTRATTRSPLITMAP_TBLNAME
    End If
    
    LoadFtrAttrSplitMapping
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdLoadGroupCapability_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable (GROUPCAPABILITY_TBLNAME)
    End If
    
    LoadGroupCapabilityAssignments
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadGroups_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable (GROUP_TBLNAME)
    End If
    
    LoadGroups
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadUserGroups_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable (USERGROUP_TBLNAME)
    End If
    
    LoadUserGroupAssignments
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdLoadUsers_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable (USER_TBLNAME)
    End If
    
    LoadUsers
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadWorkFlow_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable WORKFLOW_TBLNAME
    End If
    
    LoadWorkFlow
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdNtwkConfig_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRSTOPCOND_TBLNAME
        DeleteTable NETWORKASSIGN_TBLNAME
        DeleteNetworkConfig
    End If
       
    LoadNetworkConfig
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub DeleteNetworkConfig()
    Dim sql$
    
    sql = "Delete from " & NETWORKCONFIG_TBLNAME & _
            " WHERE " & NETWORKCONFIG_PARENTID & " IS NOT NULL"

    Conn.Execute sql, , adCmdText + adExecuteNoRecords

    
    DeleteTable NETWORKCONFIG_TBLNAME
End Sub

Private Sub CmdNtwkConfigAssign_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable NETWORKASSIGN_TBLNAME
    End If
    
    LoadNetworkAssign
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub LoadNetworkAssign()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Name$, NetConfig$, NetName$, parent$, FeatureAttribute$, Feature$
    Dim FeatureID&, NetConfigID&, FeatureAttributeID&
    Dim ID&, ParentID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading Network Assignment"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("NetworkAssignment")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("NetworkAssignment")
    logUpdates = GetLogUpdates("NetworkAssignment")

    ctr = 2
    
    Set cell = ws.Range("A2")
    NetConfig = Trim(cell.value)
    
    rs.Open NETWORKASSIGN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(NETWORKASSIGN_TBLNAME, NETWORKASSIGN_ID)
    Do While NetConfig <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        parent = Trim(cell.value)
        
        NetConfigID = NetConfigFromNetConfigParent(NetConfig, parent)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        FeatureAttribute = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Feature = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        If (FeatureAttribute <> "") Then
            If ds <> "" Then
                FeatureAttributeID = AttrIdFromNameAndFtrTbl(FeatureAttribute, Feature, ds)
            Else
                FeatureAttributeID = AttrIdFromNameAndFtrTbl(FeatureAttribute, Feature)
            End If
        Else
            If ds <> "" Then
                FeatureID = FeatureTypeID(Feature, ds)
            Else
                FeatureID = FeatureTypeID(Feature)
            End If
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & NETWORKASSIGN_TBLNAME & _
                " where " & NETWORKASSIGN_TBLNAME & "." & NETWORKASSIGN_NETWORKCONFIGID & " = " & NetConfigID
                
        If (FeatureAttribute <> "") Then
            sqlTmp = sqlTmp & " and " & NETWORKASSIGN_TBLNAME & "." & NETWORKASSIGN_FEATUREATTRIBUTEID & " = " & FeatureAttributeID
        Else
            sqlTmp = sqlTmp & " and " & NETWORKASSIGN_TBLNAME & "." & NETWORKASSIGN_FEATURETYPEID & " = " & FeatureID
        End If
                
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(NETWORKASSIGN_ID).value = ID
            rs.Fields.Item(NETWORKASSIGN_NETWORKCONFIGID).value = NetConfigID
            If (FeatureAttribute <> "") Then
                rs.Fields(NETWORKASSIGN_FEATUREATTRIBUTEID) = FeatureAttributeID
            Else
                rs.Fields(NETWORKASSIGN_FEATURETYPEID) = FeatureID
            End If
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(NETWORKASSIGN_ID).Value = ID
            'rsTmp.Fields.Item(NETWORKASSIGN_NETWORKCONFIGID).Value = NetConfigID
            'If (FeatureAttribute <> "") Then
            '    rsTmp.Fields(NETWORKASSIGN_FEATUREATTRIBUTEID) = FeatureAttributeID
            'Else
            '    rsTmp.Fields(NETWORKASSIGN_FEATURETYPEID) = FeatureID
            'End If
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        NetConfig = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "NetworkAssignment"
    End If
    ImgNtwkConfigAssign.Visible = True
End Sub
Private Sub CmdPACUAssign_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CUPAASSIGN_TBLNAME
    End If
    
    LoadCUPAAssignments
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdPlacementDefaults_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable PLACEDEFSET_TBLNAME
    End If
    
    LoadPlacementDefaultSettings
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdPlantAccount_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable PLANTACCOUNT_TBLNAME
    End If
    
    LoadPlantAccount
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub cmdLoadLaborType_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable LABORTYPE_TBLNAME
        DeleteTable WORKTYPE_TBLNAME
    End If
    
    LoadLaborType
    LoadWorkType
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub cmdLoadCUActivity_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CUACTIVITY_TBLNAME
    End If
    
    LoadCUActivity
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub cmdLoadFixedCULaborCost_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FIXEDCULABORCOST_TBLNAME
    End If
    
    LoadFixedCULaborCost
    LoadFixedCULaborCost2
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadUserUnitAssign_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable USERUNITASSIGNSETTINGS_TBLNAME
    End If
    
    LoadUserUnitAssignSettings
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub LoadLaborType()
    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Rate#
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Labor Type"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("LaborType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("LaborType")
    logUpdates = GetLogUpdates("LaborType")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open LABORTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(LABORTYPE_TBLNAME, LABORTYPE_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Rate = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
    
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & LABORTYPE_TBLNAME & _
                " where " & LABORTYPE_TBLNAME & "." & LABORTYPE_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(LABORTYPE_ID) = ID
            rs(LABORTYPE_NAME) = Name
            rs(LABORTYPE_RATE) = Rate
            rs(LABORTYPE_COMMODITYGROUPID).value = groupid
            ID = ID + 1
        Else
            'rsTmp(LABORTYPE_ID) = ID
            'rsTmp(LABORTYPE_NAME) = name
            rsTmp(LABORTYPE_RATE) = Rate
            rsTmp(LABORTYPE_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "LaborType"
    End If
    'imgLoadLaborType.Visible = True
End Sub

Private Sub LoadWorkType()
    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Work Type"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("WorkType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WorkType")
    logUpdates = GetLogUpdates("WorkType")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open WORKTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(WORKTYPE_TBLNAME, WORKTYPE_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
       
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & WORKTYPE_TBLNAME & _
                " where " & WORKTYPE_TBLNAME & "." & WORKTYPE_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(WORKTYPE_ID) = ID
            rs(WORKTYPE_NAME) = Name
            rs(WORKTYPE_COMMODITYGROUPID).value = groupid
            ID = ID + 1
        Else
            'rsTmp(WORKTYPE_ID) = ID
            'rsTmp(WORKTYPE_NAME) = name
            rsTmp(WORKTYPE_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "WorkType"
    End If
    imgLoadLaborType.Visible = True
End Sub

Private Sub LoadWRRequirementType()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, REMARKTYPE$, Desc$, ReqType$, temp$
    Dim MyNum&
    Dim ctr%, i%, DupReqType%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading WR Requirement Type"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("WRRequirementType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WRRequirementType")
    logUpdates = GetLogUpdates("WRRequirementType")

    ctr = 2
    
    Set cell = ws.Range("A2")
    ReqType = Trim(cell.value)
        
    rs.Open WRRQMTTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    Do While ReqType <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If IsNumeric(ReqType) Then
            
            DupReqType = False
            For i = 1 To ctr - 1
                cellstr = "A" & i
                Set cell = ws.Range(cellstr)
                temp = Trim(cell.value)
                If temp = ReqType Then
                    DupReqType = True
                    Exit For
                End If
            Next i
                
            If Not DupReqType Then
                
                cellstr = "B" & ctr
                Set cell = ws.Range(cellstr)
                Desc = Trim(cell.value)
                
                cellstr = "C" & ctr
                Set cell = ws.Range(cellstr)
                REMARKTYPE = Trim(cell.value)
                
                cellstr = "D" & ctr
                Set cell = ws.Range(cellstr)
                If Len(REMARKTYPE) < 5 Then
                    If IsRemarkTypeValid(REMARKTYPE) Then
                
                        ' Check for existing rows: DONE
                        sqlTmp = "select * from " & WRRQMTTYPE_TBLNAME & _
                                " where " & WRRQMTTYPE_TBLNAME & "." & WRRQMTTYPE_TYPE & " = " & CLng(ReqType) & _
                                " and " & WRRQMTTYPE_TBLNAME & "." & WRRQMTTYPE_REMARKTYPE & " = '" & REMARKTYPE & "'"
                        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                        If rsTmp.BOF And rsTmp.EOF Then
                            rs.AddNew
                            rs(WRRQMTTYPE_TYPE) = CLng(ReqType)
                            rs(WRRQMTTYPE_DESCRIPTION) = Desc
                            rs(WRRQMTTYPE_REMARKTYPE) = REMARKTYPE
                        Else
                            'rsTmp(WRRQMTTYPE_TYPE) = CLng(ReqType)
                            rsTmp(WRRQMTTYPE_DESCRIPTION) = Desc
                            'rsTmp(WRRQMTTYPE_REMARKTYPE) = REMARKTYPE
                            rsTmp.Update

                            If logUpdates = "1" Then
                                ' Tell user about our update:
                                Set cell = ws.Range((ErrorCol & ctr))
                                cell.Font.Color = RGB(255, 0, 0)
                                cell.value = cell.value & " Updated existing row"
                                Failure = True
                            End If
                        End If
                        rsTmp.Close
                        
                    Else
                        cell.Font.Color = RGB(255, 0, 0)
                        Failure = True
                        cell.value = "Could not find Remark Type"
                    End If
                Else
                    cell.Font.Color = RGB(255, 0, 0)
                    Failure = True
                    cell.value = "Remark Type must be 4 characters or less"
                End If
            Else
                cellstr = "D" & ctr
                Set cell = ws.Range(cellstr)
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Duplicate Requirement Type"
            End If

        Else
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Requirement Type must be numeric"
        End If
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ReqType = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close

    If Failure Then
        LogSheetFailure "WRRequirementType"
    End If
End Sub

Function IsRemarkTypeValid%(REMARKTYPE$)
    Dim rs As Recordset
    Dim qrystr As String


    qrystr = "select " & WRREMARKTYPE_TYPE & " from " & WRREMARKTYPE_TBLNAME & " where " & _
                    WRREMARKTYPE_TYPE & " = '" & REMARKTYPE & "'"
    
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        IsRemarkTypeValid = False
    Else
        IsRemarkTypeValid = True
    End If
    
    rs.Close
    
End Function
Private Sub LoadWRRemarkType()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, REMARKTYPE$, Desc$
    Dim MyNum&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading WR Remark Type"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("WRRemarkType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WRRemarkType")
    logUpdates = GetLogUpdates("WRRemarkType")

    ctr = 2
    
    Set cell = ws.Range("A2")
    REMARKTYPE = Trim(cell.value)
        
    rs.Open WRREMARKTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    Do While REMARKTYPE <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If Len(REMARKTYPE) < 5 Then
            
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            Desc = Trim(cell.value)
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & WRREMARKTYPE_TBLNAME & _
                    " where " & WRREMARKTYPE_TBLNAME & "." & WRREMARKTYPE_TYPE & " = '" & REMARKTYPE & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(WRREMARKTYPE_TYPE) = REMARKTYPE
                rs(WRREMARKTYPE_DESCRIPTION) = Desc
            Else
                'rsTmp(WRREMARKTYPE_TYPE) = REMARKTYPE
                rsTmp(WRREMARKTYPE_DESCRIPTION) = Desc
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
    
            ctr = ctr + 1
            cellstr = "A" & ctr
            Set cell = ws.Range(cellstr)
            REMARKTYPE = Trim(cell.value)
        End If
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    If Failure Then
        LogSheetFailure "WRRemarkType"
    End If
End Sub
Private Sub LogSheetFailure(SheetName$)

    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, value$
    Dim ctr%

    Set ws = Worksheets("DataloaderErrors")
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    
    Do While value <> ""
    
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop

    'cell.Value = SheetName
    LogMsg "Error: " & SheetName
    
    ' Lets make it just a bit easier to go to the tab in error by adding a hyperlink to it:
    Application.Worksheets("DataloaderErrors").Select
    Application.Range("A" & ctr).Select
    ActiveSheet.Hyperlinks.Add Anchor:=Selection, Address:="", SubAddress:=SheetName & "!A1", ScreenTip:="", TextToDisplay:=SheetName
    
    FailedSheets = FailedSheets & SheetName & vbCrLf
End Sub

Private Sub LoadWorkFlow()
    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, Name$, Description$, InitialState$, LastState$, PWTempFldGRUID$, PWSubFldNAME, PWBaseFldGRUID$
    Dim ID&, InitialStateID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Work Flow"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("WorkFlow")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WorkFlow")
    logUpdates = GetLogUpdates("WorkFlow")

    ctr = 2
    LastState = ""
    
    cellstr = "A" & ctr
    Set cell = ws.Range(cellstr)
    Name = Trim(cell.value)
        
    rs.Open WORKFLOW_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(WORKFLOW_TBLNAME, WORKFLOW_ID)
    
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        InitialState = Trim(cell.value)
        If InitialState <> "" Then
            If InitialState <> LastState Then
                InitialStateID = WRState(InitialState)
                LastState = InitialState
            End If
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        PWTempFldGRUID = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        PWSubFldNAME = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        PWBaseFldGRUID = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        If InitialStateID = 0 Then
            'Flag the failure on the sheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find initial state"
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & WORKFLOW_TBLNAME & _
                    " where " & WORKFLOW_TBLNAME & "." & WORKFLOW_NAME & " = '" & Name & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(WORKFLOW_ID) = ID
                rs(WORKFLOW_NAME) = Name
                rs(WORKFLOW_DESCRIPTION) = Description
                rs(WORKFLOW_INITIALSTATEID) = InitialStateID
                rs(WORKFLOW_COMMODITYGROUPID).value = groupid
                rs(WORKFLOW_PWTEMPLATEFOLDERGUID).value = PWTempFldGRUID
                rs(WORKFLOW_PWSUBFOLDERNAME).value = PWSubFldNAME
                rs(WORKFLOW_PWBASEFOLDERGUID).value = PWBaseFldGRUID
                ID = ID + 1
            Else
                'rsTmp(WORKFLOW_ID) = ID
                'rsTmp(WORKFLOW_NAME) = name
                rsTmp(WORKFLOW_DESCRIPTION) = Description
                rsTmp(WORKFLOW_INITIALSTATEID) = InitialStateID
                rsTmp(WORKFLOW_COMMODITYGROUPID).value = groupid
                rsTmp(WORKFLOW_PWTEMPLATEFOLDERGUID).value = PWTempFldGRUID
                rsTmp(WORKFLOW_PWSUBFOLDERNAME).value = PWSubFldNAME
                rsTmp(WORKFLOW_PWBASEFOLDERGUID).value = PWBaseFldGRUID
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    ImgWorkFlow.Visible = True
    
    If Failure Then
        LogSheetFailure "WorkFlow"
    End If
End Sub

Private Sub LoadCUActivity()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$, CurrentWorkType$
    Dim MyNum&, ID&, ctr&, CurrentWorkTypeID&
    Dim IHours#, RHours#, THours#, AHours#
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False

    Label2.Caption = "Loading CUActivity"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("CUActivity")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CUActivity")
    logUpdates = GetLogUpdates("CUActivity")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CUACTIVITY_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    CurrentWorkType = "None"
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        MyNum = CUID(Trim(MyStr))
        
        If MyNum = 0 Then
            ' Tell user about our update:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = cell.value & " Unable to locate CU id."
            Failure = True
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If CurrentWorkType <> MyStr Then
            CurrentWorkType = MyStr
            CurrentWorkTypeID = WorkTypeID(MyStr)
        End If
        
        If CurrentWorkTypeID = 0 Then
            ' Tell user about our update:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = cell.value & " Unable to locate Work Type id."
            Failure = True
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        IHours = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RHours = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        THours = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        AHours = Trim(cell.value)
        
        If MyNum <> 0 And CurrentWorkTypeID <> 0 Then
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & CUACTIVITY_TBLNAME & _
                    " where " & CUACTIVITY_TBLNAME & "." & CUACTIVITY_CUID & " = " & MyNum & _
                    " and " & CUACTIVITY_TBLNAME & "." & CUACTIVITY_WORKTYPEID & " = " & CurrentWorkTypeID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(CUACTIVITY_CUID) = MyNum
                rs(CUACTIVITY_WORKTYPEID) = CurrentWorkTypeID
                rs(CUACTIVITY_INSTALLHOURS) = IHours
                rs(CUACTIVITY_REMOVEHOURS) = RHours
                rs(CUACTIVITY_TRANSFERHOURS) = THours
                rs(CUACTIVITY_ABANDONHOURS) = AHours
            Else
                'rsTmp(CUACTIVITY_CUID) = MyNum
                'rsTmp(CUACTIVITY_WORKTYPEID) = CurrentWorkTypeID
                rsTmp(CUACTIVITY_INSTALLHOURS) = IHours
                rsTmp(CUACTIVITY_REMOVEHOURS) = RHours
                rsTmp(CUACTIVITY_TRANSFERHOURS) = THours
                rsTmp(CUACTIVITY_ABANDONHOURS) = AHours
                rsTmp.Update
    
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        End If

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CUActivity"
    End If
    imgLoadCUActivity.Visible = True
End Sub

Function WorkTypeID(strWTName As String) As Long
    Dim rs As Recordset
    Dim sql$
    Dim ID&
    
    If WorkTypes Is Nothing Then
        Set WorkTypes = New Collection
    End If
    On Error GoTo not_in_WT_collection
    ID = WorkTypes.Item(strWTName)
    On Error GoTo 0
    WorkTypeID = ID
    Exit Function
    
not_in_WT_collection:
    sql = "select " & WORKTYPE_ID & " from " & WORKTYPE_TBLNAME & _
            " where " & WORKTYPE_NAME & " = '" & strWTName & "'"
    Set rs = Conn.Execute(sql)
    
    If rs.EOF And rs.BOF Then
        ID = 0
    Else
        ID = rs.Fields.Item(WORKTYPE_ID).value
    End If

    rs.Close
    
    WorkTypes.Add ID, strWTName
    WorkTypeID = ID
    
End Function
Private Sub LoadFixedCULaborCost()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyNumD&, MyNumE&, MyNumF&, MyNumG&, MyNumH&, MyNumI&, MyNumJ&, MyNumK&, MyNumL&
    Dim MyStr$, cellstr$, Name$, value$, NewLaborType$, NewWorkType$, CUName$, LastCU$
    Dim MyNum&, ID&, CurrentLaborTypeID&, CurrentWorkTypeID&, CU_ID&
    Dim ctr&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Fixed CU Labor Cost"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("FixedCULaborCost")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FixedCULaborCost")
    logUpdates = GetLogUpdates("FixedCULaborCost")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open FIXEDCULABORCOST_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    NewLaborType = "NONE"
    NewWorkType = "NONE"
    LastCU = ""
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CUName = Trim(cell.value)
        If LastCU <> CUName Then
            CU_ID = CUID(CUName)
            LastCU = CUName
        End If
        
        If CU_ID = 0 Then
            ' Tell user about our update:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = cell.value & " Unable to locate CU id."
            Failure = True
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        
        If NewLaborType <> MyStr Then
            NewLaborType = MyStr
            CurrentLaborTypeID = LaborTypeID(MyStr)
        End If
        If CurrentLaborTypeID = 0 Then
            ' Tell user about our update:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = cell.value & " Unable to locate Labor Type id."
            Failure = True
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        
        If NewWorkType <> MyStr Then
            NewWorkType = MyStr
            CurrentWorkTypeID = WorkTypeID(MyStr)
        End If

        If CurrentWorkTypeID = 0 Then
            ' Tell user about our update:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            cell.value = cell.value & " Unable to locate Work Type id."
            Failure = True
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNumD = BoolStringToInt(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyNumE = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNumF = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        MyNumG = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MyNumH = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        MyNumI = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        MyNumJ = Trim(cell.value)
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        MyNumK = Trim(cell.value)
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        MyNumL = Trim(cell.value)
              
        If CU_ID <> 0 And CurrentLaborTypeID <> 0 And CurrentWorkTypeID <> 0 Then

            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FIXEDCULABORCOST_TBLNAME & _
                    " where " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_CUID & " = " & CU_ID & _
                    " and " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_LABORTYPEID & " = " & CurrentLaborTypeID & _
                    " and " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_WORKTYPEID & " = " & CurrentWorkTypeID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(FIXEDCULABORCOST_CUID) = CU_ID
                rs(FIXEDCULABORCOST_LABORTYPEID) = CurrentLaborTypeID
                rs(FIXEDCULABORCOST_WORKTYPEID) = CurrentWorkTypeID
                rs(FIXEDCULABORCOST_ISFIXED) = MyNumD
                rs(FIXEDCULABORCOST_FIXEDINSTALLCOST) = MyNumE
                rs(FIXEDCULABORCOST_FIXEDREMOVECOST) = MyNumF
                rs(FIXEDCULABORCOST_FIXEDTRANSFERCOST) = MyNumG
                rs(FIXEDCULABORCOST_FIXEDABANDONCOST) = MyNumH
                rs(FIXEDCULABORCOST_LABORCOSTINSTALL) = MyNumI
                rs(FIXEDCULABORCOST_LABORCOSTREMOVE) = MyNumJ
                rs(FIXEDCULABORCOST_LABORCOSTTRANSFER) = MyNumK
                rs(FIXEDCULABORCOST_LABORCOSTABANDON) = MyNumL
            Else
                'rsTmp(FIXEDCULABORCOST_CUID) = CU_ID
                'rsTmp(FIXEDCULABORCOST_LABORTYPEID) = CurrentLaborTypeID
                'rsTmp(FIXEDCULABORCOST_WORKTYPEID) = CurrentWorkTypeID
                rsTmp(FIXEDCULABORCOST_ISFIXED) = MyNumD
                rsTmp(FIXEDCULABORCOST_FIXEDINSTALLCOST) = MyNumE
                rsTmp(FIXEDCULABORCOST_FIXEDREMOVECOST) = MyNumF
                rsTmp(FIXEDCULABORCOST_FIXEDTRANSFERCOST) = MyNumG
                rsTmp(FIXEDCULABORCOST_FIXEDABANDONCOST) = MyNumH
                rsTmp(FIXEDCULABORCOST_LABORCOSTINSTALL) = MyNumI
                rsTmp(FIXEDCULABORCOST_LABORCOSTREMOVE) = MyNumJ
                rsTmp(FIXEDCULABORCOST_LABORCOSTTRANSFER) = MyNumK
                rsTmp(FIXEDCULABORCOST_LABORCOSTABANDON) = MyNumL
                rsTmp.Update
    
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FixedCULaborCost"
    End If
End Sub
'Loads from a second FixedCULaborCost sheet as there may be more FixedCULaborCost records
'than can fit onto a single sheet. If the sheet FixedCULaborCost2 does not exist, the
'function just exits. N.B. Max number of rows in Excel is 65,536
Private Sub LoadFixedCULaborCost2()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyNumD&, MyNumE&, MyNumF&, MyNumG&, MyNumH&, MyNumI&, MyNumJ&, MyNumK&, MyNumL&
    Dim MyStr$, cellstr$, Name$, value$, NewLaborType$, NewWorkType$, CUName$, LastCU$
    Dim MyNum&, ID&, CurrentLaborTypeID&, CurrentWorkTypeID&, CU_ID&
    Dim ctr&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    On Error GoTo LFCULC_Err
    'just exit quietly if the sheet doesn't exist
    Set ws = Worksheets("FixedCULaborCost2")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FixedCULaborCost2")
    logUpdates = GetLogUpdates("FixedCULaborCost2")

    On Error GoTo 0
    
    Label2.Caption = "Loading Fixed CU Labor Cost"
    frmLoadIntoDb.Repaint
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open FIXEDCULABORCOST_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    NewLaborType = "NONE"
    NewWorkType = "NONE"
    LastCU = ""
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CUName = Trim(cell.value)
        If LastCU <> CUName Then
            CU_ID = CUID(CUName)
            LastCU = CUName
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        
        If NewLaborType <> MyStr Then
            NewLaborType = MyStr
            CurrentLaborTypeID = LaborTypeID(MyStr)
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        
        If NewWorkType <> MyStr Then
            NewWorkType = MyStr
            CurrentWorkTypeID = WorkTypeID(MyStr)
        End If
              
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNumD = BoolStringToInt(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyNumE = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNumF = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        MyNumG = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MyNumH = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        MyNumI = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        MyNumJ = Trim(cell.value)
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        MyNumK = Trim(cell.value)
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        MyNumL = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & FIXEDCULABORCOST_TBLNAME & _
                " where " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_CUID & " = " & CU_ID & _
                " and " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_LABORTYPEID & " = " & CurrentLaborTypeID & _
                " and " & FIXEDCULABORCOST_TBLNAME & "." & FIXEDCULABORCOST_WORKTYPEID & " = " & CurrentWorkTypeID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(FIXEDCULABORCOST_CUID) = CU_ID
            rs(FIXEDCULABORCOST_LABORTYPEID) = CurrentLaborTypeID
            rs(FIXEDCULABORCOST_WORKTYPEID) = CurrentWorkTypeID
            rs(FIXEDCULABORCOST_ISFIXED) = MyNumD
            rs(FIXEDCULABORCOST_FIXEDINSTALLCOST) = MyNumE
            rs(FIXEDCULABORCOST_FIXEDREMOVECOST) = MyNumF
            rs(FIXEDCULABORCOST_FIXEDTRANSFERCOST) = MyNumG
            rs(FIXEDCULABORCOST_FIXEDABANDONCOST) = MyNumH
            rs(FIXEDCULABORCOST_LABORCOSTINSTALL) = MyNumI
            rs(FIXEDCULABORCOST_LABORCOSTREMOVE) = MyNumJ
            rs(FIXEDCULABORCOST_LABORCOSTTRANSFER) = MyNumK
            rs(FIXEDCULABORCOST_LABORCOSTABANDON) = MyNumL
        Else
            'rsTmp(FIXEDCULABORCOST_CUID) = CU_ID
            'rsTmp(FIXEDCULABORCOST_LABORTYPEID) = CurrentLaborTypeID
            'rsTmp(FIXEDCULABORCOST_WORKTYPEID) = CurrentWorkTypeID
            rsTmp(FIXEDCULABORCOST_ISFIXED) = MyNumD
            rsTmp(FIXEDCULABORCOST_FIXEDINSTALLCOST) = MyNumE
            rsTmp(FIXEDCULABORCOST_FIXEDREMOVECOST) = MyNumF
            rsTmp(FIXEDCULABORCOST_FIXEDTRANSFERCOST) = MyNumG
            rsTmp(FIXEDCULABORCOST_FIXEDABANDONCOST) = MyNumH
            rsTmp(FIXEDCULABORCOST_LABORCOSTINSTALL) = MyNumI
            rsTmp(FIXEDCULABORCOST_LABORCOSTREMOVE) = MyNumJ
            rsTmp(FIXEDCULABORCOST_LABORCOSTTRANSFER) = MyNumK
            rsTmp(FIXEDCULABORCOST_LABORCOSTABANDON) = MyNumL
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close

LFCULC_Err:
    If Failure Then
        LogSheetFailure "FixedCULaborCost2"
    End If
    imgLoadFixedCULaborCost.Visible = True
End Sub

Function LaborTypeID(strLTName As String) As Long
    Dim rs As Recordset
    Dim sql$
    Dim ID&
    
    If LaborTypes Is Nothing Then
        Set LaborTypes = New Collection
    End If
    On Error GoTo not_in_LT_collection
    ID = LaborTypes.Item(strLTName)
    On Error GoTo 0
    LaborTypeID = ID
    Exit Function
    
not_in_LT_collection:
    sql = "select " & LABORTYPE_ID & " from " & LABORTYPE_TBLNAME & _
            " where " & LABORTYPE_NAME & " = '" & strLTName & "'"
    Set rs = Conn.Execute(sql)
    
    If rs.EOF And rs.BOF Then
        ID = 0
    Else
        ID = rs.Fields.Item(LABORTYPE_ID).value
    End If

    rs.Close
    LaborTypes.Add ID, strLTName
    LaborTypeID = ID
    
End Function
Private Sub LoadUserUnitAssignSettings()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$, OldWorkType$, OldLaborType$
    Dim MyNum&, ID&, LaborID&, WorkID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading User Unit Assign Settings"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("UserUnitAssignment")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("UserUnitAssignment")
    logUpdates = GetLogUpdates("UserUnitAssignment")
    
    OldWorkType = ""
    OldLaborType = ""
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open USERUNITASSIGNSETTINGS_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        MyNum = UserIDForName(Trim(value))
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If OldLaborType <> MyStr Then
            OldLaborType = MyStr
            LaborID = LaborTypeID(MyStr)
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If OldWorkType <> MyStr Then
            OldWorkType = MyStr
            WorkID = WorkTypeID(MyStr)
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & USERUNITASSIGNSETTINGS_TBLNAME & _
                " where " & USERUNITASSIGNSETTINGS_TBLNAME & "." & USERUNITASSIGNSETTINGS_USERID & " = " & MyNum & _
                " and " & USERUNITASSIGNSETTINGS_TBLNAME & "." & USERUNITASSIGNSETTINGS_LABORTYPEID & " = " & LaborID & _
                " and " & USERUNITASSIGNSETTINGS_TBLNAME & "." & USERUNITASSIGNSETTINGS_WORKTYPEID & " = " & WorkID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(USERUNITASSIGNSETTINGS_USERID) = MyNum
            rs(USERUNITASSIGNSETTINGS_LABORTYPEID) = LaborID
            rs(USERUNITASSIGNSETTINGS_WORKTYPEID) = WorkID
        Else
            'rsTmp(USERUNITASSIGNSETTINGS_USERID) = MyNum
            'rsTmp(USERUNITASSIGNSETTINGS_LABORTYPEID) = LaborID
            'rsTmp(USERUNITASSIGNSETTINGS_WORKTYPEID) = WorkID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "UserUnitAssignment"
    End If
    imgLoadUserUnitAssign.Visible = True
End Sub

Private Sub CmdPlotScale_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable PLOTSCALE_TBLNAME
    End If
    
    LoadPlotScale
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdPowerTranChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable POWERTRANCHAR_TABLENAME
    End If
    
    LoadPowerTranChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdPWMapping_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable PWATTRMAP_TBLNAME
    End If
    
    LoadPWMapping
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdRating_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CONDCHAR_TABLENAME
        DeleteTable DISTTRANCHAR_TABLENAME
        DeleteTable VOLTREGCHAR_TABLENAME
        DeleteTable POWERTRANCHAR_TABLENAME
        DeleteTable ACUNITLOADCHAR_TABLENAME
        DeleteTable FUSECHAR_TABLENAME
        DeleteTable DISTTRANPREF_TABLENAME
        DeleteTable DISTTRANFLICKER_TABLENAME
        DeleteTable CONDPREFRANK_TABLENAME
        
        DeleteTable EARATING_TABLENAME
    End If
    
    LoadEARating
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdReportContext_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable REPORTCONTEXT_TBLNAME
    End If
    
    LoadReportContext
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdReportSpec_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable REPORTSPEC_TBLNAME
    End If
    
    LoadReportSpec
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub


Private Sub CmdSrvCoincidence_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable SRVCOINCFACTOR_TABLENAME
    End If
    
    LoadServiceCoincidenceFactor
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdSrvPower_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable SRVLOADPOWER_TABLENAME
    End If
    
    LoadServiceLoadPowerFactor
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdStateActions_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable STATEACTION_TBLNAME
    End If
    
    LoadStateAvailableActions
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdTreeTrim_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTreeTrimmingSpecificData
        DeleteTreeTrimming
    End If
    
    LoadTreeTrimming
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdVoltRegChar_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable VOLTREGCHAR_TABLENAME
    End If
    
    LoadVoltageRegChar
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdWizSettings_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable EAOPTWIZ_TABLENAME
    End If
        
    LoadEAOptWizardSetting
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdWRActions_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable WRACTION_TBLNAME
    End If
    
    LoadWorkRequestActions
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdWREvent_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteCustomWREvents
    End If
    
    LoadCustomWorkRequestEvents
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdWRState_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteCustomWREvents
        DeleteTable STATEACTION_TBLNAME
        DeleteTable WRACTION_TBLNAME
        DeleteTable WRSTATE_TBLNAME
    End If
    LoadWorkRequestStates
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadFtrTypes_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait

    If Not IncrementalLoad Then
        DeleteTable FEATURETYPE_TBLNAME
    End If
    
    LoadFeatureTypes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub




Private Sub CmdLoadAllwdCnnctn_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait

    If Not IncrementalLoad Then
        DeleteTable ALLOWEDCONN_TBLNAME
    End If
    
    LoadAllowedConnection
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub CmdLoadUnitRules_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteCuUnitRules
    End If
    
    'prog.Value = 0
    'prog.Visible = True
    
    LoadRuleAttributes
    
    'prog.Visible = False
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdClassAssign_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CLASSASSIGN_TBLNAME
    End If
    
    LoadClassifications
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAll_Click()
    LoadAll
End Sub

Sub LoadAll()
    Dim msg$
    If LoadUnitsOnly And IgnoreUnits Then
        msg = "Error: Leave Unit Data and Unit Data Only are both checked. I can't do both."
        If logdir <> "" And logfile <> "" Then
            LogMsg msg
        Else
            MsgBox msg, vbSystemModal + vbExclamation + vbOKOnly, "Expert Designer Data Loader"
        End If
        Exit Sub
    End If
    
    ' Verify that we can run:
    Dim ctrl As Control
    For Each ctrl In Me.Controls
        If ctrl.Name = "CmdLoadAll" Then
            If ctrl.Enabled = False Then
                msg = "Error: LoadAll not enabled."
                If logdir <> "" And logfile <> "" Then
                    LogMsg msg
                End If
                Exit Sub
            End If
            Exit For
        End If
    Next ctrl
    
    Dim OldCursor&
    Static Running As Boolean
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Running Then
        Running = False
    Else
        CmdLoadAll.Caption = "Cancel"
        Running = True
        'Conn.BeginTrans
        
        FailedSheets = ""
        ClearSheet "DataloaderErrors", 1
        
        'First delete all of the existing entries, then reload
        'The ordering is important so as not to break the relational integrity of the database
        If Not IncrementalLoad Then
            DeleteAll
        End If

        DoEvents
        If Not Running Then GoTo LA_Cancel
            
        LogMsg "Loading..."
        If Not LoadUnitsOnly Then
            
            LoadCommodityType
            LoadCommodityGroup
            LoadCommodityGroupAssignment
             
            LoadPWMapping
            
            LoadWorkRequestStates
            LoadWorkFlow
            LoadCustomWorkRequestEvents
            LoadWorkRequestActions
            LoadStateAvailableActions
            LoadWRRemarkType
            LoadWRRequirementType

            LoadUsers
            LoadGroups
            LoadUserGroupAssignments
            LoadGroupCapabilityAssignments
            GetCurrentUser

            LoadConfiguration
            LoadConfigurationSettings
            LoadPlotScale

            LoadErrorMessage

            LoadFolderCustomQuery

            DoEvents
            If Not Running Then GoTo LA_Cancel

            'EA Rating is used by AttributeLegalValue
            LoadEARating

            LoadFeatureTypes
            LoadAttributeDomains
            LoadOverlappingDomains
            LoadAttributeLegalValues
            LoadFeatureAttributes
            LoadLinkedAttributes
            LoadCompoundFeature
            LoadFeatureAttrMapping
            LoadFeatureGeometry
            LoadClassificationTypes
            LoadClassifications
            LoadFeatureStates
            LoadFeatureStateTransitions
            LoadFtrAttrSplitMapping

            DoEvents
            If Not Running Then GoTo LA_Cancel

            LoadComponentTypes
            LoadFixedViolations
            LoadAllowedConnection
            LoadAttributeRelations
            LoadAttributeConstraints
            LoadCustomRuleViolation

            LoadAttributeSets
            LoadAttributeDefaultValues
            LoadPlacementDefaultSettings

            DoEvents
            If Not Running Then GoTo LA_Cancel
            

        End If

        LogMsg "Loading..."

        If Not IgnoreUnits Then
            LoadPlantAccount
            'prog.Value = 0
            'prog.Visible = True
            LoadCompatibleUnits
            LoadMaterialItems
            LoadUnitAggregations
            LoadUnitAggregations2
            LoadCustomCostType
            LoadCustomCostItem
            'prog.Visible = False
            LoadCUPAAssignments

            LoadLaborType
            LoadWorkType
            LoadCUActivity
            LoadFixedCULaborCost
            LoadFixedCULaborCost2
            LoadUserUnitAssignSettings


            DoEvents
            If Not Running Then GoTo LA_Cancel
        End If

        LogMsg "Loading..."

        If Not LoadUnitsOnly Then
             'prog.Value = 0
             'prog.Visible = True
             LoadRuleAttributes
            'prog.Visible = False

             LoadReportContext
             LoadReportSpec

             LoadCustomAttributes
             
             LoadExportFtrDetails
             
             LoadDifficultyFactor

             DoEvents
             If Not Running Then GoTo LA_Cancel

             LoadNetworkConfig
             LoadNetworkAssign
             LoadAttrStopCondition
             LoadFilter
             LoadFilterConstraintType
             LoadEAOptWizardSetting
             LoadEAOptLFParamSetting
             LoadEAElementType
             LoadEAAttrDomain
             LoadEAElementAttr
             LoadServiceLoadPowerFactor
             LoadServiceCoincidenceFactor

             LoadCondChar
             LoadDistTranChar
             LoadPowerTranChar
             LoadVoltageRegChar
             LoadACLoadChar
             LoadFuseChar
             LoadDistTranPreference
             LoadDistTranFlickerBasedSize
             LoadCondPrefRanking
             LoadCondCharRuleAttributes
             LoadDistTranCharRuleAttributes
             LoadFuseCharRuleAttributes
             LoadVoltageRegCharRuleAttributes
             LoadPowerTransCharRuleAttributes

             DoEvents
             If Not Running Then GoTo LA_Cancel

             LoadAppDependRules
             LoadADFeatureTypeRules
             LoadFeatureInstRules
             LoadFeatureAttrConstraintRules

             If Not IsSQLSERVER Then
                LoadTreeTrimming
             End If
             LoadEDServer

             LoadFtrCatalog
                
             RunCustomSQL
        End If
        'Conn.CommitTrans
            
        Label2.Caption = "Performing Custom Actions"
        frmUserCustom.CustomCode Conn
        Unload frmUserCustom
                
        If FailedSheets <> "" Then
            If logdir <> "" And logfile <> "" Then
                LogMsg "Errors during LoadAll"
            Else
                frmLoadErrors.Show vbModal
            End If
        End If
                
        msg = "Load Complete"
        Label2.Caption = msg
        LogMsg msg
        
        Application.Cursor = OldCursor
        CmdLoadAll.Caption = "Load All"
    End If
    
    Exit Sub
LA_Cancel:
    'Conn.RollbackTrans
    CmdLoadAll.Caption = "Load All"
End Sub


Private Sub CmdLoadFtrState_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FTRSTATETRANS_TBLNAME
        DeleteTable FTRSTATE_TBLNAME
    End If
    
    LoadFeatureStates
    LoadFeatureStateTransitions
    
    Label2.Caption = "Ready"
    Application.Cursor = OldCursor
    
End Sub

Private Sub CmdLoadCmpndFtr_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable COMPOUNDFTR_TBLNAME
    End If
    
    LoadCompoundFeature
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadClassTypes_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable CLASSTYPE_TBLNAME
    End If
    
    LoadClassificationTypes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor

End Sub

Private Sub CmdLoadUnitsMaterials_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    Label2.Caption = "Truncating unit tables"
       
    If Not IncrementalLoad Then
        DeleteTable UNITAGG_TBLNAME
        DeleteTable CU_TBLNAME
        DeleteTable MI_TBLNAME
        DeleteTable CUSTOMCOST_TBLNAME
        DeleteCustomCostType
    End If
    
    'prog.Value = 0
    'prog.Visible = True
    
    LoadCompatibleUnits
    LoadMaterialItems
    LoadUnitAggregations
    LoadUnitAggregations2
    LoadCustomCostType
    LoadCustomCostItem
    
    'prog.Visible = False
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAttrDomain_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable OVERLAPPINGDOMAIN_TBLNAME
        DeleteTable ATTRDOMAIN_TBLNAME
    End If
    
    LoadAttributeDomains
    LoadOverlappingDomains
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub



Private Sub CmdLoadFtrAttrib_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FEATUREATTR_TBLNAME
    End If
    
    LoadFeatureAttributes
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAttrSet_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRSET_TBLNAME
    End If
    
    If Not IncrementalLoad Then
        LoadAttributeSets
    End If
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAttrLegalVal_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRLEGALVALUE_TBLNAME
        DeleteTable ATTRLEGALVALUEASSIGN_TBLNAME
    End If
    
    LoadAttributeLegalValues
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadAttrDefaults_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable ATTRDEFVAL_TBLNAME
    End If
    
    LoadAttributeDefaultValues
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Sub CmdLoadFtrGeometry_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
    
    If Not IncrementalLoad Then
        DeleteTable FTRGEOM_TBLNAME
    End If
    
    LoadFeatureGeometry
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor

End Sub

Private Sub CmdLoadCmpntTypes_Click()
    Dim OldCursor&
    OldCursor = Application.Cursor
    Application.Cursor = xlWait
        
    If Not IncrementalLoad Then
        DeleteTable ALLOWEDCONN_TBLNAME
        DeleteTable ATTRCONSTRAINT_TBLNAME
        DeleteTable ATTRREL_TBLNAME
        DeleteTable ENABLEDBUSINESSRULE_TBLNAME
        DeleteTable RULE_TBLNAME
        DeleteTable RULESET_TBLNAME
        DeleteTable VIOLATION_TBLNAME
        DeleteTable COMPTYPE_TBLNAME
    End If
    
    LoadComponentTypes
    LoadFixedViolations
    
    Label2.Caption = "Status: Ready"
    Application.Cursor = OldCursor
End Sub

Private Function NextPK(TableName As String, KeyField As String, Optional SchemaName As String) As Long
    Dim rs As Recordset
    Dim qrystr$, maxstr$
    
    If IsSQLSERVER Then
    
        ' Original:
        'qrystr = "SELECT MAX(" & KeyField & ") as MAXID FROM " & TableName & " WHERE " & _
        '            KeyField & " < 500000"
    
        qrystr = "SELECT MAX(" & KeyField & ") as MAXID FROM "
    
        If SchemaName <> "" Then
            If IsSQLSERVER Then
                qrystr = qrystr & "[" & SchemaName & "]."
            Else
                qrystr = qrystr & SchemaName & "."
            End If
        End If

        If IsSQLSERVER Then
            qrystr = qrystr & "[" & TableName & "] WHERE " & KeyField & " < 500000"
        Else
            qrystr = qrystr & TableName & " WHERE " & KeyField & " < 500000"
        End If

        Set rs = Conn.Execute(qrystr)
        
        If Not rs.EOF Then
            maxstr = "MAXID"
            If rs.Fields.Item(maxstr).value > 0 Then
                NextPK = rs.Fields.Item(maxstr).value + 1
            Else
                NextPK = 1
            End If
        Else
            NextPK = 1
        End If
    Else
        If SchemaName = "" Then
            qrystr = "SELECT MAX(" & KeyField & ") FROM " & TableName & " WHERE " & KeyField & " < 500000"
        Else
            qrystr = "SELECT MAX(" & KeyField & ") FROM " & SchemaName & "." & TableName & " WHERE " & KeyField & " < 500000"
        End If
        
        Set rs = Conn.Execute(qrystr)
        
        If Not rs.EOF Then
            maxstr = "MAX(" & KeyField & ")"
            If rs.Fields.Item(maxstr).value > 0 Then
                NextPK = rs.Fields.Item(maxstr).value + 1
            Else
                NextPK = 1
            End If
        Else
            NextPK = 1
        End If
    End If
End Function


Private Sub TruncateTable(TableName As String)
    On Error GoTo truncateTableError
    
    Dim sql$
    
    sql = "Truncate Table " & TableName

    Conn.Execute sql, , adCmdText + adExecuteNoRecords

    Exit Sub
truncateTableError:
    Err.Raise vbObjectError + 27, , "Error Truncating Table " & TableName
    Debug.Print Err.Description
End Sub

Private Sub DeleteTable(TableName As String, Optional SchemaName As String)
    On Error GoTo DeleteTableError
    
    Dim sql$
    sql = "Delete from "
    If SchemaName <> "" Then
        If IsSQLSERVER Then
            sql = sql & "[" & SchemaName & "]."
        Else
            sql = sql & SchemaName & "."
        End If
    End If
    
    If IsSQLSERVER Then
        sql = sql & "[" & TableName & "]"
    Else
        sql = sql & TableName
    End If

    Conn.Execute sql, , adCmdText + adExecuteNoRecords

    Exit Sub
DeleteTableError:
    Debug.Print Err.Description
    Err.Raise vbObjectError + 27, , "Error Deleting Table " & TableName
    
End Sub
Private Sub LoadFeatureTypes()

    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim DisplayName$
    Dim ctr%
    Dim ID&
    Dim valB$, valC$, valD$, valE$, valF$, valG$, valH$, valI$, valJ$, valK$, valL$, valM$
    Dim valN$, valO$, valP$, valQ$, valR$, valS$, valT$, valU$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading feature types"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("FeatureTypes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureTypes")
    logUpdates = GetLogUpdates("FeatureTypes")
    
    ctr = 2
   
    If Not FtrTypes Is Nothing Then Set FtrTypes = Nothing
    Set FtrTypes = New Collection
    
    Set cell = ws.Range("A2")
    DisplayName = Trim(cell.value)
    
    rs.Open FEATURETYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FEATURETYPE_TBLNAME, FEATURETYPE_ID)
    Do While DisplayName <> ""
    
        ' FeatureClass
        If LCase(Trim(ws.Range("AA" & CStr(ctr)))) <> "ftrcls" Then
    
            ' Clear previous errors:
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.ColorIndex = xlColorIndexAutomatic
            cell.value = ""
        
            valB = Trim(ws.Range(("B" & ctr)))
            valC = Trim(ws.Range(("C" & ctr)))
            valD = Trim(ws.Range(("D" & ctr)))
            valE = Trim(ws.Range(("E" & ctr)))
            valF = Trim(ws.Range(("F" & ctr)))
            valG = Trim(ws.Range(("G" & ctr)))
            valH = Trim(ws.Range(("H" & ctr)))
            valI = Trim(ws.Range(("I" & ctr)))
            valJ = Trim(ws.Range(("J" & ctr)))
            valK = Trim(ws.Range(("K" & ctr)))
            valL = Trim(ws.Range(("L" & ctr)))
            valM = Trim(ws.Range(("M" & ctr)))
            valN = Trim(ws.Range(("N" & ctr)))
            valO = Trim(ws.Range(("O" & ctr)))
            valP = Trim(ws.Range(("P" & ctr)))
            valQ = Trim(ws.Range(("Q" & ctr)))
            valR = Trim(ws.Range(("R" & ctr)))
            valS = Trim(ws.Range(("S" & ctr)))
            valT = Trim(ws.Range(("T" & ctr)))
            valU = Trim(ws.Range(("U" & ctr)))
        
            cellstr = "AH" & ctr
            Set cell = ws.Range(cellstr)
            Group = Trim(cell.value)
            If LastGroup <> Group Then
                groupid = CommodityGroupIDForName(Group)
                LastGroup = Group
            End If
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FEATURETYPE_TBLNAME & _
                    " where " & FEATURETYPE_TBLNAME & "." & FEATURETYPE_NAME & " = '" & DisplayName & "'"
                    
            ' Dataset Addition:
            If valR <> "" Then
                sqlTmp = sqlTmp + " and " & FEATURETYPE_DATASET & " = '" & valR & "'"
            End If
                    
            'DAVID Custem
            '---------------------------------------------------------------------------
            If IsSqlServerS2T Then
                If valD <> "" Or valR <> "" Then
                    valD = valR + "_" + valD
                End If
            End If
            '---------------------------------------------------------------------------
                    
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FEATURETYPE_ID).value = ID
                rs.Fields.Item(FEATURETYPE_NAME).value = DisplayName
                If valB <> "" Then rs.Fields.Item(FEATURETYPE_DISPLAYGROUP).value = valB
                If valC <> "" Then rs.Fields.Item(FEATURETYPE_OHUG).value = valC
                If valD <> "" Then rs.Fields.Item(FEATURETYPE_GISTABLE).value = valD
                If valE <> "" Then rs.Fields.Item(FEATURETYPE_ICONGROUP).value = BoolStringToInt(valE)
                If valF <> "" Then rs.Fields.Item(FEATURETYPE_INTERNALTABLE).value = valF
                If valG <> "" Then rs.Fields.Item(FEATURETYPE_ISPOINT).value = BoolStringToInt(valG)
                If valH <> "" Then rs.Fields.Item(FEATURETYPE_ISPLACEABLE).value = BoolStringToInt(valH)
                If valI <> "" Then rs.Fields.Item(FEATURETYPE_ISDISPLAYABLE).value = BoolStringToInt(valI)
                If valJ <> "" Then rs.Fields.Item(FEATURETYPE_ISCOMPOUND).value = BoolStringToInt(valJ)
                If valK <> "" Then rs.Fields.Item(FEATURETYPE_ISSTRUCTURE).value = BoolStringToInt(valK)
                If valL <> "" Then rs.Fields.Item(FEATURETYPE_ISCONDUCTOR).value = BoolStringToInt(valL)
                If valM <> "" Then rs.Fields.Item(FEATURETYPE_ISDEVICE).value = BoolStringToInt(valM)
                If valN <> "" Then rs.Fields.Item(FEATURETYPE_ISSERVICE).value = BoolStringToInt(valN)
                If valO <> "" Then rs.Fields.Item(FEATURETYPE_ISBOUNDARY).value = BoolStringToInt(valO)
                If valP <> "" Then rs.Fields.Item(FEATURETYPE_AUTOANNOTATE).value = BoolStringToInt(valP)
                If valQ <> "" Then rs.Fields.Item(FEATURETYPE_ICONINDEX).value = valQ
                If valR <> "" Then rs.Fields.Item(FEATURETYPE_DATASET).value = valR
                If valS <> "" Then rs.Fields.Item(FEATURETYPE_ISNONMAPPED).value = BoolStringToInt(valS)
                If valT <> "" Then rs.Fields.Item(FEATURETYPE_ISCHFEATURE).value = BoolStringToInt(valT)
                If valU <> "" Then rs.Fields.Item(FEATURETYPE_RESOLVEORDER).value = valU
                rs.Fields.Item(FEATURETYPE_COMMODITYGROUPID).value = groupid
                
                'RAS - 08/13/2012
                'Use dataset in the featuretype collection
                Dim SearchStr As String
                If valR <> "" Then
                    SearchStr = valR & "." & DisplayName
                Else
                    SearchStr = DisplayName
                End If
                    
                FtrTypes.Add ID, SearchStr
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FEATURETYPE_ID).Value = ID
                'rsTmp.Fields.Item(FEATURETYPE_NAME).Value = DisplayName
                If valB <> "" Then rsTmp.Fields.Item(FEATURETYPE_DISPLAYGROUP).value = valB
                If valC <> "" Then rsTmp.Fields.Item(FEATURETYPE_OHUG).value = valC
                If valD <> "" Then rsTmp.Fields.Item(FEATURETYPE_GISTABLE).value = valD
                If valE <> "" Then rsTmp.Fields.Item(FEATURETYPE_ICONGROUP).value = BoolStringToInt(valE)
                If valF <> "" Then rsTmp.Fields.Item(FEATURETYPE_INTERNALTABLE).value = valF
                If valG <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISPOINT).value = BoolStringToInt(valG)
                If valH <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISPLACEABLE).value = BoolStringToInt(valH)
                If valI <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISDISPLAYABLE).value = BoolStringToInt(valI)
                If valJ <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISCOMPOUND).value = BoolStringToInt(valJ)
                If valK <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISSTRUCTURE).value = BoolStringToInt(valK)
                If valL <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISCONDUCTOR).value = BoolStringToInt(valL)
                If valM <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISDEVICE).value = BoolStringToInt(valM)
                If valN <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISSERVICE).value = BoolStringToInt(valN)
                If valO <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISBOUNDARY).value = BoolStringToInt(valO)
                If valP <> "" Then rsTmp.Fields.Item(FEATURETYPE_AUTOANNOTATE).value = BoolStringToInt(valP)
                If valQ <> "" Then rsTmp.Fields.Item(FEATURETYPE_ICONINDEX).value = valQ
                If valR <> "" Then rsTmp.Fields.Item(FEATURETYPE_DATASET).value = valR
                If valS <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISNONMAPPED).value = BoolStringToInt(valS)
                If valT <> "" Then rsTmp.Fields.Item(FEATURETYPE_ISCHFEATURE).value = BoolStringToInt(valT)
                If valU <> "" Then rsTmp.Fields.Item(FEATURETYPE_RESOLVEORDER).value = valU
                rsTmp.Fields.Item(FEATURETYPE_COMMODITYGROUPID).value = groupid
                rsTmp.Update
    
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureTypes"
    End If
    ImgFtrType.Visible = True
End Sub
Private Sub LoadCompatibleUnits()
    
    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range, rg As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim DisplayName$, LastCC$
    Dim ctr%, progress%, lastpos%
    Dim ID&, rowtotal&, count&, CC_ID&
    Dim valC$, valD$, valE$, valF$, valG$, valH$, valI$, valJ$, valK$, valL$, valM$
    Dim valN$, valO$, valP$, valQ$, valR$, valS$, valT$, valU$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading compatible units"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("CompatibleUnits")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CompatibleUnits")
    logUpdates = GetLogUpdates("CompatibleUnits")
    
    Set rg = ws.UsedRange
    rowtotal = rg.Cells.count / 21
    'prog.Value = 0
    lastpos = 0
    count = 0
    ctr = 2
    
    LastCC = ""
    
    If Not CUs Is Nothing Then Set CUs = Nothing
    Set CUs = New Collection
    
    Set cell = ws.Range("A2")
    DisplayName = Trim(cell.value)
    
    rs.Open CU_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CU_TBLNAME, CU_ID)
    Do While DisplayName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            If Trim$(cell.value) <> LastCC Then
                CC_ID = ClassCodeId(Trim(cell.value))
                LastCC = Trim$(cell.value)
            End If
        Else
            CC_ID = 0
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            If Len(Trim(cell.value)) > 50 Then
                valC = Left(Trim(cell.value), 50)
            Else
                valC = Trim(cell.value)
            End If
        Else
            valC = ""
        End If
        
        valD = Trim(ws.Range(("D" & ctr)))
        valE = Trim(ws.Range(("E" & ctr)))
        valF = Trim(ws.Range(("F" & ctr)))
        valG = Trim(ws.Range(("G" & ctr)))
        valH = Trim(ws.Range(("H" & ctr)))
        valI = Trim(ws.Range(("I" & ctr)))
        valJ = Trim(ws.Range(("J" & ctr)))
        valK = Trim(ws.Range(("K" & ctr)))
        valL = Trim(ws.Range(("L" & ctr)))
        valM = Trim(ws.Range(("M" & ctr)))
        valN = Trim(ws.Range(("N" & ctr)))
        valO = Trim(ws.Range(("O" & ctr)))
        valP = Trim(ws.Range(("P" & ctr)))
        valQ = Trim(ws.Range(("Q" & ctr)))
        valR = Trim(ws.Range(("R" & ctr)))
        valS = Trim(ws.Range(("S" & ctr)))
        valT = Trim(ws.Range(("T" & ctr)))
        valU = Trim(ws.Range(("U" & ctr)))
    
        cellstr = "V" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CU_TBLNAME & _
                " where " & CU_TBLNAME & "." & CU_CUID & " = '" & DisplayName & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(CU_ID).value = ID
            rs.Fields.Item(CU_CUID).value = DisplayName
            rs.Fields.Item(CU_CLASSCODEID).value = CC_ID
            If valC <> "" Then rs.Fields.Item(CU_SHORTDESC).value = valC
            If valD <> "" Then rs.Fields.Item(CU_DESC).value = valD
            If valE <> "" Then rs.Fields.Item(CU_EQUIPCOSTINSTALL).value = valE
            If valF <> "" Then rs.Fields.Item(CU_EQUIPCOSTREMOVE).value = valF
            If valG <> "" Then rs.Fields.Item(CU_EQUIPCOSTTRANSFER).value = valG
            If valH <> "" Then rs.Fields.Item(CU_MATCOSTINSTALL).value = valH
            If valI <> "" Then rs.Fields.Item(CU_TOTALINSTALL).value = valI
            If valJ <> "" Then rs.Fields.Item(CU_TOTALREMOVE).value = valJ
            If valK <> "" Then rs.Fields.Item(CU_TOTALTRANSFER).value = valK
            If valL <> "" Then rs.Fields.Item(CU_SCRAPVALUE).value = valL
            If valM <> "" Then rs.Fields.Item(CU_ISMACRO).value = BoolStringToInt(valM)
            If valN <> "" Then rs.Fields.Item(CU_ISPUBLIC).value = BoolStringToInt(valN)
            If valO <> "" Then rs.Fields.Item(CU_OVERRIDEMASK).value = valO
            If valP <> "" Then rs.Fields.Item(CU_EQUIPMENTCOSTABANDON).value = valP
            If valQ <> "" Then rs.Fields.Item(CU_TOTALABANDONCOST).value = valQ
            If valR <> "" Then rs.Fields.Item(CU_RETIREMENTDATE).value = valR
            If valS <> "" Then rs.Fields.Item(CU_ISRETIRED).value = BoolStringToInt(valS)
            If valT <> "" Then rs.Fields.Item(CU_SALVAGEVALUE).value = valT
            If valU <> "" Then rs.Fields.Item(CU_ISLINEAR).value = BoolStringToInt(valU)
            rs.Fields.Item(CU_CREATEDBY).value = CurrentUserID
            rs.Fields.Item(CU_OWNERID).value = CurrentUserID
            rs.Fields.Item(CU_CREATEDATE).value = DateTime.Date
            rs.Fields.Item(CU_UPDATEDATE).value = DateTime.Date
            rs.Fields.Item(CU_COMMODITYGROUPID).value = groupid
            CUs.Add ID, DisplayName
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(CU_ID).Value = ID
            'rsTmp.Fields.Item(CU_CUID).Value = DisplayName
            rsTmp.Fields.Item(CU_CLASSCODEID).value = CC_ID
            If valC <> "" Then rsTmp.Fields.Item(CU_SHORTDESC).value = valC
            If valD <> "" Then rsTmp.Fields.Item(CU_DESC).value = valD
            If valE <> "" Then rsTmp.Fields.Item(CU_EQUIPCOSTINSTALL).value = valE
            If valF <> "" Then rsTmp.Fields.Item(CU_EQUIPCOSTREMOVE).value = valF
            If valG <> "" Then rsTmp.Fields.Item(CU_EQUIPCOSTTRANSFER).value = valG
            If valH <> "" Then rsTmp.Fields.Item(CU_MATCOSTINSTALL).value = valH
            If valI <> "" Then rsTmp.Fields.Item(CU_TOTALINSTALL).value = valI
            If valJ <> "" Then rsTmp.Fields.Item(CU_TOTALREMOVE).value = valJ
            If valK <> "" Then rsTmp.Fields.Item(CU_TOTALTRANSFER).value = valK
            If valL <> "" Then rsTmp.Fields.Item(CU_SCRAPVALUE).value = valL
            If valM <> "" Then rsTmp.Fields.Item(CU_ISMACRO).value = BoolStringToInt(valM)
            If valN <> "" Then rsTmp.Fields.Item(CU_ISPUBLIC).value = BoolStringToInt(valN)
            If valO <> "" Then rsTmp.Fields.Item(CU_OVERRIDEMASK).value = valO
            If valP <> "" Then rsTmp.Fields.Item(CU_EQUIPMENTCOSTABANDON).value = valP
            If valQ <> "" Then rsTmp.Fields.Item(CU_TOTALABANDONCOST).value = valQ
            If valR <> "" Then rsTmp.Fields.Item(CU_RETIREMENTDATE).value = valR
            If valS <> "" Then rsTmp.Fields.Item(CU_ISRETIRED).value = BoolStringToInt(valS)
            If valT <> "" Then rsTmp.Fields.Item(CU_SALVAGEVALUE).value = valT
            If valU <> "" Then rsTmp.Fields.Item(CU_ISLINEAR).value = BoolStringToInt(valU)
            rsTmp.Fields.Item(CU_CREATEDBY).value = CurrentUserID
            rsTmp.Fields.Item(CU_OWNERID).value = CurrentUserID
            rsTmp.Fields.Item(CU_CREATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(CU_UPDATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(CU_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        count = count + 1
        progress = (count / rowtotal) * 100
        If lastpos < progress Then
            If progress Mod 5 = 0 Then
                'prog.Value = progress
                'lastpos = prog.Value
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CompatibleUnits"
    End If
End Sub
Private Sub LoadMaterialItems()
    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim rg As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim DisplayName$, LastUoM$
    Dim ctr%, progress%, lastpos%
    Dim ID&, count&, rowtotal&, UOM_ID&
    Dim valB$, valC$, valD$, valE$, valF$, valG$, valH$, valI$, valJ$, valK$, valL$, valM$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading material items"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("MaterialItems")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("MaterialItems")
    logUpdates = GetLogUpdates("MaterialItems")
    
    Set rg = ws.UsedRange
    rowtotal = rg.Cells.count / 9
    'prog.Value = 0
    lastpos = 0
    count = 0
    ctr = 2
    LastUoM = ""
    
    Set cell = ws.Range("A2")
    DisplayName = Trim(cell.value)
    
    rs.Open MI_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(MI_TBLNAME, MI_ID)
    Do While DisplayName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        valB = Trim(ws.Range(("B" & ctr)))
        If valB <> "" Then
             valB = Left(valB, 50)
        End If
        valC = Trim(ws.Range(("C" & ctr)))
        valD = Trim(ws.Range(("D" & ctr)))
        valE = Trim(ws.Range(("E" & ctr)))
        If valE <> "" Then
            If valE <> LastUoM Then
                UOM_ID = UnitOfMeasureID(valE)
                LastUoM = valE
            End If
        Else
            UOM_ID = 0
        End If
        valF = Trim(ws.Range(("F" & ctr)))
        valG = Trim(ws.Range(("G" & ctr)))
        valH = Trim(ws.Range(("H" & ctr)))
        valI = Trim(ws.Range(("I" & ctr)))
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
    
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & MI_TBLNAME & _
                " where " & MI_TBLNAME & "." & MI_MIID & " = '" & DisplayName & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(MI_ID).value = ID
            rs.Fields.Item(MI_MIID).value = DisplayName
            If valB <> "" Then rs.Fields.Item(MI_SHORTDESC).value = valB
            If valC <> "" Then rs.Fields.Item(MI_DESC).value = valC
            If valD <> "" Then rs.Fields.Item(MI_COST).value = valD
            rs.Fields.Item(MI_UOMID).value = UOM_ID
            If valF <> "" Then rs.Fields.Item(MI_ISMAJOR).value = BoolStringToInt(valF)
            If valH <> "" Then rs.Fields.Item(MI_ISPUBLIC).value = BoolStringToInt(valH)
            If valI <> "" Then rs.Fields.Item(MI_QUANTITY).value = valI
            rs.Fields.Item(MI_OWNERID).value = CurrentUserID
            rs.Fields.Item(MI_CREATEDBY).value = CurrentUserID
            rs.Fields.Item(MI_UPDATEDATE).value = DateTime.Date
            rs.Fields.Item(MI_CREATEDATE).value = DateTime.Date
            rs.Fields.Item(MI_COMMODITYGROUPID).value = groupid
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(MI_ID).Value = ID
            'rsTmp.Fields.Item(MI_MIID).Value = DisplayName
            If valB <> "" Then rsTmp.Fields.Item(MI_SHORTDESC).value = valB
            If valC <> "" Then rsTmp.Fields.Item(MI_DESC).value = valC
            If valD <> "" Then rsTmp.Fields.Item(MI_COST).value = valD
            rsTmp.Fields.Item(MI_UOMID).value = UOM_ID
            If valF <> "" Then rsTmp.Fields.Item(MI_ISMAJOR).value = BoolStringToInt(valF)
            If valH <> "" Then rsTmp.Fields.Item(MI_ISPUBLIC).value = BoolStringToInt(valH)
            If valI <> "" Then rsTmp.Fields.Item(MI_QUANTITY).value = valI
            rsTmp.Fields.Item(MI_OWNERID).value = CurrentUserID
            rsTmp.Fields.Item(MI_CREATEDBY).value = CurrentUserID
            rsTmp.Fields.Item(MI_UPDATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(MI_CREATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(MI_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        count = count + 1
        progress = (count / rowtotal) * 100
        If lastpos < progress Then
            If progress Mod 5 = 0 Then
                'prog.Value = progress
                'lastpos = prog.Value
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    
    'Make sure there is at least one UOM
    UOM_ID = UnitOfMeasureID(valE)
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "MaterialItems"
    End If
End Sub
Private Sub LoadUnitAggregations()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim rg As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim DisplayName$, LastCU$, childName$
    Dim UnitAggId&, ctr&
    Dim progress%, lastpos%, IsMacro%
    Dim CompId&, ChildID&, count&, rowtotal&
    Dim AggQty#
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading unit aggregations"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("UnitAggregations")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("UnitAggregations")
    logUpdates = GetLogUpdates("UnitAggregations")

    Set rg = ws.UsedRange
    rowtotal = rg.Cells.count / 4
    'prog.Value = 0
    lastpos = 0
    count = 0
    ctr = 2
    
    Set cell = ws.Range("A2")
    DisplayName = Trim(cell.value)
    LastCU = ""
    
    rs.Open UNITAGG_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    UnitAggId = NextPK(UNITAGG_TBLNAME, UNITAGG_ID)
    
    Do While DisplayName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        AggQty = Round(Trim(cell.value), 2)
        
        If AggQty > 0 Then
        
            If DisplayName <> LastCU Then
                CompId = CUID(DisplayName)
                LastCU = DisplayName
            End If
        
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            If Trim(cell.value) <> "" Then
                IsMacro = BoolStringToInt(Trim(cell.value))
            Else
                IsMacro = False
            End If
        
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            childName = Trim(cell.value)
            If IsMacro Then
                ChildID = CUID(childName)
            Else
                ChildID = MIID(childName)
            End If
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            If ChildID <> 0 And CompId <> 0 Then
                
                ' Check for existing rows: DONE
                If IsMacro Then
                    sqlTmp = "select * from " & UNITAGG_TBLNAME & _
                            " where " & UNITAGG_TBLNAME & "." & UNITAGG_CUID & " = " & CompId & _
                            " and " & UNITAGG_TBLNAME & "." & UNITAGG_CHILDCUID & " = " & ChildID
                Else
                    sqlTmp = "select * from " & UNITAGG_TBLNAME & _
                            " where " & UNITAGG_TBLNAME & "." & UNITAGG_CUID & " = " & CompId & _
                            " and " & UNITAGG_TBLNAME & "." & UNITAGG_MIID & " = " & ChildID
                End If
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs.Fields.Item(UNITAGG_ID).value = UnitAggId
                    rs.Fields.Item(UNITAGG_CUID).value = CompId
                    If IsMacro Then
                        rs.Fields.Item(UNITAGG_CHILDCUID).value = ChildID
                    Else
                        rs.Fields.Item(UNITAGG_MIID).value = ChildID
                    End If
                    rs.Fields.Item(UNITAGG_QUANTITY).value = AggQty
                    rs.Update
                    UnitAggId = UnitAggId + 1
                Else
                    'rsTmp.Fields.Item(UNITAGG_ID).Value = UnitAggId
                    'rsTmp.Fields.Item(UNITAGG_CUID).Value = CompId
                    'If IsMacro Then
                    '    rsTmp.Fields.Item(UNITAGG_CHILDCUID).Value = ChildID
                    'Else
                    '    rsTmp.Fields.Item(UNITAGG_MIID).Value = ChildID
                    'End If
                    rsTmp.Fields.Item(UNITAGG_QUANTITY).value = AggQty
                    rsTmp.Update

                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing row"
                        Failure = True
                    End If
                End If
                rsTmp.Close
                
            ElseIf CompId = 0 Then
                'Mark the failure in the spreadsheet
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Could not find Compatible unit " & DisplayName
            Else
                'Mark the failure in the spreadsheet
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                If IsMacro Then
                    cell.value = "Could not find Compatible Unit " & childName
                Else
                    cell.value = "Could not find Material Item " & childName
                End If
            End If
            
        End If
        
        count = count + 1
        progress = (count / rowtotal) * 100
        If lastpos < progress Then
            If progress Mod 5 = 0 Then
                'prog.Value = progress
                'lastpos = prog.Value
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "UnitAggregations"
    End If
End Sub
'Loads from a second unit aggregation sheet as there may be more unit aggregation records
'than can fit onto a single sheet. If the sheet UnitAggregations2 does not exist, the
'function just exits. N.B. Max number of rows in Excel is 65,536
Private Sub LoadUnitAggregations2()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim rg As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim DisplayName$, LastCU$, childName$
    Dim UnitAggId&, ctr&
    Dim progress%, lastpos%, IsMacro%
    Dim CompId&, ChildID&, count&, rowtotal&
    Dim AggQty#
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    On Error GoTo LUA2_Err
    'the sheet might not exist, so just exit quietly if there is an error
    Set ws = Worksheets("UnitAggregations2")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("UnitAggregations2")
    logUpdates = GetLogUpdates("UnitAggregations2")

    On Error GoTo 0
    
    Label2.Caption = "Loading unit aggregations"
    frmLoadIntoDb.Repaint
    
    Set rg = ws.UsedRange
    rowtotal = rg.Cells.count / 4
    'prog.Value = 0
    lastpos = 0
    count = 0
    ctr = 2
    
    Set cell = ws.Range("A2")
    DisplayName = Trim(cell.value)
    LastCU = ""
    
    rs.Open UNITAGG_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    UnitAggId = NextPK(UNITAGG_TBLNAME, UNITAGG_ID)
    
    Do While DisplayName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        AggQty = Round(Trim(cell.value), 2)
        
        If AggQty > 0 Then
        
            If DisplayName <> LastCU Then
                CompId = CUID(DisplayName)
                LastCU = DisplayName
            End If
        
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            If Trim(cell.value) <> "" Then
                IsMacro = BoolStringToInt(Trim(cell.value))
            Else
                IsMacro = False
            End If
        
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            childName = Trim(cell.value)
            If IsMacro Then
                ChildID = CUID(childName)
            Else
                ChildID = MIID(childName)
            End If
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            If ChildID <> 0 And CompId <> 0 Then
                
                ' Check for existing rows: DONE
                If IsMacro Then
                    sqlTmp = "select * from " & UNITAGG_TBLNAME & _
                            " where " & UNITAGG_TBLNAME & "." & UNITAGG_CUID & " = " & CompId & _
                            " and " & UNITAGG_TBLNAME & "." & UNITAGG_CHILDCUID & " = " & ChildID
                Else
                    sqlTmp = "select * from " & UNITAGG_TBLNAME & _
                            " where " & UNITAGG_TBLNAME & "." & UNITAGG_CUID & " = " & CompId & _
                            " and " & UNITAGG_TBLNAME & "." & UNITAGG_MIID & " = " & ChildID
                End If
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs.Fields.Item(UNITAGG_ID).value = UnitAggId
                    rs.Fields.Item(UNITAGG_CUID).value = CompId
                    If IsMacro Then
                        rs.Fields.Item(UNITAGG_CHILDCUID).value = ChildID
                    Else
                        rs.Fields.Item(UNITAGG_MIID).value = ChildID
                    End If
                    rs.Fields.Item(UNITAGG_QUANTITY).value = AggQty
                    rs.Update
                    UnitAggId = UnitAggId + 1
                Else
                    'rsTmp.Fields.Item(UNITAGG_ID).Value = UnitAggId
                    'rsTmp.Fields.Item(UNITAGG_CUID).Value = CompId
                    'If IsMacro Then
                    '    rsTmp.Fields.Item(UNITAGG_CHILDCUID).Value = ChildID
                    'Else
                    '    rsTmp.Fields.Item(UNITAGG_MIID).Value = ChildID
                    'End If
                    rsTmp.Fields.Item(UNITAGG_QUANTITY).value = AggQty
                    rsTmp.Update

                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing row"
                        Failure = True
                    End If
                End If
                rsTmp.Close
                
            ElseIf CompId = 0 Then
                'Mark the failure in the spreadsheet
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Could not find CompatibleUnit " & DisplayName
            Else
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                If IsMacro Then
                    cell.value = "Could not find CompatibleUnit " & childName
                Else
                    cell.value = "Could not find Material Item " & childName
                End If
            End If
            
        End If
        
        count = count + 1
        progress = (count / rowtotal) * 100
        If lastpos < progress Then
            If progress Mod 5 = 0 Then
                'prog.Value = progress
                'lastpos = prog.Value
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
LUA2_Err:
    If Failure Then
        LogSheetFailure "UnitAggregations2"
    End If
End Sub
Private Sub LoadAttributeDomains()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim domainName$
    Dim ID&
    Dim valB$, valC$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading attribute domains"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("AttributeDomain")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeDomain")
    logUpdates = GetLogUpdates("AttributeDomain")

    ctr = 2
    
    Set cell = ws.Range("A2")
    domainName = Trim(cell.value)
    
    rs.Open ATTRDOMAIN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(ATTRDOMAIN_TBLNAME, ATTRDOMAIN_ID)
    Do While domainName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        valB = Trim(ws.Range(("B" & ctr)))
        valC = Trim(ws.Range(("C" & ctr)))
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ATTRDOMAIN_TBLNAME & _
                " where " & ATTRDOMAIN_TBLNAME & "." & ATTRDOMAIN_NAME & " = '" & domainName & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(ATTRDOMAIN_ID).value = ID
            rs.Fields.Item(ATTRDOMAIN_NAME).value = domainName
            If valB <> "" Then rs.Fields.Item(ATTRDOMAIN_VALUETYPE).value = ValueTypeID(valB)
            If valC <> "" Then rs.Fields.Item(ATTRDOMAIN_CONTROLTYPE).value = ControlTypeId(valC)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(ATTRDOMAIN_ID).Value = ID
            'rsTmp.Fields.Item(ATTRDOMAIN_NAME).Value = DomainName
            If valB <> "" Then rsTmp.Fields.Item(ATTRDOMAIN_VALUETYPE).value = ValueTypeID(valB)
            If valC <> "" Then rsTmp.Fields.Item(ATTRDOMAIN_CONTROLTYPE).value = ControlTypeId(valC)
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        domainName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeDomain"
    End If
    ImgDomain.Visible = True
End Sub

Private Sub LoadReportSpec()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Name$, Description$, FileName$
    Dim IsPublic%
    Dim ID&, ReportContextTypeID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading report spec"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("ReportSpec")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ReportSpec")
    logUpdates = GetLogUpdates("ReportSpec")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)
    
    rs.Open REPORTSPEC_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(REPORTSPEC_TBLNAME, REPORTSPEC_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        ReportContextTypeID = ReportContext(MyStr)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        IsPublic = BoolStringToInt(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        FileName = Trim(cell.value)
        
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & REPORTSPEC_TBLNAME & _
                " where " & REPORTSPEC_TBLNAME & "." & REPORTSPEC_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(REPORTSPEC_ID).value = ID
            rs(REPORTSPEC_NAME) = Name
            rs(REPORTSPEC_OWNERID) = CurrentUserID
            rs(REPORTSPEC_DESCRIPTION) = Description
            rs(REPORTSPEC_ISPUBLIC) = IsPublic
            rs(REPORTSPEC_CONTEXTTYPE) = ReportContextTypeID
            rs(REPORTSPEC_FILENAME) = FileName
            If IsSQLSERVER Then
                rs(REPORTSPEC_DATEUPDATED) = Format(Now, "Short Date")
                rs(REPORTSPEC_DATECREATED) = Format(Now, "Short Date")
            Else
                rs(REPORTSPEC_DATEUPDATED) = Now
                rs(REPORTSPEC_DATECREATED) = Now
            End If
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(REPORTSPEC_ID).Value = ID
            'rsTmp(REPORTSPEC_NAME) = name
            rsTmp(REPORTSPEC_OWNERID) = CurrentUserID
            rsTmp(REPORTSPEC_DESCRIPTION) = Description
            rsTmp(REPORTSPEC_ISPUBLIC) = IsPublic
            rsTmp(REPORTSPEC_CONTEXTTYPE) = ReportContextTypeID
            rsTmp(REPORTSPEC_FILENAME) = FileName
            If IsSQLSERVER Then
                rsTmp(REPORTSPEC_DATEUPDATED) = Format(Now, "Short Date")
                rsTmp(REPORTSPEC_DATECREATED) = Format(Now, "Short Date")
            Else
                rsTmp(REPORTSPEC_DATEUPDATED) = Now
                rsTmp(REPORTSPEC_DATECREATED) = Now
            End If
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ReportSpec"
    End If
    ImgRptSpec.Visible = True
End Sub

Private Sub LoadReportContext()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Name$
    Dim ID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading report context types"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("ReportContext")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ReportContext")
    logUpdates = GetLogUpdates("ReportContext")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)
    
    rs.Open REPORTCONTEXT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(REPORTCONTEXT_TBLNAME, REPORTCONTEXT_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & REPORTCONTEXT_TBLNAME & _
                " where " & REPORTCONTEXT_TBLNAME & "." & REPORTCONTEXT_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(REPORTCONTEXT_ID).value = ID
            If Name <> "" Then rs.Fields.Item(REPORTCONTEXT_NAME).value = Name
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(REPORTCONTEXT_ID).Value = ID
            'If name <> "" Then rsTmp.Fields.Item(REPORTCONTEXT_NAME).Value = name
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ReportContext"
    End If
    ImgRptContext.Visible = True
End Sub

Private Sub LoadPlotScale()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Name$, GISKey$
    Dim ID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading plot scales"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("PlotScale")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PlotScale")
    logUpdates = GetLogUpdates("PlotScale")

    ctr = 2
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)
    
    rs.Open PLOTSCALE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(PLOTSCALE_TBLNAME, PLOTSCALE_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        GISKey = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & PLOTSCALE_TBLNAME & _
                " where " & PLOTSCALE_TBLNAME & "." & PLOTSCALE_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(PLOTSCALE_ID).value = ID
            rs(PLOTSCALE_NAME) = Name
            rs(PLOTSCALE_GISKEY) = GISKey
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(PLOTSCALE_ID).Value = ID
            'rsTmp(PLOTSCALE_NAME) = name
            rsTmp(PLOTSCALE_GISKEY) = GISKey
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PlotScale"
    End If
    ImgPlotScale.Visible = True
End Sub

Private Sub LoadNetworkConfig()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Name$, NetType$, NetName$, parent$, LastParent$
    Dim ID&, ParentID&, NetTypeID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Network Configuration"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("NetworkConfiguration")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("NetworkConfiguration")
    logUpdates = GetLogUpdates("NetworkConfiguration")

    ctr = 2
    LastParent = ""
    
    Set cell = ws.Range("A2")
    NetType = Trim(cell.value)
    
    rs.Open NETWORKCONFIG_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(NETWORKCONFIG_TBLNAME, NETWORKCONFIG_ID)
    Do While NetType <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If IsNumeric(NetType) Then
            NetTypeID = CLng(NetType)
            If NetTypeID < 1 Or NetTypeID > 7 Then
                NetTypeID = NULL_LONG
            End If
        Else
            NetTypeID = NetworkTypeID(NetType)
        End If
            
        If NetTypeID <> NULL_LONG Then
            
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            Name = Trim(cell.value)
            
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            NetName = Trim(cell.value)
            
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            parent = Trim(cell.value)
            If parent <> "" Then
                If parent <> LastParent Then
                    ParentID = NetworkParentID(parent)
                    LastParent = parent
                End If
            Else
                ParentID = 0
                LastParent = ""
            End If
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & NETWORKCONFIG_TBLNAME & _
                    " where " & NETWORKCONFIG_TBLNAME & "." & NETWORKCONFIG_DISPLAYNAME & " = '" & Name & "'" & _
                    "AND " & NETWORKCONFIG_TBLNAME & "." & NETWORKCONFIG_TYPE & " = " & NetTypeID & _
                    "AND " & NETWORKCONFIG_TBLNAME & "." & NETWORKCONFIG_GISNETWORKNAME & " = '" & NetName & "'" & _
                    "AND " & NETWORKCONFIG_TBLNAME & "." & NETWORKCONFIG_PARENTID & " = " & ParentID
            
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(NETWORKCONFIG_ID) = ID
                rs(NETWORKCONFIG_DISPLAYNAME) = Name
                rs(NETWORKCONFIG_TYPE) = NetTypeID
                rs(NETWORKCONFIG_GISNETWORKNAME) = NetName
                If ParentID <> 0 Then rs(NETWORKCONFIG_PARENTID) = ParentID
                rs.Update
                
                ID = ID + 1
            Else
                'rsTmp(NETWORKCONFIG_ID) = ID
                'rsTmp(NETWORKCONFIG_DISPLAYNAME) = name
                rsTmp(NETWORKCONFIG_TYPE) = NetTypeID
                rsTmp(NETWORKCONFIG_GISNETWORKNAME) = NetName
                If ParentID <> 0 Then rsTmp(NETWORKCONFIG_PARENTID) = ParentID
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - not a valid network type"
        End If
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        NetType = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "NetworkConfiguration"
    End If
    ImgNetwkConfig.Visible = True
End Sub

Function FuseCharacteristicID&(FuseSize$, FuseType$)

    Dim FuseSizeID&, FuseTypeID&
    Dim sql$
    Dim rs As ADODB.Recordset

    FuseSizeID = EARatingID(FuseSize, EARating_FuseSize)
    FuseTypeID = EARatingID(FuseType, EARating_FuseType)
    
    sql = "select " & FUSECHAR_ID & " from " & FUSECHAR_TABLENAME & " where " & _
                FUSECHAR_FUSESIZEEARID & " = " & FuseSizeID & " and " & _
                FUSECHAR_FUSETYPEEARID & " = " & FuseTypeID
    
    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        Err.Raise vbObjectError + 27, , "No Fuse Characteristic Found"
    Else
       FuseCharacteristicID = rs(FUSECHAR_ID)
    End If

End Function
Private Sub LoadAttrStopCondition()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ConditionOperator$, LogicalOperator$, FtrAttrValue$, FtrTable$, parent$, NetConfig$
    Dim ID&, ClassificationTypeID&, FeatureAttributeID&, Sequence&, NetConfigID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading Attribute Stop Conditions"
    frmLoadIntoDb.Repaint
    Set ws = Worksheets("AttributeStopCondition")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeStopCondition")
    logUpdates = GetLogUpdates("AttributeStopCondition")

    ctr = 2
    
    Set cell = ws.Range("A2")
    MyStr = Trim(cell.value)
    cellstr = "b" & ctr
    Set cell = ws.Range(cellstr)
    NetConfig = Trim(cell.value)
    
    rs.Open ATTRSTOPCOND_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(ATTRSTOPCOND_TBLNAME, ATTRSTOPCOND_ID)
    
    Do While MyStr <> "" Or NetConfig <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ClassificationTypeID = ClassificationID(MyStr)
     
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        NetConfig = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        parent = Trim(cell.value)
        
        NetConfigID = NetConfigFromNetConfigParent(NetConfig, parent)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        FtrTable = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If ds <> "" Then
            FeatureAttributeID = AttrIdFromNameAndFtrTbl(MyStr, FtrTable, ds)
        Else
            FeatureAttributeID = AttrIdFromNameAndFtrTbl(MyStr, FtrTable)
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        ConditionOperator = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        FtrAttrValue = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        Sequence = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        LogicalOperator = Trim(cell.value)
                        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ATTRSTOPCOND_TBLNAME & _
                " where " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_FTRATTRID & " = " & FeatureAttributeID & _
                " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_CONDITIONOPERATOR & " = '" & ConditionOperator & "'" & _
                " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_GISFTRATTRVALUE & " = '" & FtrAttrValue & "'" & _
                " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_SEQUENCE & " = " & Sequence & _
                " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_LOGICALOPERATOR & " = '" & LogicalOperator & "'"
        If (ClassificationTypeID <> 0) Then
            sqlTmp = sqlTmp & _
            " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_CLASSTYPEID & " = " & ClassificationTypeID
        Else
            sqlTmp = sqlTmp & _
            " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_CLASSTYPEID & " is null"
        End If
        If (NetConfigID) <> 0 Then
            sqlTmp = sqlTmp & _
            " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_NETWORKCONFIGID & " = " & NetConfigID
        Else
            sqlTmp = sqlTmp & _
            " and " & ATTRSTOPCOND_TBLNAME & "." & ATTRSTOPCOND_NETWORKCONFIGID & " is null"
        End If
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(ATTRSTOPCOND_ID).value = ID
            rs(ATTRSTOPCOND_FTRATTRID) = FeatureAttributeID
            rs(ATTRSTOPCOND_CONDITIONOPERATOR) = ConditionOperator
            rs(ATTRSTOPCOND_GISFTRATTRVALUE) = FtrAttrValue
            rs(ATTRSTOPCOND_SEQUENCE) = Sequence
            rs(ATTRSTOPCOND_LOGICALOPERATOR) = LogicalOperator
            If (ClassificationTypeID <> 0) Then rs(ATTRSTOPCOND_CLASSTYPEID) = ClassificationTypeID
            If (NetConfigID) <> 0 Then rs(ATTRSTOPCOND_NETWORKCONFIGID) = NetConfigID
            ID = ID + 1
        Else
            'rsTmp(ATTRSTOPCOND_ID).Value = ID
            'rsTmp(ATTRSTOPCOND_FTRATTRID) = FeatureAttributeID
            'rsTmp(ATTRSTOPCOND_CONDITIONOPERATOR) = ConditionOperator
            'rsTmp(ATTRSTOPCOND_GISFTRATTRVALUE) = FtrAttrValue
            'rsTmp(ATTRSTOPCOND_SEQUENCE) = Sequence
            'rsTmp(ATTRSTOPCOND_LOGICALOPERATOR) = LogicalOperator
            'If (ClassificationTypeID <> 0) Then rsTmp(ATTRSTOPCOND_CLASSTYPEID) = ClassificationTypeID
            'If (NetConfigID) <> 0 Then rsTmp(ATTRSTOPCOND_NETWORKCONFIGID) = NetConfigID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
      
        cellstr = "b" & ctr
        Set cell = ws.Range(cellstr)
        NetConfig = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeStopCondition"
    End If
    ImgAttrStopCond.Visible = True
End Sub
Function NetConfigFromNetConfigParent(NetConfig$, parent$) As Long
    Dim rs As Recordset
    Dim qrystr As String
      
      
    qrystr = "select " & NETWORKCONFIG_ID & " from " & NETWORKCONFIG_TBLNAME & _
            " where " & NETWORKCONFIG_DISPLAYNAME & " ='" & NetConfig & _
            "' and " & NETWORKCONFIG_PARENTID & " in (select " & NETWORKCONFIG_ID & _
            " from " & NETWORKCONFIG_TBLNAME & " where " & NETWORKCONFIG_DISPLAYNAME & _
            " = '" & parent & "'" & ")"
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
        NetConfigFromNetConfigParent = 0
    Else
        NetConfigFromNetConfigParent = rs.Fields.Item(NETWORKCONFIG_ID).value
    End If

    rs.Close
    
End Function

Function NetworkParentID&(parent$)
    
    Dim AttrID&, DomainID&
    Dim sql$, domainName$
    Dim rs As ADODB.Recordset
    Dim retVal%

    sql = "select " & NETWORKCONFIG_ID & " from " & NETWORKCONFIG_TBLNAME & " where " _
    & NETWORKCONFIG_DISPLAYNAME & " = '" & parent & "'"
    
    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF And rs.EOF Then
        NetworkParentID = 0
    Else
        NetworkParentID = rs(NETWORKCONFIG_ID)
    End If
    rs.Close

End Function
Private Sub LoadOverlappingDomains()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim domainName$, FriendDomain$
    Dim DomainID&, FriendID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading overlapping domains"
    Me.Repaint
    Set ws = Worksheets("OverlappingDomains")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("OverlappingDomains")
    logUpdates = GetLogUpdates("OverlappingDomains")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    domainName = Trim(cell.value)
    
    rs.Open OVERLAPPINGDOMAIN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While domainName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        DomainID = AttributeDomainId(domainName)
              
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        FriendDomain = Trim(cell.value)
        FriendID = AttributeDomainId(FriendDomain)
            
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & OVERLAPPINGDOMAIN_TBLNAME & _
                " where " & OVERLAPPINGDOMAIN_TBLNAME & "." & OVERLAPPINGDOMAIN_ATTRDOMAINID & " = " & DomainID & _
                " and " & OVERLAPPINGDOMAIN_TBLNAME & "." & OVERLAPPINGDOMAIN_FRIENDDOMAINID & " = " & FriendID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(OVERLAPPINGDOMAIN_ATTRDOMAINID).value = DomainID
            rs.Fields.Item(OVERLAPPINGDOMAIN_FRIENDDOMAINID).value = FriendID
        Else
            'rsTmp.Fields.Item(OVERLAPPINGDOMAIN_ATTRDOMAINID).Value = DomainID
            'rsTmp.Fields.Item(OVERLAPPINGDOMAIN_FRIENDDOMAINID).Value = FriendID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
    
        ' Add the friendly domains in both directions
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & OVERLAPPINGDOMAIN_TBLNAME & _
                " where " & OVERLAPPINGDOMAIN_TBLNAME & "." & OVERLAPPINGDOMAIN_ATTRDOMAINID & " = " & FriendID & _
                " and " & OVERLAPPINGDOMAIN_TBLNAME & "." & OVERLAPPINGDOMAIN_FRIENDDOMAINID & " = " & DomainID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(OVERLAPPINGDOMAIN_ATTRDOMAINID).value = FriendID
            rs.Fields.Item(OVERLAPPINGDOMAIN_FRIENDDOMAINID).value = DomainID
        Else
            'rsTmp.Fields.Item(OVERLAPPINGDOMAIN_ATTRDOMAINID).Value = FriendID
            'rsTmp.Fields.Item(OVERLAPPINGDOMAIN_FRIENDDOMAINID).Value = DomainID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row (Other Direction)"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        domainName = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "OverlappingDomains"
    End If
End Sub

Private Function GetErrorCol(tabName As String) As String
    Dim ws As Worksheet
    Dim ctr As Integer
    Dim valA As String
    Dim found As Boolean
    found = False
    
    GetErrorCol = "NA"
    Set ws = Worksheets("TabConfig")
    ctr = 3
    valA = Trim(ws.Range(("A" & ctr)).value)
    Do While (valA <> "")
        If UCase(valA) = UCase(tabName) Then
            GetErrorCol = Trim(ws.Range(("B" & ctr)).value)
            ws.Range(("D" & ctr)).value = 1
            found = True
            Exit Do
        End If
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not found Then
        ctr = ctr
    End If
End Function
Private Function GetLogUpdates(tabName As String) As String
    Dim ws As Worksheet
    Dim ctr As Integer
    Dim valA As String
    
    GetLogUpdates = "0"
    
    If logUpdatesToFile Then
        Set ws = Worksheets("TabConfig")
        ctr = 3
        valA = Trim(ws.Range(("A" & ctr)).value)
        Do While (valA <> "")
            If UCase(valA) = UCase(tabName) Then
                GetLogUpdates = Trim(ws.Range(("C" & ctr)).value)
                Exit Do
            End If
            ctr = ctr + 1
            valA = Trim(ws.Range(("A" & ctr)).value)
        Loop
    End If
End Function

' FeatureClass
Private Function IsFtrCls(ftrName As String) As Boolean
    IsFtrCls = False
    Dim ws As Worksheet
    Dim ctr As Integer
    Dim valA As String
    Set ws = Worksheets("FeatureTypes")
    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    Do While (valA <> "")
        If UCase(valA) = UCase(ftrName) Then
            If LCase(Trim(ws.Range(("AA" & ctr)).value)) = "ftrcls" Then
                IsFtrCls = True
            End If
            Exit Do
        End If
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
End Function

' FeatureClass

Private Sub GetFtrTypes(FtrTblName As String, ByRef aFtr() As String, ByRef cFtr As Integer)
    Dim fcRow%
    Dim fcChild$, fcParent$
    Dim pWorkSheetFtrCls As Excel.Worksheet
    Set pWorkSheetFtrCls = Worksheets("FeatureClasses")
    fcRow = 2
    fcParent = Trim(pWorkSheetFtrCls.Range(("B" & fcRow)).value)
    Do While fcParent <> ""
        If fcParent = FtrTblName Then
            fcChild = Trim(pWorkSheetFtrCls.Range(("A" & fcRow)).value)
            If fcChild <> "" Then
                If IsFtrCls(fcChild) Then
                    GetFtrTypes fcChild, aFtr, cFtr
                Else
                    ReDim Preserve aFtr(cFtr)
                    aFtr(cFtr) = fcChild
                    cFtr = cFtr + 1
                End If
            End If
        
        End If
        fcRow = fcRow + 1
        fcParent = Trim(pWorkSheetFtrCls.Range(("B" & fcRow)).value)
    Loop
End Sub

Private Sub LoadFeatureAttributes()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ID&, FtrTypeID&, DomainID&
    Dim IntName$, ErrorMessage$
    Dim FtrTblName$, OldFtrName$, domainName$, lastDomainName$
    Dim FtrAttrName As String
    Dim FtrAttrExtName As String
    Dim FtrAttrDisplayOrder As String
    Dim FtrAttrAllowedAccess As String
    Dim FtrAttrDesignOnly As String
    Dim bAddNew As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading feature attributes"
    Me.Repaint
    
    Set ws = Worksheets("FeatureAttributes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureAttributes")
    logUpdates = GetLogUpdates("FeatureAttributes")

    ctr = 2
    OldFtrName = ""
    lastDomainName = ""
    Failure = False
    Set cell = ws.Range("B2")
    
    rs.Open FEATUREATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FEATUREATTR_TBLNAME, FEATUREATTR_ID)
    
    Do While Trim(cell.value) <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If Trim(ws.Range(("O" & ctr)).value) = "1" Then 'EDProcess?
        
            cellstr = "A" & ctr
            Set cell = ws.Range(cellstr)
            FtrTblName = Trim(cell.value)
        
            ' FeatureClass
            ' If feature class, locate all feature types that inherit from it:
            ' If feature type, just add to array:
            Dim aFtr() As String
            Dim cFtr As Integer
            Dim iFtr As Integer
            cFtr = 0
            ReDim Preserve aFtr(cFtr)
            If IsFtrCls(FtrTblName) Then
                GetFtrTypes FtrTblName, aFtr, cFtr
            Else
                ReDim Preserve aFtr(cFtr)
                aFtr(cFtr) = FtrTblName
                cFtr = cFtr + 1
            End If
            
            ' Process array of feature types:
            If cFtr > 0 Then
                For iFtr = LBound(aFtr) To UBound(aFtr)
                    FtrTblName = aFtr(iFtr)
                
                    cellstr = "AA" & ctr
                    Set cell = ws.Range(cellstr)
                    ds = Trim(cell.value)
            
                    If FtrTblName <> "" Then
                        If OldFtrName <> FtrTblName Then
                            If ds <> "" Then
                                FtrTypeID = FeatureTypeID(FtrTblName, ds)
                            Else
                                FtrTypeID = FeatureTypeID(FtrTblName)
                            End If
                            OldFtrName = FtrTblName
                        End If
                    Else
                        FtrTypeID = NULL_LONG
                        OldFtrName = FtrTblName
                    End If
            
                    cellstr = "B" & ctr
                    Set cell = ws.Range(cellstr)
                    FtrAttrName = Trim(cell.value)
                    
                    cellstr = "C" & ctr
                    Set cell = ws.Range(cellstr)
                    domainName = Trim(cell.value)
                    If domainName <> "" Then
                        If domainName <> lastDomainName Then
                            DomainID = AttributeDomainId(Trim(cell.value))
                            lastDomainName = domainName
                        End If
                    End If
                    
                    cellstr = "D" & ctr
                    Set cell = ws.Range(cellstr)
                    FtrAttrExtName = Trim(cell.value)
                    
                    cellstr = "E" & ctr
                    Set cell = ws.Range(cellstr)
                    IntName = Trim(cell.value)
                    
                    cellstr = "F" & ctr
                    Set cell = ws.Range(cellstr)
                    FtrAttrDisplayOrder = Trim(cell.value)
                    
                    cellstr = "G" & ctr
                    Set cell = ws.Range(cellstr)
                    FtrAttrAllowedAccess = Trim(cell.value)
                    
                    cellstr = "H" & ctr
                    Set cell = ws.Range(cellstr)
                    FtrAttrDesignOnly = Trim(cell.value)
                    
                    ' Extra error checking for feature attributes:
                    If (FtrTypeID <> NULL_LONG) And (ValidateUtility = True) Then
                        If Not ValidateUtilityAttribute(FtrTypeID, IntName, DomainID, ErrorMessage) Then
                            'Mark the failure in the spreadsheet
                            Set cell = ws.Range((ErrorCol & ctr))
                            cell.Font.Color = RGB(255, 0, 0)
                            Failure = True
                            cell.value = ErrorMessage
                            Failure = True
                        End If
                    End If
                
                    ' Check for existing rows: DONE
                    sqlTmp = "select * from " & FEATUREATTR_TBLNAME & _
                            " where " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_FTRTYPEID & " = " & FtrTypeID & _
                            " and " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_NAME & " = '" & FtrAttrName & "'"
                    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                    If rsTmp.BOF And rsTmp.EOF Then
                        rs.AddNew
                        rs.Fields.Item(FEATUREATTR_ID).value = ID
                        rs.Fields.Item(FEATUREATTR_FTRTYPEID).value = FtrTypeID
                        rs.Fields.Item(FEATUREATTR_NAME).value = FtrAttrName
                        rs.Fields.Item(FEATUREATTR_ATTRDOMAINID).value = DomainID
                        rs.Fields.Item(FEATUREATTR_EXTERNALNAME).value = FtrAttrExtName
                        rs.Fields.Item(FEATUREATTR_INTERNALNAME).value = IntName
                        rs.Fields.Item(FEATUREATTR_DISPLAYORDER).value = FtrAttrDisplayOrder
                        rs.Fields.Item(FEATUREATTR_ALLOWEDACCESS).value = AllowedAccessValue(FtrAttrAllowedAccess)
                        rs.Fields.Item(FEATUREATTR_ISNONMAPPED).value = BoolStringToInt(FtrAttrDesignOnly)
                        ID = ID + 1
                    Else
                        rsTmp.Fields.Item(FEATUREATTR_ATTRDOMAINID).value = DomainID
                        rsTmp.Fields.Item(FEATUREATTR_EXTERNALNAME).value = FtrAttrExtName
                        rsTmp.Fields.Item(FEATUREATTR_INTERNALNAME).value = IntName
                        rsTmp.Fields.Item(FEATUREATTR_DISPLAYORDER).value = FtrAttrDisplayOrder
                        rsTmp.Fields.Item(FEATUREATTR_ALLOWEDACCESS).value = AllowedAccessValue(FtrAttrAllowedAccess)
                        rsTmp.Fields.Item(FEATUREATTR_ISNONMAPPED).value = BoolStringToInt(FtrAttrDesignOnly)
                        rsTmp.Update
            
                        If logUpdates = "1" Then
                            ' Tell user about our update:
                            Set cell = ws.Range((ErrorCol & ctr))
                            cell.Font.Color = RGB(255, 0, 0)
                            cell.value = cell.value & " Updated existing row"
                            Failure = True
                        End If
                    End If
                    rsTmp.Close
                    
                Next iFtr
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureAttributes"
    End If
    ImgFtrAttrs.Visible = True
End Sub

Private Sub LoadFeatureAttributes_new()
    Label2.Caption = "Loading feature attributes"
    Me.Repaint

    LoadFeatureAttributesEngine
    
    ' Add loop and call the following for each featuretype or add this call to the sub above.
    Dim curFtrType As String
    ProcessFeatureClasses curFtrType, curFtrType

    ImgFtrAttrs.Visible = True
End Sub

Private Sub ProcessFeatureClasses(curFtrType As String, curChild As String)
    Dim fcRow%
    Dim fcWs As Worksheet
    Dim fcChild$, fcParent$
    fcRow = 2
    Set fcWs = Worksheets("FeatureClasses")
    fcChild = Trim(fcWs.Range(("A" & fcRow)).value)
    Do While fcChild <> ""
        If fcChild = curChild Then
            fcParent = Trim(fcWs.Range(("B" & fcRow)).value)
            If fcParent <> "" Then
                ProcessFeatureClasses curFtrType, fcParent
                
                ' Not sure how to call a sub by name in order to prevent multiple versions of this sub.
                LoadFeatureAttributesEngine curFtrType, fcParent
                
                
            End If
        End If
        fcRow = fcRow + 1
        fcChild = Trim(fcWs.Range(("A" & fcRow)).value)
    Loop
End Sub

Private Sub LoadFeatureAttributesEngine(Optional curFtr As String, Optional FtrClass As String)
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ID&, FtrTypeID&, DomainID&
    Dim IntName$, ErrorMessage$
    Dim FtrTblName$, OldFtrName$, domainName$, lastDomainName$
    Dim FtrAttrName As String
    Dim FtrAttrExtName As String
    Dim FtrAttrDisplayOrder As String
    Dim FtrAttrAllowedAccess As String
    Dim FtrAttrDesignOnly As String
    Dim bAddNew As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    
    Set ws = Worksheets("FeatureAttributes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureAttributes")
    logUpdates = GetLogUpdates("FeatureAttributes")

    ctr = 2
    OldFtrName = ""
    lastDomainName = ""
    Failure = False
    Set cell = ws.Range("B2")
    
    rs.Open FEATUREATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FEATUREATTR_TBLNAME, FEATUREATTR_ID)
    
    Do While Trim(cell.value) <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If Trim(ws.Range(("O" & ctr)).value) = "1" Then 'EDProcess?
        
            cellstr = "A" & ctr
            Set cell = ws.Range(cellstr)
            FtrTblName = Trim(cell.value)
            
            cellstr = "AA" & ctr
            Set cell = ws.Range(cellstr)
            ds = Trim(cell.value)
    
            If FtrTblName <> "" Then
                If OldFtrName <> FtrTblName Then
                    If ds <> "" Then
                        FtrTypeID = FeatureTypeID(FtrTblName, ds)
                    Else
                        FtrTypeID = FeatureTypeID(FtrTblName)
                    End If
                    OldFtrName = FtrTblName
                End If
            Else
                FtrTypeID = NULL_LONG
                OldFtrName = FtrTblName
            End If
    
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            FtrAttrName = Trim(cell.value)
            
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            domainName = Trim(cell.value)
            If domainName <> "" Then
                If domainName <> lastDomainName Then
                    DomainID = AttributeDomainId(Trim(cell.value))
                    lastDomainName = domainName
                End If
            End If
            
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            FtrAttrExtName = Trim(cell.value)
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            IntName = Trim(cell.value)
            
            cellstr = "F" & ctr
            Set cell = ws.Range(cellstr)
            FtrAttrDisplayOrder = Trim(cell.value)
            
            cellstr = "G" & ctr
            Set cell = ws.Range(cellstr)
            FtrAttrAllowedAccess = Trim(cell.value)
            
            cellstr = "H" & ctr
            Set cell = ws.Range(cellstr)
            FtrAttrDesignOnly = Trim(cell.value)
            
            ' Extra error checking for feature attributes:
            If (FtrTypeID <> NULL_LONG) And (ValidateUtility = True) Then
                If Not ValidateUtilityAttribute(FtrTypeID, IntName, DomainID, ErrorMessage) Then
                    'Mark the failure in the spreadsheet
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    Failure = True
                    cell.value = ErrorMessage
                    Failure = True
                End If
            End If
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FEATUREATTR_TBLNAME & _
                    " where " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_FTRTYPEID & " = " & FtrTypeID & _
                    " and " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_NAME & " = '" & FtrAttrName & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FEATUREATTR_ID).value = ID
                rs.Fields.Item(FEATUREATTR_FTRTYPEID).value = FtrTypeID
                rs.Fields.Item(FEATUREATTR_NAME).value = FtrAttrName
                rs.Fields.Item(FEATUREATTR_ATTRDOMAINID).value = DomainID
                rs.Fields.Item(FEATUREATTR_EXTERNALNAME).value = FtrAttrExtName
                rs.Fields.Item(FEATUREATTR_INTERNALNAME).value = IntName
                rs.Fields.Item(FEATUREATTR_DISPLAYORDER).value = FtrAttrDisplayOrder
                rs.Fields.Item(FEATUREATTR_ALLOWEDACCESS).value = AllowedAccessValue(FtrAttrAllowedAccess)
                rs.Fields.Item(FEATUREATTR_ISNONMAPPED).value = BoolStringToInt(FtrAttrDesignOnly)
                ID = ID + 1
            Else
                rsTmp.Fields.Item(FEATUREATTR_ATTRDOMAINID).value = DomainID
                rsTmp.Fields.Item(FEATUREATTR_EXTERNALNAME).value = FtrAttrExtName
                rsTmp.Fields.Item(FEATUREATTR_INTERNALNAME).value = IntName
                rsTmp.Fields.Item(FEATUREATTR_DISPLAYORDER).value = FtrAttrDisplayOrder
                rsTmp.Fields.Item(FEATUREATTR_ALLOWEDACCESS).value = AllowedAccessValue(FtrAttrAllowedAccess)
                rsTmp.Fields.Item(FEATUREATTR_ISNONMAPPED).value = BoolStringToInt(FtrAttrDesignOnly)
                rsTmp.Update
    
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        End If
        
        ctr = ctr + 1
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureAttributes"
    End If
End Sub

Private Sub LoadAttributeSets()

    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ID&
    Dim valB$, valC$, valD$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading attribute sets"
    Me.Repaint
    Set ws = Worksheets("AttributeSets")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeSets")
    logUpdates = GetLogUpdates("AttributeSets")
    
    ctr = 2
    
    Dim SetName As String
    Set cell = ws.Range("A2")
    SetName = Trim(cell.value)
    
    rs.Open ATTRSET_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(ATTRSET_TBLNAME, ATTRSET_ID)
    Do While SetName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        valB = Trim(ws.Range(("B" & ctr)).value)
        valC = Trim(ws.Range(("C" & ctr)).value)
        valD = Trim(ws.Range(("D" & ctr)).value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ATTRSET_TBLNAME & _
                " where " & ATTRSET_TBLNAME & "." & ATTRSET_NAME & " = '" & SetName & "'" & _
                " and " & ATTRSET_TBLNAME & "." & ATTRSET_DESCRIPTION & " = '" & valB & "'" & _
                " and " & ATTRSET_TBLNAME & "." & ATTRSET_TYPE & " = " & AttributeSetTypeId(valC)
                
        If valD <> "" Then
            sqlTmp = sqlTmp & _
                    " and " & ATTRSET_TBLNAME & "." & ATTRSET_GLOBALID & " = " & AttributeSetId(valD)
        Else
            sqlTmp = sqlTmp & _
                    " and " & ATTRSET_TBLNAME & "." & ATTRSET_GLOBALID & " is null"
        End If
                
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(ATTRSET_ID).value = ID
            If SetName <> "" Then rs.Fields.Item(ATTRSET_NAME).value = SetName
            If valB <> "" Then rs.Fields.Item(ATTRSET_DESCRIPTION).value = valB
            If valC <> "" Then rs.Fields.Item(ATTRSET_TYPE).value = AttributeSetTypeId(valC)
            If valD <> "" Then rs.Fields.Item(ATTRSET_GLOBALID).value = AttributeSetId(valD)
            rs.Fields.Item(ATTRSET_ISPUBLIC).value = -1
            rs.Fields.Item(ATTRSET_CREATORID).value = CurrentUserID
            rs.Fields.Item(ATTRSET_OWNERID).value = CurrentUserID
            rs.Fields.Item(ATTRSET_CREATEDATE).value = DateTime.Date
            rs.Fields.Item(ATTRSET_UPDATEDATE).value = DateTime.Date
            rs.Fields.Item(ATTRSET_COMMODITYGROUPID).value = groupid

            ID = ID + 1
        Else
            'rsTmp.Fields.Item(ATTRSET_ID).Value = ID
            'If SetName <> "" Then rsTmp.Fields.Item(ATTRSET_NAME).Value = SetName
            'If valB <> "" Then rsTmp.Fields.Item(ATTRSET_DESCRIPTION).Value = valB
            'If valC <> "" Then rsTmp.Fields.Item(ATTRSET_TYPE).Value = AttributeSetTypeId(valC)
            'If valD <> "" Then rsTmp.Fields.Item(ATTRSET_GLOBALID).Value = AttributeSetId(valD)
            rsTmp.Fields.Item(ATTRSET_ISPUBLIC).value = -1
            rsTmp.Fields.Item(ATTRSET_CREATORID).value = CurrentUserID
            rsTmp.Fields.Item(ATTRSET_OWNERID).value = CurrentUserID
            rsTmp.Fields.Item(ATTRSET_CREATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(ATTRSET_UPDATEDATE).value = DateTime.Date
            rsTmp.Fields.Item(ATTRSET_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        SetName = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeSets"
    End If
    ImgAttrSet.Visible = True
End Sub


Private Sub LoadCustomCostType()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ID&, ParentID&
    Dim Name$, LastParent$
    Dim valC$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Custom Cost Types"
    Me.Repaint
    Set ws = Worksheets("CustomCostType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CustomCostType")
    logUpdates = GetLogUpdates("CustomCostType")
    
    ctr = 2
    LastParent = ""
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)
    
    rs.Open CUSTOMCOSTTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CUSTOMCOSTTYPE_TBLNAME, CUSTOMCOSTTYPE_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ParentID = 0
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If MyStr <> LastParent Then
                ParentID = CustomCostTypeID(MyStr)
                LastParent = MyStr
            End If
            If ParentID = 0 Then
                'Mark the failure in the spreadsheet
                cellstr = "D" & ctr
                Set cell = ws.Range(cellstr)
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Could not find Parent"
            'Else
                'rs.Fields.Item(CUSTOMCOSTTYPE_PARENTID).Value = ParentID
            End If
        End If
        
        valC = Trim(ws.Range(("C" & ctr)).value)
        
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CUSTOMCOSTTYPE_TBLNAME & _
                " where " & CUSTOMCOSTTYPE_TBLNAME & "." & CUSTOMCOSTTYPE_NAME & " = '" & Name & "'"
        If ParentID <> 0 Then
            sqlTmp = sqlTmp & _
                    " and " & CUSTOMCOSTTYPE_TBLNAME & "." & CUSTOMCOSTTYPE_PARENTID & " = " & ParentID
        Else
            sqlTmp = sqlTmp & _
                    " and " & CUSTOMCOSTTYPE_TBLNAME & "." & CUSTOMCOSTTYPE_PARENTID & " IS NULL"
        End If
                    
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(CUSTOMCOSTTYPE_ID).value = ID
            rs.Fields.Item(CUSTOMCOSTTYPE_NAME).value = Name
            If ParentID <> 0 Then rs.Fields.Item(CUSTOMCOSTTYPE_PARENTID).value = ParentID
            If valC <> "" Then rs.Fields.Item(CUSTOMCOSTTYPE_DISPLAYIDPREFIX).value = valC
            rs.Update
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(CUSTOMCOSTTYPE_ID).Value = ID
            'rsTmp.Fields.Item(CUSTOMCOSTTYPE_NAME).Value = name
            'If ParentID <> 0 Then rsTmp.Fields.Item(CUSTOMCOSTTYPE_PARENTID).Value = ParentID
            If valC <> "" Then rsTmp.Fields.Item(CUSTOMCOSTTYPE_DISPLAYIDPREFIX).value = valC
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CustomCostType"
    End If
End Sub

Private Sub LoadCustomCostItem()

    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim ID&, typeid&
    Dim CCID$
    Dim valB$, valC$, valD$, valE$, valF$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Custom Cost Items"
    Me.Repaint
    Set ws = Worksheets("CustomCostItem")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CustomCostItem")
    logUpdates = GetLogUpdates("CustomCostItem")

    ctr = 2
    
    Set cell = ws.Range("A2")
    CCID = Trim(cell.value)
    
    rs.Open CUSTOMCOST_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CUSTOMCOST_TBLNAME, CUSTOMCOST_ID)
    Do While CCID <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        valB = Trim(ws.Range(("B" & ctr)).value)
        valC = Trim(ws.Range(("C" & ctr)).value)
        valD = Trim(ws.Range(("D" & ctr)).value)
        If valD <> "" Then
            If Not IsNumeric(valD) Then
                'Mark the failure in the spreadsheet
                cellstr = "G" & ctr
                Set cell = ws.Range(cellstr)
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Cost is not numeric"
            End If
        End If
        valE = Trim(ws.Range(("E" & ctr)).value)
        If valE <> "" Then
            typeid = CustomCostTypeID(valE)
            If typeid = 0 Then
                'Mark the failure in the spreadsheet
                cellstr = "G" & ctr
                Set cell = ws.Range(cellstr)
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Could not find type"
            End If
        End If
        valF = Trim(ws.Range(("F" & ctr)).value)
    
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CUSTOMCOST_TBLNAME & _
                " where " & CUSTOMCOST_TBLNAME & "." & CUSTOMCOST_CCID & " = '" & CCID & "'" & _
                " and " & CUSTOMCOST_TBLNAME & "." & CUSTOMCOST_CUSTOMTYPEID & " = " & typeid
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(CUSTOMCOST_ID).value = ID
            rs.Fields.Item(CUSTOMCOST_CCID).value = CCID
            If valB <> "" Then rs.Fields.Item(CUSTOMCOST_DESC).value = valB
            If valC <> "" Then rs.Fields.Item(CUSTOMCOST_SHORTDESC).value = valC
            If valD <> "" Then
                If IsNumeric(valD) Then rs.Fields.Item(CUSTOMCOST_COST).value = CDbl(valD)
            End If
            If typeid <> 0 Then rs.Fields.Item(CUSTOMCOST_CUSTOMTYPEID).value = typeid
            If valF <> "" Then rs.Fields.Item(CUSTOMCOST_ISPUBLIC).value = BoolStringToInt(valF)
            rs.Fields.Item(CUSTOMCOST_CREATEDBY) = CurrentUserID
            rs.Fields.Item(CUSTOMCOST_OWNERID) = CurrentUserID
            If IsSQLSERVER Then
                rs.Fields.Item(CUSTOMCOST_CREATEDATE) = Format(Now, "Short Date")
                rs.Fields.Item(CUSTOMCOST_UPDATEDATE) = Format(Now, "Short Date")
            Else
                rs.Fields.Item(CUSTOMCOST_CREATEDATE) = Now
                rs.Fields.Item(CUSTOMCOST_UPDATEDATE) = Now
            End If
            rs.Fields.Item(CUSTOMCOST_COMMODITYGROUPID).value = groupid
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(CUSTOMCOST_ID).Value = ID
            'rsTmp.Fields.Item(CUSTOMCOST_CCID).Value = CCID
            If valB <> "" Then rsTmp.Fields.Item(CUSTOMCOST_DESC).value = valB
            If valC <> "" Then rsTmp.Fields.Item(CUSTOMCOST_SHORTDESC).value = valC
            If valD <> "" Then
                If IsNumeric(valD) Then rsTmp.Fields.Item(CUSTOMCOST_COST).value = CDbl(valD)
            End If
            'If TypeID <> 0 Then rsTmp.Fields.Item(CUSTOMCOST_CUSTOMTYPEID).Value = TypeID
            If valF <> "" Then rsTmp.Fields.Item(CUSTOMCOST_ISPUBLIC).value = BoolStringToInt(valF)
            rsTmp.Fields.Item(CUSTOMCOST_CREATEDBY) = CurrentUserID
            rsTmp.Fields.Item(CUSTOMCOST_OWNERID) = CurrentUserID
            If IsSQLSERVER Then
                rsTmp.Fields.Item(CUSTOMCOST_CREATEDATE) = Format(Now, "Short Date")
                rsTmp.Fields.Item(CUSTOMCOST_UPDATEDATE) = Format(Now, "Short Date")
            Else
                rsTmp.Fields.Item(CUSTOMCOST_CREATEDATE) = Now
                rsTmp.Fields.Item(CUSTOMCOST_UPDATEDATE) = Now
            End If
            rsTmp.Fields.Item(CUSTOMCOST_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CCID = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CustomCostItem"
    End If
    ImgUnit.Visible = True
End Sub
Private Sub LoadAttributeLegalValues()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, domainName$, LastDomain$, temp$
    Dim LglVluId&, ctr&, DomainID&, displayOrder&
    Dim UseEARating%
    Dim AlternateVal$, LegalVal$, RatingName$, ratingType$, AnalysisVal$, MyStr$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading legal value assignments"
    Me.Repaint
    Set ws = Worksheets("AttributeLegalValue")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeLegalValue")
    logUpdates = GetLogUpdates("AttributeLegalValue")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    domainName = Trim(cell.value)
    LastDomain = ""
    
    rs.Open ATTRLEGALVALUEASSIGN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While domainName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        AnalysisVal = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        LegalVal = Trim(cell.value)
        
        'Debug.Print ("DomainName:" & DomainName & "LegalValue:" & LegalVal & ">" & CStr(ctr))
            
        If Trim(cell.value) <> "" Then
            
            If domainName <> LastDomain Then
                DomainID = AttributeDomainId(domainName)
                LastDomain = domainName
            End If
            
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            AlternateVal = Trim(cell.value)
            
            AtrLglVlUpdate = ""
            If AlternateVal <> "" Then
                LglVluId = LegalValueId(LegalVal, True, AlternateVal)
            Else
                LglVluId = LegalValueId(LegalVal, True)
            End If
            
            If AtrLglVlUpdate <> "" Then
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing legal values: " & AtrLglVlUpdate
                    Failure = True
                End If
            End If
            
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            AnalysisVal = Trim(cell.value)
            If AnalysisVal <> "" Then
                'EA Rating entries should be of the form RatingType~RatingName
                'e.g. "4~ACSR"
                temp = AnalysisVal
                If InStr(temp, SeparatorChar) <> 0 Then
                    ratingType = Token2(temp, SeparatorChar)
                    RatingName = Token2(temp, SeparatorChar)
                    AnalysisVal = CStr(EARatingID(RatingName, CLng(ratingType)))
                End If
            End If
            
            cellstr = "E" & ctr
            Set cell = ws.Range(cellstr)
            MyStr = Trim(cell.value)
            If IsNumeric(MyStr) Then
                displayOrder = CLng(MyStr)
            Else
                displayOrder = 1
            End If
            
            If LglVluId <> 0 Then
                
                ' Check for existing rows: DONE
                sqlTmp = "select * from " & ATTRLEGALVALUEASSIGN_TBLNAME & _
                        " where " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_LEGALVALUEID & " = " & LglVluId & _
                        " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_DOMAINID & " = " & DomainID
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs.Fields.Item(ATTRLEGALVALUEASSIGN_LEGALVALUEID).value = LglVluId
                    rs.Fields.Item(ATTRLEGALVALUEASSIGN_DOMAINID).value = DomainID
                    If AnalysisVal <> "" Then rs(ATTRLEGALVALUEASSIGN_ALTERNATEVALUE) = AnalysisVal
                    rs.Fields.Item(ATTRLEGALVALUEASSIGN_DISPLAYORDER).value = displayOrder
                Else
                    'rsTmp.Fields.Item(ATTRLEGALVALUEASSIGN_LEGALVALUEID).Value = LglVluId
                    'rsTmp.Fields.Item(ATTRLEGALVALUEASSIGN_DOMAINID).Value = DomainID
                    If AnalysisVal <> "" Then rsTmp(ATTRLEGALVALUEASSIGN_ALTERNATEVALUE) = AnalysisVal
                    rsTmp.Fields.Item(ATTRLEGALVALUEASSIGN_DISPLAYORDER).value = displayOrder
                    rsTmp.Update

                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing legal value assignment"
                        Failure = True
                    End If
                End If
                rsTmp.Close
            
            End If
        End If
          
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        domainName = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeLegalValue"
    End If
    ImgAttrLegalVals.Visible = True
End Sub

Function LegalValueIDFromDomainID&(LegalValue$, DomID&)
    Dim rs As Recordset
    Dim qrystr$, temp$
    Dim ID&
    
    temp = LegalValue
    DealWithApostrophes temp
    
    
    qrystr = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " from " & _
                ATTRLEGALVALUE_TBLNAME & ", " & ATTRLEGALVALUEASSIGN_TBLNAME & " where " & _
                ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_VALUE & " = '" & temp & _
                "' and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_DOMAINID & " =  " & _
                 CStr(DomID) & " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & _
                 ATTRLEGALVALUEASSIGN_LEGALVALUEID & " = " & ATTRLEGALVALUE_TBLNAME & "." & _
                 ATTRLEGALVALUE_ID
             
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
         'Err.Raise vbObjectError + 27, , "No legal value found"
         LegalValueIDFromDomainID = NULL_LONG
    Else
         LegalValueIDFromDomainID = rs.Fields.Item(ATTRLEGALVALUE_ID).value
    End If
        
    rs.Close

End Function
Function AlternateValueIDFromDomainID&(LegalValue$, DomID&)
    Dim rs As Recordset
    Dim qrystr$, temp$
    Dim ID&
    
    temp = LegalValue
    DealWithApostrophes temp
    
    
    qrystr = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " from " & _
                ATTRLEGALVALUE_TBLNAME & ", " & ATTRLEGALVALUEASSIGN_TBLNAME & " where " & _
                ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ALTERNATEVALUE & " = '" & temp & _
                "' and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_DOMAINID & " =  " & _
                 CStr(DomID) & " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & _
                 ATTRLEGALVALUEASSIGN_LEGALVALUEID & " = " & ATTRLEGALVALUE_TBLNAME & "." & _
                 ATTRLEGALVALUE_ID
             
    Set rs = Conn.Execute(qrystr)
    
    If rs.EOF And rs.BOF Then
         'Err.Raise vbObjectError + 27, , "No legal value found"
         AlternateValueIDFromDomainID = NULL_LONG
    Else
         AlternateValueIDFromDomainID = rs.Fields.Item(ATTRLEGALVALUE_ID).value
    End If
        
    rs.Close

End Function
Function Token2$(a$, t$)
    Dim i%

    i = InStr(a, t)
    If i Then
        Token2 = Left(a, i - 1)
        a = Mid(a, i + 1)
    Else
        Token2 = a
        a = ""
    End If
End Function
Private Sub LoadAttributeDefaultValues()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim SetName$, FtrTblName$, domainName$, LastSet$, LastFtrName$
    Dim ctr%
    Dim ID&, DomainID&, LegalValID&, AttrSetID&, FtrTypeID&
    Dim valC$, valE$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading default values"
    Me.Repaint
    Set ws = Worksheets("AttributeDefaultValues")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeDefaultValues")
    logUpdates = GetLogUpdates("AttributeDefaultValues")

    ctr = 2
    
    Set cell = ws.Range("A2")
    SetName = Trim(cell.value)
    LastSet = ""
    LastFtrName = ""
        
    rs.Open ATTRDEFVAL_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(ATTRDEFVAL_TBLNAME, ATTRDEFVAL_ID)
    Do While SetName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If SetName <> LastSet Then
            AttrSetID = AttributeSetId(SetName)
            LastSet = SetName
        End If
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        ' EDProcess?:
        If Trim(ws.Range("M" & ctr).value) = "1" Then
        
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            FtrTblName = Trim(cell.value)
            
            ' FeatureClass
            ' If feature class, locate all feature types that inherit from it:
            ' If feature type, just add to array:
            Dim aFtr() As String
            Dim cFtr As Integer
            Dim iFtr As Integer
            cFtr = 0
            ReDim Preserve aFtr(cFtr)
            If IsFtrCls(FtrTblName) Then
                GetFtrTypes FtrTblName, aFtr, cFtr
            Else
                ReDim Preserve aFtr(cFtr)
                aFtr(cFtr) = FtrTblName
                cFtr = cFtr + 1
            End If
            
            ' Process array of feature types:
            For iFtr = LBound(aFtr) To UBound(aFtr)
                FtrTblName = aFtr(iFtr)
                If FtrTblName <> "" Then
                    If FtrTblName <> LastFtrName Then
                        If ds <> "" Then
                            FtrTypeID = FeatureTypeID(FtrTblName, ds)
                        Else
                            FtrTypeID = FeatureTypeID(FtrTblName)
                        End If
                        LastFtrName = FtrTblName
                    End If
                Else
                    LastFtrName = ""
                    FtrTypeID = NULL_LONG
                End If
                
                valC = Trim(ws.Range(("C" & ctr)).value)
                Debug.Print (CStr(ctr) & ">" & FtrTblName & ">" & valC)
                
                cellstr = "D" & ctr
                Set cell = ws.Range(cellstr)
                domainName = Trim(cell.value)
                DomainID = NULL_LONG
                If InStr(1, StandardDomains, domainName, vbTextCompare) = 0 Then
                    DomainID = AttributeDomainId(domainName)
                End If
                
                valE = Trim(ws.Range(("E" & ctr)).value)
                If valE <> "" Then
                    If (DomainID <> NULL_LONG) Then
                        cellstr = "G" & ctr
                        Set cell = ws.Range(cellstr)
                        
                        LegalValID = LegalValueIDFromDomainID(valE, DomainID)
                        If LegalValID = NULL_LONG Then
                            cell.Font.Color = RGB(255, 0, 0)
                            Failure = True
                            cell.value = "Could not find value in domain"
                        End If
                    End If
                End If
                
                ' Check for existing rows: DONE
                sqlTmp = "select * from " & ATTRDEFVAL_TBLNAME & _
                        " where " & ATTRDEFVAL_TBLNAME & "." & ATTRDEFVAL_ATTRSETID & " = " & AttrSetID & _
                        " and " & ATTRDEFVAL_TBLNAME & "." & ATTRDEFVAL_FTRATTRID & " = " & AttrIdFromNameAndFtrTypeID(valC, FtrTypeID)
                If FtrTblName = "" Then
                    sqlTmp = sqlTmp & _
                            " and " & ATTRDEFVAL_TBLNAME & "." & ATTRDEFVAL_FTRTYPEID & " is null"
                Else
                    sqlTmp = sqlTmp & _
                            " and " & ATTRDEFVAL_TBLNAME & "." & ATTRDEFVAL_FTRTYPEID & " = " & FtrTypeID
                End If
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs.Fields.Item(ATTRDEFVAL_ID).value = ID
                    rs.Fields.Item(ATTRDEFVAL_ATTRSETID).value = AttrSetID
                    If FtrTblName <> "" Then rs.Fields.Item(ATTRDEFVAL_FTRTYPEID).value = FtrTypeID
                    If valC <> "" Then rs.Fields.Item(ATTRDEFVAL_FTRATTRID).value = AttrIdFromNameAndFtrTypeID(valC, FtrTypeID)
                    If valE <> "" Then rs.Fields.Item(ATTRDEFVAL_TEXTVAL).value = valE
                    If LegalValID <> NULL_LONG And LegalValID <> 0 Then rs.Fields.Item(ATTRDEFVAL_ATTRLEGALVALID).value = LegalValID
                    ID = ID + 1
                Else
                    'rsTmp.Fields.Item(ATTRDEFVAL_ID).Value = ID
                    'rsTmp.Fields.Item(ATTRDEFVAL_ATTRSETID).Value = AttrSetID
                    'If FtrTblName <> "" Then rsTmp.Fields.Item(ATTRDEFVAL_FTRTYPEID).Value = FtrTypeID
                    'If valC <> "" Then rsTmp.Fields.Item(ATTRDEFVAL_FTRATTRID).Value = AttrIdFromNameAndFtrTypeID(valC, FtrTypeID)
                    If valE <> "" Then rsTmp.Fields.Item(ATTRDEFVAL_TEXTVAL).value = valE
                    If LegalValID <> NULL_LONG And LegalValID <> 0 Then rsTmp.Fields.Item(ATTRDEFVAL_ATTRLEGALVALID).value = LegalValID
                    rsTmp.Update
        
                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing row"
                        Failure = True
                    End If
                End If
                rsTmp.Close
            
            Next iFtr
            
        End If ' EDProcess?:
                
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        SetName = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    ImgAttrDef.Visible = True
    
    If Failure Then
        LogSheetFailure "AttributeDefaultValues"
    End If
End Sub

Private Sub DeleteClassifications()
    Dim MySql$

         
    MySql = "Delete from " & CLASSTYPE_TBLNAME & _
            " where " & CLASSTYPE_PARENTID & " IS NOT NULL"
    
    Conn.Execute (MySql)
    
    MySql = "Delete from " & CLASSTYPE_TBLNAME
    
    Conn.Execute (MySql)
        

End Sub

Private Sub DeleteConfigurationSettings()
    Dim MySql$
    If IsSQLSERVER Then
        MySql = "Delete from " & CONFIGSETTING_TBLNAME
    Else
        MySql = "Delete from " & CONFIGSETTING_TBLNAME & " Cascade"
    End If
    Conn.Execute (MySql)
End Sub

Private Sub DeleteFtrCatalogConfigurationSettings()
    Dim MySql$
    Dim ParentID&
    Dim rs As ADODB.Recordset

    MySql = "Select * from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - ConfigurableFtrCatalog'"
            
    Set rs = Conn.Execute(MySql, , adCmdText)
    If Not (rs.BOF And rs.EOF) Then
        ParentID = rs(CONFIGSETTING_ID).value
        MySql = "Delete from " & CONFIGSETTING_TBLNAME & _
                " where " & CONFIGSETTING_PARENTID & " = " & ParentID
        Conn.Execute (MySql)
    End If
    
    MySql = "delete from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - ConfigurableFtrCatalog'"
    Conn.Execute (MySql)
        

End Sub
Private Sub DeleteCustomCostType()
    Dim MySql$

         
    MySql = "Delete from " & CUSTOMCOSTTYPE_TBLNAME & _
            " where " & CUSTOMCOSTTYPE_PARENTID & " IS NOT NULL"
    
    Conn.Execute (MySql)
    
    MySql = "Delete from " & CUSTOMCOSTTYPE_TBLNAME
    
    Conn.Execute (MySql)
        

End Sub
Private Sub LoadPlacementDefaultSettings()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum&, AttrSetID&
    Dim SetName$, FtrTblName$, OldSetName$
    Dim ctr%
    Dim FtrTypeID&, MyNumC&
    Dim valC$, valD$, valE$, valF$, valG$, valH$, valI$, valJ$, valK$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading Placement Default Settings"
    Me.Repaint
    Set ws = Worksheets("PlacementDefaultSettings")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PlacementDefaultSettings")
    logUpdates = GetLogUpdates("PlacementDefaultSettings")

    OldSetName = ""
    ctr = 2
    
    Set cell = ws.Range("B2")
    SetName = Trim(cell.value)
        
    rs.Open PLACEDEFSET_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While SetName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        FtrTblName = Trim(cell.value)
        If Trim(cell.value) <> "" Then
            If ds <> "" Then
                FtrTypeID = FeatureTypeID(FtrTblName, ds)
            Else
                FtrTypeID = FeatureTypeID(FtrTblName)
            End If
        Else
            FtrTypeID = 0
        End If
        
        If SetName <> OldSetName Then
            AttrSetID = AttributeSetId(SetName)
            OldSetName = SetName
        End If
        
        valC = Trim(ws.Range(("C" & ctr)).value)
        valD = Trim(ws.Range(("D" & ctr)).value)
        valE = Trim(ws.Range(("E" & ctr)).value)
        valF = Trim(ws.Range(("F" & ctr)).value)
        valG = Trim(ws.Range(("G" & ctr)).value)
        valH = Trim(ws.Range(("H" & ctr)).value)
        valI = Trim(ws.Range(("I" & ctr)).value)
        valJ = Trim(ws.Range(("J" & ctr)).value)
        valK = Trim(ws.Range(("K" & ctr)).value)
        
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & PLACEDEFSET_TBLNAME & _
                " where " & PLACEDEFSET_TBLNAME & "." & PLACEDEFSET_FTRTYPEID & " = " & FtrTypeID & _
                " and " & PLACEDEFSET_TBLNAME & "." & PLACEDEFSET_ATTRSETID & " = " & AttrSetID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(PLACEDEFSET_FTRTYPEID).value = FtrTypeID
            rs.Fields.Item(PLACEDEFSET_ATTRSETID).value = AttrSetID
            If valC <> "" Then rs.Fields.Item(PLACEDEFSET_OFFSETDIST).value = valC
            If valD <> "" Then rs.Fields.Item(PLACEDEFSET_OFFSETANGLE).value = valD
            If valE <> "" Then rs.Fields.Item(PLACEDEFSET_ANNOOFFSETDIST).value = valE
            If valF <> "" Then rs.Fields.Item(PLACEDEFSET_ANNOOFFSETANGLE).value = valF
            If valG <> "" Then rs.Fields.Item(PLACEDEFSET_ISAUTOANNO).value = BoolStringToInt(valG)
            If valH <> "" Then rs.Fields.Item(PLACEDEFSET_ISDOWNSTREAM).value = BoolStringToInt(valH)
            If valI <> "" Then rs.Fields.Item(PLACEDEFSET_ISSYSDEFGEOM).value = BoolStringToInt(valI)
            If valJ <> "" Then rs.Fields.Item(PLACEDEFSET_ISENABLEDBUSRULES).value = BoolStringToInt(valJ)
            If valK <> "" Then rs.Fields.Item(PLACEDEFSET_CONFLICTOFFSETDIST).value = valK
        Else
            'rsTmp.Fields.Item(PLACEDEFSET_FTRTYPEID).Value = FtrTypeID
            'rsTmp.Fields.Item(PLACEDEFSET_ATTRSETID).Value = AttrSetID
            If valC <> "" Then rsTmp.Fields.Item(PLACEDEFSET_OFFSETDIST).value = valC
            If valD <> "" Then rsTmp.Fields.Item(PLACEDEFSET_OFFSETANGLE).value = valD
            If valE <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ANNOOFFSETDIST).value = valE
            If valF <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ANNOOFFSETANGLE).value = valF
            If valG <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ISAUTOANNO).value = BoolStringToInt(valG)
            If valH <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ISDOWNSTREAM).value = BoolStringToInt(valH)
            If valI <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ISSYSDEFGEOM).value = BoolStringToInt(valI)
            If valJ <> "" Then rsTmp.Fields.Item(PLACEDEFSET_ISENABLEDBUSRULES).value = BoolStringToInt(valJ)
            If valK <> "" Then rsTmp.Fields.Item(PLACEDEFSET_CONFLICTOFFSETDIST).value = valK
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        SetName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PlacementDefaultSettings"
    End If
    ImgPlaceDef.Visible = True
End Sub
Private Sub LoadFeatureGeometry()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim geomName$
    Dim ctr%
    Dim ID&, GeometryType_ID&, PlacementType_ID&, FtrTypeID&, GeomCategory&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading feature geometries"
    Me.Repaint
    
    Set ws = Worksheets("FeatureGeometry")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureGeometry")
    logUpdates = GetLogUpdates("FeatureGeometry")

    ctr = 2
    
    Set cell = ws.Range("B2")
    geomName = Trim(cell.value)

    rs.Open FTRGEOM_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FTRGEOM_TBLNAME, FTRGEOM_ID)
    Do While geomName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            If ds <> "" Then
                FtrTypeID = FeatureTypeID(Trim(cell.value), ds)
            Else
                FtrTypeID = FeatureTypeID(Trim(cell.value))
            End If
        Else
            FtrTypeID = NULL_LONG
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MyStr = Trim(cell.value)
            GeometryType_ID = GeomTypeId(MyStr)
        Else
            GeometryType_ID = NULL_LONG
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MyStr = Trim(cell.value)
            PlacementType_ID = ValidatePlacementType(GeometryType_ID, PlacementTypeId(MyStr))
        Else
            PlacementType_ID = NULL_LONG
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MyStr = Trim(cell.value)
            GeomCategory = GeomCategoryValue(MyStr)
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        If FtrTypeID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the Feature Type"
        ElseIf GeometryType_ID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the Geometry Type"
        ElseIf PlacementType_ID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the Placement Type"
        Else
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FTRGEOM_TBLNAME & _
                    " where " & FTRGEOM_TBLNAME & "." & FTRGEOM_FTRTYPEID & " = " & FtrTypeID & _
                    " and " & FTRGEOM_TBLNAME & "." & FTRGEOM_NAME & " = '" & geomName & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FTRGEOM_ID).value = ID
                rs.Fields.Item(FTRGEOM_FTRTYPEID).value = FtrTypeID
                rs.Fields.Item(FTRGEOM_NAME).value = geomName
                rs.Fields.Item(FTRGEOM_GEOMTYPE).value = GeometryType_ID
                rs.Fields.Item(FTRGEOM_PLACEMENTTYPE).value = PlacementType_ID
                rs.Fields.Item(FTRGEOM_GEOMCATEGORY).value = GeomCategory
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(FTRGEOM_ID).Value = ID
                'rsTmp.Fields.Item(FTRGEOM_FTRTYPEID).Value = FtrTypeID
                'rsTmp.Fields.Item(FTRGEOM_NAME).Value = geomName
                rsTmp.Fields.Item(FTRGEOM_GEOMTYPE).value = GeometryType_ID
                rsTmp.Fields.Item(FTRGEOM_PLACEMENTTYPE).value = PlacementType_ID
                rsTmp.Fields.Item(FTRGEOM_GEOMCATEGORY).value = GeomCategory
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        End If
        
        ctr = ctr + 1
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        geomName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FeatureGeometry"
    End If
    ImgFtrGeom.Visible = True
End Sub
Private Sub LoadCompoundFeature()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim parentName$, childName$, ChildTableName$, ValidChars$, LastChildName$
    Dim ctr%, IsPost%, DeriveType%, GISAutoCreate%, GISEditTrigger%
    Dim badDeriveFrom%, badDeriveTo%, badFixed%
    Dim ID&, ParentIDFtrAttrID&, ParentID&, ChildID&, DerivedFtrAttrID&, DeriveToFtrAttrID&
    Dim FixedChildren&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading compound features"
    Me.Repaint
    Set ws = Worksheets("CompoundFeatures")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CompoundFeatures")
    logUpdates = GetLogUpdates("CompoundFeatures")
    
    ctr = 2
    LastChildName = ""
    
    Set cell = ws.Range("A2")
    parentName = Trim(cell.value)
        
    rs.Open COMPOUNDFTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(COMPOUNDFTR_TBLNAME, COMPOUNDFTR_ID)
    Do While parentName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        badDeriveFrom = False
        badDeriveTo = False
        badFixed = False
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            If ds <> "" Then
                ParentID = FeatureTypeID(parentName, ds)
            Else
                ParentID = FeatureTypeID(parentName)
            End If
        Else
            ParentID = NULL_LONG
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        childName = Trim(cell.value)
        If childName <> "" Then
            If childName <> LastChildName Then
                If ds <> "" Then
                    ChildID = FeatureTypeID(childName, ds)
                Else
                    ChildID = FeatureTypeID(childName)
                End If
                ChildTableName = FeatureTypeGISTableName(ChildID)
                LastChildName = childName
            End If
        Else
            ChildID = NULL_LONG
            LastChildName = ""
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        IsPost = BoolStringToInt(Trim(cell.value))

        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If (IsPost = False) Then
                ParentIDFtrAttrID = AttrIdFromInternalNameAndFtrTypeID(MyStr, ParentID)
            Else
                ParentIDFtrAttrID = AttrIdFromInternalNameAndFtrTypeID(MyStr, ChildID)
            End If
        Else
            ParentIDFtrAttrID = NULL_LONG
        End If
       
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            If UCase(Trim(cell.value)) = "STRING" Then
                DeriveType = 0
            ElseIf UCase(Trim(cell.value)) = "TEXT" Then
                DeriveType = 0
            ElseIf UCase(Trim(cell.value)) = "INTEGER" Then
                DeriveType = 1
            ElseIf UCase(Trim(cell.value)) = "NUMBER" Then
                DeriveType = 1
            ElseIf UCase(Trim(cell.value)) = "NUMERIC" Then
                DeriveType = 1
            ElseIf UCase(Trim(cell.value)) = "FIXED" Then
                DeriveType = 2
            Else
                DeriveType = 16
            End If
        End If
         
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            DerivedFtrAttrID = AttrIdFromInternalNameAndFtrTypeID(Trim(cell.value), ParentID)
        Else
            DerivedFtrAttrID = NULL_LONG
        End If
        If DeriveType = 0 Or DeriveType = 1 Then
            'Derive types of string and integer must have a Derive From field
            If DerivedFtrAttrID = NULL_LONG Then badDeriveFrom = True
        End If
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            DeriveToFtrAttrID = AttrIdFromInternalNameAndFtrTypeID(Trim(cell.value), ChildID)
        Else
            DeriveToFtrAttrID = NULL_LONG
        End If
        If DeriveType = 0 Then
            'Derive type of string must have a Derive To field
            If DeriveToFtrAttrID = NULL_LONG Then badDeriveTo = True
        End If
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        GISAutoCreate = BoolStringToInt(Trim(cell.value))

        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ValidChars = Trim(cell.value)
        End If
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" And IsNumeric(Trim(cell.value)) Then
            FixedChildren = Trim(cell.value)
        Else
            FixedChildren = NULL_LONG
        End If
        If DeriveType = 2 Then
            'Derive type of Fixed must have a number of children set
            If FixedChildren = NULL_LONG Then badFixed = True
        End If
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            GISEditTrigger = BoolStringToInt(Trim(cell.value))
        Else
            GISEditTrigger = False
        End If
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        If ParentID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the parent feature"
        ElseIf ChildID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the child feature"
        ElseIf ParentIDFtrAttrID = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the parent field"
        ElseIf badDeriveFrom Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the Derive From field"
        ElseIf badDeriveTo Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find the Derive To field"
        ElseIf badFixed Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "The Fixed number of children must be numeric"
        Else
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & COMPOUNDFTR_TBLNAME & _
                    " where " & COMPOUNDFTR_TBLNAME & "." & COMPOUNDFTR_PARENTID & " = " & ParentID & _
                    " and " & COMPOUNDFTR_TBLNAME & "." & COMPOUNDFTR_CHILDID & " = " & ChildID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(COMPOUNDFTR_ID).value = ID
                rs.Fields.Item(COMPOUNDFTR_PARENTID).value = ParentID
                rs.Fields.Item(COMPOUNDFTR_CHILDID).value = ChildID
                If ChildTableName <> "" Then rs.Fields.Item(COMPOUNDFTR_CHILDTBLNAME).value = ChildTableName
                rs.Fields.Item(COMPOUNDFTR_ISPOST).value = IsPost
                If ParentIDFtrAttrID <> NULL_LONG Then rs.Fields.Item(COMPOUNDFTR_PARENTIDFTRATTRID).value = ParentIDFtrAttrID
                rs.Fields.Item(COMPOUNDFTR_DERIVEDTYPE).value = DeriveType
                If DerivedFtrAttrID <> NULL_LONG Then rs.Fields.Item(COMPOUNDFTR_DERIVEDFROMFTRATTRID).value = DerivedFtrAttrID
                If DeriveToFtrAttrID <> NULL_LONG Then rs.Fields.Item(COMPOUNDFTR_DERIVEDTOFTRATTRID).value = DeriveToFtrAttrID
                rs.Fields.Item(COMPOUNDFTR_ISGISAUTOCREATE).value = GISAutoCreate
                If ValidChars <> "" Then rs.Fields.Item(COMPOUNDFTR_VALIDCHARS).value = ValidChars
                If FixedChildren <> NULL_LONG Then rs.Fields.Item(COMPOUNDFTR_FIXEDCHILDREN).value = FixedChildren
                rs.Fields.Item(COMPOUNDFTR_ISGISEDITTRIGGER).value = GISEditTrigger
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(COMPOUNDFTR_ID).Value = ID
                'rsTmp.Fields.Item(COMPOUNDFTR_PARENTID).Value = ParentID
                'rsTmp.Fields.Item(COMPOUNDFTR_CHILDID).Value = ChildID
                If ChildTableName <> "" Then rsTmp.Fields.Item(COMPOUNDFTR_CHILDTBLNAME).value = ChildTableName
                rsTmp.Fields.Item(COMPOUNDFTR_ISPOST).value = IsPost
                If ParentIDFtrAttrID <> NULL_LONG Then rsTmp.Fields.Item(COMPOUNDFTR_PARENTIDFTRATTRID).value = ParentIDFtrAttrID
                rsTmp.Fields.Item(COMPOUNDFTR_DERIVEDTYPE).value = DeriveType
                If DerivedFtrAttrID <> NULL_LONG Then rsTmp.Fields.Item(COMPOUNDFTR_DERIVEDFROMFTRATTRID).value = DerivedFtrAttrID
                If DeriveToFtrAttrID <> NULL_LONG Then rsTmp.Fields.Item(COMPOUNDFTR_DERIVEDTOFTRATTRID).value = DeriveToFtrAttrID
                rsTmp.Fields.Item(COMPOUNDFTR_ISGISAUTOCREATE).value = GISAutoCreate
                If ValidChars <> "" Then rsTmp.Fields.Item(COMPOUNDFTR_VALIDCHARS).value = ValidChars
                If FixedChildren <> NULL_LONG Then rsTmp.Fields.Item(COMPOUNDFTR_FIXEDCHILDREN).value = FixedChildren
                rsTmp.Fields.Item(COMPOUNDFTR_ISGISEDITTRIGGER).value = GISEditTrigger
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        parentName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CompoundFeatures"
    End If
    ImgCompFtr.Visible = True
End Sub

Private Sub LoadComponentTypes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim CompName$, LastFtr$
    Dim ID&, FtrTypeID&
    Dim ctr%
    Dim valA$, valB$, valC$, valD$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading component types"
    Me.Repaint
    Set ws = Worksheets("ComponentTypes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ComponentTypes")
    logUpdates = GetLogUpdates("ComponentTypes")
    
    On Error GoTo LCT_Error
    
    ctr = 2
    LastFtr = ""
    
    Set cell = ws.Range("B2")
    CompName = Trim(cell.value)
        
    rs.Open COMPTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    ID = NextPK(COMPTYPE_TBLNAME, COMPTYPE_ID)
    
    Do While CompName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ds = Trim(ws.Range(("E" & ctr)).value)
        
        valA = Trim(ws.Range(("A" & ctr)).value)
        If valA <> "" Then
            If valA <> LastFtr Then
                If ds <> "" Then
                    FtrTypeID = FeatureTypeID(valA, ds)
                Else
                    FtrTypeID = FeatureTypeID(valA)
                End If
                LastFtr = valA
            End If
        End If
        valB = Trim(ws.Range(("B" & ctr)).value)
        valC = Trim(ws.Range(("C" & ctr)).value)
        valD = Trim(ws.Range(("D" & ctr)).value)
            
            
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & COMPTYPE_TBLNAME & _
                " where " & COMPTYPE_TBLNAME & "." & COMPTYPE_NAME & " = '" & valB & "'" & _
                " and " & COMPTYPE_TBLNAME & "." & COMPTYPE_FTRTYPEID & " = " & FtrTypeID & _
                " and " & COMPTYPE_TBLNAME & "." & COMPTYPE_COMPTYPE$ & " = " & ComponentTypeTypeId(valD)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(COMPTYPE_ID).value = ID
            If valA <> "" Then rs.Fields.Item(COMPTYPE_FTRTYPEID).value = FtrTypeID
            If valB <> "" Then rs.Fields.Item(COMPTYPE_NAME).value = valB
            If valC <> "" Then rs.Fields.Item(COMPTYPE_RQDCONNS).value = valC
            If valD <> "" Then rs.Fields.Item(COMPTYPE_COMPTYPE$).value = ComponentTypeTypeId(valD)
            rs.Fields.Item(COMPTYPE_ISDEVICE).value = 0
            rs.Fields.Item(COMPTYPE_PORTCOUNT).value = 2
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(COMPTYPE_ID).Value = ID
            'If valA <> "" Then rsTmp.Fields.Item(COMPTYPE_FTRTYPEID).Value = FtrTypeID
            'If valB <> "" Then rsTmp.Fields.Item(COMPTYPE_NAME).Value = valB
            If valC <> "" Then rsTmp.Fields.Item(COMPTYPE_RQDCONNS).value = valC
            'If valD <> "" Then rsTmp.Fields.Item(COMPTYPE_COMPTYPE$).Value = ComponentTypeTypeId(valD)
            rsTmp.Fields.Item(COMPTYPE_ISDEVICE).value = 0
            rsTmp.Fields.Item(COMPTYPE_PORTCOUNT).value = 2
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CompName = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ComponentTypes"
    End If
    ImgCompTypes.Visible = True
    Exit Sub
LCT_Error:
    Debug.Print Err.Description
    If Not rs Is Nothing Then
        If rs.State = adStateOpen Then rs.Close
        Set rs = Nothing
    End If
End Sub

Private Sub LoadAllowedConnection()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim RuleID&, FtrTypeID&, ComponentType&, CompTypeID&, LastComponentType&
    Dim ComponentTypeName$, RuleName$, ViolationString$, value$, LastFtr$
    Dim ID&, RulesetNum&, LastRuleset&, RuleSetID&
    Dim ctr%, FtrChanged%
    Dim valC$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Dim ConnFtrTypeID&
    Dim iRuleEnabled As Integer
    
    Failure = False
        
    Label2.Caption = "Loading allowed connections"
    Me.Repaint
    Set ws = Worksheets("AllowedConnections")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AllowedConnections")
    logUpdates = GetLogUpdates("AllowedConnections")
    
    ctr = 2
    LastFtr = ""
    FtrChanged = True
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open ALLOWEDCONN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    ID = NextPK(ALLOWEDCONN_TBLNAME, ALLOWEDCONN_ID)
    LastRuleset = 0
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        RuleName = Trim(cell.value)
    
        '----- Rule Enabled ----------------------------
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        iRuleEnabled = BoolStringToInt(Trim(cell.value))
        '----- Rule Enabled ----------------------------
        
        'cellstr = "G" & ctr
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> LastFtr Then
            If ds <> "" Then
                FtrTypeID = FeatureTypeID(MyStr, ds)
            Else
                FtrTypeID = FeatureTypeID(MyStr)
            End If
            LastFtr = MyStr
            FtrChanged = True
        Else
            FtrChanged = False
        End If
            
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        ComponentType = ComponentTypeTypeId(Trim(cell.value))
        If FtrChanged Or (LastComponentType <> ComponentType) Then
            CompTypeID = ComponentTypeId(FtrTypeID, ComponentType)
            LastComponentType = ComponentType
        End If
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        ViolationString = Trim(cell.value)
            
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RulesetNum = Trim(cell.value)
        If RulesetNum <> LastRuleset Then
            RuleSetID = CreateRuleset(CompTypeID, ViolationString, True, 0)
            LastRuleset = RulesetNum
        End If
        
        'RuleID = CreateRule(RuleSetID, 0, RuleName, True, False)
        RuleID = CreateRule(RuleSetID, 0, RuleName, iRuleEnabled, False)
        
        valC = Trim(ws.Range(("C" & ctr)).value)
        If ds <> "" Then
            ConnFtrTypeID = FeatureTypeID(valC, ds)
        Else
            ConnFtrTypeID = FeatureTypeID(valC)
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ALLOWEDCONN_TBLNAME & _
                " where " & ALLOWEDCONN_TBLNAME & "." & ALLOWEDCONN_RULEID & " = " & RuleID & _
                " and " & ALLOWEDCONN_TBLNAME & "." & ALLOWEDCONN_ONPORT & " = " & "0" & _
                " and " & ALLOWEDCONN_TBLNAME & "." & ALLOWEDCONN_CONNECTTO & " = " & FeatureTypeID(valC)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(ALLOWEDCONN_ID) = ID
            rs(ALLOWEDCONN_RULEID) = RuleID
            rs(ALLOWEDCONN_ONPORT) = 0
            If valC <> "" Then rs(ALLOWEDCONN_CONNECTTO) = ConnFtrTypeID
            ID = ID + 1
        Else
            'rsTmp(ALLOWEDCONN_ID) = ID
            'rsTmp(ALLOWEDCONN_RULEID) = RuleID
            'rsTmp(ALLOWEDCONN_ONPORT) = 0
            'If valC <> "" Then rsTmp(ALLOWEDCONN_CONNECTTO) = ConnFtrTypeID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AllowedConnections"
    End If
    ImgAllowConn.Visible = True
End Sub


Private Function GetConfigurationValue(ws As Worksheet, Name As String, ByRef row As Integer) As String
    Dim ctr As Integer
    Dim process As Boolean
    Dim valA As String
    Dim valB As String
    
    GetConfigurationValue = ""
    row = -1
    ctr = 2
    valA = UCase(Trim(ws.Range(("A" & ctr)).value))
    Do While (valA <> "")
        ' Check to see if we should process this row:
        process = False
        If IsSQLSERVER Then
            If valA = "ALL" Or valA = "SQLSERVER" Then
                process = True
            End If
        Else
            If valA = "ALL" Or valA = "ORACLE" Then
                process = True
            End If
        End If
        
        If process Then
            valB = UCase(Trim(ws.Range(("B" & ctr)).value))
            If valB = UCase(Name) Then
                GetConfigurationValue = Trim(ws.Range(("C" & ctr)).value)
                row = ctr
                Exit Do
            End If
        End If
        ctr = ctr + 1
        valA = UCase(Trim(ws.Range(("A" & ctr)).value))
    Loop
End Function


Private Sub UpdateConfiguration(ws As Worksheet, Name As String, ByRef rs As Recordset, col As String, _
                                ErrorCol As String, ByRef showUpdates As Boolean, ByRef Failure As Boolean)
    Dim tmpStr As String
    Dim tmpStr2 As String
    Dim row As Integer
    
    Dim curDS As String
    Dim containsDataset As Boolean
    Dim Sep As String
    Dim WorkLine As String
    Dim pos As Integer
    Dim NextPos As Integer
    Dim tempVal As String
    
    tmpStr = GetConfigurationValue(ws, Name, row)
    If tmpStr <> "" Then
        If showUpdates Then
            tmpStr2 = rs(col)
            If (tmpStr <> tmpStr2) Then
                If CONFIGURATION_LINEARALLOWANCE = col Then
                    rs(col) = CDbl(tmpStr)
                ElseIf CONFIGURATION_GISDATASETS = col Then
                
                    ' Check if this DS value is in or db value: electric:gas:water
                    tmpStr2 = rs(col)
                    If tmpStr2 <> "" Then
                        curDS = tmpStr
                        containsDataset = False
                        Sep = ":"
                        WorkLine = tmpStr
                        pos = 1
                        NextPos = InStr(pos, WorkLine, Sep)
                        While NextPos >= 1
                            tempVal = Mid(WorkLine, pos, NextPos - pos)
                            If tempVal = curDS Then
                                containsDataset = True
                            End If
                            WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                            pos = 1
                            NextPos = InStr(pos, WorkLine, Sep)
                        Wend
                        If Len(WorkLine) > 0 Then
                            If WorkLine = curDS Then
                                containsDataset = True
                            End If
                        End If
                        If Not containsDataset Then
                            rs(col) = rs(col) & ":" & curDS
                        End If
                    Else
                        rs(col) = tmpStr
                    End If
                    
                Else
                    rs(col) = tmpStr
                End If
                If row <> -1 Then
                    ws.Range((ErrorCol & row)).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & row)).value = "Updated existing row"
                End If
                Failure = True
            End If
        Else
            If CONFIGURATION_LINEARALLOWANCE = col Then
                rs(col) = CDbl(tmpStr)
            ElseIf CONFIGURATION_GISDATASETS = col Then
            
                ' Check if this DS value is in or db value: electric:gas:water
                tmpStr2 = rs(col)
                If tmpStr2 <> "" Then
                    curDS = tmpStr
                    containsDataset = False
                    Sep = ":"
                    WorkLine = tmpStr
                    pos = 1
                    NextPos = InStr(pos, WorkLine, Sep)
                    While NextPos >= 1
                        tempVal = Mid(WorkLine, pos, NextPos - pos)
                        If tempVal = curDS Then
                            containsDataset = True
                        End If
                        WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                        pos = 1
                        NextPos = InStr(pos, WorkLine, Sep)
                    Wend
                    If Len(WorkLine) > 0 Then
                        If WorkLine = curDS Then
                            containsDataset = True
                        End If
                    End If
                    If Not containsDataset Then
                        rs(col) = rs(col) & ":" & curDS
                    End If
                Else
                    rs(col) = tmpStr
                End If
            
            Else
                rs(col) = tmpStr
            End If
        End If
    End If
    
End Sub

Private Sub LoadConfiguration()


    Dim tmpStr As String
    Dim tmpStr2 As String
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ctr%
    Dim changes As Boolean
    Dim process As Boolean
    Dim colA As String
    Dim colB As String
    Dim colC As String
    Dim row As Integer
    Failure = False
        
    Label2.Caption = "Loading configuration"
    Me.Repaint
    Set ws = Worksheets("Configuration")
    
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Configuration")
    logUpdates = GetLogUpdates("Configuration")
        
    rs.Open CONFIGURATION_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    ' Clear previous errors:
    ctr = 2
    tmpStr = Trim(ws.Range(("A" & ctr)).value)
    Do While tmpStr <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        ctr = ctr + 1
        tmpStr = Trim(ws.Range(("A" & ctr)).value)
    Loop

    
    ' Check for existing rows: DONE
    sqlTmp = "select * from " & CONFIGURATION_TBLNAME
    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
    If rsTmp.BOF And rsTmp.EOF Then
    
        ' check to see if we have any changes:
        changes = False
        ctr = 2
        colA = UCase(Trim(ws.Range(("A" & ctr)).value))
        Do While colA <> ""
            ' Check to see if we should process this row:
            process = False
            If IsSQLSERVER Then
                If colA = "ALL" Or colA = "SQLSERVER" Then
                    process = True
                End If
            Else
                If colA = "ALL" Or colA = "ORACLE" Then
                    process = True
                End If
            End If
            
            If process Then
                colC = Trim(ws.Range(("C" & ctr)).value)
                If colA <> "" Then
                    changes = True
                    Exit Do
                End If
            End If
            ctr = ctr + 1
            colA = UCase(Trim(ws.Range(("A" & ctr)).value))
        Loop
        
        If changes Then
            rs.AddNew
            rs(CONFIGURATION_ID) = NextPK(CONFIGURATION_TBLNAME, CONFIGURATION_ID)
            UpdateConfiguration ws, "CONVERSION FACTOR", rs, CONFIGURATION_CONVERSIONFACTOR, ErrorCol, False, Failure
            UpdateConfiguration ws, "GIS DATASET", rs, CONFIGURATION_GISDATASETS, ErrorCol, False, Failure
            UpdateConfiguration ws, "TOLERANCE", rs, CONFIGURATION_TOLERANCE, ErrorCol, False, Failure
            UpdateConfiguration ws, "BASE WORKSPACE NAME", rs, CONFIGURATION_BASEWKSPACENAME, ErrorCol, False, Failure
            UpdateConfiguration ws, "RADIUS", rs, CONFIGURATION_RADIUS, ErrorCol, False, Failure
            UpdateConfiguration ws, "PUBLIC REPORT PATH", rs, CONFIGURATION_PUBLICREPORTPATH, ErrorCol, False, Failure
            UpdateConfiguration ws, "SYSTEM ADMIN EMAIL ADDRESS", rs, CONFIGURATION_SYSEMAILADDRESS, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES FROM", rs, CONFIGURATION_WPTFAVTEMPLATEFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES WHERE", rs, CONFIGURATION_WPTFAVTEMPLATEWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS FROM", rs, CONFIGURATION_WPTINPROGDESIGNSFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS WHERE", rs, CONFIGURATION_WPTINPROGDESIGNSWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK FROM", rs, CONFIGURATION_WPTPASTDUEWORKFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK WHERE", rs, CONFIGURATION_WPTPASTDUEWORKWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK FROM", rs, CONFIGURATION_WPTPENDINGWORKFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK WHERE", rs, CONFIGURATION_WPTPENDINGWORKWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "LINEAR ALLOWANCE", rs, CONFIGURATION_LINEARALLOWANCE, ErrorCol, False, Failure
        End If
    Else
        If logUpdates = "1" Then
            UpdateConfiguration ws, "CONVERSION FACTOR", rsTmp, CONFIGURATION_CONVERSIONFACTOR, ErrorCol, True, Failure
            UpdateConfiguration ws, "GIS DATASET", rsTmp, CONFIGURATION_GISDATASETS, ErrorCol, True, Failure
            UpdateConfiguration ws, "TOLERANCE", rsTmp, CONFIGURATION_TOLERANCE, ErrorCol, True, Failure
            UpdateConfiguration ws, "BASE WORKSPACE NAME", rsTmp, CONFIGURATION_BASEWKSPACENAME, ErrorCol, True, Failure
            UpdateConfiguration ws, "RADIUS", rsTmp, CONFIGURATION_RADIUS, ErrorCol, True, Failure
            UpdateConfiguration ws, "PUBLIC REPORT PATH", rsTmp, CONFIGURATION_PUBLICREPORTPATH, ErrorCol, True, Failure
            UpdateConfiguration ws, "SYSTEM ADMIN EMAIL ADDRESS", rsTmp, CONFIGURATION_SYSEMAILADDRESS, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES FROM", rsTmp, CONFIGURATION_WPTFAVTEMPLATEFROM, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES WHERE", rsTmp, CONFIGURATION_WPTFAVTEMPLATEWHERE, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS FROM", rsTmp, CONFIGURATION_WPTINPROGDESIGNSFROM, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS WHERE", rsTmp, CONFIGURATION_WPTINPROGDESIGNSWHERE, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK FROM", rsTmp, CONFIGURATION_WPTPASTDUEWORKFROM, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK WHERE", rsTmp, CONFIGURATION_WPTPASTDUEWORKWHERE, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK FROM", rsTmp, CONFIGURATION_WPTPENDINGWORKFROM, ErrorCol, True, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK WHERE", rsTmp, CONFIGURATION_WPTPENDINGWORKWHERE, ErrorCol, True, Failure
            UpdateConfiguration ws, "LINEAR ALLOWANCE", rsTmp, CONFIGURATION_LINEARALLOWANCE, ErrorCol, True, Failure
            rsTmp.Update
        Else
            UpdateConfiguration ws, "CONVERSION FACTOR", rsTmp, CONFIGURATION_CONVERSIONFACTOR, ErrorCol, False, Failure
            UpdateConfiguration ws, "GIS DATASET", rsTmp, CONFIGURATION_GISDATASETS, ErrorCol, False, Failure
            UpdateConfiguration ws, "TOLERANCE", rsTmp, CONFIGURATION_TOLERANCE, ErrorCol, False, Failure
            UpdateConfiguration ws, "BASE WORKSPACE NAME", rsTmp, CONFIGURATION_BASEWKSPACENAME, ErrorCol, False, Failure
            UpdateConfiguration ws, "RADIUS", rsTmp, CONFIGURATION_RADIUS, ErrorCol, False, Failure
            UpdateConfiguration ws, "PUBLIC REPORT PATH", rsTmp, CONFIGURATION_PUBLICREPORTPATH, ErrorCol, False, Failure
            UpdateConfiguration ws, "SYSTEM ADMIN EMAIL ADDRESS", rsTmp, CONFIGURATION_SYSEMAILADDRESS, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES FROM", rsTmp, CONFIGURATION_WPTFAVTEMPLATEFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY FAVORITE TEMPLATES WHERE", rsTmp, CONFIGURATION_WPTFAVTEMPLATEWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS FROM", rsTmp, CONFIGURATION_WPTINPROGDESIGNSFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY IN PROGRESS DESIGNS WHERE", rsTmp, CONFIGURATION_WPTINPROGDESIGNSWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK FROM", rsTmp, CONFIGURATION_WPTPASTDUEWORKFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PAST DUE WORK WHERE", rsTmp, CONFIGURATION_WPTPASTDUEWORKWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK FROM", rsTmp, CONFIGURATION_WPTPENDINGWORKFROM, ErrorCol, False, Failure
            UpdateConfiguration ws, "WPTODAY PENDING WORK WHERE", rsTmp, CONFIGURATION_WPTPENDINGWORKWHERE, ErrorCol, False, Failure
            UpdateConfiguration ws, "LINEAR ALLOWANCE", rsTmp, CONFIGURATION_LINEARALLOWANCE, ErrorCol, False, Failure
            rsTmp.Update
        End If
    End If
    rsTmp.Close

    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    If Failure Then
        LogSheetFailure "Configuration"
    End If
    'ImgConfig.Visible = True
End Sub

Private Sub LoadFixedViolations()

    Dim rs As New Recordset
   
    If Not IncrementalLoad Then
        rs.Open VIOLATION_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
        rs.AddNew
        rs(VIOLATION_ID) = 1
        rs(VIOLATION_MESSAGE) = "Point/Span Mismatch"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 2
        rs(VIOLATION_MESSAGE) = "Cannot be placed on Path"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 3
        rs(VIOLATION_MESSAGE) = "Structure Already at Location"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 4
        rs(VIOLATION_MESSAGE) = "Cannot Place at Mid-Span Tap"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 5
        rs(VIOLATION_MESSAGE) = "Cannot Place Device"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 6
        rs(VIOLATION_MESSAGE) = "Cannot be placed using current GIS trail"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 7
        rs(VIOLATION_MESSAGE) = "The GIS trail points are not at this Work Location"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 8
        rs(VIOLATION_MESSAGE) = "The GIS trail points cannot be used to truncate"
        rs.Update
        rs.AddNew
        rs(VIOLATION_ID) = 9
        rs(VIOLATION_MESSAGE) = "The second GIS trail point does not lie between two spans"
        rs.Update
        rs.Close
    End If
End Sub

Private Sub LoadTreeTrimming()

    LoadVegSpeciesGrowthType
    LoadVegSpecies
    LoadVegClassification
    LoadVegSize
    LoadVegBenchmark
    LoadActionDetail
    LoadCrew

    ImgTreeTrim.Visible = True
    
End Sub

Private Sub DeleteTreeTrimming()
    Dim MySql As String
    Dim rs As Recordset
    Dim OldCaption$
    
    OldCaption = Label2.Caption
    Label2.Caption = "Deleting TreeTrimming"
    Me.Repaint
    
    MySql = "Delete from " & VEGSPECIES_TABLENAME
    Set rs = Conn.Execute(MySql)
    
    MySql = "Delete from " & ACTIONDETAIL_TABLENAME
    Set rs = Conn.Execute(MySql)
    
    MySql = "Delete from " & VEGSPECIESGROWTHTYPE_TABLENAME
    Set rs = Conn.Execute(MySql)
 
    MySql = "Delete from " & VEGCLASSIFICATION_TABLENAME
    Set rs = Conn.Execute(MySql)
    
    MySql = "Delete from " & VEGSIZE_TABLENAME
    Set rs = Conn.Execute(MySql)
    
    MySql = "Delete from " & VEGBENCHMARK_TABLENAME
    Set rs = Conn.Execute(MySql)
    
    MySql = "Delete from " & CREW_TABLENAME
    Set rs = Conn.Execute(MySql)
       
    Label2.Caption = OldCaption
    Me.Repaint
End Sub

Private Sub LoadVegSpeciesGrowthType()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$
    Dim ID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading VegSpeciesGrowthType"
    Me.Repaint
    Set ws = Worksheets("VegSpeciesGrowthType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VegSpeciesGrowthType")
    logUpdates = GetLogUpdates("VegSpeciesGrowthType")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    rs.Open VEGSPECIESGROWTHTYPE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(VEGSPECIESGROWTHTYPE_TABLENAME, VEGSPECIESGROWTHTYPE_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VEGSPECIESGROWTHTYPE_TABLENAME & _
                " where " & VEGSPECIESGROWTHTYPE_TABLENAME & "." & VEGSPECIESGROWTHTYPE_NAME & " = '" & valA & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(VEGSPECIESGROWTHTYPE_ID).value = ID
            rs.Fields.Item(VEGSPECIESGROWTHTYPE_NAME).value = valA
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(VEGSPECIESGROWTHTYPE_ID).Value = ID
            'rsTmp.Fields.Item(VEGSPECIESGROWTHTYPE_NAME).Value = valA
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VegSpeciesGrowthType"
    End If
End Sub

Private Sub LoadVegSpecies()
    Dim rs As New Recordset
    Dim rsB As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, MySql$
    Dim ID$, growthtype$, growthtypeID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading VegSpecies"
    Me.Repaint
    Set ws = Worksheets("VegSpecies")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VegSpecies")
    logUpdates = GetLogUpdates("VegSpecies")
    
    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    rs.Open VEGSPECIES_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(VEGSPECIES_TABLENAME, VEGSPECIES_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            growthtype = Trim(cell.value)
        End If
        
        MySql = "Select " & VEGSPECIESGROWTHTYPE_ID & " from " & VEGSPECIESGROWTHTYPE_TABLENAME & " where " & VEGSPECIES_NAME & " = '" & growthtype & "'"
        Set rsB = Conn.Execute(MySql)
        If Not rsB.BOF And Not rsB.EOF Then
            growthtypeID = rsB(VEGSPECIESGROWTHTYPE_ID)
        Else
            growthtypeID = -1
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VEGSPECIES_TABLENAME & _
                " where " & VEGSPECIES_TABLENAME & "." & VEGSPECIES_NAME & " = '" & valA & "'" & _
                " and " & VEGSPECIES_TABLENAME & "." & VEGSPECIES_GROWTHTYPEID & " = " & growthtypeID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(VEGSPECIES_ID).value = ID
            If valA <> "" Then rs.Fields.Item(VEGSPECIES_NAME).value = valA
            If growthtypeID <> -1 Then rs.Fields.Item(VEGSPECIES_GROWTHTYPEID).value = growthtypeID
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(VEGSPECIES_ID).Value = ID
            'If valA <> "" Then rsTmp.Fields.Item(VEGSPECIES_NAME).Value = valA
            'If growthtypeID <> -1 Then rsTmp.Fields.Item(VEGSPECIES_GROWTHTYPEID).Value = growthtypeID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VegSpecies"
    End If
End Sub

Private Sub LoadVegClassification()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$
    Dim ID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading VegClassification"
    Me.Repaint
    Set ws = Worksheets("VegClassification")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VegClassification")
    logUpdates = GetLogUpdates("VegClassification")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    
    rs.Open VEGCLASSIFICATION_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(VEGCLASSIFICATION_TABLENAME, VEGCLASSIFICATION_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VEGCLASSIFICATION_TABLENAME & _
                " where " & VEGCLASSIFICATION_TABLENAME & "." & VEGCLASSIFICATION_NAME & " = '" & valA & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(VEGCLASSIFICATION_ID).value = ID
            rs.Fields.Item(VEGCLASSIFICATION_NAME).value = valA
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(VEGCLASSIFICATION_ID).Value = ID
            'rsTmp.Fields.Item(VEGCLASSIFICATION_NAME).Value = valA
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VegClassification"
    End If
End Sub

Private Sub LoadVegSize()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$
    Dim ID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading VegSize"
    Me.Repaint
    Set ws = Worksheets("VegSize")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VegSize")
    logUpdates = GetLogUpdates("VegSize")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    rs.Open VEGSIZE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(VEGSIZE_TABLENAME, VEGSIZE_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VEGSIZE_TABLENAME & _
                " where " & VEGSIZE_TABLENAME & "." & VEGSIZE_VEGSIZE & " = '" & valA & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(VEGSIZE_ID).value = ID
            rs.Fields.Item(VEGSIZE_VEGSIZE).value = valA
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(VEGSIZE_ID).Value = ID
            'rsTmp.Fields.Item(VEGSIZE_VEGSIZE).Value = valA
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VegSize"
    End If
End Sub
Private Sub LoadVegBenchmark()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$
    Dim ID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading VegBenchmark"
    Me.Repaint
    Set ws = Worksheets("VegBenchmark")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VegBenchmark")
    logUpdates = GetLogUpdates("VegBenchmark")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    
    rs.Open VEGBENCHMARK_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(VEGBENCHMARK_TABLENAME, VEGBENCHMARK_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VEGBENCHMARK_TABLENAME & _
                " where " & VEGBENCHMARK_TABLENAME & "." & VEGBENCHMARK_NAME & " = '" & valA & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(VEGBENCHMARK_ID).value = ID
            rs.Fields.Item(VEGBENCHMARK_NAME).value = valA
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(VEGBENCHMARK_ID).Value = ID
            'rsTmp.Fields.Item(VEGBENCHMARK_NAME).Value = valA
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VegBenchmark"
    End If
End Sub
Private Sub LoadActionDetail()
    Dim rs As New Recordset
    Dim rsB As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim growthtype$, growthtypeID$
    Dim cellstr$, MySql$
    Dim ID$
    Dim ctr%
    Dim valA$, valB$, valC$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading ActionDetail"
    Me.Repaint
    Set ws = Worksheets("ActionDetail")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ActionDetail")
    logUpdates = GetLogUpdates("ActionDetail")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    
    rs.Open ACTIONDETAIL_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(ACTIONDETAIL_TABLENAME, ACTIONDETAIL_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        valB = Trim(ws.Range(("B" & ctr)).value)
        If valB <> "" Then
            growthtype = Trim(cell.value)
        End If
        
        MySql = "Select " & VEGSPECIESGROWTHTYPE_ID & " from " & VEGSPECIESGROWTHTYPE_TABLENAME & " where " & VEGSPECIES_NAME & " = '" & growthtype & "'"
        Set rsB = Conn.Execute(MySql)
        If Not rsB.BOF And Not rsB.EOF Then
            growthtypeID = rsB(VEGSPECIESGROWTHTYPE_ID)
        Else
            growthtypeID = -1
        End If
        valC = Trim(ws.Range(("C" & ctr)).value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ACTIONDETAIL_TABLENAME & _
                " where " & ACTIONDETAIL_TABLENAME & "." & ACTIONDETAIL_NAME & " = '" & valA & "'" & _
                " and " & ACTIONDETAIL_TABLENAME & "." & ACTIONDETAIL_GROWTHTYPEID & " = " & growthtypeID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(ACTIONDETAIL_ID).value = ID
            rs.Fields.Item(ACTIONDETAIL_NAME).value = valA
            If growthtypeID <> -1 Then rs.Fields.Item(ACTIONDETAIL_GROWTHTYPEID).value = growthtypeID
            If valC <> "" Then rs.Fields.Item(ACTIONDETAIL_DISTANCE).value = Trim(cell.value)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(ACTIONDETAIL_ID).Value = ID
            'rsTmp.Fields.Item(ACTIONDETAIL_NAME).Value = valA
            'If growthtypeID <> -1 Then rsTmp.Fields.Item(ACTIONDETAIL_GROWTHTYPEID).Value = growthtypeID
            If valC <> "" Then rsTmp.Fields.Item(ACTIONDETAIL_DISTANCE).value = Trim(cell.value)
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ActionDetail"
    End If
End Sub

Private Sub LoadCrew()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$
    Dim ID$
    Dim ctr%
    Dim valA$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Crew"
    Me.Repaint
    Set ws = Worksheets("Crew")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Crew")
    logUpdates = GetLogUpdates("Crew")

    ctr = 2
    valA = Trim(ws.Range(("A" & ctr)).value)
    
    rs.Open CREW_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    'ID = NextPK(CREW_TABLENAME, CREW_ID)
    
    Do While valA <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
            
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CREW_TABLENAME & _
                " where " & CREW_TABLENAME & "." & CREW_NAME & " = '" & valA & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(CREW_ID).value = ID
            rs.Fields.Item(CREW_NAME).value = valA
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(CREW_ID).Value = ID
            'rsTmp.Fields.Item(CREW_NAME).Value = valA
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        valA = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "Crew"
    End If
End Sub
Private Sub LoadErrorMessage()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, message$, ComponentName$
    Dim ctr%, UserError%
    Dim FacCode&, ErrorCode&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Error Messages"
    Me.Repaint
    Set ws = Worksheets("ErrorMessage")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ErrorMessage")
    logUpdates = GetLogUpdates("ErrorMessage")

    ctr = 2
    
    Set cell = ws.Range("A2")
    
    rs.Open ERRORMESSAGE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While Trim(cell.value) <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ComponentName = Trim(cell.value)
        FacCode = FacilityCode(ComponentName)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ErrorCode = Trim(cell.value)
        Else
            ErrorCode = 0
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        message = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        'the column is labelled "Display More Button?"
        UserError = Not BoolStringToInt(Trim(cell.value))
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ERRORMESSAGE_TABLENAME & _
                " where " & ERRORMESSAGE_TABLENAME & "." & ERRORMESSAGE_FACILITYCODE & " = " & FacCode & _
                " and " & ERRORMESSAGE_TABLENAME & "." & ERRORMESSAGE_ERRORCODE & " = " & ErrorCode
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(ERRORMESSAGE_FACILITYCODE).value = FacCode
            rs.Fields.Item(ERRORMESSAGE_ERRORCODE).value = ErrorCode
            rs.Fields.Item(ERRORMESSAGE_MESSAGE).value = message
            rs.Fields.Item(ERRORMESSAGE_ISUSERERROR).value = UserError
        Else
            'rsTmp.Fields.Item(ERRORMESSAGE_FACILITYCODE).Value = FacCode
            'rsTmp.Fields.Item(ERRORMESSAGE_ERRORCODE).Value = ErrorCode
            rsTmp.Fields.Item(ERRORMESSAGE_MESSAGE).value = message
            rsTmp.Fields.Item(ERRORMESSAGE_ISUSERERROR).value = UserError
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ErrorMessage"
    End If
    ImgErrMessage.Visible = True
End Sub
  

Private Sub LoadEAOptWizardSetting()
    
    Dim tmpStr As String
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
            
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EAOptWizardSettings" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Optimization Wizard Settings"
    Me.Repaint
    Set ws = Worksheets("EAOptWizardSettings")
    
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAOptWizardSettings")
    logUpdates = GetLogUpdates("EAOptWizardSettings")
        
    rs.Open EAOPTWIZ_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    ' Clear previous errors:
    ws.Range((ErrorCol & "1")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "1")).value = ""
    ws.Range((ErrorCol & "2")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "2")).value = ""
    ws.Range((ErrorCol & "3")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "3")).value = ""
    ws.Range((ErrorCol & "4")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "4")).value = ""
    ws.Range((ErrorCol & "5")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "5")).value = ""
    ws.Range((ErrorCol & "6")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "6")).value = ""
    ws.Range((ErrorCol & "7")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "7")).value = ""
    ws.Range((ErrorCol & "8")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "8")).value = ""
    ws.Range((ErrorCol & "9")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "9")).value = ""
    ws.Range((ErrorCol & "10")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "10")).value = ""
    ws.Range((ErrorCol & "11")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "11")).value = ""
    ws.Range((ErrorCol & "12")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "12")).value = ""
    ws.Range((ErrorCol & "13")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "13")).value = ""
    ws.Range((ErrorCol & "14")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "14")).value = ""
    ws.Range((ErrorCol & "15")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "15")).value = ""
    ws.Range((ErrorCol & "16")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "16")).value = ""
    ws.Range((ErrorCol & "17")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "17")).value = ""
    
    ' Check for existing rows: DONE
    sqlTmp = "select * from " & EAOPTWIZ_TABLENAME
    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
    If rsTmp.BOF And rsTmp.EOF Then
        
        If ws.Range("B1").value <> "" Or _
           ws.Range("B2").value <> "" Or _
           ws.Range("B3").value <> "" Or _
           ws.Range("B4").value <> "" Or _
           ws.Range("B5").value <> "" Or _
           ws.Range("B6").value <> "" Or _
           ws.Range("B7").value <> "" Or _
           ws.Range("B8").value <> "" Or _
           ws.Range("B9").value <> "" Or _
           ws.Range("B10").value <> "" Or _
           ws.Range("B11").value <> "" Or _
           ws.Range("B12").value <> "" Or _
           ws.Range("B13").value <> "" Or _
           ws.Range("B14").value <> "" Or _
           ws.Range("B15").value <> "" Or _
           ws.Range("B16").value <> "" Or _
           ws.Range("B17").value <> "" Then
    
            ' The following does not work and I could not figure out why so I'm switching to the insert statement below it:
            'rs.AddNew
            'rs(EAOPTWIZ_ID) = 1 'NextPK(EAOPTWIZ_TABLENAME, EAOPTWIZ_ID)
            'If ws.Range("B1").Value <> "" Then rs(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Int(Trim(ws.Range("B1").Value))
            'If ws.Range("B2").Value <> "" Then rs(EAOPTWIZ_OPTIMIZEPRIMARY) = Int(Trim(ws.Range("B2").Value))
            'If ws.Range("B3").Value <> "" Then rs(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = CDbl(Trim(ws.Range("B3").Value))
            'If ws.Range("B4").Value <> "" Then rs(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = CDbl(Trim(ws.Range("B4").Value))
            'If ws.Range("B5").Value <> "" Then rs(EAOPTWIZ_PRIMARYLINEOVERLOAD) = CDbl(Trim(ws.Range("B5").Value))
            'If ws.Range("B6").Value <> "" Then rs(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Int(Trim(ws.Range("B6").Value))
            'If ws.Range("B7").Value <> "" Then rs(EAOPTWIZ_OPTIMIZESECONDARY) = Int(Trim(ws.Range("B7").Value))
            'If ws.Range("B8").Value <> "" Then rs(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Int(Trim(ws.Range("B8").Value))
            'If ws.Range("B9").Value <> "" Then rs(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = CDbl(Trim(ws.Range("B9").Value))
            'If ws.Range("B10").Value <> "" Then rs(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = CDbl(Trim(ws.Range("B10").Value))
            'If ws.Range("B11").Value <> "" Then rs(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = CDbl(Trim(ws.Range("B11").Value))
            'If ws.Range("B12").Value <> "" Then rs(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = CDbl(Trim(ws.Range("B12").Value))
            'If ws.Range("B13").Value <> "" Then rs(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = CDbl(Trim(ws.Range("B13").Value))
            'If ws.Range("B14").Value <> "" Then rs(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = CDbl(Trim(ws.Range("B14").Value))
            'If ws.Range("B15").Value <> "" Then rs(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = CDbl(Trim(ws.Range("B15").Value))
            'If ws.Range("B16").Value <> "" Then rs(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = CDbl(Trim(ws.Range("B16").Value))
            'If ws.Range("B17").Value <> "" Then rs(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = CDbl(Trim(ws.Range("B17").Value))
            
            Dim insSql As String
            insSql = "INSERT INTO CHDATA." & EAOPTWIZ_TABLENAME & " (" & _
            EAOPTWIZ_ID & "," & _
            EAOPTWIZ_DOWNSIZEINITIALRATINGS & "," & _
            EAOPTWIZ_OPTIMIZEPRIMARY & "," & _
            EAOPTWIZ_PRIMARYLOADPOWERFACTOR & "," & _
            EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING & "," & _
            EAOPTWIZ_PRIMARYLINEOVERLOAD & "," & _
            EAOPTWIZ_INCLUDEFUSECUTOUTS & "," & _
            EAOPTWIZ_OPTIMIZESECONDARY & "," & _
            EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION & "," & _
            EAOPTWIZ_PRIMARYLOADMULTIPLIER & "," & _
            EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC & "," & _
            EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC & "," & _
            EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP & "," & _
            EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP & "," & _
            EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING & "," & _
            EAOPTWIZ_SECONDARYLOADMULTIPLIER & "," & _
            EAOPTWIZ_SECONDARYLOADPOWERFACTOR & "," & _
            EAOPTWIZ_ALLOWABLETRANOVERLOAD & ")"
            
            insSql = insSql & " VALUES (" & _
            NextPK(EAOPTWIZ_TABLENAME, EAOPTWIZ_ID) & "," & _
            Int(Trim(ws.Range("B1").value)) & "," & _
            Int(Trim(ws.Range("B2").value)) & "," & _
            CDbl(Trim(ws.Range("B3").value)) & "," & _
            CDbl(Trim(ws.Range("B4").value)) & "," & _
            CDbl(Trim(ws.Range("B5").value)) & "," & _
            Int(Trim(ws.Range("B6").value)) & "," & _
            Int(Trim(ws.Range("B7").value)) & "," & _
            Int(Trim(ws.Range("B8").value)) & "," & _
            CDbl(Trim(ws.Range("B9").value)) & "," & _
            CDbl(Trim(ws.Range("B10").value)) & "," & _
            CDbl(Trim(ws.Range("B11").value)) & "," & _
            CDbl(Trim(ws.Range("B12").value)) & "," & _
            CDbl(Trim(ws.Range("B13").value)) & "," & _
            CDbl(Trim(ws.Range("B14").value)) & "," & _
            CDbl(Trim(ws.Range("B15").value)) & "," & _
            CDbl(Trim(ws.Range("B16").value)) & "," & _
            CDbl(Trim(ws.Range("B17").value)) & ")"
                    
            Conn.Execute (insSql)
            
        End If
    Else
        If logUpdates = "1" Then
            If (Trim(ws.Range("B1").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS)
                If (tmpStr <> Int(Trim(ws.Range("B1").value))) Then
                    rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Trim(ws.Range("B1").value)
                    ws.Range((ErrorCol & "1")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "1")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B2").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY)
                If (tmpStr <> Int(Trim(ws.Range("B2").value))) Then
                    rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY) = Trim(ws.Range("B2").value)
                    ws.Range((ErrorCol & "2")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "2")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B3").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR)
                If (tmpStr <> CDbl(Trim(ws.Range("B3").value))) Then
                    rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = Trim(ws.Range("B3").value)
                    ws.Range((ErrorCol & "3")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "3")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B4").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING)
                If (tmpStr <> CDbl(Trim(ws.Range("B4").value))) Then
                    rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = Trim(ws.Range("B4").value)
                    ws.Range((ErrorCol & "4")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "4")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B5").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD)
                If (tmpStr <> CDbl(Trim(ws.Range("B5").value))) Then
                    rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD) = Trim(ws.Range("B5").value)
                    ws.Range((ErrorCol & "5")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "5")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B6").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS)
                If (tmpStr <> Int(Trim(ws.Range("B6").value))) Then
                    rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Trim(ws.Range("B6").value)
                    ws.Range((ErrorCol & "6")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "6")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B7").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_OPTIMIZESECONDARY)
                If (tmpStr <> Int(Trim(ws.Range("B7").value))) Then
                    rsTmp(EAOPTWIZ_OPTIMIZESECONDARY) = Trim(ws.Range("B7").value)
                    ws.Range((ErrorCol & "7")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "7")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B8").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION)
                If (tmpStr <> Int(Trim(ws.Range("B8").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Trim(ws.Range("B8").value)
                    ws.Range((ErrorCol & "8")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "8")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B9").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER)
                If (tmpStr <> CDbl(Trim(ws.Range("B9").value))) Then
                    rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = Trim(ws.Range("B9").value)
                    ws.Range((ErrorCol & "9")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "9")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B10").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC)
                If (tmpStr <> CDbl(Trim(ws.Range("B10").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = Trim(ws.Range("B10").value)
                    ws.Range((ErrorCol & "10")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "10")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B11").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC)
                If (tmpStr <> CDbl(Trim(ws.Range("B11").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = Trim(ws.Range("B11").value)
                    ws.Range((ErrorCol & "11")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "11")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B12").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP)
                If (tmpStr <> CDbl(Trim(ws.Range("B12").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = Trim(ws.Range("B12").value)
                    ws.Range((ErrorCol & "12")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "12")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B13").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP)
                If (tmpStr <> CDbl(Trim(ws.Range("B13").value))) Then
                    rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = Trim(ws.Range("B13").value)
                    ws.Range((ErrorCol & "13")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "13")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B14").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING)
                If (tmpStr <> CDbl(Trim(ws.Range("B14").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = Trim(ws.Range("B14").value)
                    ws.Range((ErrorCol & "14")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "14")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B15").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER)
                If (tmpStr <> CDbl(Trim(ws.Range("B15").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = Trim(ws.Range("B15").value)
                    ws.Range((ErrorCol & "15")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "15")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            ' Do not remove the next statement as it will result in an error if removed.
            rsTmp.Update
            If (Trim(ws.Range("B16").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR)
                If (tmpStr <> CDbl(Trim(ws.Range("B16").value))) Then
                    rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = Trim(ws.Range("B16").value)
                    ws.Range((ErrorCol & "16")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "16")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B17").value) <> "") Then
                tmpStr = rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD)
                If (tmpStr <> CDbl(Trim(ws.Range("B17").value))) Then
                    rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = Trim(ws.Range("B17").value)
                    ws.Range((ErrorCol & "17")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "17")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Update
        Else
            If ws.Range("B1").value <> "" Then rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Int(Trim(ws.Range("B1").value))
            If ws.Range("B2").value <> "" Then rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY) = Int(Trim(ws.Range("B2").value))
            If ws.Range("B3").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = CDbl(Trim(ws.Range("B3").value))
            If ws.Range("B4").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = CDbl(Trim(ws.Range("B4").value))
            If ws.Range("B5").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD) = CDbl(Trim(ws.Range("B5").value))
            If ws.Range("B6").value <> "" Then rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Int(Trim(ws.Range("B6").value))
            If ws.Range("B7").value <> "" Then rsTmp(EAOPTWIZ_OPTIMIZESECONDARY) = Int(Trim(ws.Range("B7").value))
            If ws.Range("B8").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Int(Trim(ws.Range("B8").value))
            If ws.Range("B9").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = CDbl(Trim(ws.Range("B9").value))
            If ws.Range("B10").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = CDbl(Trim(ws.Range("B10").value))
            If ws.Range("B11").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = CDbl(Trim(ws.Range("B11").value))
            If ws.Range("B12").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = CDbl(Trim(ws.Range("B12").value))
            If ws.Range("B13").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = CDbl(Trim(ws.Range("B13").value))
            If ws.Range("B14").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = CDbl(Trim(ws.Range("B14").value))
            If ws.Range("B15").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = CDbl(Trim(ws.Range("B15").value))
            ' Do not remove the next statement as it will result in an error if removed
            rsTmp.Update
            If ws.Range("B16").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = CDbl(Trim(ws.Range("B16").value))
            If ws.Range("B17").value <> "" Then rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = CDbl(Trim(ws.Range("B17").value))
            rsTmp.Update
        End If
    End If
    rsTmp.Close

    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    If Failure Then
        LogSheetFailure "EAOptWizardSettings"
    End If
    'ImgConfig.Visible = True
End Sub

Private Sub LoadEAOptWizardSetting3()
    
    If 1 = 2 Then
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False

    Label2.Caption = "Loading EA Optimization Wizard Settings"
    Me.Repaint
    Set ws = Worksheets("EAOptWizardSettings")
    
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAOptWizardSettings")
    logUpdates = GetLogUpdates("EAOptWizardSettings")

    rs.Open EAOPTWIZ_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    ' Clear previous errors:
    ws.Range((ErrorCol & "1")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "1")).value = ""
    ws.Range((ErrorCol & "2")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "2")).value = ""
    ws.Range((ErrorCol & "3")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "3")).value = ""
    ws.Range((ErrorCol & "4")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "4")).value = ""
    ws.Range((ErrorCol & "5")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "5")).value = ""
    ws.Range((ErrorCol & "6")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "6")).value = ""
    ws.Range((ErrorCol & "7")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "7")).value = ""
    ws.Range((ErrorCol & "8")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "8")).value = ""
    ws.Range((ErrorCol & "9")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "9")).value = ""
    ws.Range((ErrorCol & "10")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "10")).value = ""
    ws.Range((ErrorCol & "11")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "11")).value = ""
    ws.Range((ErrorCol & "12")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "12")).value = ""
    ws.Range((ErrorCol & "13")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "13")).value = ""
    ws.Range((ErrorCol & "14")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "14")).value = ""
    ws.Range((ErrorCol & "15")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "15")).value = ""
    ws.Range((ErrorCol & "16")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "16")).value = ""
    ws.Range((ErrorCol & "17")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "17")).value = ""
    
    ' Check for existing rows: DONE
    sqlTmp = "select * from " & EAOPTWIZ_TABLENAME
    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
    If rsTmp.BOF And rsTmp.EOF Then
    
        If ws.Range("B1").value <> "" Or _
           ws.Range("B2").value <> "" Or _
           ws.Range("B3").value <> "" Or _
           ws.Range("B4").value <> "" Or _
           ws.Range("B5").value <> "" Or _
           ws.Range("B6").value <> "" Or _
           ws.Range("B7").value <> "" Or _
           ws.Range("B8").value <> "" Or _
           ws.Range("B9").value <> "" Or _
           ws.Range("B10").value <> "" Or _
           ws.Range("B11").value <> "" Or _
           ws.Range("B12").value <> "" Or _
           ws.Range("B13").value <> "" Or _
           ws.Range("B14").value <> "" Or _
           ws.Range("B15").value <> "" Or _
           ws.Range("B16").value <> "" Or _
           ws.Range("B17").value <> "" Then
    
            rs.AddNew
            rs(EAOPTWIZ_ID) = NextPK(EAOPTWIZ_TABLENAME, EAOPTWIZ_ID)
            If ws.Range("B1").value <> "" Then rs(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rs(EAOPTWIZ_OPTIMIZEPRIMARY) = Trim(ws.Range("B2").value)
            If ws.Range("B3").value <> "" Then rs(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = Trim(ws.Range("B3").value)
            If ws.Range("B4").value <> "" Then rs(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = Trim(ws.Range("B4").value)
            If ws.Range("B5").value <> "" Then rs(EAOPTWIZ_PRIMARYLINEOVERLOAD) = Trim(ws.Range("B5").value)
            If ws.Range("B6").value <> "" Then rs(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Trim(ws.Range("B6").value)
            If ws.Range("B7").value <> "" Then rs(EAOPTWIZ_OPTIMIZESECONDARY) = Trim(ws.Range("B7").value)
            If ws.Range("B8").value <> "" Then rs(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Trim(ws.Range("B8").value)
            If ws.Range("B9").value <> "" Then rs(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = Trim(ws.Range("B9").value)
            If ws.Range("B10").value <> "" Then rs(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = Trim(ws.Range("B10").value)
            If ws.Range("B11").value <> "" Then rs(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = Trim(ws.Range("B11").value)
            If ws.Range("B12").value <> "" Then rs(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = Trim(ws.Range("B12").value)
            If ws.Range("B13").value <> "" Then rs(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = Trim(ws.Range("B13").value)
            If ws.Range("B14").value <> "" Then rs(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = Trim(ws.Range("B14").value)
            If ws.Range("B15").value <> "" Then rs(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = Trim(ws.Range("B15").value)
            If ws.Range("B16").value <> "" Then rs(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = Trim(ws.Range("B16").value)
            If ws.Range("B17").value <> "" Then rs(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = Trim(ws.Range("B17").value)
        End If
    Else
        If logUpdates = "1" Then
            If (Trim(ws.Range("B1").value) <> "") Then
                If (rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS) <> Trim(ws.Range("B1").value)) Then
                    rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Trim(ws.Range("B1").value)
                    ws.Range((ErrorCol & "1")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "1")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B2").value) <> "") Then
                If (rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY) <> Trim(ws.Range("B2").value)) Then
                    rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY) = Trim(ws.Range("B2").value)
                    ws.Range((ErrorCol & "2")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "2")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B3").value) <> "") Then
                If (rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) <> Trim(ws.Range("B3").value)) Then
                    rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = Trim(ws.Range("B3").value)
                    ws.Range((ErrorCol & "3")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "3")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B4").value) <> "") Then
                If (rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) <> Trim(ws.Range("B4").value)) Then
                    rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = Trim(ws.Range("B4").value)
                    ws.Range((ErrorCol & "4")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "4")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B5").value) <> "") Then
                If (rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD) <> Trim(ws.Range("B5").value)) Then
                    rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD) = Trim(ws.Range("B5").value)
                    ws.Range((ErrorCol & "5")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "5")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B6").value) <> "") Then
                If (rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS) <> Trim(ws.Range("B6").value)) Then
                    rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Trim(ws.Range("B6").value)
                    ws.Range((ErrorCol & "6")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "6")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B7").value) <> "") Then
                If (rsTmp(EAOPTWIZ_OPTIMIZESECONDARY) <> Trim(ws.Range("B7").value)) Then
                    rsTmp(EAOPTWIZ_OPTIMIZESECONDARY) = Trim(ws.Range("B7").value)
                    ws.Range((ErrorCol & "7")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "7")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B8").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) <> Trim(ws.Range("B8").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Trim(ws.Range("B8").value)
                    ws.Range((ErrorCol & "8")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "8")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B9").value) <> "") Then
                If (rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER) <> Trim(ws.Range("B9").value)) Then
                    rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = Trim(ws.Range("B9").value)
                    ws.Range((ErrorCol & "9")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "9")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B10").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) <> Trim(ws.Range("B10").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = Trim(ws.Range("B10").value)
                    ws.Range((ErrorCol & "10")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "10")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B11").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) <> Trim(ws.Range("B11").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = Trim(ws.Range("B11").value)
                    ws.Range((ErrorCol & "11")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "11")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B12").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) <> Trim(ws.Range("B12").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = Trim(ws.Range("B12").value)
                    ws.Range((ErrorCol & "12")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "12")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B13").value) <> "") Then
                If (rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) <> Trim(ws.Range("B13").value)) Then
                    rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = Trim(ws.Range("B13").value)
                    ws.Range((ErrorCol & "13")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "13")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B14").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) <> Trim(ws.Range("B14").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = Trim(ws.Range("B14").value)
                    ws.Range((ErrorCol & "14")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "14")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B15").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER) <> Trim(ws.Range("B15").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = Trim(ws.Range("B15").value)
                    ws.Range((ErrorCol & "15")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "15")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B16").value) <> "") Then
                If (rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) <> Trim(ws.Range("B16").value)) Then
                    rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = Trim(ws.Range("B16").value)
                    ws.Range((ErrorCol & "16")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "16")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B17").value) <> "") Then
                If (rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD) <> Trim(ws.Range("B17").value)) Then
                    rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = Trim(ws.Range("B17").value)
                    ws.Range((ErrorCol & "17")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "17")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Update
        Else
            If ws.Range("B1").value <> "" Then rsTmp(EAOPTWIZ_DOWNSIZEINITIALRATINGS) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rsTmp(EAOPTWIZ_OPTIMIZEPRIMARY) = Trim(ws.Range("B2").value)
            If ws.Range("B3").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLOADPOWERFACTOR) = Trim(ws.Range("B3").value)
            If ws.Range("B4").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYMAXINITIALCONDLOADING) = Trim(ws.Range("B4").value)
            If ws.Range("B5").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLINEOVERLOAD) = Trim(ws.Range("B5").value)
            If ws.Range("B6").value <> "" Then rsTmp(EAOPTWIZ_INCLUDEFUSECUTOUTS) = Trim(ws.Range("B6").value)
            If ws.Range("B7").value <> "" Then rsTmp(EAOPTWIZ_OPTIMIZESECONDARY) = Trim(ws.Range("B7").value)
            If ws.Range("B8").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYOPTIMIZATIONCRITERION) = Trim(ws.Range("B8").value)
            If ws.Range("B9").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYLOADMULTIPLIER) = Trim(ws.Range("B9").value)
            If ws.Range("B10").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERSINGLESVC) = Trim(ws.Range("B10").value)
            If ws.Range("B11").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXFLICKERMULTISVC) = Trim(ws.Range("B11").value)
            If ws.Range("B12").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXALLOWABLEVDROP) = Trim(ws.Range("B12").value)
            If ws.Range("B13").value <> "" Then rsTmp(EAOPTWIZ_PRIMARYMAXALLOWABLEVDROP) = Trim(ws.Range("B13").value)
            If ws.Range("B14").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYMAXINITIALCONDLOADING) = Trim(ws.Range("B14").value)
            If ws.Range("B15").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYLOADMULTIPLIER) = Trim(ws.Range("B15").value)
            If ws.Range("B16").value <> "" Then rsTmp(EAOPTWIZ_SECONDARYLOADPOWERFACTOR) = Trim(ws.Range("B16").value)
            If ws.Range("B17").value <> "" Then rsTmp(EAOPTWIZ_ALLOWABLETRANOVERLOAD) = Trim(ws.Range("B17").value)
            rsTmp.Update
        End If
    End If
    rsTmp.Close
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EAOptWizardSettings"
    End If
    ImgWizardSetting.Visible = True
    End If
End Sub


Private Sub LoadEAOptLFParamSetting()

    Dim tmpStr As String
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EAOptLFParameterSetting" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Optimization LF Parameter Settings"
    Me.Repaint
    Set ws = Worksheets("EAOptLFParameterSetting")

    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAOptLFParameterSetting")
    logUpdates = GetLogUpdates("EAOptLFParameterSetting")
        
    rs.Open EAOPTLFPARAM_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    ' Clear previous errors:
    ws.Range((ErrorCol & "1")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "1")).value = ""
    ws.Range((ErrorCol & "2")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "2")).value = ""
    ws.Range((ErrorCol & "3")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "3")).value = ""
    ws.Range((ErrorCol & "4")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "4")).value = ""
    ws.Range((ErrorCol & "5")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "5")).value = ""
    ws.Range((ErrorCol & "6")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "6")).value = ""
    ws.Range((ErrorCol & "7")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "7")).value = ""
    ws.Range((ErrorCol & "8")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "8")).value = ""
    ws.Range((ErrorCol & "9")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "9")).value = ""
    ws.Range((ErrorCol & "10")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "10")).value = ""
    
    ' Check for existing rows: DONE
    sqlTmp = "select * from " & EAOPTLFPARAM_TABLENAME
    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
    If rsTmp.BOF And rsTmp.EOF Then
    
        If ws.Range("B1").value <> "" Or _
           ws.Range("B2").value <> "" Or _
           ws.Range("B3").value <> "" Or _
           ws.Range("B4").value <> "" Or _
           ws.Range("B5").value <> "" Or _
           ws.Range("B6").value <> "" Or _
           ws.Range("B7").value <> "" Or _
           ws.Range("B8").value <> "" Or _
           ws.Range("B9").value <> "" Or _
           ws.Range("B10").value <> "" Then
    
            rs.AddNew
            rs(EAOPTLFPARAM_ID) = NextPK(EAOPTLFPARAM_TABLENAME, EAOPTLFPARAM_ID)
            If ws.Range("B1").value <> "" Then rs(EAOPTLFPARAM_LOADREPRESENTATIONTYPE) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rs(EAOPTLFPARAM_VOLTAGERESULTVALUES) = Trim(ws.Range("B2").value)
            If ws.Range("B3").value <> "" Then rs(EAOPTLFPARAM_VOLTAGEMISMATCHCRITERION) = Trim(ws.Range("B3").value)
            If ws.Range("B4").value <> "" Then rs(EAOPTLFPARAM_MAXITERATIONCOUNT) = Trim(ws.Range("B4").value)
            If ws.Range("B5").value <> "" Then rs(EAOPTLFPARAM_LINERXUNITS) = Trim(ws.Range("B5").value)
            If ws.Range("B6").value <> "" Then rs(EAOPTLFPARAM_LINECHARGINGUNITS) = Trim(ws.Range("B6").value)
            If ws.Range("B7").value <> "" Then rs(EAOPTLFPARAM_SOURCERXUNITS) = Trim(ws.Range("B7").value)
            If ws.Range("B8").value <> "" Then rs(EAOPTLFPARAM_SEGMENTUNITS) = Trim(ws.Range("B8").value)
            If ws.Range("B9").value <> "" Then rs(EAOPTLFPARAM_RXLINESOURCEMVABASE) = Trim(ws.Range("B9").value)
            If ws.Range("B10").value <> "" Then rs(EAOPTLFPARAM_ZUNITLENGTH) = Trim(ws.Range("B10").value)
        End If
    Else
        If logUpdates = "1" Then
            If (Trim(ws.Range("B1").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_LOADREPRESENTATIONTYPE)
                If (tmpStr <> Trim(ws.Range("B1").value)) Then
                    rsTmp(EAOPTLFPARAM_LOADREPRESENTATIONTYPE) = Trim(ws.Range("B1").value)
                    ws.Range((ErrorCol & "1")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "1")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B2").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_VOLTAGERESULTVALUES)
                If (tmpStr <> Trim(ws.Range("B2").value)) Then
                    rsTmp(EAOPTLFPARAM_VOLTAGERESULTVALUES) = Trim(ws.Range("B2").value)
                    ws.Range((ErrorCol & "2")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "2")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B3").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_VOLTAGEMISMATCHCRITERION)
                If (tmpStr <> Trim(ws.Range("B3").value)) Then
                    rsTmp(EAOPTLFPARAM_VOLTAGEMISMATCHCRITERION) = Trim(ws.Range("B3").value)
                    ws.Range((ErrorCol & "3")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "3")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B4").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_MAXITERATIONCOUNT)
                If (tmpStr <> Trim(ws.Range("B4").value)) Then
                    rsTmp(EAOPTLFPARAM_MAXITERATIONCOUNT) = Trim(ws.Range("B4").value)
                    ws.Range((ErrorCol & "4")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "4")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B5").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_LINERXUNITS)
                If (tmpStr <> Trim(ws.Range("B5").value)) Then
                    rsTmp(EAOPTLFPARAM_LINERXUNITS) = Trim(ws.Range("B5").value)
                    ws.Range((ErrorCol & "5")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "5")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B6").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_LINECHARGINGUNITS)
                If (tmpStr <> Trim(ws.Range("B6").value)) Then
                    rsTmp(EAOPTLFPARAM_LINECHARGINGUNITS) = Trim(ws.Range("B6").value)
                    ws.Range((ErrorCol & "6")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "6")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B7").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_SOURCERXUNITS)
                If (tmpStr <> Trim(ws.Range("B7").value)) Then
                    rsTmp(EAOPTLFPARAM_SOURCERXUNITS) = Trim(ws.Range("B7").value)
                    ws.Range((ErrorCol & "7")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "7")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B8").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_SEGMENTUNITS)
                If (tmpStr <> Trim(ws.Range("B8").value)) Then
                    rsTmp(EAOPTLFPARAM_SEGMENTUNITS) = Trim(ws.Range("B8").value)
                    ws.Range((ErrorCol & "8")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "8")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B9").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_RXLINESOURCEMVABASE)
                If (tmpStr <> Trim(ws.Range("B9").value)) Then
                    rsTmp(EAOPTLFPARAM_RXLINESOURCEMVABASE) = Trim(ws.Range("B9").value)
                    ws.Range((ErrorCol & "9")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "9")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B10").value) <> "") Then
                tmpStr = rsTmp(EAOPTLFPARAM_ZUNITLENGTH)
                If (tmpStr <> Trim(ws.Range("B10").value)) Then
                    rsTmp(EAOPTLFPARAM_ZUNITLENGTH) = Trim(ws.Range("B10").value)
                    ws.Range((ErrorCol & "10")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "10")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Update
        Else
            If ws.Range("B1").value <> "" Then rsTmp(EAOPTLFPARAM_LOADREPRESENTATIONTYPE) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rsTmp(EAOPTLFPARAM_VOLTAGERESULTVALUES) = Trim(ws.Range("B2").value)
            If ws.Range("B3").value <> "" Then rsTmp(EAOPTLFPARAM_VOLTAGEMISMATCHCRITERION) = Trim(ws.Range("B3").value)
            If ws.Range("B4").value <> "" Then rsTmp(EAOPTLFPARAM_MAXITERATIONCOUNT) = Trim(ws.Range("B4").value)
            If ws.Range("B5").value <> "" Then rsTmp(EAOPTLFPARAM_LINERXUNITS) = Trim(ws.Range("B5").value)
            If ws.Range("B6").value <> "" Then rsTmp(EAOPTLFPARAM_LINECHARGINGUNITS) = Trim(ws.Range("B6").value)
            If ws.Range("B7").value <> "" Then rsTmp(EAOPTLFPARAM_SOURCERXUNITS) = Trim(ws.Range("B7").value)
            If ws.Range("B8").value <> "" Then rsTmp(EAOPTLFPARAM_SEGMENTUNITS) = Trim(ws.Range("B8").value)
            If ws.Range("B9").value <> "" Then rsTmp(EAOPTLFPARAM_RXLINESOURCEMVABASE) = Trim(ws.Range("B9").value)
            If ws.Range("B10").value <> "" Then rsTmp(EAOPTLFPARAM_ZUNITLENGTH) = Trim(ws.Range("B10").value)
            rsTmp.Update
        End If
    End If
    rsTmp.Close
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EAOptLFParameterSetting"
    End If
    ImgLFParam.Visible = True
    
End Sub
Private Sub LoadAttributeRelations()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim RuleID&, FtrTypeID&, RuleSetID&, LastFtrTypeID&
    Dim RuleName$, ViolationString$, value$
    Dim RulesetNum&, LastRuleset&, CompTypeID&, ComponentType&
    Dim LAttr$, RAttr$, Operator$
    Dim ctr%, IsPropagation%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Label2.Caption = "Loading Attribute Relation Rules"
    Me.Repaint
    Set ws = Worksheets("AttributeRelations")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeRelations")
    logUpdates = GetLogUpdates("AttributeRelations")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open ATTRREL_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    LastRuleset = 0
    LastFtrTypeID = 0
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
       
        'Debug.Print "In LoadAttributeRelations - ctr=" & ctr
         
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        RuleName = Trim(cell.value)
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        'Debug.Print "   Rule name:" & RuleName
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If ds <> "" Then
            FtrTypeID = FeatureTypeID(Trim(cell.value), ds)
        Else
            FtrTypeID = FeatureTypeID(Trim(cell.value))
        End If
        
        'Debug.Print "   Feature Type:" & cell.Value
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ComponentType = ComponentTypeTypeId(Trim(cell.value))
        CompTypeID = ComponentTypeId(FtrTypeID, ComponentType)
        
        'Debug.Print "   Component Type:" & cell.Value
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        LAttr = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        Operator = OperatorValue(MyStr, False)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RAttr = Trim(cell.value)
            
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ViolationString = Trim(cell.value)
            
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        IsPropagation = BoolStringToInt(Trim(cell.value))
            
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        RulesetNum = Trim(cell.value)
        
        'Debug.Print "   Lattr:" & LAttr
        'Debug.Print "   Rattr:" & RAttr
        
        If RulesetNum <> LastRuleset Or FtrTypeID <> LastFtrTypeID Then
            RuleSetID = CreateRuleset(CompTypeID, ViolationString, True, 1)
            LastRuleset = RulesetNum
            LastFtrTypeID = FtrTypeID
        End If
        
        RuleID = CreateRule(RuleSetID, 1, RuleName, True, IsPropagation)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ATTRREL_TBLNAME & _
                " where " & ATTRREL_TBLNAME & "." & ATTRREL_OPERATOR & " = '" & Operator & "'" & _
                " and " & ATTRREL_TBLNAME & "." & ATTRREL_LATTR & " = '" & LAttr & "'" & _
                " and " & ATTRREL_TBLNAME & "." & ATTRREL_RATTR & " = '" & RAttr & "'" & _
                " and " & ATTRREL_TBLNAME & "." & ATTRREL_LPORT & " = " & "0" & _
                " and " & ATTRREL_TBLNAME & "." & ATTRREL_RPORT & " = " & "1" & _
                " and " & ATTRREL_TBLNAME & "." & ATTRREL_ID & " = " & RuleID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(ATTRREL_ID) = RuleID
            rs(ATTRREL_LPORT) = 0
            rs(ATTRREL_LATTR) = LAttr
            rs(ATTRREL_RPORT) = 1
            rs(ATTRREL_RATTR) = RAttr
            rs(ATTRREL_OPERATOR) = Operator
        Else
            'rsTmp(ATTRREL_ID) = RuleID
            'rsTmp(ATTRREL_LPORT) = 0
            'rsTmp(ATTRREL_LATTR) = LAttr
            'rsTmp(ATTRREL_RPORT) = 1
            'rsTmp(ATTRREL_RATTR) = RAttr
            'rsTmp(ATTRREL_OPERATOR) = Operator
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeRelations"
    End If
    ImgAttrRel.Visible = True
End Sub
Private Sub LoadAttributeConstraints()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim RuleID&, FtrTypeID&
    Dim RuleName$, ViolationString$, attr$, value$
    Dim RulesetNum&, LastRuleset&, CompTypeID&, ComponentType&
    Dim RuleSetID&, Maximum&, Minimum&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
        
    Label2.Caption = "Loading Attribute Constraint Rules"
    Me.Repaint
    Set ws = Worksheets("AttributeConstraints")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeConstraints")
    logUpdates = GetLogUpdates("AttributeConstraints")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open ATTRCONSTRAINT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    LastRuleset = 0
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        RuleName = Trim(cell.value)
            
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If ds <> "" Then
            FtrTypeID = FeatureTypeID(Trim(cell.value), ds)
        Else
            FtrTypeID = FeatureTypeID(Trim(cell.value))
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ComponentType = ComponentTypeTypeId(Trim(cell.value))
        CompTypeID = ComponentTypeId(FtrTypeID, ComponentType)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        attr = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        Maximum = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        Minimum = Trim(cell.value)
            
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ViolationString = Trim(cell.value)
            
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        RulesetNum = Trim(cell.value)
        
        If RulesetNum <> LastRuleset Then
            RuleSetID = CreateRuleset(CompTypeID, ViolationString, True, 2)
            LastRuleset = RulesetNum
        End If
        RuleID = CreateRule(RuleSetID, 2, RuleName, True, False)
        
        
        ' Check for existing rows: TDB
        sqlTmp = "select * from " & ATTRCONSTRAINT_TBLNAME & _
                " where " & ATTRCONSTRAINT_TBLNAME & "." & ATTRCONSTRAINT_ATTRNAME & " = '" & attr & "'" & _
                " and " & ATTRCONSTRAINT_TBLNAME & "." & ATTRCONSTRAINT_ID & " = " & RuleID & _
                " and " & ATTRCONSTRAINT_TBLNAME & "." & ATTRCONSTRAINT_PORT & " = " & "0"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(ATTRCONSTRAINT_ID) = RuleID
            rs(ATTRCONSTRAINT_PORT) = 0
            rs(ATTRCONSTRAINT_ATTRNAME) = attr
            rs(ATTRCONSTRAINT_MAX) = Maximum
            rs(ATTRCONSTRAINT_MIN) = Minimum
        Else
            'rsTmp(ATTRCONSTRAINT_ID) = RuleID
            'rsTmp(ATTRCONSTRAINT_PORT) = 0
            'rsTmp(ATTRCONSTRAINT_ATTRNAME) = attr
            rsTmp(ATTRCONSTRAINT_MAX) = Maximum
            rsTmp(ATTRCONSTRAINT_MIN) = Minimum
            rsTmp.Update
            
            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeConstraints"
    End If
    ImgAttrConst.Visible = True
End Sub

Private Sub LoadUsers()
    
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellSID As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim USERNAME$, FirstName$, LastName$, Initials$, Email$, PhoneNum$, PagerNum$
    Dim ID&, IDSID&, startIDSID&, countSID&, WkFlwID&
    Dim ctr%, EntUserAdded%
    Dim value$, Supervisor$, cellstrSID$, LastWorkFlow$, WPTodayURL$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    
    Label2.Caption = "Loading Users"
    Me.Repaint
    Set ws = Worksheets("Users")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Users")
    logUpdates = GetLogUpdates("Users")

    ctr = 2
    EntUserAdded = False
    LastWorkFlow = ""
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    
    rs.Open USER_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    startIDSID = NextPK(USER_TBLNAME, USER_ID)
    ID = startIDSID
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        USERNAME = LCase(Trim(cell.value))
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        FirstName = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        LastName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Initials = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        Email = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> LastWorkFlow Then
            WkFlwID = WorkFlowID(MyStr)
            LastWorkFlow = MyStr
        End If
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        PhoneNum = MyStr
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        PagerNum = MyStr
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        WPTodayURL = MyStr
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & USER_TBLNAME & _
                " where " & USER_TBLNAME & "." & USER_USERNAME & " = '" & USERNAME & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(USER_USERNAME) = USERNAME
            rs(USER_FIRSTNAME) = FirstName
            rs(USER_LASTNAME) = LastName
            rs(USER_INITIALS) = Initials
            rs(USER_EMAIL) = Email
            If (LCase(USERNAME) = "enterpriseuser") Then
                rs(USER_ID) = 0
                EntUserAdded = True
            Else
                rs(USER_ID) = ID
                ID = ID + 1
            End If
            If IsSQLSERVER Then
                rs(USER_CREATED) = Format(Now, "Short Date")
                rs(USER_UPDATED) = Format(Now, "Short Date")
            Else
                rs(USER_CREATED) = Now
                rs(USER_UPDATED) = Now
            End If
            rs(USER_WORKFLOWID) = WkFlwID
            If PhoneNum <> "" Then rs(USER_PHONENUM) = PhoneNum
            If PagerNum <> "" Then rs(USER_PAGERNUM) = PagerNum
            If WPTodayURL <> "" Then rs(USER_WPTODAYURL) = WPTodayURL
            rs.Update
        Else
            'rsTmp(USER_USERNAME) = UserName
            rsTmp(USER_FIRSTNAME) = FirstName
            rsTmp(USER_LASTNAME) = LastName
            rsTmp(USER_INITIALS) = Initials
            rsTmp(USER_EMAIL) = Email
            If (LCase(USERNAME) = "enterpriseuser") Then
                EntUserAdded = True
            End If
            If IsSQLSERVER Then
                rsTmp(USER_CREATED) = Format(Now, "Short Date")
                rsTmp(USER_UPDATED) = Format(Now, "Short Date")
            Else
                rsTmp(USER_CREATED) = Now
                rsTmp(USER_UPDATED) = Now
            End If
            rsTmp(USER_WORKFLOWID) = WkFlwID
            If PhoneNum <> "" Then rsTmp(USER_PHONENUM) = PhoneNum
            If PagerNum <> "" Then rsTmp(USER_PAGERNUM) = PagerNum
            If WPTodayURL <> "" Then rsTmp(USER_WPTODAYURL) = WPTodayURL
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ' extract the supervisor ID number from the supervisor User Name
        ' that is in the spreadsheet
        'cellstr = "F" & ctr
        'Set cell = ws.Range(cellstr)
        'Supervisor = Trim(cell.value)
        'If Supervisor <> "" Then
        '    countSID = 2
        '    IDSID = startIDSID
        '    Set cellSID = ws.Range("A2")
        '    'Loop through the user names until we find the supervisor.
        '    Do While cellSID.value <> ""
        '       If LCase(Supervisor) = LCase(Trim(cellSID.value)) Then
        '            rs(USER_SUPERVISORID) = IDSID
        '            Exit Do
        '        End If
        '        IDSID = IDSID + 1
        '       countSID = countSID + 1
        '       cellstrSID = "A" & countSID
        '       Set cellSID = ws.Range(cellstrSID)
        '    Loop
        'End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    'If the enterprise user has not been added, add it now. This user account must
    'have an ID of 0 as it is used by our single sequence mode
    If Not EntUserAdded Then
    
        'Check for enterprise user
        Dim rsForNew As Recordset
        sqlTmp = "select * from " & USER_TBLNAME & _
                " where " & USER_TBLNAME & "." & USER_USERNAME & " = 'enterpriseuser'"
        Set rsForNew = Conn.Execute(sqlTmp, adCmdText)
        If rsForNew.BOF And rsForNew.EOF Then
            If CheckIncrementalLoad.value Then
                rs.AddNew
                rs(USER_ID) = 0
                rs(USER_USERNAME) = "enterpriseuser"
                rs(USER_FIRSTNAME) = "Enterprise"
                rs(USER_LASTNAME) = "User"
                If IsSQLSERVER Then
                    rs(USER_CREATED) = Format(Now, "Short Date")
                    rs(USER_UPDATED) = Format(Now, "Short Date")
                Else
                    rs(USER_CREATED) = Now
                    rs(USER_UPDATED) = Now
                End If
                rs(USER_WORKFLOWID) = 1 'What can we hard code this to?
            End If
        End If
        rsForNew.Close
    End If
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    ' Go through the excel sheet again to update the supervisor user name
    UpdateSupervisorUserName
    
    If Failure Then
        LogSheetFailure "Users"
    End If
    ImgUser.Visible = True
End Sub

Private Sub UpdateSupervisorUserName()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellSID As Range
    Dim ctr%
    Dim UserID$, supervisorID$
    Dim USERNAME$, superVisorUserName$, LastSupervisorName$
    Dim value$, sql$, cellstr$
        
    ctr = 2
    LastSupervisorName = ""
    
    Set ws = Worksheets("Users")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Users")
    logUpdates = GetLogUpdates("Users")
    
    Set cell = ws.Range("A2")
    USERNAME = Trim(cell.value)
    
    Do While USERNAME <> ""
                
        'obtain the Supervisor user name
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        superVisorUserName = Trim(cell.value)
        
        'if this user has a supervisor, then find the supervisor's
        'userID and update the database accordingly
        If (superVisorUserName <> "") Then
            If superVisorUserName <> LastSupervisorName Then
                supervisorID = UserIDForName(superVisorUserName)
                LastSupervisorName = superVisorUserName
            End If
            UserID = UserIDForName(USERNAME)
            
            sql = "Select " & USER_ID & ", " & USER_SUPERVISORID & " From " & USER_TBLNAME & " Where id = " & UserID
            rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
            rs.Fields.Item(USER_SUPERVISORID).value = supervisorID
            rs.Update
            rs.Close
        End If
        
        'Find next user
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        USERNAME = Trim(cell.value)
    
    Loop
    
    
End Sub

Private Sub LoadEARating()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$, Name$
    Dim MyNum&, ID&, ratingType&
    Dim NumericValue#
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EARating" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Rating"
    Me.Repaint
    Set ws = Worksheets("EARating")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EARating")
    logUpdates = GetLogUpdates("EARating")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open EARATING_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(EARATING_TABLENAME, EARATING_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ratingType = cell.value
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        NumericValue = cell.value

        ' Check for existing rows: DONE
        sqlTmp = "select * from " & EARATING_TABLENAME & _
                " where " & EARATING_TABLENAME & "." & EARATING_NAME & " = '" & Name & "'" & _
                " and " & EARATING_TABLENAME & "." & EARATING_TYPE & " = " & ratingType
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(EARATING_ID) = ID
            rs(EARATING_NAME) = Name
            rs(EARATING_TYPE) = ratingType
            rs(EARATING_NUMERICVALUE) = NumericValue
            ID = ID + 1
        Else
            'rsTmp(EARATING_ID) = ID
            'rsTmp(EARATING_NAME) = name
            'rsTmp(EARATING_TYPE) = ratingType
            rsTmp(EARATING_NUMERICVALUE) = NumericValue
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EARating"
    End If
    ImgEARating.Visible = True
End Sub

Private Sub LoadEAAttrDomain()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim TblName$, value$
    Dim ID&, AttrDomainID&, DomainType&, ratingType&
    Dim ctr%
    Dim ratingTypeNull As Boolean
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Dim newDmnName As String
    Dim newDmnVlTp As String
    Dim newDmnClTp As String
    Dim newDmnrs As New Recordset
    Dim newDmnID&
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EAElementAttributeDomain" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Element Attribute Domain"
    Me.Repaint
    Set ws = Worksheets("EAElementAttributeDomain")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAElementAttributeDomain")
    logUpdates = GetLogUpdates("EAElementAttributeDomain")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open EAELEMATTRDOMAIN_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(EAELEMATTRDOMAIN_TABLENAME, EAELEMATTRDOMAIN_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        AttrDomainID = AttributeDomainId(MyStr)
        
        If AttrDomainID = 0 Then
        
            ' Create the domain if it is missing:
            'NAME    VALUETYPE   CONTROLTYPE
            'ACTON   stringval   Drop Down

            newDmnrs.Open ATTRDOMAIN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
            
            newDmnName = MyStr
            newDmnVlTp = "stringval"
            newDmnClTp = "Drop Down"
            
            newDmnID = NextPK(ATTRDOMAIN_TBLNAME, ATTRDOMAIN_ID)
            newDmnrs.AddNew
            newDmnrs.Fields.Item(ATTRDOMAIN_ID).value = newDmnID
            newDmnrs.Fields.Item(ATTRDOMAIN_NAME).value = newDmnName
            If newDmnVlTp <> "" Then newDmnrs.Fields.Item(ATTRDOMAIN_VALUETYPE).value = ValueTypeID(newDmnVlTp)
            If newDmnClTp <> "" Then newDmnrs.Fields.Item(ATTRDOMAIN_CONTROLTYPE).value = ControlTypeId(newDmnClTp)
            If Not (newDmnrs.BOF And newDmnrs.EOF) Then newDmnrs.Update
            AttrDomainID = newDmnID
            
            newDmnrs.Close
        End If
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        DomainType = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        'Check if there is a value in the cell.value, set a flag
        If (Trim(cell.value) <> "") Then
            ratingType = Trim(cell.value)
            ratingTypeNull = False
        Else
            ratingTypeNull = True
        End If

        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        TblName = Trim(cell.value)

        ' Check for existing rows: DONE
        sqlTmp = "select * from " & EAELEMATTRDOMAIN_TABLENAME & _
                " where " & EAELEMATTRDOMAIN_TABLENAME & "." & EAELEMATTRDOMAIN_ATTRIBUTEDOMAINID & " = " & AttrDomainID & _
                " and " & EAELEMATTRDOMAIN_TABLENAME & "." & EAELEMATTRDOMAIN_DOMAINTYPE & " = " & DomainType
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(EAELEMATTRDOMAIN_ID) = ID
            rs(EAELEMATTRDOMAIN_ATTRIBUTEDOMAINID) = AttrDomainID
            rs(EAELEMATTRDOMAIN_DOMAINTYPE) = DomainType
            If Not (ratingTypeNull) Then
                    rs(EAELEMATTRDOMAIN_EARATINGTYPE) = ratingType
            End If
            rs(EAELEMATTRDOMAIN_CHARACTERISTICTABLENAME) = TblName
            ID = ID + 1
        Else
            'rsTmp(EAELEMATTRDOMAIN_ID) = ID
            'rsTmp(EAELEMATTRDOMAIN_ATTRIBUTEDOMAINID) = AttrDomainID
            'rsTmp(EAELEMATTRDOMAIN_DOMAINTYPE) = DomainType
            If Not (ratingTypeNull) Then
                    rs(EAELEMATTRDOMAIN_EARATINGTYPE) = ratingType
            End If
            rsTmp(EAELEMATTRDOMAIN_CHARACTERISTICTABLENAME) = TblName
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EAElementAttributeDomain"
    End If
    ImgElementAttrDom.Visible = True
End Sub


Private Sub LoadEAElementAttr()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim Name$, DisplayName$, AttrDomainName$, value$
    Dim ID&, EAAttrDomID&, ElementTypeID&, displayOrder&, allowedAccess&, ClassID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EAElementAttribute" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Element Attribute"
    Me.Repaint
    Set ws = Worksheets("EAElementAttribute")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAElementAttribute")
    logUpdates = GetLogUpdates("EAElementAttribute")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open EAELEMATTR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(EAELEMATTR_TABLENAME, EAELEMATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
       
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        AttrDomainName = Trim(cell.value)
        EAAttrDomID = EAAttrDomainID(AttrDomainName)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        ClassID = ClassificationID(MyStr)
        ElementTypeID = EAElementTypeID(ClassID)
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
        
        displayOrder = NULL_LONG
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If cell.value <> "" Then
            displayOrder = Trim(cell.value)
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        allowedAccess = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & EAELEMATTR_TABLENAME & _
                " where " & EAELEMATTR_TABLENAME & "." & EAELEMATTR_EAEDITELEMENTTYPEID & " = " & ElementTypeID & _
                " and " & EAELEMATTR_TABLENAME & "." & EAELEMATTR_EAEDITELEMATTRDOMAINID & " = " & EAAttrDomID & _
                " and " & EAELEMATTR_TABLENAME & "." & EAELEMATTR_NAME & " = '" & Name & "'" & _
                " and " & EAELEMATTR_TABLENAME & "." & EAELEMATTR_DISPLAYNAME & " = '" & DisplayName & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(EAELEMATTR_ID) = ID
            rs(EAELEMATTR_EAEDITELEMENTTYPEID) = ElementTypeID
            rs(EAELEMATTR_EAEDITELEMATTRDOMAINID) = EAAttrDomID
            rs(EAELEMATTR_NAME) = Name
            rs(EAELEMATTR_DISPLAYNAME) = DisplayName
            If displayOrder <> NULL_LONG Then rs(EAELEMATTR_DISPLAYORDER) = displayOrder
            rs(EAELEMATTR_ALLOWEDACCESS) = allowedAccess
            ID = ID + 1
        Else
            'rsTmp(EAELEMATTR_ID) = ID
            'rsTmp(EAELEMATTR_EAEDITELEMENTTYPEID) = ElementTypeID
            'rsTmp(EAELEMATTR_EAEDITELEMATTRDOMAINID) = EAAttrDomID
            'rsTmp(EAELEMATTR_NAME) = name
            'rsTmp(EAELEMATTR_DISPLAYNAME) = DisplayName
            If displayOrder <> NULL_LONG Then rsTmp(EAELEMATTR_DISPLAYORDER) = displayOrder
            rsTmp(EAELEMATTR_ALLOWEDACCESS) = allowedAccess
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EAElementAttribute"
    End If
    ImgElementAttr.Visible = True
End Sub
Private Sub LoadCondChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim LineType&, IsDefault&, NumPhases&, NumConductors&, RecordStatus&, CurrentRating&
    Dim PhaseCondMatRatingID&, PhaseCondSizeRatingID&, NeutCondMatRatingID&, NeutCondSizeRatingID&
    Dim LineNominalVoltageRatingID&
    Dim RatingName$, Description$, ShortDesc$, value$
    Dim PosSeqResist#, PosSeqReact#, ZeroSeqResist#, ZeroSeqReact#, LineCharging#
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "ConductorCharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Conductor Characteristic"
    Me.Repaint
    Set ws = Worksheets("ConductorCharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ConductorCharacteristic")
    logUpdates = GetLogUpdates("ConductorCharacteristic")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CONDCHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CONDCHAR_TABLENAME, CONDCHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        LineType = Trim(cell.value) 'LineTypeVal(MyStr)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsDefault = BoolStringToInt(MyStr)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        PhaseCondMatRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        PhaseCondSizeRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)
            
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        'Invalidates the NeutCondSizeRatingID before using it.
        NeutCondSizeRatingID = NULL_LONG
        If Trim(cell.value) <> "" Then
            MyNum = Trim(cell.value)
            NeutCondSizeRatingID = EARatingID(RatingName, MyNum)
        End If
            
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        'Invalidates the NeutCondMatRatingID before using it.
        NeutCondMatRatingID = NULL_LONG
        If Trim(cell.value) <> "" Then
            MyNum = Trim(cell.value)
            NeutCondMatRatingID = EARatingID(RatingName, MyNum)
        End If
                
        cellstr = "M" & ctr
        Set cell = ws.Range(cellstr)
        CurrentRating = Trim(cell.value)
            
        cellstr = "N" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqResist = Trim(cell.value)
        
        cellstr = "O" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqReact = Trim(cell.value)
        
        cellstr = "P" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqResist = Trim(cell.value)
            
        cellstr = "Q" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqReact = Trim(cell.value)
        
        cellstr = "R" & ctr
        Set cell = ws.Range(cellstr)
        LineCharging = Trim(cell.value)
        
        'DB constraint requires this to be not null, but excel has null value for it
        'Solution: if cell.value is empty, replace with 0
        cellstr = "S" & ctr
        Set cell = ws.Range(cellstr)
        RecordStatus = 0
        If Trim(cell.value) <> "" Then
            RecordStatus = Trim(cell.value)
        End If
            
        cellstr = "T" & ctr
        Set cell = ws.Range(cellstr)
        ShortDesc = Trim(cell.value)
        
        'Need to protect against null cell.value here
        'Write a 0 to DB if cell.value is empty
        cellstr = "U" & ctr
        Set cell = ws.Range(cellstr)
        NumConductors = 0
        If Trim(cell.value) <> "" Then
            NumConductors = Trim(cell.value)
        End If
        
        cellstr = "V" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        'Need to protect against null cell.value here
        cellstr = "W" & ctr
        Set cell = ws.Range(cellstr)
        LineNominalVoltageRatingID = NULL_LONG
        If Trim(cell.value) <> "" Then
            MyNum = Trim(cell.value)
            LineNominalVoltageRatingID = EARatingID(RatingName, MyNum)
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CONDCHAR_TABLENAME & _
                " where " & CONDCHAR_TABLENAME & "." & CONDCHAR_LINETYPE & " = " & LineType & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_ISDEFAULT & " = " & IsDefault & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_PHASECONDUCTORMATERIALEARID & " = " & PhaseCondMatRatingID & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_PHASECONDUCTORSIZEEARID & " = " & PhaseCondSizeRatingID & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_CONFIGURATIONDESCRIPTION & " = '" & Description & "'" & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_NOOFPHASES & " = " & NumPhases & _
                " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_CURRENTRATING & " = " & CurrentRating

        If (NeutCondSizeRatingID <> NULL_LONG) Then
            sqlTmp = sqlTmp & _
            " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_NEUTRALCONDUCTORSIZEEARID & " = " & NeutCondSizeRatingID
        Else
            sqlTmp = sqlTmp & _
            " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_NEUTRALCONDUCTORSIZEEARID & " is null"
        End If
        
        If (NeutCondMatRatingID <> NULL_LONG) Then
            sqlTmp = sqlTmp & _
            " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_NEUTRALCONDUCTORMATERIALEARID & " = " & NeutCondMatRatingID
        Else
            sqlTmp = sqlTmp & _
            " and " & CONDCHAR_TABLENAME & "." & CONDCHAR_NEUTRALCONDUCTORMATERIALEARID & " is null"
        End If
        
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(CONDCHAR_ID) = ID
            rs(CONDCHAR_LINETYPE) = LineType
            rs(CONDCHAR_ISDEFAULT) = IsDefault
            rs(CONDCHAR_PHASECONDUCTORMATERIALEARID) = PhaseCondMatRatingID
            rs(CONDCHAR_PHASECONDUCTORSIZEEARID) = PhaseCondSizeRatingID
            rs(CONDCHAR_CONFIGURATIONDESCRIPTION) = Description
            rs(CONDCHAR_NOOFPHASES) = NumPhases
            If (NeutCondSizeRatingID <> NULL_LONG) Then
                rs(CONDCHAR_NEUTRALCONDUCTORSIZEEARID) = NeutCondSizeRatingID
            End If
            If (NeutCondMatRatingID <> NULL_LONG) Then
                rs(CONDCHAR_NEUTRALCONDUCTORMATERIALEARID) = NeutCondMatRatingID
            End If
            rs(CONDCHAR_CURRENTRATING) = CurrentRating
            rs(CONDCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rs(CONDCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rs(CONDCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rs(CONDCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rs(CONDCHAR_LINECHARGING) = LineCharging
            rs(CONDCHAR_RECORDSTATUS) = RecordStatus
            rs(CONDCHAR_SHORTDESCRIPTION) = ShortDesc
            rs(CONDCHAR_NOOFCONDUCTORS) = NumConductors
            If (LineNominalVoltageRatingID <> NULL_LONG) Then
                rs(CONDCHAR_LINENOMINALVOLTAGEEARID) = LineNominalVoltageRatingID
            End If
            ID = ID + 1
        Else
            'rsTmp(CONDCHAR_ID) = ID
            'rsTmp(CONDCHAR_LINETYPE) = LineType
            'rsTmp(CONDCHAR_ISDEFAULT) = IsDefault
            'rsTmp(CONDCHAR_PHASECONDUCTORMATERIALEARID) = PhaseCondMatRatingID
            'rsTmp(CONDCHAR_PHASECONDUCTORSIZEEARID) = PhaseCondSizeRatingID
            'rsTmp(CONDCHAR_CONFIGURATIONDESCRIPTION) = Description
            'rsTmp(CONDCHAR_NOOFPHASES) = NumPhases
            'If (NeutCondSizeRatingID <> NULL_LONG) Then
            '    rsTmp(CONDCHAR_NEUTRALCONDUCTORSIZEEARID) = NeutCondSizeRatingID
            'End If
            'If (NeutCondMatRatingID <> NULL_LONG) Then
            '    rsTmp(CONDCHAR_NEUTRALCONDUCTORMATERIALEARID) = NeutCondMatRatingID
            'End If
            'rsTmp(CONDCHAR_CURRENTRATING) = CurrentRating
            rsTmp(CONDCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rsTmp(CONDCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rsTmp(CONDCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rsTmp(CONDCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rsTmp(CONDCHAR_LINECHARGING) = LineCharging
            rsTmp(CONDCHAR_RECORDSTATUS) = RecordStatus
            rsTmp(CONDCHAR_SHORTDESCRIPTION) = ShortDesc
            rsTmp(CONDCHAR_NOOFCONDUCTORS) = NumConductors
            If (LineNominalVoltageRatingID <> NULL_LONG) Then
                rsTmp(CONDCHAR_LINENOMINALVOLTAGEEARID) = LineNominalVoltageRatingID
            End If
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ConductorCharacteristic"
    End If
    ImgCondChar.Visible = True
End Sub
Private Sub LoadFuseCharRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ftrName$, ClassName$, MappedFtrName$, value$
    Dim FuseSize$, FuseType$
    Dim AttrID&, AttrRuleId&
    Dim ctr%, AddNew%
    Dim ID&, CharacteristicID&, RuleSet&, LastRuleset&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "FuseCharacteristicRules" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading fuse characteristic rules"
    Me.Repaint
    
    Set ws = Worksheets("FuseCharacteristicRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FuseCharacteristicRules")
    logUpdates = GetLogUpdates("FuseCharacteristicRules")

    ctr = 2
    LastRuleset = 0
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    Dim valE As String
    
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        FuseSize = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        FuseType = Trim(cell.value)
                
        CharacteristicID = FuseCharacteristicID(FuseSize, FuseType)
                
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        ClassName = Trim(cell.value)

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        valE = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        If RuleSet = LastRuleset Then
            AddNew = False
        Else
            AddNew = True
            If ds <> "" Then
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew, ds)
            Else
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew)
            End If
            LastRuleset = RuleSet
        End If
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MappedFtrName = Trim(cell.value)
        Else
            MappedFtrName = ftrName
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & ClassName & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & valE & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = " & AttrRuleId & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & "203" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(RULEATTR_ID).value = ID
            If ClassName <> "" Then rs.Fields.Item(RULEATTR_NAME).value = ClassName
            rs.Fields.Item(RULEATTR_VALUETYPE).value = 203
            rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttrRuleId
            If valE <> "" Then rs.Fields.Item(RULEATTR_VALUE).value = valE
            rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
            'If ClassName <> "" Then rsTmp.Fields.Item(RULEATTR_NAME).Value = ClassName
            'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = 203
            'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttrRuleId
            'If valE <> "" Then rsTmp.Fields.Item(RULEATTR_VALUE).Value = valE
            'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FuseCharacteristicRules"
    End If
End Sub

Private Sub LoadDistTranPreference()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim XFrmrType&, NumUnits&
    Dim UnitKVASizeRatingID&, BankKVASizeRatingID&
    Dim RatingName$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "DistTranPreference" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Dist Tran Preference"
    Me.Repaint
    Set ws = Worksheets("DistTranPreference")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("DistTranPreference")
    logUpdates = GetLogUpdates("DistTranPreference")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open DISTTRANPREF_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(DISTTRANPREF_TABLENAME, DISTTRANPREF_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        XFrmrType = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        NumUnits = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        UnitKVASizeRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        BankKVASizeRatingID = EARatingID(RatingName, MyNum)

        ' Check for existing rows: DONE
        sqlTmp = "select * from " & DISTTRANPREF_TABLENAME & _
                " where " & DISTTRANPREF_TABLENAME & "." & DISTTRANPREF_TRANSFORMERTYPE & " = " & XFrmrType & _
                " and " & DISTTRANPREF_TABLENAME & "." & DISTTRANPREF_NUMBEROFUNITS & " = " & NumUnits & _
                " and " & DISTTRANPREF_TABLENAME & "." & DISTTRANPREF_UNITKVASIZEEARID & " = " & UnitKVASizeRatingID & _
                " and " & DISTTRANPREF_TABLENAME & "." & DISTTRANPREF_BANKKVASIZEEARID & " = " & BankKVASizeRatingID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(DISTTRANPREF_ID) = ID
            rs(DISTTRANPREF_TRANSFORMERTYPE) = XFrmrType
            rs(DISTTRANPREF_NUMBEROFUNITS) = NumUnits
            rs(DISTTRANPREF_UNITKVASIZEEARID) = UnitKVASizeRatingID
            rs(DISTTRANPREF_BANKKVASIZEEARID) = BankKVASizeRatingID
            ID = ID + 1
        Else
            'rsTmp(DISTTRANPREF_ID) = ID
            'rsTmp(DISTTRANPREF_TRANSFORMERTYPE) = XFrmrType
            'rsTmp(DISTTRANPREF_NUMBEROFUNITS) = NumUnits
            'rsTmp(DISTTRANPREF_UNITKVASIZEEARID) = UnitKVASizeRatingID
            'rsTmp(DISTTRANPREF_BANKKVASIZEEARID) = BankKVASizeRatingID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "DistTranPreference"
    End If
    ImgDistTranPref.Visible = True
End Sub

Private Sub LoadDistTranChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim XFrmrType&, NumUnits&, IsDefault&
    Dim UnitKVASizeRatingID&, BankKVASizeRatingID&, SecVoltRatingID&
    Dim XfmrPCR#, XfmrPCX#
    Dim RatingName$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "DistTranCharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Dist Tran Characteristic"
    Me.Repaint
    Set ws = Worksheets("DistTranCharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("DistTranCharacteristic")
    logUpdates = GetLogUpdates("DistTranCharacteristic")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open DISTTRANCHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(DISTTRANCHAR_TABLENAME, DISTTRANCHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        XFrmrType = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsDefault = BoolStringToInt(MyStr)
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        NumUnits = cell.value
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        UnitKVASizeRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        BankKVASizeRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        SecVoltRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        XfmrPCR = Trim(cell.value)
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        XfmrPCX = Trim(cell.value)
    
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & DISTTRANCHAR_TABLENAME & _
                " where " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_TRANSFORMERTYPE & " = " & XFrmrType & _
                " and " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_ISDEFAULT & " = " & IsDefault & _
                " and " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_NUMBEROFUNITS & " = " & NumUnits & _
                " and " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_UNITKVASIZEEARID & " = " & UnitKVASizeRatingID & _
                " and " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_BANKKVASIZEEARID & " = " & BankKVASizeRatingID & _
                " and " & DISTTRANCHAR_TABLENAME & "." & DISTTRANCHAR_SECONDARYVOLTAGEEARID & " = " & SecVoltRatingID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(DISTTRANCHAR_ID) = ID
            rs(DISTTRANCHAR_TRANSFORMERTYPE) = XFrmrType
            rs(DISTTRANCHAR_ISDEFAULT) = IsDefault
            rs(DISTTRANCHAR_NUMBEROFUNITS) = NumUnits
            rs(DISTTRANCHAR_UNITKVASIZEEARID) = UnitKVASizeRatingID
            rs(DISTTRANCHAR_BANKKVASIZEEARID) = BankKVASizeRatingID
            rs(DISTTRANCHAR_SECONDARYVOLTAGEEARID) = SecVoltRatingID
            rs(DISTTRANCHAR_XFMRPERCENTR) = XfmrPCR
            rs(DISTTRANCHAR_XFMRPERCENTX) = XfmrPCX
            ID = ID + 1
        Else
            'rsTmp(DISTTRANCHAR_ID) = ID
            'rsTmp(DISTTRANCHAR_TRANSFORMERTYPE) = XFrmrType
            'rsTmp(DISTTRANCHAR_ISDEFAULT) = IsDefault
            'rsTmp(DISTTRANCHAR_NUMBEROFUNITS) = NumUnits
            'rsTmp(DISTTRANCHAR_UNITKVASIZEEARID) = UnitKVASizeRatingID
            'rsTmp(DISTTRANCHAR_BANKKVASIZEEARID) = BankKVASizeRatingID
            'rsTmp(DISTTRANCHAR_SECONDARYVOLTAGEEARID) = SecVoltRatingID
            rsTmp(DISTTRANCHAR_XFMRPERCENTR) = XfmrPCR
            rsTmp(DISTTRANCHAR_XFMRPERCENTX) = XfmrPCX
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "DistTranCharacteristic"
    End If
    ImgDistTranChar.Visible = True
End Sub


Private Sub LoadPowerTranChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim NumPhases&, IsDefault&
    Dim NomPriVoltRatingID&, NomSecVoltRatingID&, RatedKVASizeRatingID&
    Dim MinTapSetting#, MaxTapSetting#, IncTapSetting#
    Dim PosSeqResist#, PosSeqReact#, ZeroSeqResist#, ZeroSeqReact#
    Dim RatingName$, Desc$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "PowerTranCharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Power Tran Characteristic"
    Me.Repaint
    Set ws = Worksheets("PowerTranCharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PowerTranCharacteristic")
    logUpdates = GetLogUpdates("PowerTranCharacteristic")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open POWERTRANCHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(POWERTRANCHAR_TABLENAME, POWERTRANCHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsDefault = BoolStringToInt(MyStr)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        NomPriVoltRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        NomSecVoltRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        RatedKVASizeRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        MinTapSetting = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        MaxTapSetting = Trim(cell.value)
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        IncTapSetting = Trim(cell.value)
    
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqResist = Trim(cell.value)
        
        cellstr = "M" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqReact = Trim(cell.value)
        
        cellstr = "N" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqResist = Trim(cell.value)
        
        cellstr = "O" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqReact = Trim(cell.value)
        
        cellstr = "P" & ctr
        Set cell = ws.Range(cellstr)
        Desc = Trim(cell.value)
    
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & POWERTRANCHAR_TABLENAME & _
                " where " & POWERTRANCHAR_TABLENAME & "." & POWERTRANCHAR_ISDEFAULT & " = " & IsDefault & _
                " and " & POWERTRANCHAR_TABLENAME & "." & POWERTRANCHAR_NOOFPHASES & " = " & NumPhases & _
                " and " & POWERTRANCHAR_TABLENAME & "." & POWERTRANCHAR_NOMINALPRIMARYVOLTAGEEARID & " = " & NomPriVoltRatingID & _
                " and " & POWERTRANCHAR_TABLENAME & "." & POWERTRANCHAR_NOMINALSECONDARYVOLTAGEEARID & " = " & NomSecVoltRatingID & _
                " and " & POWERTRANCHAR_TABLENAME & "." & POWERTRANCHAR_RATEDKVASIZEEARID & " = " & RatedKVASizeRatingID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(POWERTRANCHAR_ID) = ID
            rs(POWERTRANCHAR_ISDEFAULT) = IsDefault
            rs(POWERTRANCHAR_NOOFPHASES) = NumPhases
            rs(POWERTRANCHAR_NOMINALPRIMARYVOLTAGEEARID) = NomPriVoltRatingID
            rs(POWERTRANCHAR_NOMINALSECONDARYVOLTAGEEARID) = NomSecVoltRatingID
            rs(POWERTRANCHAR_RATEDKVASIZEEARID) = RatedKVASizeRatingID
            rs(POWERTRANCHAR_MINTAPSETTING) = MinTapSetting
            rs(POWERTRANCHAR_MAXTAPSETTING) = MaxTapSetting
            rs(POWERTRANCHAR_INCREMENTALTAPSETTING) = IncTapSetting
            rs(POWERTRANCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rs(POWERTRANCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rs(POWERTRANCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rs(POWERTRANCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rs(POWERTRANCHAR_SHORTDESCRIPTION) = Desc
            ID = ID + 1
        Else
            'rsTmp(POWERTRANCHAR_ID) = ID
            'rsTmp(POWERTRANCHAR_ISDEFAULT) = IsDefault
            'rsTmp(POWERTRANCHAR_NOOFPHASES) = NumPhases
            'rsTmp(POWERTRANCHAR_NOMINALPRIMARYVOLTAGEEARID) = NomPriVoltRatingID
            'rsTmp(POWERTRANCHAR_NOMINALSECONDARYVOLTAGEEARID) = NomSecVoltRatingID
            'rsTmp(POWERTRANCHAR_RATEDKVASIZEEARID) = RatedKVASizeRatingID
            rsTmp(POWERTRANCHAR_MINTAPSETTING) = MinTapSetting
            rsTmp(POWERTRANCHAR_MAXTAPSETTING) = MaxTapSetting
            rsTmp(POWERTRANCHAR_INCREMENTALTAPSETTING) = IncTapSetting
            rsTmp(POWERTRANCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rsTmp(POWERTRANCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rsTmp(POWERTRANCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rsTmp(POWERTRANCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rsTmp(POWERTRANCHAR_SHORTDESCRIPTION) = Desc
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PowerTranCharacteristic"
    End If
    ImgPowerTranChar.Visible = True
End Sub

Private Sub LoadVoltageRegChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim NumPhases&, IsDefault&, LoadCurrent&, RegulationRange&
    Dim RatedVoltRatingID&, RatedKVASizeRatingID&
    Dim PosSeqResist#, PosSeqReact#, ZeroSeqResist#, ZeroSeqReact#
    Dim RatingName$, Desc$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "VoltageRegCharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Voltage Reg Characteristic"
    Me.Repaint
    Set ws = Worksheets("VoltageRegCharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VoltageRegCharacteristic")
    logUpdates = GetLogUpdates("VoltageRegCharacteristic")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open VOLTREGCHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(VOLTREGCHAR_TABLENAME, VOLTREGCHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsDefault = BoolStringToInt(MyStr)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        RatedVoltRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        RatedKVASizeRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        LoadCurrent = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        RegulationRange = Trim(cell.value)
    
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqResist = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        PosSeqReact = Trim(cell.value)
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqResist = Trim(cell.value)
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ZeroSeqReact = Trim(cell.value)
        
        cellstr = "M" & ctr
        Set cell = ws.Range(cellstr)
        Desc = Trim(cell.value)
    
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & VOLTREGCHAR_TABLENAME & _
                " where " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_ISDEFAULT & " = " & IsDefault & _
                " and " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_NOOFPHASES & " = " & NumPhases & _
                " and " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_RATEDVOLTAGEEARID & " = " & RatedVoltRatingID & _
                " and " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_RATEKVASIZEEARID & " = " & RatedKVASizeRatingID & _
                " and " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_LOADCURRENT & " = " & LoadCurrent & _
                " and " & VOLTREGCHAR_TABLENAME & "." & VOLTREGCHAR_REGULATIONRANGE & " = " & RegulationRange
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(VOLTREGCHAR_ID) = ID
            rs(VOLTREGCHAR_ISDEFAULT) = IsDefault
            rs(VOLTREGCHAR_NOOFPHASES) = NumPhases
            rs(VOLTREGCHAR_RATEDVOLTAGEEARID) = RatedVoltRatingID
            rs(VOLTREGCHAR_RATEKVASIZEEARID) = RatedKVASizeRatingID
            rs(VOLTREGCHAR_LOADCURRENT) = LoadCurrent
            rs(VOLTREGCHAR_REGULATIONRANGE) = RegulationRange
            rs(VOLTREGCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rs(VOLTREGCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rs(VOLTREGCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rs(VOLTREGCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rs(VOLTREGCHAR_SHORTDESCRIPTION) = Desc
            ID = ID + 1
        Else
            'rsTmp(VOLTREGCHAR_ID) = ID
            'rsTmp(VOLTREGCHAR_ISDEFAULT) = IsDefault
            'rsTmp(VOLTREGCHAR_NOOFPHASES) = NumPhases
            'rsTmp(VOLTREGCHAR_RATEDVOLTAGEEARID) = RatedVoltRatingID
            'rsTmp(VOLTREGCHAR_RATEKVASIZEEARID) = RatedKVASizeRatingID
            'rsTmp(VOLTREGCHAR_LOADCURRENT) = LoadCurrent
            'rsTmp(VOLTREGCHAR_REGULATIONRANGE) = RegulationRange
            rsTmp(VOLTREGCHAR_POSITIVESEQUENCERESISTANCE) = PosSeqResist
            rsTmp(VOLTREGCHAR_POSITIVESEQUENCEREACTANCE) = PosSeqReact
            rsTmp(VOLTREGCHAR_ZEROSEQUENCERESISTANCE) = ZeroSeqResist
            rsTmp(VOLTREGCHAR_ZEROSEQUENCEREACTANCE) = ZeroSeqReact
            rsTmp(VOLTREGCHAR_SHORTDESCRIPTION) = Desc
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VoltageRegCharacteristic"
    End If
    ImgVoltRegChar.Visible = True
End Sub


Private Sub LoadACLoadChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, RatingName$, value$
    Dim MyNum&, ID&
    Dim NumPhases&, IsDefault&, StartCurrent&
    Dim NominalVoltageRatingID&, TonRatingID&
    Dim StartPowerFactor#
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "Motorstrtcharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Motor start Characteristic"
    Me.Repaint
    Set ws = Worksheets("Motorstrtcharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Motorstrtcharacteristic")
    logUpdates = GetLogUpdates("Motorstrtcharacteristic")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open ACUNITLOADCHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(ACUNITLOADCHAR_TABLENAME, ACUNITLOADCHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
            
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsDefault = BoolStringToInt(MyStr)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        TonRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        NominalVoltageRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        StartCurrent = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
    
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        StartPowerFactor = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & ACUNITLOADCHAR_TABLENAME & _
                " where " & ACUNITLOADCHAR_TABLENAME & "." & ACUNITLOADCHAR_ISDEFAULT & " = " & IsDefault & _
                " and " & ACUNITLOADCHAR_TABLENAME & "." & ACUNITLOADCHAR_TONRATINGEARID & " = " & TonRatingID & _
                " and " & ACUNITLOADCHAR_TABLENAME & "." & ACUNITLOADCHAR_NOMINALVOLTAGEEARID & " = " & ACUNITLOADCHAR_TONRATINGEARID & _
                " and " & ACUNITLOADCHAR_TABLENAME & "." & ACUNITLOADCHAR_STARTINGCURRENT & " = " & StartCurrent & _
                " and " & ACUNITLOADCHAR_TABLENAME & "." & ACUNITLOADCHAR_NOOFPHASES & " = " & NumPhases
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(ACUNITLOADCHAR_ID) = ID
            rs(ACUNITLOADCHAR_ISDEFAULT) = IsDefault
            rs(ACUNITLOADCHAR_TONRATINGEARID) = TonRatingID
            rs(ACUNITLOADCHAR_NOMINALVOLTAGEEARID) = NominalVoltageRatingID
            rs(ACUNITLOADCHAR_STARTINGCURRENT) = StartCurrent
            rs(ACUNITLOADCHAR_NOOFPHASES) = NumPhases
            rs(ACUNITLOADCHAR_STARTINGPOWERFACTOR) = StartPowerFactor
            ID = ID + 1
        Else
            'rsTmp(ACUNITLOADCHAR_ID) = ID
            'rsTmp(ACUNITLOADCHAR_ISDEFAULT) = IsDefault
            'rsTmp(ACUNITLOADCHAR_TONRATINGEARID) = TonRatingID
            'rsTmp(ACUNITLOADCHAR_NOMINALVOLTAGEEARID) = NominalVoltageRatingID
            'rsTmp(ACUNITLOADCHAR_STARTINGCURRENT) = StartCurrent
            'rsTmp(ACUNITLOADCHAR_NOOFPHASES) = NumPhases
            rsTmp(ACUNITLOADCHAR_STARTINGPOWERFACTOR) = StartPowerFactor
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "Motorstrtcharacteristic"
    End If
    ImgACLoadChar.Visible = True
End Sub


Private Sub LoadDistTranFlickerBasedSize()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim CustomerCount&
    Dim MaxActionRatingID&, MinTranRatedKVARatingID&
    Dim RatingName$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "DistTranFlickerBasedSize" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Dist Tran Flicker Based Size"
    Me.Repaint
    Set ws = Worksheets("DistTranFlickerBasedSize")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("DistTranFlickerBasedSize")
    logUpdates = GetLogUpdates("DistTranFlickerBasedSize")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open DISTTRANFLICKER_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(DISTTRANFLICKER_TABLENAME, DISTTRANFLICKER_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
            
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CustomerCount = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        MaxActionRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        MinTranRatedKVARatingID = EARatingID(RatingName, MyNum)
    
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & DISTTRANFLICKER_TABLENAME & _
                " where " & DISTTRANFLICKER_TABLENAME & "." & DISTTRANFLICKER_CUSTOMERCOUNT & " = " & CustomerCount & _
                " and " & DISTTRANFLICKER_TABLENAME & "." & DISTTRANFLICKER_MAXACTONRATINGEARID & " = " & MaxActionRatingID & _
                " and " & DISTTRANFLICKER_TABLENAME & "." & DISTTRANFLICKER_MINTRANRATEDKVAEARID & " = " & MinTranRatedKVARatingID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(DISTTRANFLICKER_ID) = ID
            rs(DISTTRANFLICKER_CUSTOMERCOUNT) = CustomerCount
            rs(DISTTRANFLICKER_MAXACTONRATINGEARID) = MaxActionRatingID
            rs(DISTTRANFLICKER_MINTRANRATEDKVAEARID) = MinTranRatedKVARatingID
            ID = ID + 1
        Else
            'rsTmp(DISTTRANFLICKER_ID) = ID
            'rsTmp(DISTTRANFLICKER_CUSTOMERCOUNT) = CustomerCount
            'rsTmp(DISTTRANFLICKER_MAXACTONRATINGEARID) = MaxActionRatingID
            'rsTmp(DISTTRANFLICKER_MINTRANRATEDKVAEARID) = MinTranRatedKVARatingID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "DistTranFlickerBasedSize"
    End If
    ImgDistTranFlicker.Visible = True
End Sub
Private Sub LoadFuseChar()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim ContCurrent&, InteruptCurrent&
    Dim FuseSizeRatingID&, FuseTypeRatingID&
    Dim RatingName$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "FuseCharacteristic" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Fuse Characteristic"
    Me.Repaint
    Set ws = Worksheets("FuseCharacteristic")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FuseCharacteristic")
    logUpdates = GetLogUpdates("FuseCharacteristic")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open FUSECHAR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FUSECHAR_TABLENAME, FUSECHAR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        FuseSizeRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        FuseTypeRatingID = EARatingID(RatingName, MyNum)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        ContCurrent = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        InteruptCurrent = Trim(cell.value)

        ' Check for existing rows: DONE
        sqlTmp = "select * from " & FUSECHAR_TABLENAME & _
                " where " & FUSECHAR_TABLENAME & "." & FUSECHAR_FUSESIZEEARID & " = " & FuseSizeRatingID & _
                " and " & FUSECHAR_TABLENAME & "." & FUSECHAR_FUSETYPEEARID & " = " & FuseTypeRatingID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(FUSECHAR_ID) = ID
            rs(FUSECHAR_FUSESIZEEARID) = FuseSizeRatingID
            rs(FUSECHAR_FUSETYPEEARID) = FuseTypeRatingID
            rs(FUSECHAR_CONTINUOUSCURRENTRATING) = ContCurrent
            rs(FUSECHAR_INTERRUPTINGCURRENTRATING) = InteruptCurrent
            ID = ID + 1
        Else
            'rsTmp(FUSECHAR_ID) = ID
            'rsTmp(FUSECHAR_FUSESIZEEARID) = FuseSizeRatingID
            'rsTmp(FUSECHAR_FUSETYPEEARID) = FuseTypeRatingID
            rsTmp(FUSECHAR_CONTINUOUSCURRENTRATING) = ContCurrent
            rsTmp(FUSECHAR_INTERRUPTINGCURRENTRATING) = InteruptCurrent
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "FuseCharacteristic"
    End If
    ImgFuseChar.Visible = True
End Sub

Private Sub LoadCondPrefRanking()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim LineType&, Rank&
    Dim PhaseCondSizeRatingID&, PhaseCondMatRatingID&
    Dim RatingName$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "ConductorPrefRanking" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Conductor Pref Ranking"
    Me.Repaint
    Set ws = Worksheets("ConductorPrefRanking")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ConductorPrefRanking")
    logUpdates = GetLogUpdates("ConductorPrefRanking")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CONDPREFRANK_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CONDPREFRANK_TABLENAME, CONDPREFRANK_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        LineType = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Rank = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        PhaseCondSizeRatingID = EARatingID(RatingName, MyNum)
            
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatingName = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyNum = Trim(cell.value)
        PhaseCondMatRatingID = EARatingID(RatingName, MyNum)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CONDPREFRANK_TABLENAME & _
                " where " & CONDPREFRANK_TABLENAME & "." & CONDPREFRANK_PHASECONDUCTORSIZEEARID & " = " & PhaseCondSizeRatingID & _
                " and " & CONDPREFRANK_TABLENAME & "." & CONDPREFRANK_PHASECONDUCTORMATERIALEARID & " = " & PhaseCondMatRatingID & _
                " and " & CONDPREFRANK_TABLENAME & "." & CONDPREFRANK_LINETYPE & " = " & LineType
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(CONDPREFRANK_ID) = ID
            rs(CONDPREFRANK_PHASECONDUCTORSIZEEARID) = PhaseCondSizeRatingID
            rs(CONDPREFRANK_PHASECONDUCTORMATERIALEARID) = PhaseCondMatRatingID
            rs(CONDPREFRANK_LINETYPE) = LineType
            rs(CONDPREFRANK_RANK) = Rank
            ID = ID + 1
        Else
            'rsTmp(CONDPREFRANK_ID) = ID
            'rsTmp(CONDPREFRANK_PHASECONDUCTORSIZEEARID) = PhaseCondSizeRatingID
            'rsTmp(CONDPREFRANK_PHASECONDUCTORMATERIALEARID) = PhaseCondMatRatingID
            'rsTmp(CONDPREFRANK_LINETYPE) = LineType
            rsTmp(CONDPREFRANK_RANK) = Rank
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ConductorPrefRanking"
    End If
    ImgCondPref.Visible = True
End Sub

Private Sub LoadEAElementType()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$
    Dim MyNum&, ID&, ClassificationTypeID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "EAElementType" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading EA Element Type"
    Me.Repaint
    Set ws = Worksheets("EAElementType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("EAElementType")
    logUpdates = GetLogUpdates("EAElementType")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open EAELEMTYPE_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = 0
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        ClassificationTypeID = ClassificationID(MyStr)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & EAELEMTYPE_TABLENAME & _
                " where " & EAELEMTYPE_TABLENAME & "." & EAELEMTYPE_CLASSIFICATIONTYPEID & " = " & ClassificationTypeID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(EAELEMTYPE_ID) = ID
            rs(EAELEMTYPE_CLASSIFICATIONTYPEID) = ClassificationTypeID
            ID = ID + 1
        Else
            'rsTmp(EAELEMTYPE_ID) = ID
            'rsTmp(EAELEMTYPE_CLASSIFICATIONTYPEID) = ClassificationTypeID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "EAElementType"
    End If
    ImgElementType.Visible = True
End Sub
Private Sub LoadWorkRequestStates()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim Name$, IconFile$, value$
    Dim Initial%, Terminal%, NotifyWMS%, ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    
    Label2.Caption = "Loading Work Request States"
    Me.Repaint
    Set ws = Worksheets("WorkRequestStates")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WorkRequestStates")
    logUpdates = GetLogUpdates("WorkRequestStates")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    
    rs.Open WRSTATE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(WRSTATE_TBLNAME, WRSTATE_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        Terminal = BoolStringToInt(MyStr)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        NotifyWMS = BoolStringToInt(MyStr)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        IconFile = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & WRSTATE_TBLNAME & _
                " where " & WRSTATE_TBLNAME & "." & WRSTATE_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(WRSTATE_ID) = ID
            rs(WRSTATE_NAME) = Name
            rs(WRSTATE_ISTERMINAL) = Terminal
            rs(WRSTATE_NOTIFYWMS) = NotifyWMS
            rs(WRSTATE_ICONFILENAME) = IconFile
            ID = ID + 1
        Else
            'rs(WRSTATE_ID) = ID
            'rs(WRSTATE_NAME) = name
            rsTmp(WRSTATE_ISTERMINAL) = Terminal
            rsTmp(WRSTATE_NOTIFYWMS) = NotifyWMS
            rsTmp(WRSTATE_ICONFILENAME) = IconFile
            rsTmp.Update
            
            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close

    If Failure Then
        LogSheetFailure "WorkRequestStates"
    End If
    ImgWRState.Visible = True
End Sub

Private Sub LoadWorkRequestActions()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim Name$, IconFile$, value$
    Dim WREventID&, WRStateID&, displayOrder&, WkFlwID&
    Dim ctr%, IsUserVisible%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Work Request Actions"
    Me.Repaint
    Set ws = Worksheets("WorkRequestActions")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("WorkRequestActions")
    logUpdates = GetLogUpdates("WorkRequestActions")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open WRACTION_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        WRStateID = WRState(MyStr)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        WREventID = WREvent(MyStr)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        IconFile = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        displayOrder = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsUserVisible = BoolStringToInt(MyStr)
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & WRACTION_TBLNAME & _
                " where " & WRACTION_TBLNAME & "." & WRACTION_ID & " = " & ID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(WRACTION_ID) = ID
            rs(WRACTION_NAME) = Name
            If WREventID <> 0 Then rs(WRACTION_WREVENTID) = WREventID
            If WRStateID <> 0 Then rs(WRACTION_WRSTATEID) = WRStateID
            rs(WRACTION_ICONFILENAME) = IconFile
            rs(WRACTION_DISPLAYORDER) = displayOrder
            rs(WRACTION_ISUSERVISIBLE) = IsUserVisible
        Else
            'rsTmp(WRACTION_ID) = ID
            rsTmp(WRACTION_NAME) = Name
            If WREventID <> 0 Then rsTmp(WRACTION_WREVENTID) = WREventID
            If WRStateID <> 0 Then rsTmp(WRACTION_WRSTATEID) = WRStateID
            rsTmp(WRACTION_ICONFILENAME) = IconFile
            rsTmp(WRACTION_DISPLAYORDER) = displayOrder
            rsTmp(WRACTION_ISUSERVISIBLE) = IsUserVisible
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "WorkRequestActions"
    End If
    ImgWRAction.Visible = True
End Sub

Private Sub LoadStateAvailableActions()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$, LastState$, LastWorkFlow$, LastNextState$
    Dim MyNum&, WRActionID&, WRStateID&, WkFlwID&, NextStateID&, EventID&
    Dim ctr%, IsUserEnabled%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading State Available Actions"
    Me.Repaint
    Set ws = Worksheets("StateAvailableActions")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("StateAvailableActions")
    logUpdates = GetLogUpdates("StateAvailableActions")

    ctr = 2
    LastState = ""
    LastWorkFlow = ""
    LastNextState = ""
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open STATEACTION_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
               
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> LastState Then
            WRStateID = WRState(MyStr)
            LastState = MyStr
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        WRActionID = WRAction(MyStr)
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> LastWorkFlow Then
            WkFlwID = WorkFlowID(MyStr)
            LastWorkFlow = MyStr
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If MyStr <> LastNextState Then
                NextStateID = WRState(MyStr)
                LastNextState = MyStr
            End If
        Else
            NextStateID = 0
            LastNextState = ""
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        EventID = WREvent(MyStr)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        IsUserEnabled = BoolStringToInt(MyStr)
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & STATEACTION_TBLNAME & _
                " where " & STATEACTION_TBLNAME & "." & STATEACTION_WRACTION & " = " & WRActionID & _
                " and " & STATEACTION_TBLNAME & "." & STATEACTION_WRSTATE & " = " & WRStateID & _
                " and " & STATEACTION_TBLNAME & "." & STATEACTION_WORKFLOWID & " = " & WkFlwID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(STATEACTION_WRACTION) = WRActionID
            rs(STATEACTION_WRSTATE) = WRStateID
            rs(STATEACTION_WORKFLOWID) = WkFlwID
            If NextStateID <> 0 Then rs(STATEACTION_NEXTSTATEID) = NextStateID
            If EventID <> 0 Then rs(STATEACTION_EVENTID) = EventID
            rs(STATEACTION_ISUSERENABLED) = IsUserEnabled
        Else
            'rsTmp(STATEACTION_WRACTION) = WRActionID
            'rsTmp(STATEACTION_WRSTATE) = WRStateID
            'rsTmp(STATEACTION_WORKFLOWID) = WkFlwID
            If NextStateID <> 0 Then rsTmp(STATEACTION_NEXTSTATEID) = NextStateID
            If EventID <> 0 Then rsTmp(STATEACTION_EVENTID) = EventID
            rsTmp(STATEACTION_ISUSERENABLED) = IsUserEnabled
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "StateAvailableActions"
    End If
    ImgStateAction.Visible = True
End Sub
Private Sub LoadCustomWorkRequestEvents()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Custom Work Request Events"
    Me.Repaint
    Set ws = Worksheets("CustomWorkRequestEvents")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CustomWorkRequestEvents")
    logUpdates = GetLogUpdates("CustomWorkRequestEvents")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open WREVENT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
             
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
        If ID > 99 Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & WREVENT_TBLNAME & _
                    " where " & WREVENT_TBLNAME & "." & WREVENT_NAME & " = '" & Name & "'" & _
                    " and " & WREVENT_TBLNAME & "." & WREVENT_ID & " = " & ID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(WREVENT_ID) = ID
                rs(WREVENT_NAME) = Name
            Else
                'rsTmp(WREVENT_ID) = ID
                'rsTmp(WREVENT_NAME) = name
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
                
        Else
            Dim msg$
            msg = "Error: Custom WR Events must have an ID greater than 99" & vbCrLf & _
                        "ID of " & Name & " is " & ID & " so it will be skipped"
            If logdir <> "" And logfile <> "" Then
                LogMsg msg
            Else
                MsgBox msg, vbOKOnly + vbExclamation, "Invalid Custom WR Event"
            End If
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CustomWorkRequestEvents"
    End If
    ImgWREvent.Visible = True
End Sub
Private Sub LoadGroups()

    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim Name$, Description$, value$, WPTodayURL$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Groups"
    Me.Repaint
    Set ws = Worksheets("Groups")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Groups")
    logUpdates = GetLogUpdates("Groups")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open GROUP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(GROUP_TBLNAME, GROUP_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)
             
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        WPTodayURL = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & GROUP_TBLNAME & _
                " where " & GROUP_TBLNAME & "." & GROUP_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(GROUP_ID) = ID
            rs(GROUP_NAME) = Name
            rs(GROUP_DESCRIPTION) = Description
            If WPTodayURL <> "" Then rs(GROUP_WPTODAYURL) = WPTodayURL
            rs(GROUP_COMMODITYGROUPID) = groupid
            ID = ID + 1
        Else
            'rsTmp(GROUP_ID) = ID
            'rsTmp(GROUP_NAME) = name
            rsTmp(GROUP_DESCRIPTION) = Description
            If WPTodayURL <> "" Then rsTmp(GROUP_WPTODAYURL) = WPTodayURL
            rsTmp(GROUP_COMMODITYGROUPID) = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "Groups"
    End If
    ImgGroup.Visible = True
End Sub

Private Sub LoadPlantAccount()

    Dim Group$, LastGroup$, groupid&
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&, ID&
    Dim Name$, Description$, value$
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Plant Accounts"
    Me.Repaint
    Set ws = Worksheets("PlantAccount")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PlantAccount")
    logUpdates = GetLogUpdates("PlantAccount")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open PLANTACCOUNT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(PLANTACCOUNT_TBLNAME, PLANTACCOUNT_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)
    
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & PLANTACCOUNT_TBLNAME & _
                " where " & PLANTACCOUNT_TBLNAME & "." & PLANTACCOUNT_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(PLANTACCOUNT_ID) = ID
            rs(PLANTACCOUNT_NAME) = Name
            rs(PLANTACCOUNT_DESCRIPTION) = Description
            rs(PLANTACCOUNT_COMMODITYGROUPID).value = groupid
            ID = ID + 1
        Else
            'rsTmp(PLANTACCOUNT_ID) = ID
            'rsTmp(PLANTACCOUNT_NAME) = name
            rsTmp(PLANTACCOUNT_DESCRIPTION) = Description
            rsTmp(PLANTACCOUNT_COMMODITYGROUPID).value = groupid
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PlantAccount"
    End If
    ImgPlantAccount.Visible = True
End Sub

Private Sub LoadDifficultyFactor()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$, Name$
    Dim MyNum&, ID&
    Dim ctr%
    Dim val#
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Difficulty Factor"
    Me.Repaint
    Set ws = Worksheets("DifficultyFactor")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("DifficultyFactor")
    logUpdates = GetLogUpdates("DifficultyFactor")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open DIFFICULTYFACTOR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(DIFFICULTYFACTOR_TBLNAME, DIFFICULTYFACTOR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        val = Trim(cell.value)
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & DIFFICULTYFACTOR_TBLNAME & _
                " where " & DIFFICULTYFACTOR_TBLNAME & "." & DIFFICULTYFACTOR_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(DIFFICULTYFACTOR_ID) = ID
            rs(DIFFICULTYFACTOR_NAME) = Name
            rs(DIFFICULTYFACTOR_VALUE) = val
            ID = ID + 1
        Else
            'rsTmp(DIFFICULTYFACTOR_ID) = ID
            'rsTmp(DIFFICULTYFACTOR_NAME) = name
            rsTmp(DIFFICULTYFACTOR_VALUE) = val
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "DifficultyFactor"
    End If
    ImgDifficultyFactor.Visible = True
End Sub
Private Sub LoadServiceCoincidenceFactor()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$
    Dim MyNum&, ID&
    Dim CustCount&, SrvClassification&
    Dim CoincidenceFactor#
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "ServiceCoincidenceFactor" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Service Coincidence Factor"
    Me.Repaint
    Set ws = Worksheets("ServiceCoincidenceFactor")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ServiceCoincidenceFactor")
    logUpdates = GetLogUpdates("ServiceCoincidenceFactor")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open SRVCOINCFACTOR_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(SRVCOINCFACTOR_TABLENAME, SRVCOINCFACTOR_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CustCount = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        SrvClassification = ServiceClassification(MyStr)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        CoincidenceFactor = Trim(cell.value)
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & SRVCOINCFACTOR_TABLENAME & _
                " where " & SRVCOINCFACTOR_TABLENAME & "." & SRVCOINCFACTOR_CUSTOMERCOUNT & " = " & CustCount & _
                " and " & SRVCOINCFACTOR_TABLENAME & "." & SRVCOINCFACTOR_SERVICECLASSIFICATION & " = " & SrvClassification
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(SRVCOINCFACTOR_ID) = ID
            rs(SRVCOINCFACTOR_CUSTOMERCOUNT) = CustCount
            rs(SRVCOINCFACTOR_SERVICECLASSIFICATION) = SrvClassification
            rs(SRVCOINCFACTOR_COINCIDENCEFACTOR) = CoincidenceFactor
            ID = ID + 1
        Else
            'rsTmp(SRVCOINCFACTOR_ID) = ID
            'rsTmp(SRVCOINCFACTOR_CUSTOMERCOUNT) = CustCount
            'rsTmp(SRVCOINCFACTOR_SERVICECLASSIFICATION) = SrvClassification
            rsTmp(SRVCOINCFACTOR_COINCIDENCEFACTOR) = CoincidenceFactor
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ServiceCoincidenceFactor"
    End If
    ImgSrvCoincidence.Visible = True
End Sub

Private Sub LoadServiceLoadPowerFactor()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, value$
    Dim MyNum&, SrvClassification&, ID&
    Dim LoadFactor#, PowerFactor#
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "ServiceLoadPowerFactor" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading Service Power Load Factor"
    Me.Repaint
    Set ws = Worksheets("ServiceLoadPowerFactor")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ServiceLoadPowerFactor")
    logUpdates = GetLogUpdates("ServiceLoadPowerFactor")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open SRVLOADPOWER_TABLENAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(SRVLOADPOWER_TABLENAME, SRVLOADPOWER_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
            
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        SrvClassification = ServiceClassification(MyStr)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        LoadFactor = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        PowerFactor = Trim(cell.value)
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & SRVLOADPOWER_TABLENAME & _
                " where " & SRVLOADPOWER_TABLENAME & "." & SRVLOADPOWER_SERVICECLASSIFICATION & " = " & SrvClassification
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(SRVLOADPOWER_ID) = ID
            rs(SRVLOADPOWER_SERVICECLASSIFICATION) = SrvClassification
            rs(SRVLOADPOWER_LOADFACTOR) = LoadFactor
            rs(SRVLOADPOWER_POWERFACTOR) = PowerFactor
            rs.Update
            ID = ID + 1
        Else
            'rsTmp(SRVLOADPOWER_ID) = ID
            'rsTmp(SRVLOADPOWER_SERVICECLASSIFICATION) = SrvClassification
            rsTmp(SRVLOADPOWER_LOADFACTOR) = LoadFactor
            rsTmp(SRVLOADPOWER_POWERFACTOR) = PowerFactor
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ServiceLoadPowerFactor"
    End If
    ImgSrvPowerFactor.Visible = True
End Sub


Private Sub LoadUserGroupAssignments()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim User$, Group$, value$, LastUser$, LastGroup$
    Dim UserID&, groupid&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading User Group Assignments"
    Me.Repaint
    Set ws = Worksheets("UserGroupAssignment")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("UserGroupAssignment")
    logUpdates = GetLogUpdates("UserGroupAssignment")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    LastUser = ""
    LastGroup = ""
        
    rs.Open USERGROUP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        User = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
         
        If LastUser <> User Then
            UserID = UserIDForName(User)
            LastUser = User
        End If
        If LastGroup <> Group Then
            groupid = GroupIDForName(Group)
            LastGroup = Group
        End If
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & USERGROUP_TBLNAME & _
                " where " & USERGROUP_TBLNAME & "." & USERGROUP_GROUPID & " = " & groupid & _
                " and " & USERGROUP_TBLNAME & "." & USERGROUP_USERID & " = " & UserID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(USERGROUP_GROUPID) = groupid
            rs(USERGROUP_USERID) = UserID
        Else
            'rsTmp(USERGROUP_GROUPID) = GroupID
            'rsTmp(USERGROUP_USERID) = UserID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "UserGroupAssignment"
    End If
    ImgUserGrp.Visible = True
End Sub

Private Sub LoadCUPAAssignments()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim CU$, PA$, value$
    Dim LastCU$, LastPA$
    Dim CompUnitID&, PAID&, ID&, AssignmentType&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False

    Label2.Caption = "Loading Plant Account CU Assignments"
    Me.Repaint
    Set ws = Worksheets("CUPlantAccountAssign")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CUPlantAccountAssign")
    logUpdates = GetLogUpdates("CUPlantAccountAssign")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    LastCU = ""
    LastPA = ""
    
    rs.Open CUPAASSIGN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CUPAASSIGN_TBLNAME, CUPAASSIGN_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CU = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        PA = Trim(cell.value)
         
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        AssignmentType = GetPAAssignmentType(Trim(cell.value))
         
        If CU <> LastCU Then
            CompUnitID = CUID(CU)
            LastCU = CU
        End If
        If PA <> LastPA Then
            PAID = GetPlantAccountID(PA)
            LastPA = PA
        End If
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CUPAASSIGN_TBLNAME & _
                " where " & CUPAASSIGN_TBLNAME & "." & CUPAASSIGN_CUID & " = " & CompUnitID & _
                " and " & CUPAASSIGN_TBLNAME & "." & CUPAASSIGN_PAID & " = " & PAID & _
                " and " & CUPAASSIGN_TBLNAME & "." & CUPAASSIGN_ASSIGNMENTTYPE & " = " & AssignmentType
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(CUPAASSIGN_ID) = ID
            rs(CUPAASSIGN_CUID) = CompUnitID
            rs(CUPAASSIGN_PAID) = PAID
            rs(CUPAASSIGN_ASSIGNMENTTYPE) = AssignmentType
            ID = ID + 1
        Else
            'rsTmp(CUPAASSIGN_ID) = ID
            'rsTmp(CUPAASSIGN_CUID) = CompUnitID
            'rsTmp(CUPAASSIGN_PAID) = PAID
            'rsTmp(CUPAASSIGN_ASSIGNMENTTYPE) = AssignmentType
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CUPlantAccountAssign"
    End If
    ImgPACUAssign.Visible = True
End Sub
Private Sub LoadGroupCapabilityAssignments()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    Dim MyNum&
    Dim Capability$, Group$, value$, LastGroup$, LastCapability$
    Dim CapabilityID&, groupid&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Group Capability Assignments"
    Me.Repaint
    Set ws = Worksheets("GroupCapabilityAssignment")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("GroupCapabilityAssignment")
    logUpdates = GetLogUpdates("GroupCapabilityAssignment")

    ctr = 2
    LastGroup = ""
    LastCapability = ""
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open GROUPCAPABILITY_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
            
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Capability = Trim(cell.value)
         
        If LastCapability <> Capability Then
            CapabilityID = CapabilityIDForName(Capability)
            LastCapability = Capability
        End If
        If LastGroup <> Group Then
            groupid = GroupIDForName(Group)
            LastGroup = Group
        End If
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & GROUPCAPABILITY_TBLNAME & _
                " where " & GROUPCAPABILITY_TBLNAME & "." & GROUPCAPABILITY_GROUPID & " = " & groupid & _
                " and " & GROUPCAPABILITY_TBLNAME & "." & GROUPCAPABILITY_CAPABILITYID & " = " & CapabilityID
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(GROUPCAPABILITY_GROUPID) = groupid
            rs(GROUPCAPABILITY_CAPABILITYID) = CapabilityID
        Else
            'rsTmp(GROUPCAPABILITY_GROUPID) = GroupID
            'rsTmp(GROUPCAPABILITY_CAPABILITYID) = CapabilityID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "GroupCapabilityAssignment"
    End If
    ImgGrpCapability.Visible = True
End Sub
Private Sub LoadRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range, rg As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim value$, CompUnitCUID$, FtrTblName$, attrName$, LastFtrName$, LastClassCode$, LastRuleName$
    Dim ctr%
    Dim ID&, RuleSet&, LastRuleset&, AttributeRuleID&, valueType&, AttrID&, FtrTypeID&
    Dim Quantity&
    Dim ClassCdID&, CompUnitID&
    Dim CCName$, RuleName$, RuleValue$, LastCU$
    Dim progress%, lastpos%, ChangedFtr%, ChangedAttr%
    Dim count&, rowtotal&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False

    Label2.Caption = "Loading Unit Rules"
    Me.Repaint
    
    Set ws = Worksheets("AttributeRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("AttributeRules")
    logUpdates = GetLogUpdates("AttributeRules")

    Set rg = ws.UsedRange
    rowtotal = rg.Rows.count - rg.row + 1
    'prog.Value = 0
    lastpos = 0
    count = 0
    
    LastFtrTypeID = NULL_LONG
    LastFtrName = ""
    LastClassCode = ""
    LastCU = ""
    LastRuleName = ""
    
    ctr = 2
    Set cell = ws.Range("A2")
    FtrTblName = Trim(cell.value)
        
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While FtrTblName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""

        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)

        If LastFtrName <> FtrTblName Then
            If ds <> "" Then
                FtrTypeID = FeatureTypeID(FtrTblName, ds)
            Else
                FtrTypeID = FeatureTypeID(FtrTblName)
            End If
            LastFtrName = FtrTblName
            ChangedFtr = True
        Else
            ChangedFtr = False
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        CompUnitCUID = Trim(cell.value)
        If CompUnitCUID <> LastCU Then
            CompUnitID = CUID(CompUnitCUID)
            LastCU = CompUnitCUID
        End If

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        CCName = Trim(cell.value)
        If LastClassCode <> CCName Then
            ClassCdID = ClassCodeId(CCName)
            LastClassCode = CCName
        End If

        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
             Quantity = MyStr
        End If
            
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> LastRuleName Then
            RuleName = MyStr
            LastRuleName = RuleName
            ChangedAttr = True
        Else
            ChangedAttr = False
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
             RuleValue = MyStr
        End If
        
        If ChangedFtr Or ChangedAttr Then
            AttrID = AttrIdFromInternalNameAndFtrTypeID(RuleName, FtrTypeID)
        End If
                
        cellstr = ErrorCol & ctr
        Set cell = ws.Range(cellstr)
    
        If ValidateRuleValue(FtrTypeID, AttrID, RuleValue, valueType) Then
                    
            If RuleSet <> LastRuleset Then
                AttributeRuleID = AttributeRuleIdFromFtrTypeAndCuId(FtrTypeID, _
                                                            CompUnitID, ClassCdID, True, Quantity)
                LastRuleset = RuleSet
            End If
                      
            If AttributeRuleID <> NULL_LONG Then
        
                ' Check for existing rows: DONE
                sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                        " where " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = '" & AttributeRuleID & "'" & _
                        " and " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & RuleName & "'" & _
                        " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & RuleValue & "'" & _
                        " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & valueType & _
                        " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrID
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs.Fields.Item(RULEATTR_ID).value = ID
                    rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttributeRuleID
                    rs.Fields.Item(RULEATTR_NAME).value = RuleName
                    rs.Fields.Item(RULEATTR_VALUE).value = RuleValue
                    rs.Fields.Item(RULEATTR_VALUETYPE).value = valueType
                    rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrID
                    ID = ID + 1
                Else
                    'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
                    'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttributeRuleID
                    'rsTmp.Fields.Item(RULEATTR_NAME).Value = RuleName
                    'rsTmp.Fields.Item(RULEATTR_VALUE).Value = RuleValue
                    'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = ValueType
                    'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrID
                    'rsTmp.Update

                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing row"
                        Failure = True
                    End If
                End If
                rsTmp.Close
            
            Else
                'Mark the failure in the spreadsheet
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Couldn't create a CU Rule for this Feature Type and CU"
                Failure = True
            End If ' if (AttributeRuleID <> NULL_LONG)
        Else
            If (valueType = NULL_LONG) Then
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "Can't find a valid ValueType for this attribute"
            Else
                'Mark the failure in the spreadsheet
                cell.Font.Color = RGB(255, 0, 0)
                Failure = True
                cell.value = "This value is not valid for this attribute"
            End If ' of condition (ValueType = null_value)
        End If 'of  ValidateRuleValue(FtrTypeID, RuleName, RuleValue, AttrID)
            
        count = count + 1
        progress = (count / rowtotal) * 100
        If lastpos < progress Then
            If progress Mod 5 = 0 Then
                'prog.Value = progress
                'lastpos = prog.Value
            End If
        End If
        
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        FtrTblName = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "AttributeRules"
    End If
    ImgUnitRule.Visible = True
End Sub

Private Sub LoadCondCharRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ftrName$, ClassName$, MappedFtrName$, value$
    Dim PhaseCondMaterial$, PhaseCondSize$, NeutCondMaterial$, NeutCondSize$
    Dim AttrID&, LineType&, NumPhases&, AttributeRuleID&
    Dim ctr%, AddNew%
    Dim ID&, CharacteristicID&, RuleSet&, LastRuleset&
    Dim valI$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "ConductorCharacteristicRules" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading conductor characteristic rules"
    Me.Repaint
    
    Set ws = Worksheets("ConductorCharacteristicRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ConductorCharacteristicRules")
    logUpdates = GetLogUpdates("ConductorCharacteristicRules")
    
    ctr = 2
    LastRuleset = 0
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        LineType = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        PhaseCondMaterial = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        PhaseCondSize = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        NeutCondMaterial = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        NeutCondSize = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
                
        CharacteristicID = ConductorCharacteristicID(LineType, PhaseCondMaterial, PhaseCondSize, _
                                                                            NeutCondMaterial, NeutCondSize, NumPhases)
                
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ClassName = Trim(cell.value)
        End If
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            valI = Trim(cell.value)
        End If
                
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        If RuleSet = LastRuleset Then
            AddNew = False
        Else
            AddNew = True
            If ds <> "" Then
                AttributeRuleID = EAAttributeRuleID(ftrName, CharacteristicID, AddNew, ds)
            Else
                AttributeRuleID = EAAttributeRuleID(ftrName, CharacteristicID, AddNew)
            End If
            LastRuleset = RuleSet
        End If
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MappedFtrName = Trim(cell.value)
        Else
            MappedFtrName = ftrName
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & ClassName & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & valI & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = " & AttributeRuleID & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & "203" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(RULEATTR_ID).value = ID
            If ClassName <> "" Then rs.Fields.Item(RULEATTR_NAME).value = ClassName
            If valI <> "" Then rs.Fields.Item(RULEATTR_VALUE).value = valI
            rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttributeRuleID
            rs.Fields.Item(RULEATTR_VALUETYPE).value = 203
            rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
            'If ClassName <> "" Then rsTmp.Fields.Item(RULEATTR_NAME).Value = ClassName
            'If valI <> "" Then rsTmp.Fields.Item(RULEATTR_VALUE).Value = valI
            'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttributeRuleID
            'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = 203
            'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
    
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ConductorCharacteristicRules"
    End If
End Sub

Private Sub LoadDistTranCharRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ftrName$, ClassName$, MappedFtrName$, value$, BankKVASize$
    Dim UnitKVASize$, SecondaryVoltage$
    Dim AttrID&, TransformerType&, NumUnits&, AttrRuleId&
    Dim ctr%, AddNew%
    Dim ID&, CharacteristicID&, RuleSet&, LastRuleset&
    Dim valF$, valG$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "DistTransCharacteristicRules" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading distribution transformer characteristic rules"
    Me.Repaint
    
    Set ws = Worksheets("DistTransCharacteristicRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("DistTransCharacteristicRules")
    logUpdates = GetLogUpdates("DistTransCharacteristicRules")

    ctr = 2
    LastRuleset = 0
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        TransformerType = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        UnitKVASize = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        SecondaryVoltage = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        NumUnits = Trim(cell.value)
                
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        BankKVASize = Trim(cell.value)
        
        CharacteristicID = DistTransCharacteristicID(TransformerType, UnitKVASize, _
                                                        SecondaryVoltage, NumUnits, BankKVASize)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ClassName = Trim(cell.value)
            valF = ClassName
        Else
            valF = ""
        End If
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        valG = Trim(cell.value)
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        If RuleSet = LastRuleset Then
            AddNew = False
        Else
            AddNew = True
            If ds <> "" Then
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew, ds)
            Else
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew)
            End If
            LastRuleset = RuleSet
        End If
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MappedFtrName = Trim(cell.value)
        Else
            MappedFtrName = ftrName
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & valF & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & valG & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = " & AttrRuleId & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & "203" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(RULEATTR_ID).value = ID
            If valF <> "" Then rs.Fields.Item(RULEATTR_NAME).value = valF
            If valG <> "" Then rs.Fields.Item(RULEATTR_VALUE).value = valG
            rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttrRuleId
            rs.Fields.Item(RULEATTR_VALUETYPE).value = 203
            rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
            'If valF <> "" Then rsTmp.Fields.Item(RULEATTR_NAME).Value = valF
            'If valG <> "" Then rsTmp.Fields.Item(RULEATTR_VALUE).Value = valG
            'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttrRuleId
            'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = 203
            'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "DistTransCharacteristicRules"
    End If
End Sub

Private Sub LoadVoltageRegCharRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ftrName$, ClassName$, MappedFtrName$, value$
    Dim RatedKVASize$, RatedVoltage$
    Dim AttrID&, LoadCurrent&, RegulationRange&, NumPhases&, AttrRuleId&
    Dim ctr%, AddNew%
    Dim ID&, CharacteristicID&, RuleSet&, LastRuleset&
    Dim valH$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "VoltageRegCharacteristicRules" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading voltage regulator characteristic rules"
    Me.Repaint
    
    Set ws = Worksheets("VoltageRegCharacteristicRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("VoltageRegCharacteristicRules")
    logUpdates = GetLogUpdates("VoltageRegCharacteristicRules")

    ctr = 2
    LastRuleset = 0
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        LoadCurrent = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RatedKVASize = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        RatedVoltage = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
                
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RegulationRange = Trim(cell.value)
                
        CharacteristicID = VoltageRegCharacteristicID(LoadCurrent, RegulationRange, RatedKVASize, _
                                                                            RatedVoltage, NumPhases)
                
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ClassName = Trim(cell.value)
        Else
            ClassName = ""
        End If
                
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        valH = Trim(cell.value)
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        If RuleSet = LastRuleset Then
            AddNew = False
        Else
            AddNew = True
            If ds <> "" Then
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew, ds)
            Else
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew)
            End If
            LastRuleset = RuleSet
        End If
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MappedFtrName = Trim(cell.value)
        Else
            MappedFtrName = ftrName
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & ClassName & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & valH & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = " & AttrRuleId & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & "203" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(RULEATTR_ID).value = ID
            If ClassName <> "" Then rs.Fields.Item(RULEATTR_NAME).value = ClassName
            If valH <> "" Then rs.Fields.Item(RULEATTR_VALUE).value = valH
            rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttrRuleId
            rs.Fields.Item(RULEATTR_VALUETYPE).value = 203
            rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
            'If ClassName <> "" Then rsTmp.Fields.Item(RULEATTR_NAME).Value = ClassName
            'If valH <> "" Then rsTmp.Fields.Item(RULEATTR_VALUE).Value = valH
            'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttrRuleId
            'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = 203
            'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "VoltageRegCharacteristicRules"
    End If
End Sub

Private Sub LoadPowerTransCharRuleAttributes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ftrName$, ClassName$, MappedFtrName$, value$
    Dim RatedKVASize$, PrimaryVoltage$, SecondaryVoltage$
    Dim AttrID&, NumPhases&, AttrRuleId&
    Dim MinTapSetting#, MaxTapSetting#
    Dim ctr%, AddNew%
    Dim ID&, CharacteristicID&, RuleSet&, LastRuleset&
    Dim valI$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' If tab does not exist, exit sub
    Dim CurSheet As Worksheet
    Dim HaveSheet As Boolean
    HaveSheet = False
    For Each CurSheet In Application.Worksheets
        If CurSheet.Name = "PowerTransCharacteristicRules" Then
            HaveSheet = True
            Exit For
        End If
    Next CurSheet
    If Not HaveSheet Then
        Exit Sub
    End If
    
    Label2.Caption = "Loading power transformer characteristic rules"
    Me.Repaint
    
    Set ws = Worksheets("PowerTransCharacteristicRules")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PowerTransCharacteristicRules")
    logUpdates = GetLogUpdates("PowerTransCharacteristicRules")

    ctr = 2
    LastRuleset = 0
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open RULEATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RULEATTR_TBLNAME, RULEATTR_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "L" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ftrName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MinTapSetting = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MaxTapSetting = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        RatedKVASize = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        PrimaryVoltage = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        SecondaryVoltage = Trim(cell.value)
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        NumPhases = Trim(cell.value)
                
        CharacteristicID = PowerTransCharacteristicID(MinTapSetting, MaxTapSetting, RatedKVASize, _
                                                                                PrimaryVoltage, SecondaryVoltage, NumPhases)
                
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ClassName = Trim(cell.value)
        Else
            ClassName = ""
        End If
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        valI = Trim(cell.value)
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        RuleSet = Trim(cell.value)
        If RuleSet = LastRuleset Then
            AddNew = False
        Else
            AddNew = True
            If ds <> "" Then
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew, ds)
            Else
                AttrRuleId = EAAttributeRuleID(ftrName, CharacteristicID, AddNew)
            End If
            LastRuleset = RuleSet
        End If
        
        cellstr = "K" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MappedFtrName = Trim(cell.value)
        Else
            MappedFtrName = ftrName
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & RULEATTR_TBLNAME & _
                " where " & RULEATTR_TBLNAME & "." & RULEATTR_NAME & " = '" & ClassName & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUE & " = '" & valI & "'" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_ATTRRULEID & " = " & AttrRuleId & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_VALUETYPE & " = " & "203" & _
                " and " & RULEATTR_TBLNAME & "." & RULEATTR_FTRATTRID & " = " & AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(RULEATTR_ID).value = ID
            If ClassName <> "" Then rs.Fields.Item(RULEATTR_NAME).value = ClassName
            If valI <> "" Then rs.Fields.Item(RULEATTR_VALUE).value = valI
            rs.Fields.Item(RULEATTR_ATTRRULEID).value = AttrRuleId
            rs.Fields.Item(RULEATTR_VALUETYPE).value = 203
            rs.Fields.Item(RULEATTR_FTRATTRID).value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(RULEATTR_ID).Value = ID
            'If ClassName <> "" Then rsTmp.Fields.Item(RULEATTR_NAME).Value = ClassName
            'If valI <> "" Then rsTmp.Fields.Item(RULEATTR_VALUE).Value = valI
            'rsTmp.Fields.Item(RULEATTR_ATTRRULEID).Value = AttrRuleId
            'rsTmp.Fields.Item(RULEATTR_VALUETYPE).Value = 203
            'rsTmp.Fields.Item(RULEATTR_FTRATTRID).Value = AttrIDFromClassificationAndFtrType(MappedFtrName, ClassName, ds)
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PowerTransCharacteristicRules"
    End If
    ImgCharRules.Visible = True
End Sub
Private Sub LoadClassificationTypes()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim value$, FtrTbl$, ClassType$, parentClassification$, currentName$, sql$, LastParent$
    Dim ctr%, numOfEntry%
    Dim ID&, ParentID&, currentID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading classification types"
    Me.Repaint
    Set ws = Worksheets("ClassificationTypes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ClassificationTypes")
    logUpdates = GetLogUpdates("ClassificationTypes")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    LastParent = ""
        
    rs.Open CLASSTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CLASSTYPE_TBLNAME, CLASSTYPE_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ClassType = Trim(cell.value)
        Else
            ClassType = ""
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CLASSTYPE_TBLNAME & _
                " where " & CLASSTYPE_TBLNAME & "." & CLASSTYPE_NAME & " = '" & ClassType & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(CLASSTYPE_ID).value = ID
            If ClassType <> "" Then rs.Fields.Item(CLASSTYPE_NAME).value = ClassType
            rs.Update
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(CLASSTYPE_ID).Value = ID
            'If ClassType <> "" Then rsTmp.Fields.Item(CLASSTYPE_NAME).Value = ClassType
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'This would only work if the parent ID has already been loaded into the database
        'cellStr = "B" & ctr
        'Set cell = ws.Range(cellStr)
        'If Trim(cell.value) <> "" Then
        '    If ClassType = Trim(cell.value) Then
        '        'If the NAME equals PARENT CLASSIFCATION, then update w/ your own ID
        '        rs.Fields.Item(CLASSTYPE_PARENTID).value = rs.Fields.Item(CLASSTYPE_ID).value
        '    Else
        '        'if they are not equal, go find it. However, it can only find it if it's been loaded.
        '        rs.Fields.Item(CLASSTYPE_PARENTID).value = ClassificationID(Trim(cell.value))
        '    End If
        'End If
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
        
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Perform a second loop to update the Parent Classification
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    numOfEntry = ctr - 1
    ctr = 2
    
    'Loops till the end of the spread sheet
    Do While ctr <= numOfEntry
                        
        'Get the value from the spreadsheet
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        currentName = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        parentClassification = Trim(cell.value)
        
        'If there is a PARENT CLASSIFICATION, look up its ID and update the DB
        If (parentClassification <> "") Then
            'Find the ID
            currentID = ClassificationID(currentName)
            If LastParent <> parentClassification Then
                ParentID = ClassificationID(parentClassification)
                LastParent = parentClassification
            End If
            
            'Update to the Data base
            sql = "Select " & CLASSTYPE_ID & ", " & CLASSTYPE_PARENTID & " From " & CLASSTYPE_TBLNAME & " Where " & CLASSTYPE_ID & " = " & currentID
            rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
            rs.Fields.Item(CLASSTYPE_PARENTID).value = ParentID
            rs.Update
            rs.Close
        End If
        
        ctr = ctr + 1
    
    Loop
    
    If Failure Then
        LogSheetFailure "ClassificationTypes"
    End If
    ImgClassTypes.Visible = True
End Sub
Private Sub LoadConfigurationSettings()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim value$, parentName$, SettingName$, valueType$, Description$, LastParent$
    Dim ctr%, BadData%
    Dim ID&, ParentID&, ADOType&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading configuration settings"
    Me.Repaint
    Set ws = Worksheets("ConfigurationSetting")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ConfigurationSetting")
    logUpdates = GetLogUpdates("ConfigurationSetting")

    ctr = 2
    LastParent = ""
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)

    rs.Open CONFIGSETTING_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CONFIGSETTING_TBLNAME, CONFIGSETTING_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        BadData = False

        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        SettingName = Trim(cell.value)

        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        parentName = Trim(cell.value)
        If parentName <> "" Then
            If parentName <> LastParent Then
                ParentID = ConfigSettingID(parentName)
                LastParent = parentName
            End If
            If ParentID = NULL_LONG Then BadData = True
        Else
            ParentID = NULL_LONG
            LastParent = ""
        End If

        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Description = Trim(cell.value)

        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)

        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        valueType = Trim(cell.value)
        ADOType = ADOValueType(valueType)

        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)

        If Not BadData Then
        
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & CONFIGSETTING_TBLNAME & _
                    " where " & CONFIGSETTING_TBLNAME & "." & CONFIGSETTING_NAME & " = '" & SettingName & "'"
            If ParentID <> NULL_LONG Then
                sqlTmp = sqlTmp & _
                " and " & CONFIGSETTING_TBLNAME & "." & CONFIGSETTING_PARENTID & " = " & ParentID
            Else
                sqlTmp = sqlTmp & _
                " and " & CONFIGSETTING_TBLNAME & "." & CONFIGSETTING_PARENTID & " is null"
            End If
                    
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(CONFIGSETTING_ID).value = ID
                If ParentID <> NULL_LONG Then rs.Fields.Item(CONFIGSETTING_PARENTID).value = ParentID
                rs.Fields.Item(CONFIGSETTING_NAME).value = SettingName
                rs.Fields.Item(CONFIGSETTING_DESCRIPTION).value = Description
                rs.Fields.Item(CONFIGSETTING_VALUETYPE).value = ADOType
                If CStr(value) <> "" Then
                    Select Case ADOType
                        Case 7
                            rs.Fields.Item(CONFIGSETTING_DATEVALUE).value = CDate(value)
                        Case 3
                            rs.Fields.Item(CONFIGSETTING_LONGVALUE).value = CLng(value)
                        Case 5
                            rs.Fields.Item(CONFIGSETTING_FLOATVALUE).value = CDbl(value)
                        Case Else
                            rs.Fields.Item(CONFIGSETTING_STRINGVALUE).value = value
                    End Select
                End If
                rs.Update
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(CONFIGSETTING_ID).Value = ID
                'If ParentID <> NULL_LONG Then rsTmp.Fields.Item(CONFIGSETTING_PARENTID).Value = ParentID
                'rsTmp.Fields.Item(CONFIGSETTING_NAME).Value = SettingName
                rsTmp.Fields.Item(CONFIGSETTING_DESCRIPTION).value = Description
                rsTmp.Fields.Item(CONFIGSETTING_VALUETYPE).value = ADOType
                If CStr(value) <> "" Then
                    Select Case ADOType
                        Case 7
                            rsTmp.Fields.Item(CONFIGSETTING_DATEVALUE).value = CDate(value)
                        Case 3
                            rsTmp.Fields.Item(CONFIGSETTING_LONGVALUE).value = CLng(value)
                        Case 5
                            rsTmp.Fields.Item(CONFIGSETTING_FLOATVALUE).value = CDbl(value)
                        Case Else
                            rsTmp.Fields.Item(CONFIGSETTING_STRINGVALUE).value = value
                    End Select
                End If
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        Else
            'Mark the failure in the spreadsheet
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find parent setting"
        End If
        ctr = ctr + 1

        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ConfigurationSetting"
    End If
    ImgConfig.Visible = True
End Sub
Private Sub LoadClassifications()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim value$, FtrTbl$, LastFtr$, LastClass$
    Dim ctr%
    Dim AttrID&, ID&, FtrTypeID&, ClassTypeID&
    Dim valB$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    Label2.Caption = "Loading feature classifications"
    Me.Repaint
    Set ws = Worksheets("ClassificationAssignments")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ClassificationAssignments")
    logUpdates = GetLogUpdates("ClassificationAssignments")
    
    ctr = 2
    value = Trim(ws.Range(("A" & ctr)).value)
    
    LastClass = ""
    LastFtr = ""
        
    rs.Open CLASSASSIGN_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CLASSASSIGN_TBLNAME, CLASSASSIGN_ID)
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If value <> LastClass Then
            LastClass = value
            ClassTypeID = ClassificationID(value)
        End If
    
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        FtrTbl = Trim(cell.value)

        ' FeatureClass
        ' If feature class, locate all feature types that inherit from it:
        ' If feature type, just add to array:
        Dim aFtr() As String
        Dim cFtr As Integer
        Dim iFtr As Integer
        cFtr = 0
        ReDim Preserve aFtr(cFtr)
        If IsFtrCls(FtrTbl) Then
            GetFtrTypes FtrTbl, aFtr, cFtr
        Else
            ReDim Preserve aFtr(cFtr)
            aFtr(cFtr) = FtrTbl
            cFtr = cFtr + 1
        End If
        
        ' Process array of feature types:
        For iFtr = LBound(aFtr) To UBound(aFtr)
            FtrTbl = aFtr(iFtr)
        
                
            cellstr = "D" & ctr
            Set cell = ws.Range(cellstr)
            ds = Trim(cell.value)
            
            If FtrTbl <> LastFtr Then
                If ds <> "" Then
                    FtrTypeID = FeatureTypeID(FtrTbl, ds)
                Else
                    FtrTypeID = FeatureTypeID(FtrTbl)
                End If
                LastFtr = FtrTbl
            End If
            
            valB = Trim(ws.Range(("B" & ctr)).value)
            Label2.Caption = "Classfication Assign: " & FtrTbl & ">" & valB
            Me.Repaint
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & CLASSASSIGN_TBLNAME & _
                    " where " & CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_CLASSTYPEID & " = " & ClassTypeID
            If valB <> "" Then
                If FtrTypeID = 0 Then FtrTypeID = NULL_LONG
                AttrID = AttrIdFromNameAndFtrTypeID(valB, FtrTypeID)
                If AttrID <> 0 Then
                    sqlTmp = sqlTmp & _
                    " and " & CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_FTRATTRID & " = " & AttrID
                End If
            Else
                sqlTmp = sqlTmp & _
                " and " & CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_FTRTYPEID & " = " & FtrTypeID
            End If
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(CLASSASSIGN_ID).value = ID
                rs.Fields.Item(CLASSASSIGN_CLASSTYPEID).value = ClassTypeID
                If valB <> "" Then
                    If FtrTypeID = 0 Then FtrTypeID = NULL_LONG
                    AttrID = AttrIdFromNameAndFtrTypeID(valB, FtrTypeID)
                    If AttrID <> 0 Then
                        rs.Fields.Item(CLASSASSIGN_FTRATTRID).value = AttrID
                    End If
                Else
                    rs.Fields.Item(CLASSASSIGN_FTRTYPEID).value = FtrTypeID
                End If
                rs.Update
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(CLASSASSIGN_ID).Value = ID
                'rsTmp.Fields.Item(CLASSASSIGN_CLASSTYPEID).Value = ClassTypeID
                'If valB <> "" Then
                '    If FtrTypeID = 0 Then FtrTypeID = NULL_LONG
                '    AttrID = AttrIdFromNameAndFtrTypeID(valB, FtrTypeID)
                '    If AttrID <> 0 Then
                '        rsTmp.Fields.Item(CLASSASSIGN_FTRATTRID).Value = AttrID
                '    End If
                'Else
                '    rsTmp.Fields.Item(CLASSASSIGN_FTRTYPEID).Value = FtrTypeID
                'End If
                'rsTmp.Update
    
                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        
        Next iFtr
        
        ctr = ctr + 1
        value = Trim(ws.Range(("A" & ctr)).value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ClassificationAssignments"
    End If
    ImgClassAssign.Visible = True
End Sub
Private Sub LoadFeatureStateTransitions()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim value$, FtrTbl$, LastFtr$, LastPrev$, LastNext$
    Dim ctr%, IsInitial%, IsTerminal%, badNext%, badPrev%
    Dim ID&, StateId&, NextStateID&, PrevStateID&, FtrTypeID&, LastPrevID&, LastNextID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    LastFtr = ""
    LastPrev = ""
    LastNext = ""
    
    Label2.Caption = "Loading feature state transitions"
    Me.Repaint
    Set ws = Worksheets("featurestatetransitions")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("featurestatetransitions")
    logUpdates = GetLogUpdates("featurestatetransitions")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open FTRSTATETRANS_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        StateId = NULL_LONG
        PrevStateID = NULL_LONG
        NextStateID = NULL_LONG
        IsInitial = 0
        IsTerminal = 0
        badNext = False
        badPrev = False
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            MyStr = Trim(cell.value)
            StateId = FeatureStateIdFromExternalName(MyStr)
        End If
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If MyStr <> LastFtr Then
                If ds <> "" Then
                    FtrTypeID = FeatureTypeID(MyStr, ds)
                Else
                    FtrTypeID = FeatureTypeID(MyStr)
                End If
                LastFtr = MyStr
            End If
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If MyStr <> LastPrev Then
                PrevStateID = FeatureStateIdFromExternalName(MyStr)
                If PrevStateID = NULL_LONG Then
                    badPrev = True
                    LastPrevID = NULL_LONG
                Else
                    LastPrevID = PrevStateID
                    LastPrev = MyStr
                End If
            Else
                If LastPrevID = NULL_LONG Then
                    badPrev = True
                Else
                    PrevStateID = LastPrevID
                End If
            End If
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            If MyStr <> LastNext Then
                NextStateID = FeatureStateIdFromExternalName(MyStr)
                If NextStateID = NULL_LONG Then
                    badNext = True
                    LastNextID = NULL_LONG
                Else
                    LastNextID = NextStateID
                    LastNext = MyStr
                End If
            Else
                If LastNextID = NULL_LONG Then
                    badNext = True
                Else
                    NextStateID = LastNextID
                End If
            End If
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            IsInitial = BoolStringToInt(MyStr)
        End If
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If MyStr <> "" Then
            IsTerminal = BoolStringToInt(MyStr)
        End If
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        If StateId = NULL_LONG Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find State"
        ElseIf badPrev Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find Previous State"
        ElseIf badNext Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find Next State"
        ElseIf FtrTypeID = 0 Then
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find Feature Type"
        Else
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & FTRSTATETRANS_TBLNAME & _
                    " where " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_FTRSTATEID & " = " & StateId & _
                    " and " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_FTRTYPEID & " = " & FtrTypeID
                    
            ' Originally included these but it was violating the primary key of ftrtypeid and ftrstateid.
                    '" where " & FTRSTATETRANS_FTRSTATEID & " = " & StateId & _
                    '" and " & FTRSTATETRANS_FTRTYPEID & " = " & FtrTypeID

            'If PrevStateID <> NULL_LONG Then
            '    sqlTmp = sqlTmp & _
            '    " and " & FTRSTATETRANS_PREVSTATEID & " = " & PrevStateID
            '
            '    '" and " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_PREVSTATEID & " = " & PrevStateID
            'Else
            '    sqlTmp = sqlTmp & _
            '    " and " & FTRSTATETRANS_PREVSTATEID & " is nu" & "ll"
            '
            '    '" and " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_PREVSTATEID & " is nu" & "ll"
            'End If
            'If NextStateID <> NULL_LONG Then
            '    sqlTmp = sqlTmp & _
            '    " and " & FTRSTATETRANS_NEXTSTATEID & " = " & NextStateID
            '
            '    '" and " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_NEXTSTATEID & " = " & NextStateID
            'Else
            '    sqlTmp = sqlTmp & _
            '    " and " & FTRSTATETRANS_NEXTSTATEID & " is nu" & "ll"
            '
            '    '" and " & FTRSTATETRANS_TBLNAME & "." & FTRSTATETRANS_NEXTSTATEID & " is nu" & "ll"
            'End If
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(FTRSTATETRANS_FTRSTATEID).value = StateId
                rs.Fields.Item(FTRSTATETRANS_FTRTYPEID).value = FtrTypeID
                If PrevStateID <> NULL_LONG Then rs.Fields.Item(FTRSTATETRANS_PREVSTATEID).value = PrevStateID
                If NextStateID <> NULL_LONG Then rs.Fields.Item(FTRSTATETRANS_NEXTSTATEID).value = NextStateID
                rs.Fields.Item(FTRSTATETRANS_ISINITIAL).value = IsInitial
                rs.Fields.Item(FTRSTATETRANS_ISTERMINAL).value = IsTerminal
            Else
                'rsTmp.Fields.Item(FTRSTATETRANS_FTRSTATEID).Value = StateId
                'rsTmp.Fields.Item(FTRSTATETRANS_FTRTYPEID).Value = FtrTypeID
                If PrevStateID <> NULL_LONG Then rsTmp.Fields.Item(FTRSTATETRANS_PREVSTATEID).value = PrevStateID
                If NextStateID <> NULL_LONG Then rsTmp.Fields.Item(FTRSTATETRANS_NEXTSTATEID).value = NextStateID
                rsTmp.Fields.Item(FTRSTATETRANS_ISINITIAL).value = IsInitial
                rsTmp.Fields.Item(FTRSTATETRANS_ISTERMINAL).value = IsTerminal
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        
        End If
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "featurestatetransitions"
    End If
    ImgFtrState.Visible = True
End Sub
Private Sub LoadFeatureStates()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim value$, IntName$, ExtName$, LegalValue$, AltLegalValue$
    Dim ctr%, CUAssignStateID%
    Dim ID&, FixedID&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading feature states"
    Me.Repaint
    Set ws = Worksheets("featurestates")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("featurestates")
    logUpdates = GetLogUpdates("featurestates")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open FTRSTATE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(FTRSTATE_TBLNAME, FTRSTATE_ID)
    'Make sure we leave room for the fixed states
    If ID <= 5 Then ID = 6
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            IntName = Trim(cell.value)
        End If
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            ExtName = Trim(cell.value)
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            LegalValue = Trim(cell.value)
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        AltLegalValue = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If Trim(cell.value) <> "" Then
            CUAssignStateID = CUAssignState(cell.value)
        Else
            CUAssignStateID = NULL_LONG
        End If
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & FTRSTATE_TBLNAME & _
                " where " & FTRSTATE_TBLNAME & "." & FTRSTATE_NAME & " = '" & IntName & "'" & _
                " and " & FTRSTATE_TBLNAME & "." & FTRSTATE_EXTNAME & " = '" & ExtName & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(FTRSTATE_NAME).value = IntName
            rs.Fields.Item(FTRSTATE_EXTNAME).value = ExtName
            FixedID = FixedFeatureStateID(IntName)
            If FixedID = NULL_LONG Then
                rs.Fields.Item(FTRSTATE_ID).value = ID
                ID = ID + 1
            Else
                rs.Fields.Item(FTRSTATE_ID).value = FixedID
            End If
            rs.Fields.Item(FTRSTATE_ATTRLGLVLU).value = LegalValueId(LegalValue, False, AltLegalValue)
            If CUAssignStateID <> NULL_LONG Then
                rs.Fields.Item(FTRSTATE_CUASSIGNSTATE).value = CUAssignStateID
            End If
        Else
            FixedID = FixedFeatureStateID(IntName)
            'rsTmp.Fields.Item(FTRSTATE_NAME).Value = IntName
            'rsTmp.Fields.Item(FTRSTATE_EXTNAME).Value = ExtName
            If FixedID = NULL_LONG Then
                'rsTmp.Fields.Item(FTRSTATE_ID).Value = ID
                'ID = ID + 1
            Else
                rsTmp.Fields.Item(FTRSTATE_ID).value = FixedID
            End If
            rsTmp.Fields.Item(FTRSTATE_ATTRLGLVLU).value = LegalValueId(LegalValue, False, AltLegalValue)
            If CUAssignStateID <> NULL_LONG Then
                rsTmp.Fields.Item(FTRSTATE_CUASSIGNSTATE).value = CUAssignStateID
            End If
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "featurestates"
    End If
End Sub
Sub DeleteAll()
    
    Label2.Caption = "Deleting data"
    Me.Repaint
    
    'Delete all of the entries in the configuration tables.
    'Remember that these have to be done in order so as not to
    'break the relational integrity in the database
    
    
    'First delete all of the dynamically created data
    DeleteADTables
    If Not IsSQLSERVER Then
        DeleteTreeTrimmingSpecificData
    End If
    DeleteDesignSpecificData
    DeleteUtilityTables
    DeleteTable FOLDERCUSTOMQUERY_TBLNAME
    DeleteTable ARCHIVEEXTDATA_TABLENAME
    DeleteTable ARCHIVE_TABLENAME
    
    If Not LoadUnitsOnly Then
        'EO Tables
        DeleteEARules
        DeleteTable CONDPREFRANK_TABLENAME
        DeleteTable DISTTRANFLICKER_TABLENAME
        DeleteTable DISTTRANPREF_TABLENAME
        DeleteTable FUSECHAR_TABLENAME
        DeleteTable ACUNITLOADCHAR_TABLENAME
        DeleteTable VOLTREGCHAR_TABLENAME
        DeleteTable POWERTRANCHAR_TABLENAME
        DeleteTable DISTTRANCHAR_TABLENAME
        DeleteTable CONDCHAR_TABLENAME
        
        DeleteTable SRVCOINCFACTOR_TABLENAME
        DeleteTable SRVLOADPOWER_TABLENAME
        DeleteTable EAELEMATTR_TABLENAME
        DeleteTable EAELEMATTRDOMAIN_TABLENAME
        DeleteTable EAELEMTYPE_TABLENAME
        DeleteTable EAOPTLFPARAM_TABLENAME
        DeleteTable EAOPTWIZ_TABLENAME
        

        DeleteTable ATTRSTOPCOND_TBLNAME
        DeleteTable NETWORKASSIGN_TBLNAME
        DeleteNetworkConfig
        
        DeleteTable FILTERCONTRAINT_TBLNAME
        DeleteTable FILTERCONTRAINTTYPE_TBLNAME
        DeleteTable FILTER_TBLNAME
        
        'CHEDServer Tables
        DeleteTable RUNCONCURRENCYCNSTRNT_TBLNAME
        DeleteTable RUNTIMECNSTRNT_TBLNAME
        DeleteTable SERVERCONFIGURATION_TBLNAME
        DeleteTable SERVERLOGITEM_TBLNAME
        DeleteTable JOB_TBLNAME, "CHSERVER"
        DeleteTable JOBTYPE_TBLNAME
        
        If Not IsSQLSERVER Then
            DeleteTreeTrimming
        End If
        
        DeleteTable EXPORTFTRDETAILS_TBLNAME
        
        DeleteTable CUSTOMATTR_TBLNAME
        
        DeleteTable PINNEDCOMPATIBLEUNIT_TBLNAME
        DeleteTable ENABLEDBUSINESSRULE_TBLNAME
        DeleteTable PLACEDEFSET_TBLNAME
        DeleteTable ATTRDEFVAL_TBLNAME
        DeleteTable ATTRSET_TBLNAME
        
        DeleteTable ATTRREL_TBLNAME
        DeleteTable ATTRCONSTRAINT_TBLNAME
        DeleteTable ALLOWEDCONN_TBLNAME
        DeleteTable RULE_TBLNAME
        DeleteTable RULESET_TBLNAME
        DeleteTable VIOLATION_TBLNAME
        DeleteTable COMPTYPE_TBLNAME
    End If
    
    If Not IgnoreUnits Then
        
        'This may cause problems.
        'The tables are so big that the delete may time out.
        'The ODBC datasource needs to be setup with QueryTimeout disabled
        DeleteTable CUPAASSIGN_TBLNAME
        DeleteTable UNITAGG_TBLNAME
        
        DeleteTable CUACTIVITY_TBLNAME
        DeleteTable FIXEDCULABORCOST_TBLNAME
        DeleteTable USERUNITASSIGNSETTINGS_TBLNAME
        DeleteTable WORKTYPE_TBLNAME
        DeleteTable LABORTYPE_TBLNAME
    
        DeleteTable CU_TBLNAME
        DeleteTable MI_TBLNAME
        DeleteTable CLASSCODE_TBLNAME
        DeleteTable PLANTACCOUNT_TBLNAME
        DeleteTable CUSTOMCOST_TBLNAME
        DeleteCustomCostType
        DeleteTable UNITOFMEASURE_TBLNAME
    End If
    
    If Not LoadUnitsOnly Then
        DeleteCuUnitRules
        DeleteTable DIFFICULTYFACTOR_TBLNAME
        
        DeleteTable FTRSTATETRANS_TBLNAME
        DeleteTable FTRSTATE_TBLNAME
        DeleteTable FTRGEOM_TBLNAME
        
        DeleteTable FTRATTRSPLITMAP_TBLNAME
        
        DeleteTable ATTRLEGALVALUEASSIGN_TBLNAME
        DeleteTable ATTRLEGALVALUE_TBLNAME
        
        DeleteTable CLASSASSIGN_TBLNAME
        DeleteClassifications
        
        DeleteTable FTRATTRMAP_TBLNAME
        DeleteTable COMPOUNDFTR_TBLNAME
        
        DeleteTable ATTRIBUTELINK_TBLNAME
        DeleteTable FEATUREATTR_TBLNAME
        DeleteTable OVERLAPPINGDOMAIN_TBLNAME
        DeleteTable ATTRDOMAIN_TBLNAME
        
        DeleteTable EARATING_TABLENAME

        DeleteTable FEATURETYPE_TBLNAME
        
        DeleteTable REPORTSPEC_TBLNAME
        DeleteTable REPORTCONTEXT_TBLNAME
    
        DeleteTable PLOTSCALE_TBLNAME
        DeleteTable CONFIGURATION_TBLNAME
        DeleteConfigurationSettings
    
        DeleteTable ERRORMESSAGE_TABLENAME
        
        DeleteTable REMARK_TBLNAME
        DeleteTable REMARKTYPE_TBLNAME
        DeleteTable TASK_TBLNAME
        DeleteTable TASKTYPE_TBLNAME
        DeleteTable TASKTREMARKTYPEASSIGN_TBLNAME
    
        DeleteTable USERGROUP_TBLNAME
        DeleteTable GROUPCAPABILITY_TBLNAME
        DeleteTable GROUP_TBLNAME
        DeleteTable USER_TBLNAME
        
        DeleteTable WRRQMTTYPE_TBLNAME
        DeleteTable WRREMARKTYPE_TBLNAME
        
        DeleteTable STATEACTION_TBLNAME
        DeleteTable WRACTION_TBLNAME
        DeleteCustomWREvents
        DeleteTable WORKFLOW_TBLNAME
        DeleteTable WRSTATE_TBLNAME
        
        DeleteTable CMDTGROUPASSIGNMENT_TBLNAME
        DeleteTable CMDTGROUP_TBLNAME
        DeleteTable CMDTTYPE_TBLNAME
    End If
End Sub

Private Sub CommandButton1_Click()

End Sub

Private Sub UserForm_Initialize()

    TextBox1.Text = GetSetting("DBLoader", "General", "DSN", "CHData")
    LoadUnitsOnly = GetSetting("DBLoader", "General", "LoadUnitsOnly", 0)
    ChkUnitsOnly.value = Abs(LoadUnitsOnly)
    IgnoreUnits = GetSetting("DBLoader", "General", "IgnoreUnits", 0)
    ChkNoUnits.value = Abs(IgnoreUnits)
    
    ValidateUtility = True
    chkValidateUtility.value = ValidateUtility
        
    Application.Cursor = xlDefault
    
    'Make sure that only the Connect to DB  Frame is active initially
    Dim ctrl As Control
    For Each ctrl In Me.Controls
        ctrl.Enabled = False
    Next ctrl
    Me.Frame1.Enabled = True
    Me.TextBox1.Enabled = True
    Me.cmdConnect.Enabled = True
    Me.Label2.Enabled = True
    cmdConnect.SetFocus
    logUpdatesToFile = True
End Sub

Private Sub UserForm_Terminate()
    If Not Conn Is Nothing Then
        If Conn.State = adStateOpen Then Conn.Close
        Set Conn = Nothing
    End If
    If Not FtrAttributes Is Nothing Then Set FtrAttributes = Nothing
    If Not LaborTypes Is Nothing Then Set LaborTypes = Nothing
    If Not WorkTypes Is Nothing Then Set WorkTypes = Nothing
    If Not CUs Is Nothing Then Set CUs = Nothing
    If Not ClassCodes Is Nothing Then Set ClassCodes = Nothing
    If Not FtrTypes Is Nothing Then Set FtrTypes = Nothing
    
    SaveSetting "DBLoader", "General", "LoadUnitsOnly", LoadUnitsOnly
    SaveSetting "DBLoader", "General", "IgnoreUnits", IgnoreUnits
    
    Application.Cursor = xlDefault
End Sub

Private Sub LoadCustomAttributes()
    On Error GoTo LoadCAError
    
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim TblTypeID&, DomainID&
    Dim cellstr$, MyStr$
    Dim ctr%, ID%, displayOrder%
    Dim ColumnName$, domainName$, TableType$, LastDomain$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False

    Label2.Caption = "Status: Loading Custom Attributes"
    Set ws = Worksheets("CustomAttributes")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CustomAttributes")
    logUpdates = GetLogUpdates("CustomAttributes")

    ctr = 2
    LastDomain = ""
    
    Set cell = ws.Range("A2")
    ColumnName = Trim$(cell.value)
    
    rs.Open CUSTOMATTR_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    ID = NextPK(CUSTOMATTR_TBLNAME, CUSTOMATTR_ID)
    Do While ColumnName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        domainName = Trim(cell.value)
        If LastDomain <> domainName Then
            DomainID = AttributeDomainId(domainName)
            LastDomain = domainName
        End If
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        TableType = Trim(cell.value)
        If IsNumeric(TableType) Then
            TblTypeID = CLng(TableType)
            If TblTypeID < 0 Or TblTypeID > 7 Then
                TblTypeID = NULL_LONG
            End If
        Else
            TblTypeID = TableTypeID(TableType)
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MyStr = Trim(cell.value)
        If IsNumeric(MyStr) Then
            displayOrder = CInt(MyStr)
        Else
            displayOrder = 0
        End If
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        If TblTypeID <> NULL_LONG And DomainID <> 0 Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & CUSTOMATTR_TBLNAME & _
                    " where " & CUSTOMATTR_TBLNAME & "." & CUSTOMATTR_COLUMNNAME & " = '" & ColumnName & "'" & _
                    " and " & CUSTOMATTR_TBLNAME & "." & CUSTOMATTR_TBLTYPE & " = " & TblTypeID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(CUSTOMATTR_ID).value = ID
                rs.Fields.Item(CUSTOMATTR_COLUMNNAME).value = ColumnName
                rs.Fields.Item(CUSTOMATTR_TBLTYPE).value = TblTypeID
                rs.Fields.Item(CUSTOMATTR_ATTRDOMAINID).value = DomainID
                rs.Fields.Item(CUSTOMATTR_DISPLAYORDER).value = displayOrder
                rs.Update
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(CUSTOMATTR_ID).Value = ID
                'rsTmp.Fields.Item(CUSTOMATTR_COLUMNNAME).Value = ColumnName
                'rsTmp.Fields.Item(CUSTOMATTR_TBLTYPE).Value = TblTypeID
                rsTmp.Fields.Item(CUSTOMATTR_ATTRDOMAINID).value = DomainID
                rsTmp.Fields.Item(CUSTOMATTR_DISPLAYORDER).value = displayOrder
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            If TblTypeID = NULL_LONG Then
                cell.value = "Failed - not a valid table type"
            Else
                cell.value = "Failed - not a valid domain"
            End If
        End If
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ColumnName = Trim$(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    If Not rs Is Nothing Then Set rs = Nothing
    
    If Failure Then
        LogSheetFailure "CustomAttributes"
    End If
    ImgCustAttrs.Visible = True
    Exit Sub
    
LoadCAError:
    Label2.Caption = "Status: " & Err.Description & " Row: " & ctr
    If Not rs Is Nothing Then Set rs = Nothing
    LogSheetFailure "CustomAttributes"
End Sub



Private Function FindFeatureTypeName(s As String)
    Dim ws As Worksheet
    Dim cell As Range
    Dim cellstr$, DisplayName$
    Dim ctr%
    Dim nameFound As Boolean
    Dim valR As String
    
    Set ws = Worksheets("FeatureTypes")
    ctr = 2
    cellstr = "D2"
    Set cell = ws.Range(cellstr)
    DisplayName = Trim(cell.value)
    nameFound = False
    Do While DisplayName <> ""
        If DisplayName = s Then
            nameFound = True
            Exit Do
        End If
    
        ctr = ctr + 1
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        DisplayName = Trim(cell.value)
    Loop
    If nameFound = True Then
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        FindFeatureTypeName = Trim(cell.value)
    Else
        FindFeatureTypeName = ""
    End If
End Function




Public Sub ClearSheet(SheetName$, NumColumns%)

    Dim ws As Worksheet
    Dim active As Range
    Dim rg As Range
    Set ws = Worksheets(SheetName)
    
    Dim TotalRange As Range
    
    Set TotalRange = ws.Range("A2:A65536").Resize(, NumColumns)
    
    Set active = Intersect(TotalRange, ws.UsedRange)
    
    active.ClearContents
    
End Sub

Public Function AttrIDFromClassificationAndFtrType&(ftrTypeName$, ClassificationName$, Optional ds As String)

    Dim rs As ADODB.Recordset
    Dim sql$
    Dim FTID&, ClsID&
    
    If ds <> "" Then
        FTID = FeatureTypeID(ftrTypeName, ds)
    Else
        FTID = FeatureTypeID(ftrTypeName)
    End If
    ClsID = ClassificationID(ClassificationName)
    
    sql = "select " & CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_FTRATTRID & " from " & _
            CLASSASSIGN_TBLNAME & ", " & FEATUREATTR_TBLNAME & " where " & _
            CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_CLASSTYPEID & _
            " = " & CStr(ClsID) & " and " & CLASSASSIGN_TBLNAME & "." & CLASSASSIGN_FTRATTRID & _
            " = " & FEATUREATTR_TBLNAME & "." & FEATUREATTR_ID & " and " & _
            FEATUREATTR_TBLNAME & "." & FEATUREATTR_FTRTYPEID & " = " & CStr(FTID)
    Set rs = Conn.Execute(sql, , adCmdText)
 
    If rs.BOF Then
        Err.Raise vbObjectError + 27, , "No Attribute found for classification"
    Else
        AttrIDFromClassificationAndFtrType = rs(CLASSASSIGN_FTRATTRID)
    End If

End Function

Public Function FeatureAttributeName$(FtrAttrID&)

    Dim rs As ADODB.Recordset
    Dim sql$
    sql = "select " & FEATUREATTR_INTERNALNAME & " from " & FEATUREATTR_TBLNAME & _
            " where " & FEATUREATTR_ID & " = " & CStr(FtrAttrID)
    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.BOF Then
        Err.Raise vbObjectError + 27, , "No Attribute found for given ID"
    Else
        FeatureAttributeName = rs(FEATUREATTR_INTERNALNAME)
    End If

End Function

'Check if the current connection has a DBA or CHEDADMIN role.
'If it doesn't then we won't be able to truncate tables or add records
'to the configuration tables
Public Function HasDBARights%()
    Dim Succeeded%
    If IsSQLSERVER Then
        Succeeded = True
    Else
        Dim rs As ADODB.Recordset
        Dim sql$, Role$
        Const Admin$ = "CHEDADMIN;DBA"
    
        Succeeded = False
        sql = "select * from session_roles"
        Set rs = Conn.Execute(sql, , adCmdText)
        
        Do While Not rs.EOF
            Role = UCase(rs!Role)
            If InStr(Admin, Role) <> 0 Then
                Succeeded = True
                Exit Do
            End If
            rs.MoveNext
        Loop
    End If
    
    HasDBARights = Succeeded
End Function

Public Sub DeleteDesignSpecificData()

    Dim sql$
    
    'These tables always need clearing.
    DeleteTable CUASSIGN_TBLNAME
    DeleteTable CCASSIGN_TBLNAME
    DeleteTable MIASSIGN_TBLNAME
    
    If Not LoadUnitsOnly Then
        'And these tables are cleared only if we are reloading everything
        
        sql = "Update " & WORKREQUEST_TBLNAME & " set " & WORKREQUEST_ATTACHEDDESIGNID & " = NULL"
        Conn.Execute sql, , adCmdText + adExecuteNoRecords
        sql = "Update " & DESIGN_TBLNAME & " set " & DESIGN_ASSOCIATEDWORKREQUESTID & " = NULL"
        Conn.Execute sql, , adCmdText + adExecuteNoRecords
        
        DeleteTable EAERRORLOG_TBLNAME
        DeleteTable EACAPACITOR_TBLNAME
        DeleteTable EADISTTRANSFORMER_TBLNAME
        DeleteTable EAPRIMARYLINE_TBLNAME
        DeleteTable EAPRIMARYMETER_TBLNAME
        DeleteTable EAPRIMARYSOURCE_TBLNAME
        DeleteTable EAPROTECTIVEDEVICE_TBLNAME
        DeleteTable EASECONDARYLINE_TBLNAME
        DeleteTable EASTREETLIGHT_TBLNAME
        DeleteTable EASERVICEPOINT_TBLNAME
        DeleteTable EARECOMMENDRATING_TBLNAME
        
        DeleteTable GISDESIGNGRAPHICELEMENT_TBLNAME
        DeleteTable GISFEATUREDELETE_TBLNAME
        
        DeleteTable EXTERNALSPLIT_TBLNAME
        DeleteTable EXTERNALATTACH_TBLNAME
        DeleteTable IMPORTFAILURE_TBLNAME
        
        DeleteTable PHASEMAPPING_TBLNAME
        DeleteTable WLTAPDEVICEASSIGN_TBLNAME
        DeleteTable PATHWLASSIGN_TBLNAME
        DeleteTable WLGEOMETRY_TBLNAME
        DeleteTable PATH_TBLNAME, "CHDATA"
        DeleteTable WLFACILITY_TBLNAME
        DeleteTable CONNECTION_TBLNAME
        DeleteTable WORKLOCATION_TBLNAME
        
        DeleteTable TAPDEVICE_TBLNAME
        DeleteTable FEATUREINSTANCE_TBLNAME
        
        DeleteTable SEGMENTCOORD_TBLNAME
        DeleteTable ARCSEGMENT_TBLNAME
        DeleteTable ELLIPSESEGMENT_TBLNAME
        DeleteTable BSPLINESEGMENT_TBLNAME
        DeleteTable LINESEGMENT_TBLNAME
        DeleteTable SEGMENT_TBLNAME
        DeleteTable GEOMETRY_TBLNAME, "CHDATA"
        DeleteTable GEOCOORDINATE_TBLNAME

        DeleteTable WRREMARK_TBLNAME
        DeleteTable WRREQUIREMENT_TBLNAME
   
        DeleteTable WORKREQUEST_TBLNAME
        DeleteTable DESIGNSNAPSHOT_TBLNAME
        DeleteTable DESIGN_TBLNAME
        
        DeleteTable GISIDMAPPING_TBLNAME
    End If
End Sub
Public Sub DeleteTreeTrimmingSpecificData()

    Dim sql$
    
    'Need to null out the foreign key on the WR table before we can delete the plans
    sql = "Update " & WORKREQUEST_TBLNAME & " set " & WORKREQUEST_ATTACHEDPLANID & " = NULL"
    Conn.Execute sql, , adCmdText + adExecuteNoRecords
    
    DeleteTable VEGUNIT_TABLENAME
    DeleteTable VEGWORKPLAN_TABLENAME
    DeleteTable VEGSEGMENTFEATURE_TABLENAME
    DeleteTable VEGCLASSASSIGNMENT_TABLENAME
    DeleteTable VEGSEGMENT_TABLENAME
    DeleteTable PLAN_TABLENAME
    DeleteTable MASTERPLAN_TABLENAME
    
End Sub
Public Sub DeleteUtilityTables()

    Dim sql$, TableName$
    Dim rs As ADODB.Recordset
    If IsSQLSERVER Then
        sql = "select table_name from information_schema.TABLES where TABLE_SCHEMA = 'UTILITY' and table_name not like '%$%'"
    Else
        sql = "select table_name from all_tables where owner = 'UTILITY' and table_name not like '%$%'"
    End If
    Set rs = Conn.Execute(sql, , adCmdText)
    
    Do While Not rs.EOF
        TableName = rs!table_name
        DeleteTable TableName
        rs.MoveNext
    Loop
End Sub
Public Sub DeleteADTables()
        DeleteTable CUADASSIGN_TABLENAME
        DeleteTable CUADTYPECODE_TABLENAME
        DeleteTable CUADTYPE_TABLENAME
        DeleteTable ADFEATUREATTRCONSTRNT_TABLENAME
        DeleteTable ADFEATUREINST_TABLENAME
        DeleteTable ADCUCODERULE_TABLENAME
        DeleteTable ADFEATURETYPE_TABLENAME
        DeleteTable ADRULE_TABLENAME
End Sub

Public Function ValidateUtilityAttribute%(FtrTypeID&, FtrAttrName$, DomainID&, ErrorMessage$)

    Dim sql$, UtilityTable$, fldName$
    Dim rs As ADODB.Recordset
    Dim UtilRS As ADODB.Recordset
    Dim Fld As ADODB.Field
    Dim FoundFld%, IsEnumerator%
    Dim FldType As ADODB.DataTypeEnum
    Dim FldValue$

    ErrorMessage = ""
    FldValue = ""
    
    sql = "select " & FEATURETYPE_INTERNALTABLE & " from " & FEATURETYPE_TBLNAME & _
            " where " & FEATURETYPE_ID & " = " & FtrTypeID

    Set rs = Conn.Execute(sql, , adCmdText)
    If rs.EOF Then
       GoTo e_FtrTypeMissing
    Else
        If IsNull(rs(FEATURETYPE_INTERNALTABLE)) Then GoTo e_NoIntTable
        UtilityTable = rs(FEATURETYPE_INTERNALTABLE)
        sql = "select * from UTILITY." & UtilityTable
        On Error GoTo e_TableMissing
        Set UtilRS = Conn.Execute(sql, , adCmdText)
        On Error GoTo 0 'reset the error handler
        FoundFld = False
        For Each Fld In UtilRS.Fields
            fldName = Fld.Name
            If UCase(fldName) = UCase(FtrAttrName) Then
                FoundFld = True
                Exit For
            End If
        Next Fld
        If FoundFld Then
            FldType = Fld.Type
            If ValidateDomain(DomainID, FldType, IsEnumerator) Then
                If ADOString(FldType) And IsEnumerator Then
                    If Not ValidateFldLength(DomainID, Fld, FldValue) Then
                        GoTo e_FldTooSmall
                    End If
                End If
            Else
                GoTo e_InvalidDomain
            End If
        Else
            GoTo e_FldMissing
        End If
    End If
    
    ValidateUtilityAttribute = True
    
    Exit Function
e_FtrTypeMissing:
    ErrorMessage = "Could not find the Feature Type"
    GoTo e_VUA_Fail
e_NoIntTable:
    ErrorMessage = "There is no internal table specified"
    GoTo e_VUA_Fail
e_TableMissing:
    ErrorMessage = "Could not find the table in the utility schema"
    GoTo e_VUA_Fail
e_FldMissing:
    ErrorMessage = "Could not find the field in the utility schema"
    GoTo e_VUA_Fail
e_InvalidDomain:
    ErrorMessage = "This domain does not match the field definition in the utility schema"
    GoTo e_VUA_Fail
e_FldTooSmall:
    ErrorMessage = "This domain contains values that are too large for the field in the utility schema - value = " & FldValue
e_VUA_Fail:
    ValidateUtilityAttribute = False
End Function
Public Function ValidateDomain%(DomainID&, FldType As ADODB.DataTypeEnum, IsEnumerator%)

    Dim sql$, domainName$
    Dim rs As ADODB.Recordset
    Dim valueType&

    IsEnumerator = False
    sql = "select * from " & ATTRDOMAIN_TBLNAME & " where " & ATTRDOMAIN_ID & _
            " = " & DomainID

    Set rs = Conn.Execute(sql, , adCmdText)
    
    If rs.EOF Then
        ValidateDomain = False
    Else
        valueType = rs(ATTRDOMAIN_VALUETYPE)
        domainName = rs(ATTRDOMAIN_NAME)
    
        
        If valueType = CLng(FldType) Then
            ValidateDomain = True
        Else
            If ADONumeric(FldType) Then
                If ADONumeric(valueType) Then
                    ValidateDomain = True
                Else
                    ValidateDomain = False
                End If
            ElseIf ADOString(FldType) Then
                If ADOString(valueType) Then
                    ValidateDomain = True
                    If InStr(1, StandardDomains, domainName, vbTextCompare) = 0 Then
                        IsEnumerator = True
                    End If
                Else
                    ValidateDomain = False
                End If
            ElseIf ADODate(FldType) Then
                If ADODate(valueType) Then
                    ValidateDomain = True
                Else
                    ValidateDomain = False
                End If
            End If
        End If
    End If
    
End Function

Public Function ValidateFldLength%(DomainID&, Fld As ADODB.Field, value$)

    Dim sql$, FldValue$
    Dim FldSize, ValueLen As LongLong
    Dim rs As ADODB.Recordset

    ValidateFldLength = True
    
    FldSize = Fld.DefinedSize
    
    sql = "select " & ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_VALUE & " from " & _
            ATTRLEGALVALUE_TBLNAME & ", " & ATTRLEGALVALUEASSIGN_TBLNAME & " where " & _
            ATTRLEGALVALUE_TBLNAME & "." & ATTRLEGALVALUE_ID & " = " & _
            ATTRLEGALVALUEASSIGN_TBLNAME & "." & ATTRLEGALVALUEASSIGN_LEGALVALUEID & _
            " and " & ATTRLEGALVALUEASSIGN_TBLNAME & "." & _
            ATTRLEGALVALUEASSIGN_DOMAINID & " = " & CStr(DomainID)
    
    Set rs = Conn.Execute(sql, , adCmdText)
    Do While Not rs.EOF
        FldValue = rs(ATTRLEGALVALUE_VALUE)
        ValueLen = Len(FldValue)
        If ValueLen > FldSize Then
            ValidateFldLength = False
            value = FldValue
            Exit Do
        End If
        rs.MoveNext
    Loop
    
End Function
Public Function ADONumeric%(FldType As ADODB.DataTypeEnum)

    Select Case FldType
        Case adTinyInt, _
            adSmallInt, _
            adInteger, _
            adBigInt, _
            adUnsignedTinyInt, _
            adUnsignedSmallInt, _
            adUnsignedInt, _
            adUnsignedBigInt, _
            adSingle, _
            adDouble, _
            adDecimal, _
            adNumeric, _
            adVarNumeric
                ADONumeric = True
        Case Else
                ADONumeric = False
    End Select
    
End Function

Public Function ADOString%(FldType As ADODB.DataTypeEnum)

    Select Case FldType
        Case adBSTR, _
            adChar, _
            adVarChar, _
            adLongVarChar, _
            adWChar, _
            adVarWChar, _
            adLongVarWChar
                ADOString = True
        Case Else
                ADOString = False
    End Select
    
End Function

Public Function ADODate%(FldType As ADODB.DataTypeEnum)

    Select Case FldType
        Case adDate, _
            adDBDate, _
            adDBTime, _
            adDBTimeStamp
                ADODate = True
        Case Else
                ADODate = False
    End Select
    
End Function
Private Sub LoadFtrCatalog()
    Dim rs As New Recordset
    Dim rs1 As ADODB.Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim value$, parentName$, SettingName$, valueType$, Description$, QueryName$
    Dim ctr%, CatalogDimension%, HorizontalIdx%, VerticalIdx%, MaxVertTabs%, TmpCnt%
    Dim VertTabCount%, result%, i%, start%
    Dim ID&, ParentID&, ADOType&, FtrTypeID&, EDConfigID&, FtrCatalogConfigID&
    Dim HorizontalName$, VerticalName$, ftrTypeName$, FixedQuery$, Query$, sql$
    Dim OldHorizontalName$, OldVerticalName$, FixedQueryName$
    Dim HorizontalTabs$, VerticalTabs$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Dim ds As String
    Failure = False
    
    ' Parsing variables:
    Dim Sep As String
    Dim WorkLine As String
    Dim pos As Integer
    Dim NextPos As Integer
    Dim tempVal As Variant
    Dim tmpStr As String
    
    Dim newVerticalTabs As String
    Dim LoopCnt As Integer
    
    Label2.Caption = "Loading Feature Catalog Configuration"
    Me.Repaint
    Set ws = Worksheets("FeatureCatalog")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("FeatureCatalog")
    logUpdates = GetLogUpdates("FeatureCatalog")
    
    ' Setup some reusable variables:
    CatalogDimension = 0
    FixedQuery = "SELECT " & FEATURETYPE_ID & " from " & FEATURETYPE_TBLNAME & _
            " where " & FEATURETYPE_ISPLACEABLE & " != 0 AND " & FEATURETYPE_ID & " in ("
    FixedQueryName = "DA - Query "
    Query = FixedQuery
    OldHorizontalName = ""
    OldVerticalName = ""
    MaxVertTabs = 0
    VertTabCount = 0
    EDConfigID = NULL_LONG
    VerticalTabs = ""
    VerticalIdx = 0
    
    'The Feature catalog is a child record of the ED config setting, so we
    'need to look up this ID.
    sql = "select " & CONFIGSETTING_ID & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'ED'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        EDConfigID = rs1(CONFIGSETTING_ID)
    End If
    
    ' Calculate the maximum number of vertical tabs, so do a preliminary
    'loop through the sheet.
    ctr = 2
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
    OldHorizontalName = value
    Do While value <> ""
        ' Clear previous errors:
        ws.Range((ErrorCol & ctr)).Font.ColorIndex = xlColorIndexAutomatic
        ws.Range((ErrorCol & ctr)).value = ""
        
        HorizontalName = Trim(cell.value)
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        VerticalName = Trim(cell.value)
        
        If ctr = 2 Then
            'If there is a horizontal name, then there is at least 1 dimension.
            CatalogDimension = 1

            'If there is also a vertical, then the catalog has 2 dimensions.
            If VerticalName <> "" Then CatalogDimension = 2
        End If
        
        If HorizontalName <> OldHorizontalName Then
            OldVerticalName = ""
            VertTabCount = 0
            OldHorizontalName = HorizontalName
        End If
        
        If VerticalName <> OldVerticalName Then
            'keep the maximum value so far
            VertTabCount = VertTabCount + 1
            If MaxVertTabs < VertTabCount Then MaxVertTabs = VertTabCount
            OldVerticalName = VerticalName
        End If
             
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    ' Get are next ID for the configsetting table:
    rs.Open CONFIGSETTING_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CONFIGSETTING_TBLNAME, CONFIGSETTING_ID)
    
    ' Check for existing parent level config setting:
    sql = "select * from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - ConfigurableFtrCatalog'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        FtrCatalogConfigID = rs1(CONFIGSETTING_ID)
    Else
        ' Add the parent level config setting:
        result = AddConfigRecord(rs, ID, EDConfigID, "DA - ConfigurableFtrCatalog", _
                "This node is the parent of the DA configurable feature catalog settings", _
                adInteger, 0)
        If Not result Then
            GoTo LFC_Err
        End If
        FtrCatalogConfigID = ID
        ID = ID + 1
    End If
    
    ' Check for existing dimensions to see if we have more then the previous run:
    sql = "select " & CONFIGSETTING_LONGVALUE & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - Dimensions'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        TmpCnt = rs1(CONFIGSETTING_LONGVALUE)
        If TmpCnt < CatalogDimension Then
            ' Update the number of dimensions:
            sql = "update " & CONFIGSETTING_TBLNAME & _
                  " set " & CONFIGSETTING_LONGVALUE & " = " & CatalogDimension & _
                    " where " & CONFIGSETTING_NAME & " = 'DA - Dimensions'"
            Conn.Execute sql, , adCmdText + adExecuteNoRecords
        End If
    Else
        ' Add the number of dimensions:
        result = AddConfigRecord(rs, ID, FtrCatalogConfigID, "DA - Dimensions", _
                "This setting determines the dimensions for DA feature catalog", _
                adInteger, CatalogDimension)
        If Not result Then
            GoTo LFC_Err
        End If
        ID = ID + 1
    End If
    
    ' Check for existing max number of vertical tabs to see if we have more then the previous run:
    sql = "select " & CONFIGSETTING_LONGVALUE & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - Maximum Vertical Tabs'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        TmpCnt = rs1(CONFIGSETTING_LONGVALUE)
        If TmpCnt < MaxVertTabs Then
            ' Update the max number of vertical tabs:
            sql = "update " & CONFIGSETTING_TBLNAME & _
                  " set " & CONFIGSETTING_LONGVALUE & " = " & MaxVertTabs & _
                    " where " & CONFIGSETTING_NAME & " = 'DA - Maximum Vertical Tabs'"
            Conn.Execute sql, , adCmdText + adExecuteNoRecords
            
            ' Re-Pad the vertical tabs list with place holders based on the new MaxVertTabs:
            sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
                    " where " & CONFIGSETTING_NAME & " = 'DA - Vertical Tab Names'"
            Set rs1 = Conn.Execute(sql, , adCmdText)
            If Not rs1.EOF Then
                VerticalTabs = rs1(CONFIGSETTING_STRINGVALUE)
                
                newVerticalTabs = ""
                LoopCnt = 0
                start = True
                
                ' Parse the WorkLine:
                WorkLine = VerticalTabs
                Sep = ","
                Debug.Print WorkLine
                pos = 1
                NextPos = InStr(pos, WorkLine, Sep)
                While NextPos >= 1
                    tempVal = Mid(WorkLine, pos, NextPos - pos)
                    Debug.Print "       " & tempVal
                    
                    ' Add the current tab to our running list:
                    If start Then
                        newVerticalTabs = tempVal
                        start = False
                    Else
                        newVerticalTabs = newVerticalTabs & "," & tempVal
                    End If
                    
                    LoopCnt = LoopCnt + 1
                    If LoopCnt = TmpCnt Then
                        ' Pad the vertical tabs list with place holders based on the new MaxVertTabs:
                        If LoopCnt < MaxVertTabs Then
                            For i = LoopCnt To MaxVertTabs - 1
                                newVerticalTabs = newVerticalTabs & ","
                            Next i
                        End If
                        LoopCnt = 0
                    End If
                
                    WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                    pos = 1
                    NextPos = InStr(pos, WorkLine, Sep)
                Wend
                If Len(WorkLine) > 0 Then
                    Debug.Print "       " & WorkLine
                
                    ' Add the current tab to our running list:
                    If start Then
                        newVerticalTabs = WorkLine
                        start = False
                    Else
                        newVerticalTabs = newVerticalTabs & "," & WorkLine
                    End If
                    
                    LoopCnt = LoopCnt + 1
                    If LoopCnt = TmpCnt Then
                        ' Pad the vertical tabs list with place holders based on the new MaxVertTabs:
                        If LoopCnt < MaxVertTabs Then
                            For i = LoopCnt To MaxVertTabs + 1
                                newVerticalTabs = newVerticalTabs & ","
                            Next i
                        End If
                        LoopCnt = 0
                    End If
                End If
                Debug.Print ""
            
                VerticalTabs = newVerticalTabs
            End If
            
        Else
            MaxVertTabs = TmpCnt
        End If
    Else
        ' Add the max number of vertical tabs:
        result = AddConfigRecord(rs, ID, FtrCatalogConfigID, "DA - Maximum Vertical Tabs", _
                "This setting determines the Maximum Vertical tabs for DA feature catalog", _
                adInteger, MaxVertTabs)
        If Not result Then
            GoTo LFC_Err
        End If
        ID = ID + 1
    End If
    
    ' Check for existing Vertical Tab Names so that we can add to it:
    If VerticalTabs = "" Then
        sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
                " where " & CONFIGSETTING_NAME & " = 'DA - Vertical Tab Names'"
        Set rs1 = Conn.Execute(sql, , adCmdText)
        If Not rs1.EOF Then
            VerticalTabs = rs1(CONFIGSETTING_STRINGVALUE)
        End If
    End If
    
    ' Check for existing Horizontal Tab Names so that we can add to it:
    sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - Horizontal Tab Names'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        HorizontalTabs = rs1(CONFIGSETTING_STRINGVALUE)
        
        ' Set the number of Horizontal tabs from the existing value:
        HorizontalIdx = 0
        WorkLine = HorizontalTabs
        Sep = ","
        Debug.Print WorkLine
        pos = 1
        NextPos = InStr(pos, WorkLine, Sep)
        While NextPos >= 1
            tempVal = Mid(WorkLine, pos, NextPos - pos)
            Debug.Print "       " & tempVal
            HorizontalIdx = HorizontalIdx + 1
            WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
            pos = 1
            NextPos = InStr(pos, WorkLine, Sep)
        Wend
        If Len(WorkLine) > 0 Then
            Debug.Print "       " & WorkLine
            HorizontalIdx = HorizontalIdx + 1
        End If
        Debug.Print ""
        'HorizontalTabs = HorizontalTabs & ","
    Else
        HorizontalTabs = ""
        HorizontalIdx = 0
    End If
    
    '-------------------------------------------------------
    ' Loop through our data and build our "DA - Query" rows:
    '-------------------------------------------------------
    ctr = 2
    
    cellstr = "A" & ctr
    Set cell = ws.Range(cellstr)
    OldHorizontalName = Trim(cell.value)

    cellstr = "B" & ctr
    Set cell = ws.Range(cellstr)
    OldVerticalName = Trim(cell.value)

    start = True
    Set cell = ws.Range("C2")
    value = Trim(cell.value)
    
    Do While value <> ""

        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        HorizontalName = Trim(cell.value)

        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        VerticalName = Trim(cell.value)

        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        ds = Trim(cell.value)

        ' Add our feature type id to our query:
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        ftrTypeName = Trim(cell.value)
        If ds <> "" Then
            FtrTypeID = FeatureTypeID(ftrTypeName, ds)
        Else
            FtrTypeID = FeatureTypeID(ftrTypeName)
        End If
        If FtrTypeID = 0 Then
            Set cell = ws.Range((ErrorCol & ctr))
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Could not find this Feature Type"
        Else
            ' Check to see if this is adding to an existing list.
            ' If so, set Query equal to the database version based on this
            ' horizontal and vertical tab names and set
            
            Dim tmpCheckCnt As Integer
            Dim tmpHCheckCnt As Integer
            Dim tmpFCheckVal As String
            Dim tmpFtrInt As Integer
            Dim hCheckCnt As Integer
            Dim vCheckCnt As Integer
            Dim fCheckCnt As Integer
            hCheckCnt = -1
            vCheckCnt = -1
            fCheckCnt = 0
            
            ' Check our existing HorizontalTabs to see if this Tab exists:
            tmpCheckCnt = -1
            WorkLine = HorizontalTabs
            Sep = ","
            Debug.Print WorkLine
            pos = 1
            NextPos = InStr(pos, WorkLine, Sep)
            While NextPos >= 1
                tempVal = Mid(WorkLine, pos, NextPos - pos)
                Debug.Print "       " & tempVal
                tmpCheckCnt = tmpCheckCnt + 1
                tmpStr = tempVal
                If tmpStr = HorizontalName Then
                    hCheckCnt = tmpCheckCnt
                End If
                WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                pos = 1
                NextPos = InStr(pos, WorkLine, Sep)
            Wend
            If Len(WorkLine) > 0 Then
                Debug.Print "       " & WorkLine
                tmpCheckCnt = tmpCheckCnt + 1
                If WorkLine = HorizontalName Then
                    hCheckCnt = tmpCheckCnt
                End If
            End If
            Debug.Print ""
            
            If hCheckCnt > -1 Then
                ' Check our existing VerticalTabs for this HorizontalTab to see if this Tab exists:
                tmpHCheckCnt = 0
                tmpCheckCnt = -1
                WorkLine = VerticalTabs
                Sep = ","
                Debug.Print WorkLine
                pos = 1
                NextPos = InStr(pos, WorkLine, Sep)
                Do While NextPos >= 1
                    tempVal = Mid(WorkLine, pos, NextPos - pos)
                    Debug.Print "       " & tempVal
                    
                    tmpCheckCnt = tmpCheckCnt + 1
                    If tmpHCheckCnt = hCheckCnt Then
                        If tempVal = VerticalName Then
                            vCheckCnt = tmpCheckCnt
                            WorkLine = ""
                            Exit Do
                        End If
                    End If
                    If tmpCheckCnt = (MaxVertTabs - 1) Then
                        tmpHCheckCnt = tmpHCheckCnt + 1
                        tmpCheckCnt = -1
                    End If
                    
                    WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                    pos = 1
                    NextPos = InStr(pos, WorkLine, Sep)
                Loop
                If Len(WorkLine) > 0 Then
                    Debug.Print "       " & WorkLine
                    tmpHCheckCnt = tmpHCheckCnt + 1
                    tmpCheckCnt = tmpCheckCnt + 1
                    
                    tmpCheckCnt = tmpCheckCnt + 1
                    If tmpHCheckCnt = hCheckCnt Then
                        If tempVal = VerticalName Then
                            vCheckCnt = tmpCheckCnt
                        End If
                    End If
                    If tmpCheckCnt = (MaxVertTabs - 1) Then
                        tmpHCheckCnt = tmpHCheckCnt + 1
                        tmpCheckCnt = -1
                    End If
                    
                End If
                Debug.Print ""
            
                If vCheckCnt > -1 Then
                    ' Select this row from the database:
                    QueryName = FixedQueryName & hCheckCnt & "," & vCheckCnt
                    
                    sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
                            " where " & CONFIGSETTING_NAME & " = '" & QueryName & "'"
                    Set rs1 = Conn.Execute(sql, , adCmdText)
                    If Not rs1.EOF Then
                        tmpFCheckVal = rs1(CONFIGSETTING_STRINGVALUE)
                        
                        ' Check if the list of features contains this feature:
                        WorkLine = tmpFCheckVal
                        If WorkLine <> FixedQuery Then
                            Debug.Print WorkLine
                            '          1         2         3         4         5         6
                            ' 12345678901234567890123456789012345678901234567890123456789012
                            '"SELECT ID from FEATURETYPE where ISPLACEABLE != 0 AND ID in (64, 55, 16)
                            WorkLine = Mid(WorkLine, 62, Len(WorkLine) - 61)
                            Debug.Print WorkLine
                            
                            NextPos = InStr(1, WorkLine, ")")
                            If NextPos > 0 Then
                                WorkLine = Mid(WorkLine, 1, NextPos - 1)
                                Debug.Print WorkLine
                            End If
                            
                            tmpCheckCnt = 0
                            Sep = ","
                            pos = 1
                            NextPos = InStr(pos, WorkLine, Sep)
                            Do While NextPos >= 1
                                tempVal = Mid(WorkLine, pos, NextPos - pos)
                                Debug.Print "       " & tempVal
                                tmpCheckCnt = tmpCheckCnt + 1
                                tmpFtrInt = tempVal
                                If tmpFtrInt = FtrTypeID Then
                                    fCheckCnt = tmpCheckCnt
                                    WorkLine = ""
                                    Exit Do
                                End If
                                WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                                pos = 1
                                NextPos = InStr(pos, WorkLine, Sep)
                            Loop
                            If Len(WorkLine) > 0 Then
                                Debug.Print "       " & WorkLine
                                tmpCheckCnt = tmpCheckCnt + 1
                                tmpFtrInt = WorkLine
                                If tmpFtrInt = FtrTypeID Then
                                    fCheckCnt = tmpCheckCnt
                                End If
                            End If
                            Debug.Print ""
                        End If
                        
                        If fCheckCnt > 0 Then
                            If logUpdates = "1" Then
                                ' Mark this row as a update:
                                Set cell = ws.Range((ErrorCol & ctr))
                                cell.Font.Color = RGB(255, 0, 0)
                                Failure = True
                                cell.value = "Updated existing row"
                            End If
                        Else
                            ' Add this feature to its list:
                            tmpCheckCnt = Len(tmpFCheckVal)
                            tempVal = Mid(tmpFCheckVal, 1, tmpCheckCnt - 1)
                            tempVal = tempVal & "," & FtrTypeID & ")"
                            sql = "update " & CONFIGSETTING_TBLNAME & _
                                  " set " & CONFIGSETTING_STRINGVALUE & " = '" & tempVal & "'" & _
                                    " where " & CONFIGSETTING_NAME & " = '" & QueryName & "'"
                            Conn.Execute sql, , adCmdText + adExecuteNoRecords
                            fCheckCnt = 99
                            
                            ' Mark this row as an addition:
                            Set cell = ws.Range((ErrorCol & ctr))
                            cell.Font.Color = RGB(255, 0, 0)
                            Failure = True
                            cell.value = "Added to existing tab"
                        End If
                    Else
                        ' Error this row:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        Failure = True
                        cell.value = "Unable to locate existing row."
                    End If
                    
                End If
            
            Else
                ' Check our current list of features for this feature:
                WorkLine = Query
                If WorkLine <> FixedQuery Then
                    Debug.Print WorkLine
                    '          1         2         3         4         5         6
                    ' 12345678901234567890123456789012345678901234567890123456789012
                    '"SELECT ID from FEATURETYPE where ISPLACEABLE != 0 AND ID in (64, 55, 16)
                    WorkLine = Mid(WorkLine, 62, Len(WorkLine) - 61)
                    Debug.Print WorkLine
                    tmpCheckCnt = 0
                    Sep = ","
                    pos = 1
                    NextPos = InStr(pos, WorkLine, Sep)
                    While NextPos >= 1
                        tempVal = Mid(WorkLine, pos, NextPos - pos)
                        Debug.Print "       " & tempVal
                        tmpCheckCnt = tmpCheckCnt + 1
                        tmpFtrInt = tempVal
                        If tmpFtrInt = FtrTypeID Then
                            fCheckCnt = tmpCheckCnt
                        End If
                        WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - pos)
                        pos = 1
                        NextPos = InStr(pos, WorkLine, Sep)
                    Wend
                    If Len(WorkLine) > 0 Then
                        Debug.Print "       " & WorkLine
                        tmpCheckCnt = tmpCheckCnt + 1
                        tmpFtrInt = WorkLine
                        If tmpFtrInt = FtrTypeID Then
                            fCheckCnt = tmpCheckCnt
                        End If
                    End If
                    Debug.Print ""
                End If
            
                If fCheckCnt > 0 Then
                    If logUpdates = "1" Then
                        ' Error this as a duplicate and skip it.
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        Failure = True
                        cell.value = "Updated existing row"
                    End If
                End If
            End If
            
            
            If fCheckCnt = 0 Then
            
                If VerticalName <> OldVerticalName Or HorizontalName <> OldHorizontalName Then
                
                    ' Add the record for the previous tab:
                    QueryName = FixedQueryName & HorizontalIdx & "," & VerticalIdx
                    Query = Query & ")"
                    Debug.Print "   Adding QueryName: " & QueryName
                    Debug.Print "   with query: " & Query
                    result = AddConfigRecord(rs, ID, FtrCatalogConfigID, QueryName, _
                        "This setting determines the query for the tab in the DA feature catalog", _
                        adBSTR, Query)
                    If Not result Then
                        GoTo LFC_Err
                    End If
                    ID = ID + 1
                    Query = FixedQuery
                    
                    If VerticalName <> OldVerticalName Then
                        VerticalTabs = VerticalTabs & OldVerticalName & ","
                        VerticalIdx = VerticalIdx + 1
                        
                        If HorizontalName <> OldHorizontalName Then
                            If Len(HorizontalTabs) > 0 Then
                                HorizontalTabs = HorizontalTabs & ","
                            End If
                            HorizontalTabs = HorizontalTabs & OldHorizontalName
                            HorizontalIdx = HorizontalIdx + 1
                            
                            ' Pad the vertical tabs list with place holders:
                            If VerticalIdx < MaxVertTabs Then
                                For i = VerticalIdx To MaxVertTabs - 1
                                    VerticalTabs = VerticalTabs & ","
                                Next i
                            End If
                            
                            ' Setup for the next group
                            VerticalIdx = 0
                            OldHorizontalName = HorizontalName
                        End If
                        
                        OldVerticalName = VerticalName
                        start = True
                        
                    ElseIf HorizontalName <> OldHorizontalName Then
                        If Len(HorizontalTabs) > 0 Then
                            HorizontalTabs = HorizontalTabs & ","
                        End If
                        HorizontalTabs = HorizontalTabs & OldHorizontalName
                        HorizontalIdx = HorizontalIdx + 1
                        
                        ' Pad the vertical tabs list with place holders:
                        VerticalTabs = VerticalTabs & OldVerticalName & ","
                        VerticalIdx = VerticalIdx + 1
                        If VerticalIdx < MaxVertTabs Then
                            For i = VerticalIdx To MaxVertTabs
                                VerticalTabs = VerticalTabs & ","
                            Next i
                        End If
                        
                        ' Setup for the next group
                        VerticalIdx = 0
                        OldHorizontalName = HorizontalName
                        OldVerticalName = VerticalName
                        start = True
                    End If
                Else
                    If ctr <> 2 Then start = False
                End If
                
                ' Add our feature to the query:
                If start Then
                    Query = Query & CStr(FtrTypeID)
                Else
                    Query = Query & ", " & CStr(FtrTypeID)
                End If
            
            End If
        End If

        ' Get our next row:
        ctr = ctr + 1
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    
    ' Add our last query row:
    If FixedQuery <> Query Then
        QueryName = FixedQueryName & HorizontalIdx & "," & VerticalIdx
        Query = Query & ")"
        result = AddConfigRecord(rs, ID, FtrCatalogConfigID, QueryName, _
            "This setting determines the query for the tab in the DA feature catalog", _
            adBSTR, Query)
        If Not result Then
            GoTo LFC_Err
        End If
        ID = ID + 1
        
        ' Only add our last tab names if needed:
        VerticalTabs = VerticalTabs & OldVerticalName
        If VerticalIdx < MaxVertTabs Then
            For i = VerticalIdx To MaxVertTabs - 1
                VerticalTabs = VerticalTabs & ","
            Next i
        End If
        
        If Len(HorizontalTabs) > 0 Then
            HorizontalTabs = HorizontalTabs & ","
        End If
        HorizontalTabs = HorizontalTabs & OldHorizontalName
        
    End If
    
    
    ' Check for existing Horizontal Tab Names to see if we need to do an update:
    sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - Horizontal Tab Names'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        ' Update our Horizontal Tab Names row:
        sql = "update " & CONFIGSETTING_TBLNAME & _
              " set " & CONFIGSETTING_STRINGVALUE & " = '" & HorizontalTabs & "'" & _
                " where " & CONFIGSETTING_NAME & " = 'DA - Horizontal Tab Names'"
        Conn.Execute sql, , adCmdText + adExecuteNoRecords
    Else
        ' Add our Horizontal Tab Names row:
        result = AddConfigRecord(rs, ID, FtrCatalogConfigID, "DA - Horizontal Tab Names", _
                "This setting determines the horizontal tab names for DA feature catalog", _
                adBSTR, HorizontalTabs)
        If Not result Then
            GoTo LFC_Err
        End If
        ID = ID + 1
    End If
    
    
    ' Check for existing Vertical Tab Names to see if we need to do an update:
    sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
            " where " & CONFIGSETTING_NAME & " = 'DA - Vertical Tab Names'"
    Set rs1 = Conn.Execute(sql, , adCmdText)
    If Not rs1.EOF Then
        ' Update our Vertical Tab Names row:
        sql = "update " & CONFIGSETTING_TBLNAME & _
              " set " & CONFIGSETTING_STRINGVALUE & " = '" & VerticalTabs & "'" & _
                " where " & CONFIGSETTING_NAME & " = 'DA - Vertical Tab Names'"
        Conn.Execute sql, , adCmdText + adExecuteNoRecords
    Else
        ' Add our Vertical Tab Names row:
        result = AddConfigRecord(rs, ID, FtrCatalogConfigID, "DA - Vertical Tab Names", _
                "This setting determines the vertical tab names for DA feature catalog", _
                adBSTR, VerticalTabs)
        If Not result Then
            GoTo LFC_Err
        End If
    End If
    
    ' Clean up:
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    rs1.Close
    
    ' Log our failure if needed:
    If Failure Then
        LogSheetFailure "FeatureCatalog"
    End If
    ImgFtrCatalog.Visible = True
    Exit Sub
    
LFC_Err:
    'mark everything as failed
    LogSheetFailure "FeatureCatalog"
    Set cell = ws.Range("C2")
    value = Trim(cell.value)
    ctr = 2
    Do While value <> ""
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)

        cell.Font.Color = RGB(255, 0, 0)
        Failure = True
        cell.value = "Failed"
        
        ctr = ctr + 1
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop


    
    
    
    
    
'            Dim daHorTabNms
'            Dim Sep As String
'            Dim WorkLine As String
'            Dim Pos As Integer
'            Dim NextPos As Integer
'            Dim TempVal As Variant
'            Dim HorTabInList As Boolean
'
'            HorTabInList = False
'            Sep = ","
'
'            If IncrementalLoad Then
'                ' Before we add this vertical tab to our count we need to make sure we it doesn't already exist.
'                sql = "select " & CONFIGSETTING_STRINGVALUE & " from " & CONFIGSETTING_TBLNAME & _
'                        " where " & CONFIGSETTING_NAME & " = 'DA - Horizontal Tab Names'"
'                Set rs1 = Conn.Execute(sql, , adCmdText)
'                If Not rs1.EOF Then
'                    daHorTabNms = rs1(CONFIGSETTING_STRINGVALUE)
'
'                    ' Parse out our Horisontal Tab Names:
'                    Debug.Print daHorTabNms
'
'                    WorkLine = daHorTabNms
'                    Pos = 1
'                    NextPos = InStr(Pos, WorkLine, Sep)
'                    While NextPos >= 1
'                        TempVal = Mid(WorkLine, Pos, NextPos - Pos)
'
'                        Debug.Print "       " & TempVal
'                        If TempVal = VerticalName Then
'                            HorTabInList = True
'                        End If
'
'                        WorkLine = Mid(WorkLine, NextPos + 1, Len(WorkLine) - Pos)
'                        Pos = 1
'                        NextPos = InStr(Pos, WorkLine, Sep)
'                    Wend
'                    If Len(WorkLine) > 0 Then
'                        Debug.Print "       " & WorkLine
'                        If WorkLine = VerticalName Then
'                            HorTabInList = True
'                        End If
'
'                    End If
'                    Debug.Print ""
'
'                End If
'            End If
    
'ConfigurationSetting Table
'Global Const CONFIGSETTING_TBLNAME$ = "ConfigurationSetting"
'Global Const CONFIGSETTING_ID$ = "ID"
'Global Const CONFIGSETTING_PARENTID$ = "ParentID"
'Global Const CONFIGSETTING_NAME$ = "Name"
'Global Const CONFIGSETTING_DESCRIPTION$ = "Description"
'Global Const CONFIGSETTING_VALUETYPE$ = "ValueType"
'Global Const CONFIGSETTING_LONGVALUE$ = "LongValue"
'Global Const CONFIGSETTING_FLOATVALUE$ = "FloatValue"
'Global Const CONFIGSETTING_DATEVALUE$ = "DateValue"
'Global Const CONFIGSETTING_STRINGVALUE$ = "StringValue"
    
'select * from configurationsetting where parentid = 72;


'select STRINGVALUE from configurationsetting where name = 'DA - Horizontal Tab Names';


' NAME = DA - Dimensions
' 2

' NAME = DA - Maximum Vertical Tabs
' 4

' NAME = DA - Horizontal Tab Names
' Electric - Overhead,Electric - Underground,Electric - Miscellaneous,Miscellaneous

' NAME = DA - Vertical Tab Names
' Structures,Conductors,Devices,Services,Structures,Conductors,Devices,Services,Miscellaneous,,,,Expert Designer Features,,,,

' NAME = DA - Query 0,0
' etc...
    
    
    
    


End Sub

'Adds a new record to the ConfigSetting table. Assumes that the recordset passed in
'is this table, opened for writing.
Private Function AddConfigRecord%(ConfigTable As ADODB.Recordset, ID&, ParentID&, Name$, _
                Description$, valueType As ADODB.DataTypeEnum, value As Variant)
    
    On Error GoTo ACR_ERR
    With ConfigTable
        .AddNew
        .Fields.Item(CONFIGSETTING_ID).value = ID
        If ParentID <> NULL_LONG Then
           .Fields.Item(CONFIGSETTING_PARENTID).value = ParentID
        End If
        .Fields.Item(CONFIGSETTING_NAME).value = Name
        .Fields.Item(CONFIGSETTING_DESCRIPTION).value = Description
        .Fields.Item(CONFIGSETTING_VALUETYPE).value = valueType
        If CStr(value) <> "" Then
           Select Case valueType
               Case adDate
                   .Fields.Item(CONFIGSETTING_DATEVALUE).value = CDate(value)
               Case adInteger
                   .Fields.Item(CONFIGSETTING_LONGVALUE).value = CLng(value)
               Case adDouble
                   .Fields.Item(CONFIGSETTING_FLOATVALUE).value = CDbl(value)
               Case Else
                   .Fields.Item(CONFIGSETTING_STRINGVALUE).value = value
           End Select
        End If
        .Update
    End With
    
    AddConfigRecord = True
    Exit Function
    
ACR_ERR:
    AddConfigRecord = False
End Function
Private Sub LoadCustomRuleViolation()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, message$, sql$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Custom Rule Violation"
    Me.Repaint
    Set ws = Worksheets("CustomRuleViolation")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CustomRuleViolation")
    logUpdates = GetLogUpdates("CustomRuleViolation")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
       
        ID = CLng(Trim(value))
            
        sql = "select * from " & VIOLATION_TBLNAME & " where " & VIOLATION_ID & " = " & ID
        rs.Open sql, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        If rs.EOF And rs.BOF Then
        
            cellstr = "B" & ctr
            Set cell = ws.Range(cellstr)
            message = Trim(cell.value)
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & VIOLATION_TBLNAME & _
                    " where " & VIOLATION_TBLNAME & "." & VIOLATION_MESSAGE & " = '" & message & "'" & _
                    " and " & VIOLATION_TBLNAME & "." & VIOLATION_ID & " = " & ID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs(VIOLATION_ID) = ID
                rs(VIOLATION_MESSAGE) = message
                rs.Update
            Else
                'rsTmp(VIOLATION_ID) = ID
                'rsTmp(VIOLATION_MESSAGE) = message
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        Else
            cellstr = "C" & ctr
            Set cell = ws.Range(cellstr)
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "This ID has already been used"
        End If
        rs.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
        
    Loop
    
    If Failure Then
        LogSheetFailure "CustomRuleViolation"
    End If
End Sub



Private Sub LoadJobType()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "Loading Job Types"
    Me.Repaint
    Set ws = Worksheets("JobType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("JobType")
    logUpdates = GetLogUpdates("JobType")

    Dim ctr&, AlertToUserID&
    Dim Name$
    Dim ID&, DefPriority&, RepDelayTime&
    Dim MaxRunTime#
    Dim Enabled%, Repeat%, AbortHungJobs%
    Dim val As Variant
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
           
    ctr = 2
    Failure = False
    
    Set cell = ws.Range("B2")
    Name = Trim(cell.value)

    rs.Open JOBTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        val = Trim(cell.value)
        If val <> "" Then
            If IsNumeric(val) Then
                ID = CLng(val)
            Else
                ID = NULL_LONG
            End If
        Else
            ID = NULL_LONG
        End If
    
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        DefPriority = CLng(Trim(cell.value))
  
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Enabled = BoolStringToInt(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        Repeat = BoolStringToInt(Trim(cell.value))
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        RepDelayTime = CLng(Trim(cell.value))
        
        cellstr = "G" & ctr
        Set cell = ws.Range(cellstr)
        AlertToUserID = UserIDForName(Trim(cell.value))
        
        cellstr = "H" & ctr
        Set cell = ws.Range(cellstr)
        MaxRunTime = CDbl(Trim(cell.value))
        
        cellstr = "I" & ctr
        Set cell = ws.Range(cellstr)
        AbortHungJobs = BoolStringToInt(Trim(cell.value))
        
        cellstr = "J" & ctr
        Set cell = ws.Range(cellstr)
        If ID <> NULL_LONG Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & JOBTYPE_TBLNAME & _
                    " where " & JOBTYPE_TBLNAME & "." & JOBTYPE_ID & " = " & ID
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(JOBTYPE_ID).value = ID
                rs.Fields.Item(JOBTYPE_NAME).value = Name
                rs.Fields.Item(JOBTYPE_DEFAULTPRIORITY).value = DefPriority
                rs.Fields.Item(JOBTYPE_ENABLED).value = Enabled
                rs.Fields.Item(JOBTYPE_REPEAT).value = Repeat
                rs.Fields.Item(JOBTYPE_REPEATDELAYTIME).value = RepDelayTime
                rs.Fields.Item(JOBTYPE_SENDALERTTOUSERID).value = AlertToUserID
                rs.Fields.Item(JOBTYPE_MAXRUNTIME).value = MaxRunTime
                rs.Fields.Item(JOBTYPE_ABORTHUNGJOBS).value = AbortHungJobs
            Else
                'rsTmp.Fields.Item(JOBTYPE_ID).Value = ID
                rsTmp.Fields.Item(JOBTYPE_NAME).value = Name
                rsTmp.Fields.Item(JOBTYPE_DEFAULTPRIORITY).value = DefPriority
                rsTmp.Fields.Item(JOBTYPE_ENABLED).value = Enabled
                rsTmp.Fields.Item(JOBTYPE_REPEAT).value = Repeat
                rsTmp.Fields.Item(JOBTYPE_REPEATDELAYTIME).value = RepDelayTime
                rsTmp.Fields.Item(JOBTYPE_SENDALERTTOUSERID).value = AlertToUserID
                rsTmp.Fields.Item(JOBTYPE_MAXRUNTIME).value = MaxRunTime
                rsTmp.Fields.Item(JOBTYPE_ABORTHUNGJOBS).value = AbortHungJobs
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
        
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "ID must be a numeric value"
        End If

        ctr = ctr + 1
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "JobType"
    End If
End Sub


Private Sub LoadJob()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "Loading Jobs"
    Me.Repaint
    Set ws = Worksheets("Job")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("Job")
    logUpdates = GetLogUpdates("Job")

    Dim JobType&, ctr&, OwnerID&
    Dim Name$, Owner$, LastOwner$
    Dim ID&, Priority&, Status&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
           
    ctr = 2
    LastOwner = ""
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)

    rs.Open ("CHSERVER." & JOB_TBLNAME), Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(JOB_TBLNAME, JOB_ID, "CHSERVER")
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Priority = CLng(Trim(cell.value))
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Owner = Trim(cell.value)
        If Owner <> LastOwner Then
            OwnerID = UserIDForName(Owner)
            LastOwner = Owner
        End If
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        Status = JobStatusID(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        JobType = JobTypeID(Trim(cell.value))
              
              
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        
        If JobType <> NULL_LONG Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & "CHSERVER." & JOB_TBLNAME & _
                    " where " & "CHSERVER." & JOB_TBLNAME & "." & JOB_NAME & " = '" & Name & "'"
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(JOB_ID).value = ID
                rs.Fields.Item(JOB_NAME).value = Name
                rs.Fields.Item(JOB_PRIORITY).value = Priority
                If IsSQLSERVER Then
                    rs.Fields.Item(JOB_ARRIVALDATE).value = Format(Now, "Short Date")
                Else
                    rs.Fields.Item(JOB_ARRIVALDATE).value = Now
                End If
                rs.Fields.Item(JOB_OWNERID).value = OwnerID
                rs.Fields.Item(JOB_STATUS).value = Status
                rs.Fields.Item(JOB_JOBTYPEID).value = JobType
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(JOB_ID).Value = ID
                'rsTmp.Fields.Item(JOB_NAME).Value = name
                rsTmp.Fields.Item(JOB_PRIORITY).value = Priority
                If IsSQLSERVER Then
                    rsTmp.Fields.Item(JOB_ARRIVALDATE).value = Format(Now, "Short Date")
                Else
                    rsTmp.Fields.Item(JOB_ARRIVALDATE).value = Now
                End If
                rsTmp.Fields.Item(JOB_OWNERID).value = OwnerID
                rsTmp.Fields.Item(JOB_STATUS).value = Status
                rsTmp.Fields.Item(JOB_JOBTYPEID).value = JobType
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - not a valid job type"
        End If
        
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "Job"
    End If
End Sub

Private Sub LoadEDServer()

    LoadJobType
    LoadServerConfiguration
    LoadRunTimeConstraint
    LoadRunConcurrencyConstraint
    LoadJob

    ImgEDServer.Visible = True
    
End Sub
Private Sub LoadRunTimeConstraint()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "Loading Run Time Constraint"
    Me.Repaint
    Set ws = Worksheets("RunTimeConstraint")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("RunTimeConstraint")
    logUpdates = GetLogUpdates("RunTimeConstraint")

    Dim JobType&, ctr&, DayOfWeek&
    Dim Name$
    Dim ID&
    Dim StartDate As Date
    Dim EndDate As Date
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
           
    ctr = 2
    
    Set cell = ws.Range("A2")
    Name = Trim(cell.value)

    rs.Open RUNTIMECNSTRNT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RUNTIMECNSTRNT_TBLNAME, RUNTIMECNSTRNT_ID)
    Do While Name <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        JobType = JobTypeID(Name)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        StartDate = CDate(Trim(cell.value))
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        EndDate = CDate(Trim(cell.value))
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        DayOfWeek = WeekDay(Trim(cell.value))
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        
        If JobType <> NULL_LONG Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & RUNTIMECNSTRNT_TBLNAME & _
                    " where " & RUNTIMECNSTRNT_TBLNAME & "." & RUNTIMECNSTRNT_JOBTYPEID & " = " & JobType
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(RUNTIMECNSTRNT_ID).value = ID
                rs.Fields.Item(RUNTIMECNSTRNT_STARTDATETIME).value = StartDate
                rs.Fields.Item(RUNTIMECNSTRNT_ENDDATETIME).value = EndDate
                rs.Fields.Item(RUNTIMECNSTRNT_JOBTYPEID).value = JobType
                rs.Fields.Item(RUNTIMECNSTRNT_DAYOFWEEK).value = DayOfWeek
                ID = ID + 1
            Else
                rsTmp.Fields.Item(RUNTIMECNSTRNT_ID).value = ID
                rsTmp.Fields.Item(RUNTIMECNSTRNT_STARTDATETIME).value = StartDate
                rsTmp.Fields.Item(RUNTIMECNSTRNT_ENDDATETIME).value = EndDate
                'rsTmp.Fields.Item(RUNTIMECNSTRNT_JOBTYPEID).Value = JobType
                rsTmp.Fields.Item(RUNTIMECNSTRNT_DAYOFWEEK).value = DayOfWeek
                rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
                
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - not a valid job type"
        End If
        
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "RunTimeConstraint"
    End If
End Sub


Private Sub LoadRunConcurrencyConstraint()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Label2.Caption = "Loading Run Concurrency Constraints"
    Me.Repaint
    Set ws = Worksheets("RunConcurrencyConstraint")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("RunConcurrencyConstraint")
    logUpdates = GetLogUpdates("RunConcurrencyConstraint")

    Dim JobTypeName$
    Dim ID&, JobType&, ctr&, IncompatibleJobType&
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
           
    ctr = 2
    
    Set cell = ws.Range("A2")
    JobTypeName = Trim(cell.value)

    rs.Open RUNCONCURRENCYCNSTRNT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(RUNCONCURRENCYCNSTRNT_TBLNAME, RUNCONCURRENCYCNSTRNT_ID)
    Do While JobTypeName <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        JobType = JobTypeID(JobTypeName)
              
              
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        IncompatibleJobType = JobTypeID(Trim(cell.value))
        
        If JobType <> NULL_LONG And IncompatibleJobType <> NULL_LONG Then
            
            ' Check for existing rows: DONE
            sqlTmp = "select * from " & RUNCONCURRENCYCNSTRNT_TBLNAME & _
                    " where " & RUNCONCURRENCYCNSTRNT_TBLNAME & "." & RUNCONCURRENCYCNSTRNT_JOBTYPEID & " = " & JobType & _
                    " and " & RUNCONCURRENCYCNSTRNT_TBLNAME & "." & RUNCONCURRENCYCNSTRNT_INCOMPATIBLEJOBTYPEID & " = " & IncompatibleJobType
            rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
            If rsTmp.BOF And rsTmp.EOF Then
                rs.AddNew
                rs.Fields.Item(RUNCONCURRENCYCNSTRNT_ID).value = ID
                rs.Fields.Item(RUNCONCURRENCYCNSTRNT_JOBTYPEID).value = JobType
                rs.Fields.Item(RUNCONCURRENCYCNSTRNT_INCOMPATIBLEJOBTYPEID).value = IncompatibleJobType
                ID = ID + 1
            Else
                'rsTmp.Fields.Item(RUNCONCURRENCYCNSTRNT_ID).Value = ID
                'rsTmp.Fields.Item(RUNCONCURRENCYCNSTRNT_JOBTYPEID).Value = JobType
                'rsTmp.Fields.Item(RUNCONCURRENCYCNSTRNT_INCOMPATIBLEJOBTYPEID).Value = IncompatibleJobType
                'rsTmp.Update

                If logUpdates = "1" Then
                    ' Tell user about our update:
                    Set cell = ws.Range((ErrorCol & ctr))
                    cell.Font.Color = RGB(255, 0, 0)
                    cell.value = cell.value & " Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Close
            
        Else
            cell.Font.Color = RGB(255, 0, 0)
            Failure = True
            cell.value = "Failed - not a valid job type"
        End If
        
        ctr = ctr + 1
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        JobTypeName = Trim(cell.value)
    
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "RunConcurrencyConstraint"
    End If
End Sub

Private Sub LoadServerConfiguration()

    Dim tmpStr As String
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Server Configuration"
    Me.Repaint
    Set ws = Worksheets("ServerConfiguration")
    
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ServerConfiguration")
    logUpdates = GetLogUpdates("ServerConfiguration")

    rs.Open SERVERCONFIGURATION_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable

    ' Clear previous errors:
    ws.Range((ErrorCol & "1")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "1")).value = ""
    ws.Range((ErrorCol & "2")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "2")).value = ""
    ws.Range((ErrorCol & "3")).Font.ColorIndex = xlColorIndexAutomatic
    ws.Range((ErrorCol & "3")).value = ""
    
    ' Check for existing rows: DONE
    sqlTmp = "select * from " & SERVERCONFIGURATION_TBLNAME
    rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
    If rsTmp.BOF And rsTmp.EOF Then
        If ws.Range("B1").value <> "" Or _
           ws.Range("B2").value <> "" Or _
           ws.Range("B3").value <> "" Then
            rs.AddNew
            If ws.Range("B1").value <> "" Then rs(SERVERCONFIGURATION_COMPUTERNAME) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rs(SERVERCONFIGURATION_RETRYTIMEOUT) = CLng(Trim(ws.Range("B2").value))
            If ws.Range("B3").value <> "" Then rs(SERVERCONFIGURATION_NUMBEROFRETRIES) = CLng(Trim(ws.Range("B3").value))
        End If
    Else
        If logUpdates = "1" Then
            If (Trim(ws.Range("B1").value) <> "") Then
                tmpStr = rsTmp(SERVERCONFIGURATION_COMPUTERNAME)
                If (tmpStr <> Trim(ws.Range("B1").value)) Then
                    rsTmp(SERVERCONFIGURATION_COMPUTERNAME) = Trim(ws.Range("B1").value)
                    ws.Range((ErrorCol & "1")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "1")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B2").value) <> "") Then
                tmpStr = rsTmp(SERVERCONFIGURATION_RETRYTIMEOUT)
                If (tmpStr <> CLng(Trim(ws.Range("B2").value))) Then
                    rsTmp(SERVERCONFIGURATION_RETRYTIMEOUT) = CLng(Trim(ws.Range("B2").value))
                    ws.Range((ErrorCol & "2")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "2")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            If (Trim(ws.Range("B3").value) <> "") Then
                tmpStr = rsTmp(SERVERCONFIGURATION_NUMBEROFRETRIES)
                If (tmpStr <> CLng(Trim(ws.Range("B3").value))) Then
                    rsTmp(SERVERCONFIGURATION_NUMBEROFRETRIES) = CLng(Trim(ws.Range("B3").value))
                    ws.Range((ErrorCol & "3")).Font.Color = RGB(255, 0, 0)
                    ws.Range((ErrorCol & "3")).value = "Updated existing row"
                    Failure = True
                End If
            End If
            rsTmp.Update
        Else
            If ws.Range("B1").value <> "" Then rsTmp(SERVERCONFIGURATION_COMPUTERNAME) = Trim(ws.Range("B1").value)
            If ws.Range("B2").value <> "" Then rsTmp(SERVERCONFIGURATION_RETRYTIMEOUT) = CLng(Trim(ws.Range("B2").value))
            If ws.Range("B3").value <> "" Then rsTmp(SERVERCONFIGURATION_NUMBEROFRETRIES) = CLng(Trim(ws.Range("B3").value))
            rsTmp.Update
        End If
    End If
    rsTmp.Close
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ServerConfiguration"
    End If
End Sub
Function JobTypeID&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$

    sql = "select " & JOBTYPE_ID & " from " & JOBTYPE_TBLNAME & " where " & _
            JOBTYPE_NAME & " = '" & Name & "'"
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        JobTypeID = rs(JOBTYPE_ID)
    Else
        JobTypeID = NULL_LONG
    End If
    
End Function

Private Sub RunCustomSQL()

    Dim rs As Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, sql$, message$
    Dim ctr%
    
    Label2.Caption = "Running Custom SQL statements"
    Me.Repaint
    Set ws = Worksheets("CustomSQL")
    
    ctr = 2
    
    Set cell = ws.Range("A2")
    sql = Trim(cell.value)

    On Error GoTo CustomSQL_ERR
    
    Do While sql <> ""
        
        Set rs = Conn.Execute(sql, , adCmdText)

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        sql = Trim(cell.value)
        
    Loop
    Exit Sub
CustomSQL_ERR:
    message = "Custom SQL Statement " & ctr - 1 & " failed"
    If logdir <> "" And logfile <> "" Then
        LogMsg message
    Else
        MsgBox sql, vbOKOnly, "Custom SQL Error"
    End If
    Resume Next
End Sub

Private Sub LoadExportFtrDetails()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cellstr As String
    Dim cell As Range
    Dim MyStr As String
    Dim MyNum As Long
    Dim ctr%
    Dim Dataset$
    Dim ID&
    Dim valB$, valC$, valD$, valE$, valF$
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Export Feature Details"
    Me.Repaint
    Set ws = Worksheets("ExportFeatureDetails")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("ExportFeatureDetails")
    logUpdates = GetLogUpdates("ExportFeatureDetails")

    ctr = 2
    
    Set cell = ws.Range("A2")
    Dataset = Trim(cell.value)
    
    rs.Open EXPORTFTRDETAILS_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(EXPORTFTRDETAILS_TBLNAME, EXPORTFTRDETAILS_ID)
    Do While Dataset <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        valB = Trim(ws.Range(("B" & ctr)).value)
        valC = Trim(ws.Range(("C" & ctr)).value)
        valD = Trim(ws.Range(("D" & ctr)).value)
        valE = Trim(ws.Range(("E" & ctr)).value)
        valF = Trim(ws.Range(("F" & ctr)).value)
        
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & EXPORTFTRDETAILS_TBLNAME & _
                " where " & EXPORTFTRDETAILS_TBLNAME & "." & EXPORTFTRDETAILS_DATASET & " = '" & Dataset & "'" & _
                " and " & EXPORTFTRDETAILS_TBLNAME & "." & EXPORTFTRDETAILS_GISTABLE & " = '" & valB & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs.Fields.Item(EXPORTFTRDETAILS_ID).value = ID
            rs.Fields.Item(EXPORTFTRDETAILS_DATASET).value = Dataset
            rs.Fields.Item(EXPORTFTRDETAILS_GISTABLE).value = valB
            If valC <> "" Then rs.Fields.Item(EXPORTFTRDETAILS_ISSTRUCTURE).value = BoolStringToInt(valC)
            If valD <> "" Then rs.Fields.Item(EXPORTFTRDETAILS_USESSTRUCTURE).value = BoolStringToInt(valD)
            If valE <> "" Then rs.Fields.Item(EXPORTFTRDETAILS_HASCONNECTIONS).value = BoolStringToInt(valE)
            If valF <> "" Then rs.Fields.Item(EXPORTFTRDETAILS_ISPARENT).value = BoolStringToInt(valF)
            ID = ID + 1
        Else
            'rsTmp.Fields.Item(EXPORTFTRDETAILS_ID).Value = ID
            'rsTmp.Fields.Item(EXPORTFTRDETAILS_DATASET).Value = Dataset
            'rsTmp.Fields.Item(EXPORTFTRDETAILS_GISTABLE).Value = valB
            If valC <> "" Then rsTmp.Fields.Item(EXPORTFTRDETAILS_ISSTRUCTURE).value = BoolStringToInt(valC)
            If valD <> "" Then rsTmp.Fields.Item(EXPORTFTRDETAILS_USESSTRUCTURE).value = BoolStringToInt(valD)
            If valE <> "" Then rsTmp.Fields.Item(EXPORTFTRDETAILS_HASCONNECTIONS).value = BoolStringToInt(valE)
            If valF <> "" Then rsTmp.Fields.Item(EXPORTFTRDETAILS_ISPARENT).value = BoolStringToInt(valF)
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close
        
        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Dataset = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "ExportFeatureDetails"
    End If
    ImgExportFtrDetail.Visible = True
End Sub

Private Sub LoadCommodityGroup()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, Workspace$, Parameters$, MasterPath$, PWBaseFolderGUIS$, Command$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Dim CreatedNewForNONE As Boolean
    CreatedNewForNONE = False
    
    Label2.Caption = "Loading CommodityGroup"
    Me.Repaint
    Set ws = Worksheets("CommodityGroup")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CommodityGroup")
    logUpdates = GetLogUpdates("CommodityGroup")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CMDTGROUP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(CMDTGROUP_TBLNAME, CMDTGROUP_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Workspace = Trim(cell.value)
        
        cellstr = "C" & ctr
        Set cell = ws.Range(cellstr)
        Parameters = Trim(cell.value)
        
        cellstr = "D" & ctr
        Set cell = ws.Range(cellstr)
        MasterPath = Trim(cell.value)
        
        cellstr = "E" & ctr
        Set cell = ws.Range(cellstr)
        PWBaseFolderGUIS = Trim(cell.value)
        
        cellstr = "F" & ctr
        Set cell = ws.Range(cellstr)
        Command = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CMDTGROUP_TBLNAME & _
                " where " & CMDTGROUP_TBLNAME & "." & CMDTGROUP_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            
            If UCase(Name) = "NONE" Then
                rs(CMDTGROUP_ID) = 0
                CreatedNewForNONE = True
            Else
                rs(CMDTGROUP_ID) = ID
                ID = ID + 1
            End If
            
            rs(CMDTGROUP_NAME) = Name
            rs(CMDTGROUP_WORKSPACE) = Workspace
            rs(CMDTGROUP_PARAMETERS) = Parameters
            rs(CMDTGROUP_MASTERPATH) = MasterPath
            rs(CMDTGROUP_PWBASEFOLDERGUID) = PWBaseFolderGUIS
            rs(CMDTGROUP_COMMAND) = Command
            
        Else
            'rsTmp(CMDTGROUP_ID) = ID
            'rsTmp(CMDTGROUP_NAME) = name
            rsTmp(CMDTGROUP_WORKSPACE) = Workspace
            rsTmp(CMDTGROUP_PARAMETERS) = Parameters
            rsTmp(CMDTGROUP_MASTERPATH) = MasterPath
            rsTmp(CMDTGROUP_PWBASEFOLDERGUID) = PWBaseFolderGUIS
            rsTmp(CMDTGROUP_COMMAND) = Command
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Not CreatedNewForNONE Then
        sqlTmp = "select * from " & CMDTGROUP_TBLNAME & " WHERE " & CMDTGROUP_ID & " = 0"
        rs.Open sqlTmp, Conn, adOpenDynamic, adLockPessimistic, adCmdText
        If rs.BOF And rs.EOF Then
            rs.AddNew
            
            rs.Fields.Item(CMDTGROUP_ID).value = 0
            rs.Fields.Item(CMDTGROUP_NAME).value = "NONE"
            rs.Fields.Item(CMDTGROUP_WORKSPACE).value = "NO USEFUL VALUE"
            rs.Fields.Item(CMDTGROUP_PARAMETERS).value = "NO USEFUL VALUE"
            rs.Fields.Item(CMDTGROUP_MASTERPATH).value = "NO USEFUL VALUE"
            rs.Fields.Item(CMDTGROUP_PWBASEFOLDERGUID).value = "NO USEFUL VALUE"
            
            rs.Update
            rs.Close
        End If
    End If
    
    If Failure Then
        LogSheetFailure "CommodityGroup"
    End If
End Sub


Private Sub LoadCommodityType()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading CommodityType"
    Me.Repaint
    Set ws = Worksheets("CommodityType")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CommodityType")
    logUpdates = GetLogUpdates("CommodityType")

    ctr = 2
    
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CMDTTYPE_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        ID = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Name = Trim(cell.value)
        
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CMDTTYPE_TBLNAME & _
                " where " & CMDTTYPE_TBLNAME & "." & CMDTTYPE_NAME & " = '" & Name & "'"
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(CMDTTYPE_ID) = ID
            rs(CMDTTYPE_NAME) = Name
        Else
            'rsTmp(CMDTTYPE_ID) = ID
            'rsTmp(CMDTTYPE_NAME) = name
            rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CommodityType"
    End If
End Sub

Private Sub LoadPWMapping()
    LoadPWAttributeMapping

End Sub

Private Sub LoadPWAttributeMapping()
    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$, Name$, value$
    Dim tmpInt As Integer
    Dim EDTableTypeInt, PWTableTypeInt As Integer
    Dim PWID$, EDTableType$, EDColName$, PWTableType$, PWColName$, Domain$, DomainEDColumn$, DomainPWColumn$
    Dim MyNum&, ID&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading PWAttributeMapping"
    Me.Repaint
    Set ws = Worksheets("PWAttributeMapping")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("PWAttributeMapping")
    logUpdates = GetLogUpdates("PWAttributeMapping")

    ctr = 2
    
    Set cell = ws.Range("B2")
    value = Trim(cell.value)
        
    rs.Open PWATTRMAP_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    ID = NextPK(PWATTRMAP_TBLNAME, PWATTRMAP_ID)
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
        
        If Trim(ws.Range(("A" & ctr)).value) = "1" Then 'Process?
            
            EDTableType = Trim(ws.Range("B" & ctr).value)
            EDColName = Trim(ws.Range("C" & ctr).value)
            PWTableType = Trim(ws.Range("D" & ctr).value)
            PWID = Trim(ws.Range("E" & ctr).value)
            PWColName = Trim(ws.Range("F" & ctr).value)
            Domain = Trim(ws.Range("G" & ctr).value)
            DomainEDColumn = Trim(ws.Range("H" & ctr).value)
            DomainPWColumn = Trim(ws.Range("I" & ctr).value)
                        
            If UCase(EDTableType) = "WORKREQUEST" Then
                EDTableTypeInt = 0
            Else
                If UCase(EDTableType) = "DESIGN" Then
                    EDTableTypeInt = 1
                Else
                    EDTableTypeInt = 99
                End If
            End If
            
                        
            If UCase(PWTableType) = "PROJECT" Then
                PWTableTypeInt = 0
            Else
                If UCase(PWTableType) = "ENVIRONMENT" Then
                    PWTableTypeInt = 1
                Else
                    PWTableTypeInt = 99
                End If
            End If
            
            If EDTableTypeInt <> 99 And PWTableTypeInt <> 99 Then
                ' Check for existing rows: DONE
                sqlTmp = "select * from " & PWATTRMAP_TBLNAME & _
                        " where " & PWATTRMAP_TBLNAME & "." & PWATTRMAP_EDTABLETYPE & " = " & EDTableTypeInt & _
                        " and " & PWATTRMAP_TBLNAME & "." & PWATTRMAP_EDCOLUMNNAME & " = '" & EDColName & "'"
                rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
                If rsTmp.BOF And rsTmp.EOF Then
                    rs.AddNew
                    rs(PWATTRMAP_ID) = ID
                    rs(PWATTRMAP_EDTABLETYPE) = EDTableTypeInt
                    rs(PWATTRMAP_EDCOLUMNNAME) = EDColName
                    rs(PWATTRMAP_PWTABLETYPE) = PWTableTypeInt
                    If PWID <> "" Then
                        tmpInt = PWID
                        rs(PWATTRMAP_PWID) = tmpInt
                    End If
                    rs(PWATTRMAP_PWCOLUMNNAME) = PWColName
                    rs(PWATTRMAP_DOMAIN) = Domain
                    rs(PWATTRMAP_DOMAINEDCOLUMN) = DomainEDColumn
                    rs(PWATTRMAP_DOMAINPWCOLUMN) = DomainPWColumn
                    ID = ID + 1
                Else
                    'rsTmp(PWATTRMAP_ID) = ID
                    'rsTmp(PWATTRMAP_EDTABLETYPE) = EDTableTypeInt
                    'rsTmp(PWATTRMAP_EDCOLUMNNAME) = EDColName
                    rsTmp(PWATTRMAP_PWTABLETYPE) = PWTableTypeInt
                    If PWID <> "" Then
                        tmpInt = PWID
                        rsTmp(PWATTRMAP_PWID) = tmpInt
                    End If
                    rsTmp(PWATTRMAP_PWCOLUMNNAME) = PWColName
                    rsTmp(PWATTRMAP_DOMAIN) = Domain
                    rsTmp(PWATTRMAP_DOMAINEDCOLUMN) = DomainEDColumn
                    rsTmp(PWATTRMAP_DOMAINPWCOLUMN) = DomainPWColumn
                    rsTmp.Update
        
                    If logUpdates = "1" Then
                        ' Tell user about our update:
                        Set cell = ws.Range((ErrorCol & ctr))
                        cell.Font.Color = RGB(255, 0, 0)
                        cell.value = cell.value & " Updated existing row"
                        Failure = True
                    End If
                End If
                rsTmp.Close
            End If
            
        End If
        
        ctr = ctr + 1
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "PWAttributeMapping"
    End If
    
End Sub

Private Sub LoadCommodityGroupAssignment()

    Dim rs As New Recordset
    Dim ws As Worksheet
    Dim cell As Range
    Dim MyStr$, cellstr$
    
    Dim MyNum&
    Dim CType$, Group$, value$, LastGroup$, LastType$
    Dim typeid&, groupid&
    Dim ctr%
    Dim Failure As Boolean
    Dim sqlTmp$
    Dim rsTmp As New Recordset
    Failure = False
    
    Label2.Caption = "Loading Commodity Group Assignments"
    Me.Repaint
    Set ws = Worksheets("CommodityGroupAssignment")
    Dim ErrorCol As String
    Dim logUpdates As String
    ErrorCol = GetErrorCol("CommodityGroupAssignment")
    logUpdates = GetLogUpdates("CommodityGroupAssignment")

    ctr = 2
    LastGroup = ""
    LastType = ""
    Set cell = ws.Range("A2")
    value = Trim(cell.value)
        
    rs.Open CMDTGROUPASSIGNMENT_TBLNAME, Conn, adOpenDynamic, adLockPessimistic, adCmdTable
    
    Do While value <> ""
        ' Clear previous errors:
        Set cell = ws.Range((ErrorCol & ctr))
        cell.Font.ColorIndex = xlColorIndexAutomatic
        cell.value = ""
    
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        CType = Trim(cell.value)
        
        cellstr = "B" & ctr
        Set cell = ws.Range(cellstr)
        Group = Trim(cell.value)
            
        If LastType <> CType Then
            typeid = CommodityTypeIDForName(CType)
            LastType = CType
        End If
        If LastGroup <> Group Then
            groupid = CommodityGroupIDForName(Group)
            LastGroup = Group
        End If
             
        ' Check for existing rows: DONE
        sqlTmp = "select * from " & CMDTGROUPASSIGNMENT_TBLNAME & _
                " where " & CMDTGROUPASSIGNMENT_TBLNAME & "." & CMDTGROUPASSIGNMENT_CMDTGROUPID & " = " & groupid & _
                " and " & CMDTGROUPASSIGNMENT_TBLNAME & "." & CMDTGROUPASSIGNMENT_CMDTTYPEID & " = " & typeid
        rsTmp.Open sqlTmp, Conn, adOpenDynamic, adLockOptimistic, adCmdText
        If rsTmp.BOF And rsTmp.EOF Then
            rs.AddNew
            rs(CMDTGROUPASSIGNMENT_CMDTGROUPID) = groupid
            rs(CMDTGROUPASSIGNMENT_CMDTTYPEID) = typeid
        Else
            'rsTmp(CMDTGROUPASSIGNMENT_CMDTGROUPID) = GroupID
            'rsTmp(CMDTGROUPASSIGNMENT_CMDTTypeID) = TypeID
            'rsTmp.Update

            If logUpdates = "1" Then
                ' Tell user about our update:
                Set cell = ws.Range((ErrorCol & ctr))
                cell.Font.Color = RGB(255, 0, 0)
                cell.value = cell.value & " Updated existing row"
                Failure = True
            End If
        End If
        rsTmp.Close

        ctr = ctr + 1
        cellstr = "A" & ctr
        Set cell = ws.Range(cellstr)
        value = Trim(cell.value)
    Loop
    
    If Not (rs.BOF And rs.EOF) Then rs.Update
    rs.Close
    
    If Failure Then
        LogSheetFailure "CommodityGroupAssignment"
    End If
    ImgCommodityType.Visible = True
End Sub

Function CommodityGroupIDForName&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$, temp$
    temp = Name
    DealWithApostrophes temp
    sql = "select " & CMDTGROUP_ID & " from " & CMDTGROUP_TBLNAME & " where " & CMDTGROUP_NAME & " = '" & temp & "'"
    
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        CommodityGroupIDForName = rs(CMDTGROUP_ID)
    End If
End Function

Function CommodityTypeIDForName&(Name$)
    Dim rs As ADODB.Recordset
    Dim sql$, temp$
    temp = Name
    DealWithApostrophes temp
    sql = "select " & CMDTTYPE_ID & " from " & CMDTTYPE_TBLNAME & " where " & CMDTTYPE_NAME & " = '" & temp & "'"
    
    Set rs = Conn.Execute(sql, Nothing, adCmdText)
    If (Not (rs.BOF And rs.EOF)) Then
        CommodityTypeIDForName = rs(CMDTTYPE_ID)
    End If
End Function
